{
  Cyrille de Brebisson utility classes
  This unit is copyright Cyrille de Brebisson
}
unit HexaEdit;

interface

uses
  SysUtils, Classes, StdCtrls;

type
  THexaEdit = class(tedit)
  private
    procedure Setvalue(const Value: int64);
    Function FRValue: int64;
  protected
    procedure KeyPress(var key: char); override;
  public
    Procedure arrayvalue(var v: array of byte);
    property value: int64 read FRvalue write Setvalue;
  end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('CDBUtil', [THexaEdit]);  // wgg was exemples
end;

{ THexaEdit }

procedure THexaEdit.arrayvalue(var v: array of byte);
var
  i: integer;
begin
  for i:= 0 to length(text)-1 do
    v[i]:= pos(text[i+1], '0123456789ABCDEF')-1;
end;

function THexaEdit.FRValue: int64;
var
  i: integer;
begin
  try
    val('$'+text,result,i);
  except
    result:= -1;
  end;
end;

procedure THexaEdit.KeyPress(var key: char);
begin
  if key in ['a'..'f'] then
    key:= UpCase(key);
  if not ((key in ['0'..'9','A'..'F']) or (key<' ')) then
    key:= #0;
end;

procedure THexaEdit.Setvalue(const Value: int64);
var
  t: string;
begin
  t:= IntToHex(value, 16);
  if length(t)>MaxLength then
    t:= copy(t, length(t)-MaxLength+1, MaxLength);
  text:= t;
end;

end.
