unit Desasm;

interface
uses classes;

  Function DeAsm(b: array of byte; var adr:integer; GotoStringList: TStringList):string;

implementation

uses
  SysUtils;

Function DeAsm(b: array of byte; var adr:integer; GotoStringList: TStringList):string;
const
  Field : array [0..15] of String = ('.P', '.WP', '.XS', '.X', '.S', '.M', '.B', '.W', '', '', '', '', '', '', '', '.A');
  Op0   : array [0..15] of String = ('RTNSXM', 'RTN', 'RTNSC', 'RTNCC', 'SETHEX', 'SETDEC', 'RSTK=C', 'C=RSTK', 'CLRST', 'C=ST', 'ST=C', 'CSTEX', 'P+1', 'P-1', '', 'RTI');
  Op13  : array [0..15] of string = ('D0=A', 'D1=A', 'AD0EX', 'AD1EX', 'D0=C', 'D1=C', 'CD0EX', 'CD1EX', 'D0=AS', 'D1=AS', 'AD0XS', 'AD1XS', 'D0=CS', 'D1=CS', 'CD0XS', 'CD1XS' );
  Op14  : array [0..7]  of string = ('DAT0=A', 'DAT1=A', 'A=DAT0', 'A=DAT1', 'DAT0=C', 'DAT1=C', 'C=DAT0', 'C=DAT1');
  Opm1  : array [0..15] of string = ('A+B', 'B+C', 'C+A','C+D', 'A+A', 'B+B', 'C+C', 'D+D', 'B+A', 'C+B', 'A+C', 'C+D', 'A-1', 'B-1', 'C-1', 'D-1' );
  Opm2  : array [0..15] of string = ('A=0', 'B=0', 'C=0','D=0', 'A=B', 'B=C', 'C=A', 'D=C', 'B=A', 'C=B', 'A=C', 'C=D', 'ABEX', 'BCEX', 'ACEX', 'CDEX' );
  Opm3  : array [0..15] of string = ('A-B', 'B-C', 'C-A','D-C', 'A+1', 'B+1', 'C+1', 'D+1', 'B-A', 'C-B', 'A-C', 'C-D', 'A=B-A', 'B=C-B', 'C=A-C', 'D=C-D' );
  Opm4  : array [0..15] of string = ('ASL', 'BSL', 'CSL','DSL', 'ASR', 'BSR', 'CSR', 'DSR', 'A=-A', 'B=-B', 'C=-C', 'D=-D', 'A=-A-1', 'B=-B-1', 'C=-C-1', 'D=-D-1' );
  tests : array [0..31] of string = ('?B=A', '?C=B', '?A=C', '?C=D', '?B#A', '?C#B', '?A#C', '?C#D', '?A=0', '?B=0', '?C=0', '?D=0', '?A#0', '?B#0', '?C#0', '?D#0', '?A>B', '?B>C', '?C>A', '?D>C', '?A<B', '?B<C', '?C<A', '?D<C', '?A>=B', '?B>=C', '?C>=A', '?D>=C', '?A<=B', '?B<=C', '?C<=A', '?D<=C');
  logic : array [0..15] of string = ('A&&B', 'B&&C', 'C&&A', 'C&&D', 'B&&A', 'C&&B', 'A&&C', 'C&&D', 'A!B', 'B!C', 'C!A', 'C!D', 'B!A', 'C!B', 'A!C', 'C!D');
  I80   : array [0..15] of string = ('OUT=CS', 'OUT=C', 'A=IN', 'C=IN', 'UNCNFG', 'CONFIG', 'C=ID', 'SHUTDN', '', 'C+P+1', 'RESET', 'BUSCC', 'C=P', 'P=C', 'SREQ?', 'CPEX');
  I808  : array [0..15] of string = ('INTON', 'RSI', 'LA ', 'BUSCB', 'ABIT=0', 'ABIT=1', '?ABIT=0', '?ABIT=1', 'CBIT=0', 'CBIT=1', '?CBIT=0', '?CBIT=1', 'PC=(A)', 'BUSCD', 'PC=(C)', 'INTOFF');
  I81   : array [0..15] of string = ('ASLC', 'BSLC', 'CSLC', 'DSLC', 'ASRC', 'BSRC', 'CSRC', 'DSRC', '', '', '', '', 'ASRB.W', 'BSRB.W', 'CSRB.W', 'DSRB.W');
  I818  : array [0..15] of string = ('A=A+', 'B=B+', 'C=C+', 'D=D+', '', '', '', '', 'A=A-', 'B=B-', 'C=C-', 'D=D-', '', '', '', '');
  I819  : array [0..15] of string = ('ASRB', 'BSRB', 'CSRB', 'DSRB', '', '', '', '', '', '', '', '', '', '', '', '');
  I81B  : array [0..15] of string = ('', '', 'PC=A', 'PC=C', 'A=PC', 'C=PC', 'APCEX', 'CPCEX', '', '', '', '', '', '', '', '');
  I8081 : array [0..15] of string = ('RSI', 'LOADFile', 'SAVEFile', 'DebugBreak', '', '', '', '', '', '', '', '', '', '', '', '');
  function GetValue(i, s: integer): integer;
  Begin
    result:= 0;
    while s>0 do
    Begin
      result:=b[i+s-1]+result*16;
      dec(s);
    end;
  End;
  function GetValue2(i: integer): integer;
  Begin
    result:= GetValue(i,2);
  end;
  Function GetValue3(i: integer): integer;
  Begin
    result:= GetValue(i,3);
  end;
  function GetValue4(i: integer): integer;
  Begin
    result:= GetValue(i,4);
  end;
  Function GetValue5(i: integer): integer;
  Begin
    result:= GetValue(i,5);
  end;
  Function PerfTest(i: integer): string;
  Begin
    if GetValue2(i)=0 then
      result:= result+ ' RTY'
    else
      If GetValue2(i)< $80 then
      Begin
        Result := ' -> .'+IntToHex(adr+i+GetValue2(i),5);
        if GotoStringList<>nil then
          GotoStringList.Add(IntToHex(adr+i+GetValue2(i),5));
      end else Begin
        Result := ' -> .'+IntToHex((adr+i+$fff00+GetValue2(i)) and $fffff,5);
        if GotoStringList<>nil then
          GotoStringList.Add(IntToHex((adr+i+$fff00+GetValue2(i)) and $fffff,5));
      end;
    if (i=1) and (result[2]='-') then
      result:= copy(result, 5, maxint); 
    adr:= adr+2;
  end;
var
  j: integer;
begin
  case b[0] of    //
    0: if b[1]=14 then
       begin
         result:=Logic[b[3]]+Field[b[2]];
         adr:= adr+4;
       end else begin
         Result := Op0[b[1]];
         adr:= adr+2;
       end;
    1: case b[1] of    //
         0: if b[2]<=7 then begin adr:= adr+3;
              result:='R'+IntToStr(b[2] and (7))+'=A.W'
            end else begin adr:=adr+3;
              result:='R'+IntToStr(b[2] and (7))+'=C.W'; end;
         1: if b[2]<=7 then begin adr:=adr+3;
              result:='A=R'+IntToStr(b[2] and (7))+'.W'
            end else begin adr:= adr+3;
              result:='C=R'+IntToStr(b[2] and (7))+'.W'; end;
         2: if b[2]<=7 then begin adr:=adr+3;
              result:='AR'+IntToStr(b[2] and (7))+'EX.W'
            end else begin adr:= adr+3;
              result:='C'+IntToStr(b[2] and (7))+'EX.W'; end;
         3: begin result := Op13[b[2]]; adr:= adr+3; end;
         4: if b[2]<8 then begin adr:=adr+3;
              result:=Op14[b[2] and $7]+'.A'
            end else begin adr:=adr+3;
              result:=Op14[b[2] and $7]+'.B'; end;
         5: if b[2]<8 then begin adr:=adr+4;
              result:=Op14[b[2] and $7]+Field[b[3]]
            end else begin adr:=adr+4;
              result:=Op14[b[2] and $7]+'.'+IntToStr(b[3]+1); end;
         6: begin Result := 'D0+'+IntToStr(b[2]+1);           adr:= adr+3; end;
         7: begin Result := 'D1+'+IntToStr(b[2]+1);           adr:= adr+3; end;
         8: begin Result := 'D0-'+IntToStr(b[2]+1);           adr:= adr+3; end;
         9: begin Result := 'D0='+IntToHex(GetValue2(2),2);   adr:= adr+4; end;
        10: begin Result := 'D0='+IntToHex(GetValue4(2),4);   adr:= adr+6; end;
        11: begin Result := 'D0='+IntToHex(GetValue5(2),5);   adr:= adr+7; end;
        12: begin Result := 'D1-'+IntToStr(b[2]+1);           adr:= adr+3; end;
        13: begin Result := 'D1='+IntToHex(GetValue2(2),2);   adr:= adr+4; end;
        14: begin Result := 'D1='+IntToHex(GetValue4(2),4);   adr:= adr+6; end;
        15: begin Result := 'D1='+IntToHex(GetValue5(2),5);   adr:= adr+7; end;
    end;    //case
    2: Begin Result := 'P='+IntToStr(b[1]); adr:= adr+2; end;
    3: Begin Result := '';
         for j := 0 to b[1] do    //Iterate
           Result := IntToHex(b[2+j],1)+Result;
         Result := 'LC '+Result;
         adr:= adr+3+b[1];
       End;
    4: begin
       if b[1]+b[2]=0 then
       Begin
         Result := 'RTNC';
         adr:= adr+2;
       end else
         result:= 'GOC '+ PerfTest(1);
       adr:= adr+1;
       end;
    5: begin
       if b[1]+b[2]=0 then
       begin
         Result := 'RTNNC';
         adr:= adr+2;
       end else
         result:= 'GONC '+ PerfTest(1);
       adr:= adr+1;
       end;
    6: begin
       If GetValue3(1)< $800 then begin
         Result := 'GOTO '+IntToHex(adr+1+GetValue3(1),5);
         if GotoStringList<>nil then
           GotoStringList.add(IntToHex(adr+1+GetValue3(1),5));
       end else begin
         Result := 'GOTO '+IntToHex((adr+1+$ff000+GetValue3(1)) and $fffff,5);
         if GotoStringList<>nil then
           GotoStringList.add(IntToHex((adr+1+$ff000+GetValue3(1)) and $fffff,5));
       end;
       adr:= adr+4;
       end;
    7: begin
       If GetValue3(1)< $800 then
       begin
         Result := 'GOSUB '+IntToHex(adr+1+GetValue3(1),5);
         if GotoStringList<>nil then
           GotoStringList.add(IntToHex(adr+1+GetValue3(1),5));
       end else begin
         Result := 'GOSUB '+IntToHex((adr+1+$ff000+GetValue3(1)) and $fffff,5);
         if GotoStringList<>nil then
           GotoStringList.add(IntToHex((adr+1+$ff000+GetValue3(1)) and $fffff,5));
       end;
       adr:= adr+4;
       end;
    8: case b[1] of
         0: if b[2] = 8 then
            Begin
              Result:= I808[b[3]];
              adr:= adr+4;
              case b[3] of
                1: begin Result:= I8081[b[4]]; adr:= adr+2; end;
                2: Begin Result := '';
                     for j := 0 to b[4] do    //Iterate
                       Result := IntToHex(b[5+j],1)+Result;
                     Result := 'LA '+Result;
                     adR:= adr+ 2+ b[4];
                   End;
                4,5,8,9: begin result:= result+'.'+IntToStr(b[4]); adr:= adr+1; end;
                6,7,$A,$B: begin result:= result+'.'+IntToStr(b[4])+PerfTest(5); adr:= adr+1; end;
              end;
            end else begin
              result:= I80[b[2]];
              adr:= adr+3;
              if b[2] in [$D, $C, $F] then
              Begin adr:= adr+1;
                result:= result+'.'+inttostr(b[3]);
              end;
            end;
         1: Case b[2] of
              8: Begin result:= I818[b[4]]+IntToStr(b[5]+1)+Field[b[3]]; adr:= adr+6; end;
              9: begin Result:= I819[b[4]]+Field[b[3]]; adr:= adr+ 5; end;
              $A: begin adr:= adr+6;
                  case b[4] of
                   0: if b[5]<=7 then
                        result:='R'+IntToStr(b[5] and (7))+'=A'+Field[b[3]]
                      else
                        result:='R'+IntToStr(b[5] and (7))+'=C'+Field[b[3]];
                   1: if b[5]<=7 then
                        result:='A=R'+IntToStr(b[5] and (7))+Field[b[3]]
                      else
                        result:='C=R'+IntToStr(b[5] and (7))+Field[b[3]];
                   2: if b[5]<=7 then
                        result:='AR'+IntToStr(b[5] and (7))+'EX'+Field[b[3]]
                      else
                        result:='C'+IntToStr(b[5] and (7))+'EX'+Field[b[3]];
                  end;
                  end;
              $B: Begin Result:= I81B[b[3]]; adr:= adr+4; end;
              else begin result:= I81[B[2]]; adr:= adr+3; end;
            end;
         2: begin Result:= 'HST=0.'+IntToStr(b[2]);              adr:= adr+3; end;
         3: begin Result:= '?HST=0.'+IntToStr(b[2])+PerfTest(3); adr:= adr+3; end;
         4: begin Result:= 'ST=0.'+IntToStr(b[2]);               adr:= adr+3; end;
         5: begin Result:= 'ST=1.'+IntToStr(b[2]);               adr:= adr+3; end;
         6: begin Result:= '?ST=0.'+IntToStr(b[2])+PerfTest(3);  adr:= adr+3; end;
         7: begin Result:= '?ST=1.'+IntToStr(b[2])+PerfTest(3);  adr:= adr+3; end;
         8: begin Result:= '?P#'+IntToStr(b[2])+PerfTest(3);     adr:= adr+3; end;
         9: begin Result:= '?P='+IntToStr(b[2])+PerfTest(3);     adr:= adr+3; end;
        $A: begin Result:= Tests[b[2]]+'.A'+PerfTest(3);          adr:= adr+3; end;
        $B: begin Result:= Tests[b[2]+16]+'.A'+PerfTest(3);       adr:= adr+3; end;
        $C: begin
            If GetValue4(2)< $8000 then begin
              Result := 'GOTOL '+IntToHex(adr+2+GetValue4(2),5);
              if GotoStringList<>nil then
                GotoStringList.add(IntToHex(adr+2+GetValue4(2),5));
            end else begin
              Result := 'GOTOL '+IntToHex((adr+2+$f0000+GetValue4(2)) and $fffff,5);
              if GotoStringList<>nil then
                GotoStringList.add(IntToHex((adr+2+$f0000+GetValue4(2)) and $fffff,5));
            end;
            adr:= adr+6;
            end;
        $D: begin result:= 'GOVLNG '+IntToHex(GetValue5(2),5); adr:= adr+7;
              if GotoStringList<>nil then
                GotoStringList.add(IntToHex(GetValue5(2),5));
            end;
        $E: begin
            If GetValue4(2)< $8000 then begin
              Result := 'GOSUBL '+IntToHex(adr+6+GetValue4(2),5);
              if GotoStringList<>nil then
                GotoStringList.add(IntToHex(adr+2+GetValue4(2),5));
            end else begin
              Result := 'GOSUBL '+IntToHex((adr+6+$f0000+GetValue4(2)) and $fffff,5);
              if GotoStringList<>nil then
                GotoStringList.add(IntToHex((adr+6+$f0000+GetValue4(2)) and $fffff,5));
            end;
            adr:= adr+6;
            end;
        $F: begin result:= 'GOSBVL '+IntToHex(GetValue5(2),5);
              if GotoStringList<>nil then
                GotoStringList.add(IntToHex(GetValue5(2),5));
              adr:= adr+7;
            end;
       end;
    9: begin result:= Tests[b[2]+(b[1] and $8)*2]+Field[b[1] and $7]+PerfTest(3); adr:= adr+3; end;
   10: begin adr:= adr+3;
       if b[1]<8 then
         Result := Opm1[b[2]]+Field[b[1]]
       Else
         Result := Opm2[b[2]]+Field[b[1]-8];
       end;
   11: begin adr:= adr+3;
       if b[1]<8 then
         Result := Opm3[b[2]]+Field[b[1]]
       Else
         Result := Opm4[b[2]]+Field[b[1]-8];
       end;
   12: Begin adr:= adr+2; Result := Opm1[b[1]]+'.A'; end;
   13: Begin adr:= adr+2; Result := Opm2[b[1]]+'.A'; end;
   14: Begin adr:= adr+2; Result := Opm3[b[1]]+'.A'; end;
   15: Begin adr:= adr+2; Result := Opm4[b[1]]+'.A'; end;
  end;    //case
end;

end.
