unit HtmlHelpAPI;
{
  Conversion of HtmlHelpAPI header, Copyright (C) 2003, William G. Graves. All rights reserved.
  Used a header converter to start with on June 10, 2003
}

interface

uses
  Windows, Commctrl;

// Commands to pass to HtmlHelp()
const
  HH_DISPLAY_TOPIC = $0000;
  HH_HELP_FINDER = $0000; // WinHelp equivalent
  HH_DISPLAY_TOC = $0001;
  HH_DISPLAY_INDEX = $0002;
  HH_DISPLAY_SEARCH = $0003;
  HH_SET_WIN_TYPE = $0004;
  HH_GET_WIN_TYPE = $0005;
  HH_GET_WIN_HANDLE = $0006;
  HH_ENUM_INFO_TYPE = $0007;            // Get Info type name, call repeatedly to enumerate, -1 at end
  HH_SET_INFO_TYPE = $0008;             // Add Info type to filter.
  HH_SYNC = $0009;
  HH_RESERVED1 = $000A;
  HH_RESERVED2 = $000B;
  HH_RESERVED3 = $000C;
  HH_KEYWORD_LOOKUP = $000D;
  HH_DISPLAY_TEXT_POPUP = $000E;        // display string resource id or text in a popup window
  HH_HELP_CONTEXT = $000F;              // display mapped numeric value in dwData
  HH_TP_HELP_CONTEXTMENU = $0010;       // text popup help, same as WinHelp HELP_CONTEXTMENU
  HH_TP_HELP_WM_HELP = $0011;           // text popup help, same as WinHelp HELP_WM_HELP
  HH_CLOSE_ALL = $0012;                 // close all windows opened directly or indirectly by the caller
  HH_ALINK_LOOKUP = $0013;              // ALink version of HH_KEYWORD_LOOKUP
  HH_GET_LAST_ERROR = $0014;            // not currently implemented // See HHERROR.h
  HH_ENUM_CATEGORY = $0015;             // Get category name, call repeatedly to enumerate, -1 at end
  HH_ENUM_CATEGORY_IT = $0016;          // Get category info type members, call repeatedly to enumerate, -1 at end
  HH_RESET_IT_FILTER = $0017;           // Clear the info type filter of all info types.
  HH_SET_INCLUSIVE_FILTER = $0018;      // set inclusive filtering method for untyped topics to be included in display
  HH_SET_EXCLUSIVE_FILTER = $0019;      // set exclusive filtering method for untyped topics to be excluded from display
  HH_INITIALIZE = $001C;                // Initializes the help system.
  HH_UNINITIALIZE = $001D;              // Uninitializes the help system.
  HH_PRETRANSLATEMESSAGE = $00fd;       // Pumps messages. (NULL, NULL, MSG* ).
  HH_SET_GLOBAL_PROPERTY = $00fc;       // Set a global property. (NULL, NULL, HH_GPROP)

  HHWIN_PROP_TAB_AUTOHIDESHOW = (1 shl 0); // Automatically hide/show tri-pane window
  HHWIN_PROP_ONTOP = (1 shl 1);         // Top-most window
  HHWIN_PROP_NOTITLEBAR = (1 shl 2);    // no title bar
  HHWIN_PROP_NODEF_STYLES = (1 shl 3); // no default window styles (only HH_WINTYPE.dwStyles)
  HHWIN_PROP_NODEF_EXSTYLES = (1 shl 4); // no default extended window styles (only HH_WINTYPE.dwExStyles)
  HHWIN_PROP_TRI_PANE = (1 shl 5);      // use a tri-pane window
  HHWIN_PROP_NOTB_TEXT = (1 shl 6);     // no text on toolbar buttons
  HHWIN_PROP_POST_QUIT = (1 shl 7);     // post WM_QUIT message when window closes
  HHWIN_PROP_AUTO_SYNC = (1 shl 8);     // automatically ssync contents and index
  HHWIN_PROP_TRACKING = (1 shl 9);      // send tracking notification messages
  HHWIN_PROP_TAB_SEARCH = (1 shl 10);   // include search tab in navigation pane
  HHWIN_PROP_TAB_HISTORY = (1 shl 11);  // include history tab in navigation pane
  HHWIN_PROP_TAB_FAVORITES = (1 shl 12); // include favorites tab in navigation pane
  HHWIN_PROP_CHANGE_TITLE = (1 shl 13); // Put current HTML title in title bar
  HHWIN_PROP_NAV_ONLY_WIN = (1 shl 14); // Only display the navigation window
  HHWIN_PROP_NO_TOOLBAR = (1 shl 15);   // Don't display a toolbar
  HHWIN_PROP_MENU = (1 shl 16); // Menu
  HHWIN_PROP_TAB_ADVSEARCH = (1 shl 17); // Advanced FTS UI.
  HHWIN_PROP_USER_POS = (1 shl 18);     // After initial creation, user controls window size/position
  HHWIN_PROP_TAB_CUSTOM1 = (1 shl 19);  // Use custom tab #1
  HHWIN_PROP_TAB_CUSTOM2 = (1 shl 20);  // Use custom tab #2
  HHWIN_PROP_TAB_CUSTOM3 = (1 shl 21);  // Use custom tab #3
  HHWIN_PROP_TAB_CUSTOM4 = (1 shl 22);  // Use custom tab #4
  HHWIN_PROP_TAB_CUSTOM5 = (1 shl 23);  // Use custom tab #5
  HHWIN_PROP_TAB_CUSTOM6 = (1 shl 24);  // Use custom tab #6
  HHWIN_PROP_TAB_CUSTOM7 = (1 shl 25);  // Use custom tab #7
  HHWIN_PROP_TAB_CUSTOM8 = (1 shl 26);  // Use custom tab #8
  HHWIN_PROP_TAB_CUSTOM9 = (1 shl 27);  // Use custom tab #9
  HHWIN_TB_MARGIN = (1 shl 28);         // the window type has a margin

  HHWIN_PARAM_PROPERTIES = (1 shl 1);   // valid fsWinProperties
  HHWIN_PARAM_STYLES = (1 shl 2);       // valid dwStyles
  HHWIN_PARAM_EXSTYLES = (1 shl 3);     // valid dwExStyles
  HHWIN_PARAM_RECT = (1 shl 4);         // valid rcWindowPos
  HHWIN_PARAM_NAV_WIDTH = (1 shl 5);    // valid iNavWidth
  HHWIN_PARAM_SHOWSTATE = (1 shl 6);    // valid nShowState
  HHWIN_PARAM_INFOTYPES = (1 shl 7);    // valid apInfoTypes
  HHWIN_PARAM_TB_FLAGS = (1 shl 8);     // valid fsToolBarFlags
  HHWIN_PARAM_EXPANSION = (1 shl 9);    // valid fNotExpanded
  HHWIN_PARAM_TABPOS = (1 shl 10);      // valid tabpos
  HHWIN_PARAM_TABORDER = (1 shl 11);    // valid taborder
  HHWIN_PARAM_HISTORY_COUNT = (1 shl 12); // valid cHistory
  HHWIN_PARAM_CUR_TAB = (1 shl 13);     // valid curNavType

  HHWIN_BUTTON_EXPAND = (1 shl 1);      // Expand/contract button
  HHWIN_BUTTON_BACK = (1 shl 2);        // Back button
  HHWIN_BUTTON_FORWARD = (1 shl 3);     // Forward button
  HHWIN_BUTTON_STOP = (1 shl 4);        // Stop button
  HHWIN_BUTTON_REFRESH = (1 shl 5);     // Refresh button
  HHWIN_BUTTON_HOME = (1 shl 6);        // Home button
  HHWIN_BUTTON_BROWSE_FWD = (1 shl 7); // not implemented
  HHWIN_BUTTON_BROWSE_BCK = (1 shl 8); // not implemented
  HHWIN_BUTTON_NOTES = (1 shl 9);       // not implemented
  HHWIN_BUTTON_CONTENTS = (1 shl 10); // not implemented
  HHWIN_BUTTON_SYNC = (1 shl 11);       // Sync button
  HHWIN_BUTTON_OPTIONS = (1 shl 12); // Options button
  HHWIN_BUTTON_PRINT = (1 shl 13);      // Print button
  HHWIN_BUTTON_INDEX = (1 shl 14);      // not implemented
  HHWIN_BUTTON_SEARCH = (1 shl 15);     // not implemented
  HHWIN_BUTTON_HISTORY = (1 shl 16);    // not implemented
  HHWIN_BUTTON_FAVORITES = (1 shl 17);  // not implemented
  HHWIN_BUTTON_JUMP1 = (1 shl 18);
  HHWIN_BUTTON_JUMP2 = (1 shl 19);
  HHWIN_BUTTON_ZOOM = (1 shl 20);
  HHWIN_BUTTON_TOC_NEXT = (1 shl 21);
  HHWIN_BUTTON_TOC_PREV = (1 shl 22);

  HHWIN_DEF_BUTTONS = HHWIN_BUTTON_EXPAND  Or HHWIN_BUTTON_BACK
                   Or HHWIN_BUTTON_OPTIONS Or HHWIN_BUTTON_PRINT;

// Button IDs
  IDTB_EXPAND = 200;
  IDTB_CONTRACT = 201;
  IDTB_STOP = 202;
  IDTB_REFRESH = 203;
  IDTB_BACK = 204;
  IDTB_HOME = 205;
  IDTB_SYNC = 206;
  IDTB_PRINT = 207;
  IDTB_OPTIONS = 208;
  IDTB_FORWARD = 209;
  IDTB_NOTES = 210;                     // not implemented
  IDTB_BROWSE_FWD = 211;
  IDTB_BROWSE_BACK = 212;
  IDTB_CONTENTS = 213;                  // not implemented
  IDTB_INDEX = 214;                     // not implemented
  IDTB_SEARCH = 215;                    // not implemented
  IDTB_HISTORY = 216;                   // not implemented
  IDTB_FAVORITES = 217;                 // not implemented
  IDTB_JUMP1 = 218;
  IDTB_JUMP2 = 219;
  IDTB_CUSTOMIZE = 221;
  IDTB_ZOOM = 222;
  IDTB_TOC_NEXT = 223;
  IDTB_TOC_PREV = 224;

// Notification codes }
  HHN_FIRST = -860;
  HHN_LAST = -879;

  HHN_NAVCOMPLETE = (HHN_FIRST-0);
  HHN_TRACK = (HHN_FIRST-1);
  HHN_WINDOW_CREATE = (HHN_FIRST-2);

type
  tagHHN_NOTIFY = packed record
    hdr: NMHDR;
    pszUrl: LPCSTR;
  end;
  HHN_NOTIFY = tagHHN_NOTIFY;
  THHNNotify = tagHHN_NOTIFY;
  PHHNNotify = ^THHNNotify;

type
  tagHH_POPUP = packed record
    cbStruct: Integer; 
    hinst: HINST; 
    idString: UINT; 
    pszText: LPCTSTR; 
    pt: TPoint;  
    clrForeGround: TColorRef; 
    clrBackground: TColorRef; 
    rcMargins: TRect;
    pszFont: LPCTSTR; 
  end;
  HH_POPUP = tagHH_POPUP;
  THHPopup = tagHH_POPUP;
  PHHPopup = ^THHPopup;

type
  tagHH_AKLINK = packed record
    cbStruct: Integer;  
    fReserved: BOOL;  
    pszKeywords: LPCTSTR;
    pszUrl: LPCTSTR; 
    pszMsgText: LPCTSTR; 
    pszMsgTitle: LPCTSTR;
    pszWindow: LPCTSTR;
    fIndexOnFail: BOOL; 
  end;
  HH_AKLINK = tagHH_AKLINK;
  THHAKLink = tagHH_AKLINK;
  PHHAKLink = ^THHAKLink;
    
type
  tagHH_ENUM_IT_CatEnum = (
    HHWIN_NAVTYPE_TOC,
    HHWIN_NAVTYPE_INDEX, 
    HHWIN_NAVTYPE_SEARCH, 
    HHWIN_NAVTYPE_FAVORITES, 
    HHWIN_NAVTYPE_HISTORY, 
    HHWIN_NAVTYPE_AUTHOR, 
    HHWIN_NAVTYPE_CUSTOM_FIRST= 11 );

type
  tagHH_ENUM_IT_TypeEnum = (
    IT_INCLUSIVE, 
    IT_EXCLUSIVE, 
    IT_HIDDEN );

type
  tagHH_ENUM_IT = packed record
    cbStruct: Integer; 
    iType: Integer;                     // Inclusive, Exclusive, or Hidden
    pszCatName: LPCSTR;                 // Category enumerate
    pszITName: LPCSTR; 
    pszITDescription: LPCSTR;
  end;
  HH_ENUM_IT = tagHH_ENUM_IT;
  PHH_ENUM_IT = ^tagHH_ENUM_IT;
  THHEnumIT = tagHH_ENUM_IT;
  PHHEnumIT = ^THHEnumIT;

type
  tagHH_ENUM_CAT = packed record
    cbStruct: Integer;  
    pszCatName: LPCSTR;                 // Category enumerate
    pszCatDescription: LPCSTR;          // Category Description
  end;
  HH_ENUM_CAT = tagHH_ENUM_CAT;
  PHH_ENUM_CAT = ^tagHH_ENUM_CAT;
  THHEnumCat = tagHH_ENUM_CAT;
  PHHEnumCat = ^THHEnumCat;

type
  tagHH_SET_INFOTYPE = packed record
    cbStruct: Integer; 
    pszCatName: LPCSTR;
    pszInfoTypeName: LPCSTR;
  end;
  HH_SET_INFOTYPE = tagHH_SET_INFOTYPE;
  PHH_SET_INFOTYPE = ^tagHH_SET_INFOTYPE;
  THHSetInfoType = tagHH_SET_INFOTYPE;
  PHHSetInfoType = ^THHSetInfoType;

type
  HH_INFOTYPE = DWORD;
  PHH_INFOTYPE = ^HH_INFOTYPE;
  PHHInfoType = ^THHInfoType;
  THHInfoType = HH_INFOTYPE;

type
  tagHH_FTS_QUERY_NavEnum = (
    HHWIN_NAVTAB_TOP,
    HHWIN_NAVTAB_LEFT,
    HHWIN_NAVTAB_BOTTOM );

const
  HH_MAX_TABS = 19;                     // maximum number of tabs

type
  tagHH_FTS_QUERY_TabEnum = (
    HH_TAB_CONTENTS,
    HH_TAB_INDEX,
    HH_TAB_SEARCH,
    HH_TAB_FAVORITES,
    HH_TAB_HISTORY,
    HH_TAB_AUTHOR,
    HH_TAB_CUSTOM_FIRST = 11,
    HH_TAB_CUSTOM_LAST = HH_MAX_TABS );

const
  HH_MAX_TABS_CUSTOM = ord(HH_TAB_CUSTOM_LAST) - ord(HH_TAB_CUSTOM_FIRST) + 1;

// HH_DISPLAY_SEARCH Command Related Structures and Constants 
const
  HH_FTS_DEFAULT_PROXIMITY = -1;
type
  tagHH_FTS_QUERY = packed record
    cbStruct: Integer; 
    fUniCodeStrings: BOOL;
    pszSearchQuery: LPCTSTR;
    iProximity: LongInt; 
    fStemmedSearch: BOOL;
    fTitleOnly: BOOL;
    fExecute: BOOL; 
    pszWindow: LPCTSTR; 
  end;
  HH_FTS_QUERY = tagHH_FTS_QUERY;
  THHFtsQuery = tagHH_FTS_QUERY;
  PHHFtsQuery = ^THHFtsQuery;

// HH_WINTYPE Structure
type
  tagHH_WINTYPE = packed record
    cbStruct: Integer;
    fUniCodeStrings: BOOL;
    pszType: LPCTSTR; 
    fsValidMembers: DWORD;
    fsWinProperties: DWORD; 
    pszCaption: LPCTSTR;
    dwStyles: DWORD; 
    dwExStyles: DWORD;
    rcWindowPos: TRect;
    nShowState: Integer;
    hwndHelp: HWND; 
    hwndCaller: HWND;       
    paInfoTypes: PHHInfoType;
    // The following members are only valid if HHWIN_PROP_TRI_PANE is set 
    hwndToolBar: HWND;
    hwndNavigation: HWND;
    hwndHTML: HWND;
    iNavWidth: Integer;
    rcHTML: TRect;
    pszToc: LPCTSTR;
    pszIndex: LPCTSTR;
    pszFile: LPCTSTR;
    pszHome: LPCTSTR;
    fsToolBarFlags: DWORD;
    fNotExpanded: BOOL;
    curNavType: Integer;
    tabpos: Integer;
    idNotify: Integer;
    tabOrder: array[0..HH_MAX_TABS] of Byte;
    cHistory: Integer;
    pszJump1: LPCTSTR;
    pszJump2: LPCTSTR;
    pszUrlJump1: LPCTSTR;
    pszUrlJump2: LPCTSTR;
    rcMinSize: TRect;
    cbInfoTypes: Integer;
    pszCustomTabs: LPCTSTR; 
  end;
  HH_WINTYPE = tagHH_WINTYPE;
  PHH_WINTYPE = ^tagHH_WINTYPE;
  THHWinType = tagHH_WINTYPE;
  PHHWinType = ^THHWinType;

type
  tagHHNTRACK_Enum = (
    HHACT_TAB_CONTENTS, 
    HHACT_TAB_INDEX, 
    HHACT_TAB_SEARCH, 
    HHACT_TAB_HISTORY, 
    HHACT_TAB_FAVORITES, 
    HHACT_EXPAND, 
    HHACT_CONTRACT, 
    HHACT_BACK, 
    HHACT_FORWARD, 
    HHACT_STOP, 
    HHACT_REFRESH, 
    HHACT_HOME, 
    HHACT_SYNC, 
    HHACT_OPTIONS, 
    HHACT_PRINT, 
    HHACT_HIGHLIGHT, 
    HHACT_CUSTOMIZE, 
    HHACT_JUMP1, 
    HHACT_JUMP2, 
    HHACT_ZOOM, 
    HHACT_TOC_NEXT, 
    HHACT_TOC_PREV,
    HHACT_NOTES, 
    HHACT_LAST_ENUM );

type
  tagHHNTRACK = packed record
    hdr: NMHDR;
    pszCurUrl: LPCSTR;
    idAction: Integer; 
    phhWinType: PHHWinType; 
  end;
  HHNTRACK = tagHHNTRACK;
  THHNTrack = tagHHNTRACK;
  PHHNTrack = ^THHNTrack;

type
  CSTR = PAnsiChar;
  CWSTR = PWideChar;
  DWORD_PTR = DWORD;

function HtmlHelpA(hwndCaller: HWND; pszFile: PAnsiChar; uCommand: UINT; dwData: DWORD_PTR): HWND; stdcall;
function HtmlHelpW(hwndCaller: HWND; pszFile: PWideChar; uCommand: UINT; dwData: DWORD_PTR): HWND; stdcall;
function HtmlHelp( hwndCaller: HWND; pszFile: PChar;     uCommand: UINT; dwData: DWORD_PTR): HWND; stdcall;

const
  // Use the following for GetProcAddress to load from hhctrl.ocx
  ATOM_HTMLHELP_API_ANSI = LPTSTR(DWORD(WORD(14)));
  ATOM_HTMLHELP_API_UNICODE = LPTSTR(DWORD(WORD(15)));

////////////////////////////////////////////////////////////////////////////////
//
// Global Control Properties.
//
type
  tagHH_GPROPID = (
    HH_GPROPID_SINGLETHREAD=1,
    HH_GPROPID_TOOLBAR_MARGIN=2,
    HH_GPROPID_UI_LANGUAGE=3,
    HH_GPROPID_CURRENT_SUBSET=4,
    HH_GPROPID_CONTENT_LANGUAGE=5 );

  THHGPropID = tagHH_GPROPID;

///////////////////////////////////////////////////////////////////////////////
// 
// Global Property structure
//
type
  tagHH_GLOBAL_PROPERTY = record
    id: THHGPropID;
    Dummy: Integer;               // because of packing problem
    var_: OleVariant;             // MS has VARIANT
  end;
  HH_GLOBAL_PROPERTY = tagHH_GLOBAL_PROPERTY;
  THHGlobalProperty = tagHH_GLOBAL_PROPERTY;
  PHHGlobalProperty = ^THHGlobalProperty;

const
  hhctrldll = 'hhctrl.ocx';
  
function HtmlHelpA; external hhctrldll Name 'HtmlHelpA';
function HtmlHelpW; external hhctrldll Name 'HtmlHelpW';
function HtmlHelp;  external hhctrldll Name 'HtmlHelpA';

implementation

end.
