unit fmDebugEMU;

interface

uses
  Windows, Messages, Controls, Forms,
  Spin, StdCtrls, Debug, ActnList, WindowsPosSave, CDBShUtils, ExtCtrls, Classes;

type
  TfrmDebugEMU = class(TForm)
    RST0: TCheckBox;
    RST1: TCheckBox;
    RST2: TCheckBox;
    RST3: TCheckBox;
    RST4: TCheckBox;
    RST5: TCheckBox;
    RST6: TCheckBox;
    RST7: TCheckBox;
    RST8: TCheckBox;
    RST9: TCheckBox;
    RST10: TCheckBox;
    RST11: TCheckBox;
    RST12: TCheckBox;
    RST13: TCheckBox;
    RST14: TCheckBox;
    RST15: TCheckBox;
    RHST0: TCheckBox;
    RHST1: TCheckBox;
    RHST2: TCheckBox;
    RHST3: TCheckBox;
    Label10: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    RCarry: TCheckBox;
    RBinary: TCheckBox;
    Button1: TButton;
    Button2: TButton;
    CheckBox1: TCheckBox;
    Button3: TButton;
    ActionList1: TActionList;
    ActionStepOver: TAction;
    ActionStepIn: TAction;
    ActionContinue: TAction;
    ActionStop: TAction;
    Button4: TButton;
    WindowPosSave1: TWindowPosSave;
    CheckBox2: TCheckBox;
    Button6: TButton;
    Button7: TButton;
    Button10: TButton;
    CheckBox3: TCheckBox;
    RTicks: TLabel;
    ListBox1: TListBox;
    RTime: TLabel;
    HexaView1: THexaView;
    RA: TEditLabel;
    RB: TEditLabel;
    RC: TEditLabel;
    RD: TEditLabel;
    RR0: TEditLabel;
    RR1: TEditLabel;
    RR2: TEditLabel;
    RR3: TEditLabel;
    RR4: TEditLabel;
    RPC: TEditLabel;
    RD0: TEditLabel;
    RD1: TEditLabel;
    RRSTK1: TEditLabel;
    RRSTK2: TEditLabel;
    RRSTK3: TEditLabel;
    RRSTK4: TEditLabel;
    RRSTK5: TEditLabel;
    RRSTK6: TEditLabel;
    RRSTK7: TEditLabel;
    RRSTK0: TEditLabel;
    RP: TEditLabel;
    RV1: TEditLabel;
    RV2: TEditLabel;
    tedMemory: TEditLabel;
    RCRC: TEditLabel;
    RV148: TEditLabel;
    RV248: TEditLabel;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Button5Click(Sender: TObject);
    procedure ActionStepOverExecute(Sender: TObject);
    procedure ActionStepInExecute(Sender: TObject);
    procedure ActionContinueExecute(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure CheckBox2Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure Button10Click(Sender: TObject);
    procedure CheckBox3Click(Sender: TObject);
    procedure ListBox1Click(Sender: TObject);
    function HexaView1Read(Sender: TObject; const adr: Integer): Byte;
    procedure RBEnter(Sender: TObject);
    procedure HexaView1Write(Sender: TObject; const adr: Integer;
                const Value: Byte; const Nibble: Boolean);
    procedure tedMemoryAfterKeyPress(Sender: TObject; var Key: Char);       // wgg
    procedure RPChange(Sender: TObject);
    procedure RBinaryClick(Sender: TObject);
    procedure RAKeyPress(Sender: TObject; var Key: Char);
 private
//    LastInstrAdr: integer;
    Update: boolean;                           // wgg for spinedit, True means do not process update
    LastCycles: int64;
    c2: TIChipset;
    cs: TIChipset;
    stt: array [0..19] of TCheckBox;
    Procedure InternalUpdate(var message: TMessage); message DebuggerMessage;
    procedure InternalUpdatePt;                      // wgg split away from InternalUpdate
    procedure SpinEnable;                    // wgg
  Public
    procedure setCalcModel;                          // wgg setup calc model differences
  end;

var
  frmDebugEMU: TfrmDebugEMU;

implementation

uses SysUtils, Graphics, fmCPUCompare, fmSourceEdit, FmProject, Math, Desasm;

{$R *.DFM}

// if the form closes, continue the emulation
procedure TfrmDebugEMU.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  ActionContinueExecute(Self);
end;

procedure TfrmDebugEMU.setCalcModel;              // wgg set model differences
var
  do48: boolean;
begin
  if Debugger.DebugType <> DtNone then
    if Debugger.CalcModel='X' then  do48:= false
    else do48:= true
  else
    do48:= frmProject.isCalc48;

  RV1.Visible:= Not do48;
  RV2.Visible:= Not do48;
  RV148.Visible:= do48;
  RV248.Visible:= do48;
end;

// Set the debugger.Chipset value according to the values displayed in the box
procedure TfrmDebugEMU.Button5Click(Sender: TObject);
var
  i: integer;
begin
  if (Not Debugger.InAsmStep) then exit;
    if (Sender<>Nil) And Self.Update then exit;
  try
    with debugger.Chipset do
    begin
      if RV1.Visible then                   // wgg check calc model
      begin
        RomV1:= RV1.Value;                  // HP49
        RomV2:= RV2.Value;
      end else begin
        RomV1:= RV148.Value;               // wgg HP48
        RomV2:= RV248.Value;
      end;
      d0:= RD0.Value;
      d1:= RD1.Value;
      pc:= RPC.Value;
      A :=RA. Value;
      B :=RB. Value;
      C :=RC. Value;
      D :=RD. Value;
      R0:=RR0.Value;
      R1:=RR1.Value;
      R2:=RR2.Value;
      R3:=RR3.Value;
      R4:=RR4.Value;
      CRC:=RCRC.Value;
      for i:= 0 to 15 do
        ST[i]:= stt[i].checked;
      for i:=0 to 3 do
        HST[i]:= stt[i+16].checked;
      P:= RP.value;
      Decimal:= RBinary.Checked;
      carry:= RCarry.Checked;
      Inte:= CheckBox1.Checked;
      rstk[7]:= RRSTK0.Value;
      rstk[6]:= RRSTK1.Value;
      rstk[5]:= RRSTK2.Value;
      rstk[4]:= RRSTK3.Value;
      rstk[3]:= RRSTK4.Value;
      rstk[2]:= RRSTK5.Value;
      rstk[1]:= RRSTK6.Value;
      rstk[0]:= RRSTK7.Value;
    end;
    Debugger.SaveChipset;
  except
  end;
end;

// Set the values displayed in the box according to the values in the emulator
procedure TfrmDebugEMU.InternalUpdatePt;                      // wgg split away from InternalUpdate
var
  i, v : integer;
  LInstr: TLinstr;
  str: TStringList;
  buf: array [0..22] of byte;
  endi: integer;
  updSave: boolean;                                    // wgg
begin
  if Debugger.DebugType=DtNone then exit;              // wgg 
  Show;
  updSave:= self.update;
  self.Update:= true;  // wgg inhibit checks and retransmission of registers!!
  with debugger.Chipset do
  begin
    if Debugger.ZeroReturn then
      Application.MessageBox('Too many RSTK pop', 'Message', MB_OK);
    Debugger.EditAtAddress(pc, True);                                          // wgg added True for blue bar
    RPC.Value:= pc;
    RD0.value:=d0;
    RD1.value:=d1;
    RRSTK0.value:=rstk[7];
    RRSTK1.value:=rstk[6];
    RRSTK2.value:=rstk[5];
    RRSTK3.value:=rstk[4];
    RRSTK4.value:=rstk[3];
    RRSTK5.value:=rstk[2];
    RRSTK6.value:=rstk[1];
    RRSTK7.value:=rstk[0];
    RA.value:=A;
    RB.value:=B;
    RC.value:=C;
    RD.value:=D;
    RR0.value:=R0;
    RR1.value:=R1;
    RR2.value:=R2;
    RR3.value:=R3;
    RR4.value:=R4;
    for i:=0 to 15 do
      stt[i].checked:= ST[i];
    for i:=0 to 3 do
      stt[i+16].Checked:= HST[i];
    Rp.Value:=P;
    if RV1.Visible then                   // wgg check calc model
    begin
      RV1.Value:= RomV1;                  // HP49
      RV2.Value:= RomV2;
    end else begin
      RV148.Value:= RomV1;               // wgg HP48
      RV248.Value:= RomV2;
    end;
    RBinary.Checked:= Decimal;
    RCarry.Checked:= carry;
    CheckBox1.Checked:= Inte;
    HexaView1.Invalidate;
    RTicks.Caption:= 'Tk='+inttohex(Cycles,8);
    RTime.caption:= 'Ls='+inttohex(Cycles-LastCycles, 8);
    RCRC.Value:= CRC;
    LastCycles:= Cycles;
    if Cs.A<>A then RA.EditColor:= ClRed else Ra.EditColor:= ClBlack;
    if Cs.B<>B then RB.EditColor:= ClRed else RB.EditColor:= ClBlack;
    if Cs.C<>C then RC.EditColor:= ClRed else RC.EditColor:= ClBlack;
    if Cs.D<>D then RD.EditColor:= ClRed else RD.EditColor:= ClBlack;
    if Cs.R0<>R0 then RR0.EditColor:= ClRed else RR0.EditColor:= ClBlack;
    if Cs.R1<>R1 then RR1.EditColor:= ClRed else RR1.EditColor:= ClBlack;
    if Cs.R2<>R2 then RR2.EditColor:= ClRed else RR2.EditColor:= ClBlack;
    if Cs.R3<>R3 then RR3.EditColor:= ClRed else RR3.EditColor:= ClBlack;
    if Cs.R4<>R4 then RR4.EditColor:= ClRed else RR4.EditColor:= ClBlack;
    if Cs.D0<>D0 then RD0.EditColor:= ClRed else Rd0.EditColor:= ClBlack;
    if Cs.D1<>D1 then RD1.EditColor:= ClRed else RD1.EditColor:= ClBlack;
    if Cs.CRC<>CRC then RCRC.EditColor:= ClRed else RCRC.EditColor:= ClBlack;
    str:= TStringList.Create;
    LInstr:= Debugger.lastInstrs;
    endi:= High(LInstr);
    For i:=Low(LInstr) to endi do
    begin
      if LInstr[i]= pc then break;                         // wgg in case fresh start
      Debugger.ReadMemory(buf, LInstr[i], 22);
      v:= LInstr[i];
      str.Insert(0, InttoHex2(LInstr[i], 5)+' '+DeAsm(buf, v, nil));
    end;
    Debugger.ReadMemory(buf, pc, 22);
    v:= pc;
    str.Insert(0, InttoHex2(pc, 5)+' '+DeAsm(buf, v, nil));
    ListBox1.Items:= str;
    str.free;
//    if ActiveControl is TEdit then
//      TEdit(ActiveControl).OnEnter(ActiveControl);
  end;
  Cs:= Debugger.Chipset;
  self.Update:= updSave;               // wgg restore situation
end;

procedure TfrmDebugEMU.InternalUpdate(var message: TMessage);
begin
  InternalUpdatePt;
end;

// Step over
procedure TfrmDebugEMU.ActionStepOverExecute(Sender: TObject);
begin
  debugger.StepOverAsm;
end;

// Step In
procedure TfrmDebugEMU.ActionStepInExecute(Sender: TObject);
begin
  debugger.StepInAsm;
end;

procedure TfrmDebugEMU.SpinEnable;               // wgg
var
  b: boolean;
begin
  if Debugger.InAsmStep then b:= true
  else b:= false;
  RV1.Enabled:= b;
  RV2.Enabled:= b;
  RV148.Enabled:= b;
  RV248.Enabled:= b;
  RP.Enabled:= b;
end;

// Continue
procedure TfrmDebugEMU.ActionContinueExecute(Sender: TObject);
var
  i: integer;
begin
  Self.Update:= true;                             // wgg lock out any updating
  for i:=0 to ControlCount-1 do
    if Controls[i] is TEdit then
      TEdit(Controls[i]).text:= ''
    else
      if (Controls[i] is TCheckBox) and (TCheckBox(Controls[i]).tag=0) then
        TCheckBox(Controls[i]).checked:= false;
  ListBox1.Items.Clear;   
{  if Debugger.Asmdebug then
  begin       }
    Debugger.continueAsm;
    frmSourceEdit.ClearAdrsMark;                                            // wgg clear pc marker
    SpinEnable;            // wgg
    Self.Update:= false;
 { end; }
end;

// Enter in step by step mode
procedure TfrmDebugEMU.Button4Click(Sender: TObject);
begin
  Debugger.StopAsm;
  SpinEnable;            // wgg
end;

// creation and initialisation
procedure TfrmDebugEMU.FormCreate(Sender: TObject);
begin
  WindowPosSave1.ReadPos;
  stt[0]:= RST0;  stt[4]:= RST4;  stt[8]:= RST8;  stt[12]:= RST12;
  stt[1]:= RST1;  stt[5]:= RST5;  stt[9]:= RST9;  stt[13]:= RST13;
  stt[2]:= RST2;  stt[6]:= RST6;  stt[10]:= RST10;  stt[14]:= RST14;
  stt[3]:= RST3;  stt[7]:= RST7;  stt[11]:= RST11;  stt[15]:= RST15;
  stt[16]:= RHST0;  stt[17]:= RHST1;  stt[18]:= RHST2;  stt[19]:= RHST3;
  Debugger.OnAsmInstr:= handle;
end;

// propagate some values to the debugger
procedure TfrmDebugEMU.CheckBox2Click(Sender: TObject);
begin
  Debugger.DebugInt:= CheckBox2.Checked;
end;

// and backward
procedure TfrmDebugEMU.FormShow(Sender: TObject);
begin
  CheckBox2.Checked:= Debugger.DebugInt;
  CheckBox3.Checked:= Debugger.EraseStk;
end;

// Take a snapshot of the CPU
procedure TfrmDebugEMU.Button6Click(Sender: TObject);
begin
  C2:= Debugger.Chipset;
end;

// Compare previous snapshot with current value
procedure TfrmDebugEMU.Button7Click(Sender: TObject);
  Function str(a: integer): string;
  Begin
    result:= inttohex(a, 5);
  end;
  Function srr(a: int64): string;
  Begin
    result:= inttohex(a, 16);
  end;
  Function RCmp(a, b: int64): boolean;
  Begin
    result:= a<>b;
  end;
begin
  frmCPUCompare.Init;
  Debugger.GetChipset ;     // wgg get current chipset from emu
  with Debugger.Chipset do
  Begin
    if RomV1   <> C2.RomV1    then frmCPUCompare.Add('RomV1    '+str(C2.RomV1   )+' '+str(RomV1    ));
    if RomV2   <> C2.RomV2    then frmCPUCompare.Add('RomV2    '+str(C2.RomV2   )+' '+str(RomV2    ));
    if d0      <> C2.d0       then frmCPUCompare.Add('d0       '+str(C2.d0      )+' '+str(d0       ));
    if d1      <> C2.d1       then frmCPUCompare.Add('d1       '+str(C2.d1      )+' '+str(d1       ));
    if pc      <> C2.pc       then frmCPUCompare.Add('pc       '+str(C2.pc      )+' '+str(pc       ));
    if rcmp(A  ,  C2.A)       then frmCPUCompare.Add('A        '+srr(C2.A       )+' '+srr(A        ));
    if rcmp(B  ,  C2.B)       then frmCPUCompare.Add('B        '+srr(C2.B       )+' '+srr(B        ));
    if rcmp(C  ,  C2.C)       then frmCPUCompare.Add('C        '+srr(C2.C       )+' '+srr(C        ));
    if rcmp(D  ,  C2.D)       then frmCPUCompare.Add('D        '+srr(C2.D       )+' '+srr(D        ));
    if rcmp(R0 ,  C2.R0)      then frmCPUCompare.Add('R0       '+srr(C2.R0      )+' '+srr(R0       ));
    if rcmp(R1 ,  C2.R1)      then frmCPUCompare.Add('R1       '+srr(C2.R1      )+' '+srr(R1       ));
    if rcmp(R2 ,  C2.R2)      then frmCPUCompare.Add('R2       '+srr(C2.R2      )+' '+srr(R2       ));
    if rcmp(R3 ,  C2.R3)      then frmCPUCompare.Add('R3       '+srr(C2.R3      )+' '+srr(R3       ));
    if rcmp(R4 ,  C2.R4)      then frmCPUCompare.Add('R4       '+srr(C2.R4      )+' '+srr(R4       ));
    if P       <> C2.P        then frmCPUCompare.Add('P        '+str(C2.P       )+' '+str(P        ));
    if rstk[0] <> C2.rstk[0]  then frmCPUCompare.Add('rstk[0]  '+str(C2.rstk[0] )+' '+str(rstk[0]  ));
    if rstk[1] <> C2.rstk[1]  then frmCPUCompare.Add('rstk[1]  '+str(C2.rstk[1] )+' '+str(rstk[1]  ));
    if rstk[2] <> C2.rstk[2]  then frmCPUCompare.Add('rstk[2]  '+str(C2.rstk[2] )+' '+str(rstk[2]  ));
    if rstk[3] <> C2.rstk[3]  then frmCPUCompare.Add('rstk[3]  '+str(C2.rstk[3] )+' '+str(rstk[3]  ));
    if rstk[4] <> C2.rstk[4]  then frmCPUCompare.Add('rstk[4]  '+str(C2.rstk[4] )+' '+str(rstk[4]  ));
    if rstk[5] <> C2.rstk[5]  then frmCPUCompare.Add('rstk[5]  '+str(C2.rstk[5] )+' '+str(rstk[5]  ));
    if rstk[6] <> C2.rstk[6]  then frmCPUCompare.Add('rstk[6]  '+str(C2.rstk[6] )+' '+str(rstk[6]  ));
    if rstk[7] <> C2.rstk[7]  then frmCPUCompare.Add('rstk[7]  '+str(C2.rstk[7] )+' '+str(rstk[7]  ));
    frmCPUCompare.add('Ticks '+inttohex(cycles-c2.Cycles,2));
    frmCPUCompare.show;
  end;
end;

// redisplay cpu values
procedure TfrmDebugEMU.Button10Click(Sender: TObject);
begin
{  PostMessage(handle, DebuggerMessage, 0, 0); }
  Debugger.GetChipset ;                  // wgg get current chipset fresh from emu
  InternalUpdatePt;                      // wgg and show to the user
end;

// propagate values to the debugger
procedure TfrmDebugEMU.CheckBox3Click(Sender: TObject);
begin
  Debugger.EraseStk:= CheckBox3.checked;
end;

// edit the source at a specified address
procedure TfrmDebugEMU.ListBox1Click(Sender: TObject);
var
  t: string;
begin
  if ListBox1.ItemIndex<>-1 then
  begin
    t:= copy(ListBox1.Items[ListBox1.ItemIndex], 1, 5);
    Debugger.EditAtSymbol('$'+inttohex(Debugger.FullAdr(strtohex(t)),5));
  end;
end;

function TfrmDebugEMU.HexaView1Read(Sender: TObject; const adr: Integer): Byte;
begin
  try
    result:= Debugger.ReadInteger(adr) and $ff;
  except
    result:= 0;
  end;
end;

procedure TfrmDebugEMU.RBEnter(Sender: TObject);
begin
  HexaView1.CurrentTop:= Min(((Sender as TEditLabel).Value and $fffff), 1048480);   // wgg limit top
  tedMemory.Value:= HexaView1.CurrentTop;                              // wgg
end;

procedure TfrmDebugEMU.HexaView1Write(Sender: TObject; const adr: Integer;
  const Value: Byte; const Nibble: Boolean);
var
  b: array [0..1] of byte;
  n, i: integer;
begin
  if Not Debugger.InAsmStep then exit;                        // wgg
  if nibble then
    n:= 1
  else
    n:= 2;
  for i:= 0 to n-1 do
    b[i]:= (value shr (i*4)) and $f;
  Debugger.WriteMemory(b, adr, n);
end;

procedure TfrmDebugEMU.tedMemoryAfterKeyPress(Sender: TObject; var Key: Char);
begin
  RPChange(Sender);
  HexaView1.CurrentTop:= Min(((Sender as TEditLabel).Value and $fffff), 1048480);   // wgg limit top
  tedMemory.Value:= HexaView1.CurrentTop;                              // wgg
end;

procedure TfrmDebugEMU.RPChange(Sender: TObject);                           // wgg added
begin
  with (Sender as TEditLabel) do
    if Not Self.Update then
    begin
      Self.Update:= true;
      if Not ((minValue=0) And (maxValue=0)) then
      begin
{        if Value < minValue then value:= minValue;
        if Value > maxValue then value:= maxValue;  }
        if Value < minValue then value:= maxValue;      // wgg do a rollover
        if Value > maxValue+1 then value:= maxValue;    // case like 0-3 range, underflows to 0F, set to max
        if Value > maxValue then value:= minValue;
      end;
      SpinEnable;
      Button5Click(Nil);            // wgg now copy to emulator, signal ignore Update flag
      Hexaview1.Invalidate;         // wgg in case it changed V1, V2
      Self.Update:= false;
    end;
end;

var
  RBUpdate: boolean;                // wgg if true, onclick stuff wont happen
  
procedure TfrmDebugEMU.RBinaryClick(Sender: TObject);
begin
  if Not RBUpdate then
  begin
    RBUpdate:= true;
    if (Sender is TCheckBox) And (Not Debugger.InAsmStep) then
      (Sender as TCheckBox).Checked:= Not (Sender as TCheckBox).Checked     // wgg put it right back!
    else
      Button5Click(Sender);           // wgg now copy to emulator
    RBUpdate:= false;
  end;
end;

procedure TfrmDebugEMU.RAKeyPress(Sender: TObject; var Key: Char);
begin
  if Not Debugger.InAsmStep then key:= #0;
end;

end.
