{
  This is the RPL debug form, allowing you to debug
  RPL programs.
  This unit is copyright Hewlett Packard
}
Unit fmDebugRPL;

Interface

Uses
  Messages, Classes, Controls, Forms, StdCtrls, Menus, WindowsPosSave, RplDesasm,
  MouseScroolControl, ExtCtrls, HexaEdit, Spin, ComCtrls, Grids, ExtDlgs,  Debug,
  Dialogs;

type
  TfrmDebugRPL = Class(TForm)
    WindowPosSave1: TWindowPosSave;
    Memory_Map: TSizeAndScroolPanel;
    Memo5: TMemo;
    HexaEdit1: TEdit;
    Memo2: TMemo;
    Edit1: TEdit;

    PopupMenu1: TPopupMenu;
    Step_Over_Entry_Points: TSizeAndScroolPanel;
    Button6: TButton;
    Local_Variables: TSizeAndScroolPanel;
    Label8: TLabel;
    Rpl_Stack: TSizeAndScroolPanel;
    Label2: TLabel;
    Memory_Test: TSizeAndScroolPanel;
    HexaEdit2: THexaEdit;
    HexaEdit3: THexaEdit;
    CheckBox2: TCheckBox;
    Control: TSizeAndScroolPanel;
    Redraw: TButton;
    Label5: TLabel;
    SpinEdit1: TSpinEdit;      
    Button3: TButton;
    Button2: TButton;
    Button1: TButton;
    Button4: TButton;
    ms: TLabel;
    Label1: TLabel;
    Label4: TLabel;
    Virtual_Stack: TSizeAndScroolPanel;
    Label3: TLabel;
    Temporary_Objects: TSizeAndScroolPanel;
    Button8: TButton;
    TempObjsList: TListBox;
    Memo7: TMemo;
    Memo8: TMemo;
    Last_Instructions: TSizeAndScroolPanel;
    Label7: TLabel;
    ListBox5: TListBox;
    Home_Directory: TSizeAndScroolPanel;
    ButtonUpdateMemory: TButton;
    Memo9: TMemo;
    NbTempObj: TLabel;
    ListBox3: TListBox;
    ListBox4: TListBox;
    Return_Stack: TSizeAndScroolPanel;
    ListBox2: TListBox;
    Label6: TLabel;
    TreeView1: TTreeView;
    FlashPointers: TSizeAndScroolPanel;
    Memo1: TMemo;
    CheckBox1: TCheckBox;
    Label9: TLabel;
    Profiler: TSizeAndScroolPanel;
    Memo3: TMemo;
    CheckBox3: TCheckBox;
    Memo4: TMemo;
    CheckBox4: TCheckBox;
    BitMaps: TSizeAndScroolPanel;
    ListBox1: TListBox;
    Image1: TImage;
    Label11: TLabel;
    Arrays: TSizeAndScroolPanel;
    Label12: TLabel;
    ListBox6: TListBox;
    StringGrid1: TStringGrid;
    SavePictureDialog1: TSavePictureDialog;
    procedure FormMouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
    procedure RedrawClick(Sender: TObject);                                   
    Procedure Button3Click(Sender: TObject);
    Procedure Button2Click(Sender: TObject);
    Procedure Button1Click(Sender: TObject);
    Procedure FormClose(Sender: TObject; Var Action: TCloseAction);
    Procedure Button4Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure TempObjsListClick(Sender: TObject);
    procedure ButtonHomeClick(Sender: TObject);
    procedure Label10MouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure Label10MouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
    procedure Label10MouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure PopupMenu1Popup(Sender: TObject);
    procedure ListBox4Click(Sender: TObject);
    procedure CheckBox2Click(Sender: TObject);
    procedure HexaEdit1Change(Sender: TObject);
    procedure HexaEdit2Change(Sender: TObject);
    procedure HexaEdit3Change(Sender: TObject);
    procedure Memory_MapResize(Sender: TObject);
    procedure Memory_MapPaint(Sender: TObject);
    procedure Edit1KeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure BuildTempOb(Sender: TObject);
    procedure ListBox2Click(Sender: TObject);
    procedure Memo8MouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure CheckBox1Click(Sender: TObject);
    procedure CheckBox3Click(Sender: TObject);
    procedure CheckBox4Click(Sender: TObject);
    procedure ListBox1Click(Sender: TObject);
    procedure ListBox6Click(Sender: TObject);
    procedure Save1Click(Sender: TObject);
    procedure ButtonUpdateMemoryClick(Sender: TObject);
    procedure Edit1KeyPress(Sender: TObject; var Key: Char);
  private
    lbls: array [0..9] of TLabel;
    D0, D1, b, NextD0: integer;                         // wgg added NextD0=next rpl point
    Prolog: TPrologsList;
    LastDisplay: boolean;
    bitmapss: TStringList;
    matrixes: TStringList;
    function AddBitmap(const data: string): string;
    procedure FreeBitmaps();
    function AddMatrices(const data: string): string;
    procedure PopUpMenuClick(Sender: TObject);
    Procedure instruction(Var Message: TMessage); Message DebuggerMessage;
    Procedure InitMemMap;
    Procedure DispRstk;
    Procedure DispStk;
    Procedure DispVstk;
    Procedure DispLinstr;
    Procedure DispLocal;
    Procedure DispHome;
    Procedure DispMemMap;
  Public
    procedure RedrawData;                                                      // wgg
    procedure LoadLR;                                                          // wgg
    procedure RefreshAll;                                                      // wgg need after changing emulators
    Procedure ClearAll;                                                        // wgg need if close emulator
  End;

Var
  frmDebugRPL: TfrmDebugRPL;
  formKey: string;
  TempObjsDecomp: TStringList;                               // wgg

Implementation

uses
  SysUtils, Graphics, registry, math, CDBShUtils, lrworking,
  RegistryValues,FmProject, FmSourceEdit;

//uses update;

{$R *.DFM}

{ TForm1 }

Procedure TfrmDebugRPL.Button3Click(Sender: TObject);
Begin
  Debugger.StopRpl; // wgg RefreshAll will take place when/if an RPL instruction finishes
End;

Procedure TfrmDebugRPL.Button2Click(Sender: TObject);
Begin
  Debugger.continueRpl;
End;

Procedure TfrmDebugRPL.Button1Click(Sender: TObject);
Begin
  Debugger.StepInRpl;
End;

Procedure TfrmDebugRPL.LoadLR;
Begin
  InitPrologues(prolog);
End;

Procedure TfrmDebugRPL.FormClose(Sender: TObject; Var Action: TCloseAction);
Begin
  Button2Click(Button2);
End;

Procedure TfrmDebugRPL.Button4Click(Sender: TObject);
Begin
  Debugger.StepOverRpl;
End;

procedure TfrmDebugRPL.Button6Click(Sender: TObject);
begin
  with TRegIniFile.Create(RegistryFile) do
  Begin
    WriteString(formKey, 'NoStepOver', memo5.Lines.Text);
    free;
  end;
end;

procedure TfrmDebugRPL.FormCreate(Sender: TObject);
const
  nocasecte : string = 'COLA'#13#10'AGAIN'+
      '#0=ITE'#13#10'#<ITE'#13#10'#=ITE'#13#10'#>ITE'#13#10'2''RCOLARPITE'#13#10'ANDITE'#13#10'COLAITE'#13#10'COLARPITE'#13#10'DUP#0=ITE'#13#10'EQITE'#13#10'ITE'#13#10'RPITE'#13#10'SysITE'#13#10'UNxSYMRPITE'#13#10'UserITE'#13#10'snnSYMRPITE'#13#10'snsSYMRPITE'#13#10'ssnSYMRPITE'#13#10'sssSYMRPITE'#13#10'$_EXIT'#13#10+
      'DA1OK?NOTIT'#13#10'DA2aOK?NOTIT'#13#10'DA2bOK?NOTIT'#13#10'DA3OK?NOTIT'#13#10'DO#EXIT'#13#10'DO$EXIT'#13#10'DO%EXIT'#13#10'DOHXSEXIT'#13#10'DUP#0=IT'#13#10'EQIT'#13#10'GCDHEULPEXIT'#13#10'GSPLIT'#13#10'NOT_IT'#13#10'POINTEXIT'#13#10'POLYARIT'#13#10'RPIT'#13#10'parleftIT'#13#10'parrightIT'#13#10+
      ''''#13#10'IT'#13#10'ITE'#13#10'SEMI'#13#10'UNTIL'#13#10'LOOP'#13#10'?SEMI'#13#10'NOT?SEMI'#13#10+
      '#0=case'#13#10'#1=case'#13#10'#<>case'#13#10'#<case'#13#10'#=case'#13#10'#=casedrop'#13#10'#=casedrpfls'#13#10'#>2case'#13#10'#>33case'#13#10'#>case'#13#10'%-1=case'#13#10'%0=case'#13#10'%1=case'#13#10'%2=case'#13#10'AEQ1stcase'#13#10'AEQopscase'#13#10'ANDNOTcase'#13#10'ANDcase'#13#10'C%-1=case'#13#10'C%0=case'#13#10'C%1=case'#13#10'C%2=case'#13#10+
      'COLANOTcase'#13#10'COLAcase'#13#10'DUP#0=case'#13#10'EQUALNOTcase'#13#10'EQUALcase'#13#10'EQUALcasedrop'#13#10'EQUALcasedrp'#13#10'EQcase'#13#10'EQcaseDROP'#13#10'EQcasedrop'#13#10'EnvNGcase'#13#10'M-1stcasechs'#13#10'MEQ*case'#13#10'MEQ+case'#13#10'MEQ-case'#13#10'MEQ/case'#13#10'MEQ1stcase'#13#10'MEQCHScase'#13#10'MEQFCNcase'#13#10'MEQINVcase'#13#10+
      'MEQSQcase'#13#10'MEQ^case'#13#10'MEQopscase'#13#10'Mid1stcase'#13#10'NOTBAKcase'#13#10'NOTLIBcase'#13#10'NOTLISTcase'#13#10'NOTMATRIXcase'#13#10'NOTROMPcase'#13#10'NOTSECOcase'#13#10'NOTTYPEcase'#13#10'NOTcase'#13#10'NOTcase2DROP'#13#10'NOTcase2drop'#13#10'NOTcaseDROP'#13#10'NOTcaseFALSE'#13#10'NOTcaseTRUE'#13#10'NOTcasedrop'#13#10'NULLargcase'#13#10+
      'NcaseSIZEERR'#13#10'NcaseTYPEERR'#13#10'NoEdit?case'#13#10'ORcase'#13#10'OVER#=case'#13#10'REALcase'#13#10'REQcase'#13#10'REQcasedrop'#13#10'Z-1=case'#13#10'Z0=case'#13#10'Z1=case'#13#10'accNBAKcase'#13#10'accNLIBcase'#13#10'case'#13#10'case2DROP'#13#10'case2drop'#13#10'case2drpfls'#13#10'caseDEADKEY'#13#10'caseDROP'#13#10'caseDoBadKey'#13#10'caseDrpBadKy'#13#10+
      'caseERRJMP'#13#10'caseFALSE'#13#10'caseSIZEERR'#13#10'caseTRUE'#13#10'casedrop'#13#10'casedrpfls'#13#10'casedrptru'#13#10'caseout'#13#10'cxcasecheck'#13#10'dARRYcase'#13#10'dIDNTNcase'#13#10'dLISTcase'#13#10'dMATRIXcase'#13#10'dREALNcase'#13#10'dREALcase'#13#10'dZINTNcase'#13#10'delimcase'#13#10'estcase'#13#10'idntcase'#13#10'idntlamcase'#13#10'j#-1=case'#13#10+
      'j#0=case'#13#10'j#1=case'#13#10'j%-1=case'#13#10'j%0=case'#13#10'j%1=case'#13#10'jEQcase'#13#10'jZ-1=case'#13#10'jZ0=case'#13#10'jZ1=case'#13#10'namelscase'#13#10'need''case'#13#10'negrealcase'#13#10'ngsizecase'#13#10'nonopcase'#13#10'nonrmcase'#13#10'num#-1=case'#13#10'num#0=case'#13#10'num#1=case'#13#10'num-1=case'#13#10'num0=case'#13#10'num0case'#13#10+
      'num1=case'#13#10'num2=case'#13#10'numb1stcase'#13#10'rebuildcase'#13#10'tok=casedrop'#13#10'wildcase'#13#10'zerdercase'#13#10;
var
  i: integer;
  m: TMenuItem;
begin
  formKey:= RegistryKey+'\'+WindowPosSave1.SubKey;             // wgg setup the various registry keys
  Bitmapss:= TStringList.Create;
  Matrixes:= TStringList.Create;                               // wgg
  TempObjsDecomp:= TStringList.Create;
  with TRegIniFile.Create(RegistryFile) do
  Begin
    memo5.lines.Text:= ReadString(formKey, 'nostepover', nocasecte);
    free;
  end;
  Debugger.OnRplInstr:= handle;
  InitMemMap;
  WindowPosSave1.ImportantComponents.clear;
  for i:= 0 to ControlCount-1 do
      // wgg this panel does not do as it is described
      // see also Applicationn start code          And (Controls[i].Name<>'FlashPointers'
    if (Controls[i] is TSizeAndScroolPanel) And (Controls[i].Name<>'Step_Over_Entry_Points') then
    begin
      m:= TMenuItem.Create(PopupMenu1);
      PopupMenu1.Items.Add(m);
      WindowPosSave1.ImportantComponents.add(Controls[i].name);
      m.Caption:=Controls[i].name;
      m.Tag:= integer(Controls[i]);
      m.OnClick:= PopUpMenuClick;
    end;
//  WindowPosSave1.ImportantComponents.SaveToFile('toto');
  WindowPosSave1.ReadPos;
end;

procedure TfrmDebugRPL.RedrawClick(Sender: TObject);
Begin
  frmDebugRPL.RedrawData;
End;

procedure TfrmDebugRPL.RedrawData;                      // wgg broke out so we can call from main invisibles
Begin
  ms.caption:= '';
  LastDisplay:= false;
  RefreshAll;
End;

procedure TfrmDebugRPL.RefreshAll;
begin                                                // wgg separated from DisplayAll
  FreeBitmaps;
  Debugger.GetChipset;                               // wgg refresh
  D0:= (Debugger.Chipset.D0 and $fffff)-5;
  D1:= Debugger.Chipset.D1 and $fffff;
  B:= Debugger.Chipset.b and $fffff;
  Debugger.NextRplStepOver:= 0;

  Label4.Caption := 'D0=' + IntToHex(d0, 5);
  NextD0:= D0;          // wgg DecompObj will give adrs of next RPL
  memo2.lines.text:= DecompObj(NextD0, Debugger.ReadInteger, debugger.ReadInt64, Prolog, AddBitmap, AddMatrices);
  Label9.Caption:= inttostr(Debugger.Chipset.RomV1)+' '+inttostr(Debugger.Chipset.RomV2);

  DispRstk;
  DispStk;
  if Debugger.CalcModel='X' then DispVstk;                                     // wgg not for 48
  DispLinstr;
  DispLocal;                      // tempenv
  DispMemMap;                     // tempob
  ListBox6.Repaint;
  StringGrid1.RePaint;
 { DispHome;
  BuildTempOb(Nil);  }  // wgg this can take a very long time
  Show;
end;

procedure TfrmDebugRPL.TempObjsListClick(Sender: TObject);
var
  i, j, k, l: integer;
  s: string;
  ss: tstringlist;
begin
  ss:= tstringlist.create;
  Memo7.Lines.clear;
  memo8.lines.clear;
  val('$'+copy(TempObjsList.items[TempObjsList.itemIndex], 1, 5), i, j);
  inc(i);
  j:= i;
  DecompObj(i, debugger.ReadInteger, Debugger.ReadInt64, prolog, nil, nil);
  Memo7.Text:= TempObjsDecomp[TempObjsList.itemIndex];                               // wgg
  while j<i do
  Begin
    s:= '';
    for k := 0 to 2 do
    begin
      for l:=0 to 4 do
      Begin
        s:= s+inttohex(debugger.ReadInteger(j) and $f, 1);
        inc(j);
      end;
      s:= s+' ';
    end;
    ss.add(s);
  end;
  memo8.Lines:= ss;
  ss.free;
end;

procedure TfrmDebugRPL.ButtonHomeClick(Sender: TObject);
Begin
  DispHome;
end;

procedure TfrmDebugRPL.instruction(var Message: TMessage);
begin
  Self.D0:= Debugger.chipset.D0-5;
  Self.D1:= Debugger.Chipset.D1;
  Self.B:= Debugger.Chipset.B and $fffff;
  Debugger.EditAtAddress(d0, True);                             // wgg True=blue bar in display
  LastDisplay:= true;
  RefreshAll;
  // wgg some commands, like ITE will consume the remainder of the run stack
  // before giving control back to Debugger.RPLInstruction
  // so the NextD0 will never be seen
  // We have to force a halt on any RPL we see
  if memo5.lines.indexof(Memo2.Lines.text)<>-1 then
    Debugger.NextRplStepOver:= -1           // if in the list, halt on it
  else        
    if copy(Memo2.Lines.text, 1, 4)='PTR ' then
      Debugger.NextRplStepOver:= -1
    else
      Debugger.NextRplStepOver:= NextD0;       // wgg added NextD0, need to point at next item!
  ms.caption:= copy(floattostr(debugger.rpltime/4000), 1, 7)+'ms';
end;

type
  TMyControl = class (tcontrol)
  public
    procedure MouseDown(Button: TMouseButton; Shift: TShiftState; X, Y: Integer); override;
    procedure MouseUp(Button: TMouseButton; Shift: TShiftState; X, Y: Integer); override;
    procedure MouseMove(Shift: TShiftState; X, Y: Integer); override;
  end;

procedure TMyControl.MouseDown(Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin inherited end;
procedure TMyControl.MouseUp(Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin inherited end;
procedure TMyControl.MouseMove(Shift: TShiftState; X, Y: Integer);
begin inherited end;


procedure TfrmDebugRPL.Label10MouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
    TMyControl((Sender as TControl).Parent).MouseDown(Button, shift, x, Y);
end;

procedure TfrmDebugRPL.Label10MouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
begin
    TMyControl((Sender as TControl).Parent).MouseMove(shift, x, Y);
end;

procedure TfrmDebugRPL.Label10MouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
    TMyControl((Sender as TControl).Parent).MouseUp(Button, shift, x, Y);
end;

procedure TfrmDebugRPL.PopupMenu1Popup(Sender: TObject);
var
  i: integer;
begin
  for i:= 0 to PopupMenu1.Items.count-1 do
    PopupMenu1.Items[i].checked:= TControl(PopupMenu1.Items[i].tag).visible;
end;

procedure TfrmDebugRPL.PopUpMenuClick(Sender: TObject);
Begin
  (Sender as TMenuItem).Checked:= not (Sender as TMenuItem).Checked;
  TControl((Sender as TMenuItem).tag).visible:= (Sender as TMenuItem).Checked;
end;

procedure TfrmDebugRPL.ListBox4Click(Sender: TObject);
var
  a: integer;
begin
  if TreeView1.Selected<>nil then
  Begin
    a:= integer(TreeView1.Selected.data);
    if a<>-1 then
      Memo9.Text:= DecompObj(a, Debugger.ReadInteger, Debugger.ReadInt64, Prolog, AddBitmap, AddMatrices);
  end;
end;

procedure TfrmDebugRPL.CheckBox2Click(Sender: TObject);
begin
  Debugger.TestMemMode:= CheckBox2.Checked;
end;

procedure TfrmDebugRPL.HexaEdit1Change(Sender: TObject);
begin
  Debugger.TestMemAdr:= SymbolTable.ValueFromText(HexaEdit1.Text);
end;

procedure TfrmDebugRPL.HexaEdit2Change(Sender: TObject);
begin
  SetLength(Debugger.TestMemValue, length(HexaEdit2.text));
  HexaEdit2.arrayvalue(Debugger.TestMemValue);
  HexaEdit3.Text:= '';
  while length(HexaEdit3.Text)<Length(HexaEdit2.Text) do HexaEdit3.Text:= HexaEdit3.Text+'F'
end;

procedure TfrmDebugRPL.HexaEdit3Change(Sender: TObject);
begin
  SetLength(Debugger.TestMemMask, length(HexaEdit3.text));
  HexaEdit3.arrayvalue(Debugger.TestMemMask);
end;

const
cls : array [0..10] of tcolor = (clAqua, clFuchsia, clBlue, clGray, clGreen, clLime, clTeal, clMaroon, clNavy, clOlive, clRed);

procedure TfrmDebugRPL.InitMemMap;
var
  i: integer;
begin
  for i:= 0 to high(Lbls) do
  Begin
    lbls[i]:= TLabel.Create(self);
    lbls[i].parent:= Memory_Map;
    lbls[i].font.color:= cls[i+1];
  end;
end;

procedure TfrmDebugRPL.Memory_MapResize(Sender: TObject);
const
  nms : array [0..9] of string = ('Tmp', 'RSTK', 'Free', 'Stack', 'CmdL', 'Loc', 'lops', 'TpEv', 'Home', 'P0');
var
  i, h: integer;
  tempob: integer;
begin
  Debugger.GetChipset;                               // wgg make sure current
  if not assigned(lbls[0]) then exit;
  if not assigned(frmProject) then exit;                                          // wgg cant check symbol table yet
  tempob := SymbolTable.ValueFromText('TEMPOB');
  if tempob = -1 then exit;

  for i:= 0 to high(lbls) do
  begin
    lbls[i].caption:= nms[i]+' '+inttohex(debugger.ReadInteger(tempob+i*5),5)+' '+inttostr(debugger.ReadInteger(tempob+5+i*5)-debugger.ReadInteger(tempob+i*5));
    h:= round((i+1) / 11 * Memory_Map.ClientWidth);
    lbls[i].left:=min(h, Memory_Map.ClientWidth - lbls[i].width-1);
    lbls[i].top:= lbls[i].height*i+10;
  end;
    Memory_Map.Invalidate;
end;

procedure TfrmDebugRPL.Memory_MapPaint(Sender: TObject);
var
  i: integer;
begin
  for i:= 0 to high(lbls)+1 do
  begin
    Memory_Map.canvas.Brush.color:= cls[i];
    Memory_Map.canvas.Pen.color:= clblack;
    Memory_Map.canvas.Rectangle(round(i / 11 * Memory_Map.ClientWidth), 1, round((i+1) / 11 * Memory_Map.ClientWidth), 5);
    if i<>high(lbls)+1 then
    Begin
      Memory_Map.canvas.MoveTo(round((i+1) / 11 * Memory_Map.ClientWidth), lbls[i].top);
      Memory_Map.canvas.LineTo(round((i+1) / 11 * Memory_Map.ClientWidth), 0);
    end;
  end;
end;

procedure TfrmDebugRPL.DispHome;
  procedure DoDir(adr: integer; tn: TTreeNode);
  var
    b, c, i: integer;
    s: string;
    tn2: TTreeNode;
  Begin
    tn.data:= pointer(-1);
    b:= Debugger.ReadInteger(adr);
    adr:= adr+b;
    while b<>0 do
    Begin
      b:=adr;
      s:= '';
      c:= Debugger.ReadInteger(b) and $FF;
      if c=0 then
        s:= 'NullName'
      else begin
        for i:= 1 to c do
          s:= s+chr(Debugger.ReadInteger(b+i*2) and $FF);
        inc(b, c*2+2);
      end;
      inc(b, 2);
      tn2:= TreeView1.Items.AddChild(tn, s+' '+inttohex(b,5));
      tn2.data:= pointer(b);
      if Debugger.FullAdr(Debugger.ReadInteger(b))=SymbolTable.ValueFromText('DORRP') then     // wgg FullAdr
        DoDir(b+8, tn2);
      b:= Debugger.ReadInteger(adr-5);
      adr:= adr-5-b;
    end;
  end;
var
  a, b: integer;
  UserOb: integer;
begin
  if not Home_Directory.Visible then exit;
  Debugger.GetChipset;                               // wgg make sure current
  userob:= SymbolTable.ValueFromText('USEROB');
  if userob = -1 then exit;
  TreeView1.Items.Clear;
  Memo9.Lines.Clear;
  a:= Debugger.ReadInteger(userob);
  if a=0 then exit;
  b:= (Debugger.ReadInteger(a+5) and $FFF);
  b:= b*13;
  a:= b+a+8;
  DoDir(a, TreeView1.Items.AddChild(nil, 'Home'));
end;

procedure TfrmDebugRPL.DispLinstr;
var
  i: integer;
begin
  If Last_Instructions.Visible then
  Begin
    ListBox5.Clear;
    For i:=0 to High(Debugger.lastRplInstrs) do
      ListBox5.Items.Insert(0, inttostr(i)+': '+InttoHex(Debugger.lastRplInstrs[i], 5));
  end;
end;

procedure TfrmDebugRPL.DispLocal;
var
  i, j, k, n, m: integer;
  s: TStringList;
  TEMPENV: integer;

begin
// Locals Display
  TEMPENV:= SymbolTable.ValueFromText('TEMPENV');
  if TEMPENV = -1 then exit;
  if Local_Variables.Visible then
  Begin
    s:= TStringList.Create;
    i := Debugger.ReadInteger(TEMPENV);
    Repeat
      j := debugger.ReadInteger(i);
      If (j <> 0) {And (ri(i + 5) = 0)} Then
      Begin
        s.add(' Protection: '+inttostr(debugger.ReadInteger(i + 5)));
        For k := 1 To (j Div 10) - 1 Do
        Begin
          n := debugger.ReadInteger(i + k * 10);
          m := debugger.ReadInteger(i + k * 10 + 5);
          s.Add(DecompObj(n, Debugger.ReadInteger, Debugger.ReadInt64, Prolog, AddBitmap, AddMatrices)
                  + ' = ' + DecompObj(m, Debugger.ReadInteger, Debugger.ReadInt64, Prolog, AddBitmap,
                   AddMatrices));
        End;
      end;
      i := i + j;
      s.add(' ---=== End Of Block ===--- ');
    Until j = 0;
    listBox4.Items:= s;
    ListBox4.ItemIndex:= -1;
    s.free;
  end;
end;

procedure TfrmDebugRPL.DispRstk;
var
  i, j: integer;
  s: tstringlist;
begin
// Return Stack Display
  if Return_Stack.Visible then
  Begin
    s:= TStringList.Create;
    i := 1;
    b := b - 5;
    j := Debugger.ReadInteger(b);
    While (j <> 0) and (i<100) Do
    Begin
      s.add(inttostr(i) + ': '+inttohex(j,5)+' '+ DecompObj(j, Debugger.ReadInteger,
                            Debugger.ReadInt64, Prolog, AddBitmap, AddMatrices));
      inc(i);
      dec(b, 5);
      j := Debugger.ReadInteger(b);
    End;
    ListBox2.items:= s;
    s.free;
    ListBox2.ItemIndex:= -1;
  end;
end;

procedure TfrmDebugRPL.DispStk;
var
  d1l, i, j: integer;
  s: TStringList;
begin
  if not Rpl_Stack.Visible then exit;
  s:= TStringList.Create;
  i := 1;
  d1l:= self.d1;
  j:= Debugger.ReadInteger(d1l);
  While (j <> 0) and (i<SpinEdit1.Value) Do
  Begin
    if (Debugger.ReadInteger(j)=Prolog[DOBINT]) or (SymbolTable.GetFromAdr(j)='') then
      s.insert(0, inttostr(i) + ': ' +inttohex(j, 5)+ ' '+ DecompObj(j, Debugger.ReadInteger,
                                       Debugger.ReadInt64, Prolog, AddBitmap, AddMatrices))
    else s.insert(0, inttostr(i) + ': ' +inttohex(j, 5)+ ' '+ SymbolTable.GetFromAdr(j));
    inc(d1l, 5);
    j:= Debugger.ReadInteger(d1l);
    inc(i);
  End;
  try
    Memo4.lines:= s;
    // wgg added test to eliminate exception on empty stack
    If length(s.text)>0 Then Memo4.SelStart:= length(s.text)-length(s[s.count-1]);
    Memo4.SelLength:= 0;
    Memo4.Perform(EM_SCROLLCARET, 0, 0);
  except
  end;
//  ListBox1.ItemIndex:= listBox1.Items.count-1;
  s.free;
end;

procedure TfrmDebugRPL.DispVstk;
var
  i, j, k, l, m, n, o: integer;
  s: tstringlist;
  VSTACK: integer;
begin
  // VStack Display
  VSTACK:= SymbolTable.ValueFromText('VSTACK');
  if VSTACK = -1 then exit;
  if Virtual_Stack.Visible then
  Begin
    s:= tstringlist.create;
    i:= Debugger.ReadInteger(VStack);
    if i<>0 then
    Begin
      i:= i+15;
      j:= Debugger.ReadInteger(i);
      i:= i+10;
      for k:= 0 to j-1 do
      Begin
        l:= Debugger.ReadInteger(i);
        s.add('---==Block: '+ inttostr(debugger.ReadInteger(i+5))+'==---');
        i:= i+10;
        o:= 0;
        for m:= 0 to (l div 5)-5 do
        Begin
          n:= debugger.ReadInteger(i);
          s.Add(inttostr(o)+': '+inttohex(n, 5)+': '+DecompObj(n, Debugger.ReadInteger,
                                   Debugger.ReadInt64, prolog, AddBitmap, AddMatrices));
          inc(i, 5);
          inc(o);
        end;
        inc(i, 10);
      end;
    end;
    listBox3.items:= s;
    ListBox3.ItemIndex:=-1;
    s.free;
  end;
end;

procedure TfrmDebugRPL.DispMemMap;
begin
  Memory_MapResize(nil);
end;

{  Procedure SetRegD(i: integer);
  Begin
    with Debugger.Chipset do
      D:= (Debugger.Chipset.D and $fffffffffff00000) + i;
    Debugger.SaveChipset;
  end;
  Procedure SetRegD1(i: integer);
  Begin
    with Debugger.Chipset do
      D1:= i;
    Debugger.SaveChipset;
    d1:= i;
  end;
  Function RegD: integer;
  Begin
    result:= Debugger.Chipset.d and $fffff;
  end;
  Function RegD1: integer;
  Begin
    result:= Debugger.chipset.d1 and $fffff;
  end;

  procedure drop(i: integer);
  Begin
    setRegD(RegD+i);
    SetRegD1(RegD1+5*i);
  end;
  procedure dup(i: integer);
  var
    j: integer;
  Begin
    if RegD<i then
      raise Exception.Create('Insufisant memory');
    SetRegD(RegD-i);
    for j:= 0 to i-1 do
      Debugger.WriteInteger(RegD1-i*5+j*5, Debugger.ReadInteger(RegD1+j*5));
    SetRegD1(RegD1-i*5);
  end;
  procedure roll(i: integer);
  var
    j, k: integer;
  Begin
    if i<2 then exit;
    j:= Debugger.ReadInteger(RegD1+i*5-5);
    for k:=0 to i-2 do
      DEbugger.WriteInteger(RegD1+(i-k)*5-5, Debugger.ReadInteger(RegD1+(i-k)*5-10));
    Debugger.WriteInteger(RegD1, j);
  end;
  procedure rolld(i: integer);
  var
    j, k: integer;
  Begin
    if i<2 then exit;
    j:= Debugger.ReadInteger(RegD1);
    for k:=0 to i-2 do
      DEbugger.WriteInteger(RegD1+k*5, Debugger.ReadInteger(RegD1+k*5+5));
    Debugger.WriteInteger(RegD1+i*5-5, j);
  end;
  procedure peek(i: integer);
  Begin
    if RegD<1 then
      raise Exception.Create('Insufisant memory');
    SetRegD1(RegD1-5);
    Debugger.writeInteger(RegD1, Debugger.ReadInteger(RegD1+i*5));
  end;
  Procedure push(i: integer);
  Begin
    if RegD<1 then
      raise Exception.Create('Insufisant memory');
    SetRegD1(RegD1-5);
    Debugger.writeInteger(RegD1, SymbolTable.ValueFromText('ZERO')+i*10);
  end;
}
procedure TfrmDebugRPL.Edit1KeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
var
  i: integer;
begin
  if Key<>13 then exit;
  i:= SymbolTable.GetEntryValue(Edit1.text);
  if i=-1 then Beep
  else
  begin
    with Debugger.Chipset do
    begin
      D0:= D0 - 5;
      A:= (A and $fffffffffff00000) + (i And $7FFFF);
      PC:= Debugger.ReadInteger(i);
      Debugger.SaveChipset;
      Debugger.NextRplStepOver:= D0;
    end;
    //Edit1.SelStart:= 0;                  // wgg this highlights (selects) the last command
    //Edit1.SelLength:= length(Edit1.Text);
    Edit1.Text:= '';                      // wgg clear
    Debugger.StepOverRpl;                 // wgg was StepInRpl
    Key:= 0;
  end;
end;

// wgg this is here to stop the beep on #13
// I tried everything else, TEdit just seems to hate the #13!
procedure TfrmDebugRPL.Edit1KeyPress(Sender: TObject; var Key: Char);
begin
  if key=#13 then key:=#0;
end;

Procedure TfrmDebugRPL.ClearAll;
Begin
//  ListBox1.Items.Clear;
  TempObjsDecomp.Clear;                                    // wgg
  TreeView1.Items.Clear;
  Memo9.Lines.Clear;
  Memo4.Lines.Clear;
  ListBox2.Items.Clear;
  ListBox5.Items.Clear;

  Memo2.Lines.clear;
  ListBox2.items.clear;
  ListBox4.items.clear;
  ListBox3.Items.clear;
  FreeBitMaps;                                              // wgg
  frmSourceEdit.ClearAdrsMark;                            // wgg clear pc marker
end;

procedure TfrmDebugRPL.BuildTempOb(Sender: TObject);
var
  ri: TReadInt;
  i, j, k, l: integer;
  s: string;
  ss: TStringList;
  tempob, RSKTOP: integer;
begin
  Debugger.GetChipset;                               // wgg make sure current
  // display temporary area
  ss:= TStringList.Create;
  Memo7.Lines.clear;
  memo8.lines.clear;
  TempObjsList.Clear;
  tempob := SymbolTable.ValueFromText('TEMPOB');
  if tempob = -1 then exit;
  RSKTOP := tempob+5;

  l:= 0;
  ri:= Debugger.ReadInteger;
  i:= ri(TempOb)+5;
  j:= ri(RSKTOP);
  While i<j do
  Begin
    dec(j, 5);
    k:= ri(j);
    s:=inttohex(k,3);                      // wgg changed all to hex
    j:= j-k+6;
    k:= j;
    TempObjsDecomp.Insert(0,DecompObj(k, ri, Debugger.ReadInt64, Prolog, AddBitmap, AddMatrices));
    // wgg address, flag, decomp length, tempobj length
    s:= inttohex(j-1, 5)+': '+inttohex(ri(j-1) and $f, 1)+' '+inttohex(k-j, 3)+' '+s;
    dec(j);
    ss.insert(0, s);
    inc(l);
    if l and $3FF = 0 then
    Begin
      NbTempObj.caption:= inttostr(l);
      Application.ProcessMessages;
    end;
  end;
  TempObjsList.items:= ss;
  NbTempObj.caption:= inttostr(l);
  ss.free;
end;

procedure TfrmDebugRPL.ListBox2Click(Sender: TObject);
begin
  if sender is TListBox then
    with sender as TListBox do
      if itemindex<>-1 then
        try
          Debugger.EditAtAddress(HexToStr(GetToken(Items[ItemIndex], 2)));
        except
        end;
end;

procedure TfrmDebugRPL.Memo8MouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  if sender is TControl then
    if (sender as tcontrol).parent<>nil then
      (sender as tcontrol).parent.BringToFront;
end;

procedure TfrmDebugRPL.CheckBox1Click(Sender: TObject);
begin
  if CheckBox1.checked then
  Begin
    Memo1.Lines.clear;
    Debugger.ActiveFlashPtr:= true;
  end
  else
  Begin
    Memo1.lines.Text:= Debugger.FlashPtrResult;
    Debugger.ActiveFlashPtr:= false;
  End;
end;

procedure TfrmDebugRPL.CheckBox3Click(Sender: TObject);
begin
  if CheckBox3.checked then
  Begin
    Memo3.Lines.clear;
    Debugger.Profiler:= true;
  end
  else
  Begin
    Debugger.Profiler:= false;
    Memo3.lines.Text:= Debugger.ProfilerResult;
  End;
end;

procedure TfrmDebugRPL.CheckBox4Click(Sender: TObject);
begin
  Memo4.WordWrap:= CheckBox4.Checked;
//  Memo4.lines:= Memo4.lines;
end;

function getint(const s: string; start, size: integer): int64;
var
  mul: int64;
begin
  result:= 0;
  mul:= 1;
  while size<>0 do
  begin
    result:= result+(pos(s[start], '0123456789ABCDEF')-1)*mul;
    mul:= mul*16;
    start:= start+1;
    dec(size);
  end;
end;

function TfrmDebugRPL.AddBitmap(const data: string): string;
begin
  Bitmapss.Add(data);
  ListBox1.Items.Add(inttostr(bitmapss.count)+' '+inttostr(getint(data, 16, 5))+
                '*'+inttostr(getint(data, 11, 5)));
  result:= inttostr(bitmapss.count);
end;

procedure TfrmDebugRPL.FreeBitmaps;
var
  x, y: integer;
begin
  Bitmapss.clear;
  Image1.Picture.Bitmap:= nil;                    // wgg clear pciture also
  ListBox1.Clear;                                 // wgg was Items.clear
  ListBox6.Items.Clear;
    for x:=StringGrid1.FixedCols to StringGrid1.ColCount do
      for y:=StringGrid1.FixedRows to StringGrid1.RowCount do
        StringGrid1.Cells[x, y]:= '';
    StringGrid1.ColCount:= StringGrid1.FixedCols+1;
    StringGrid1.RowCount:= StringGrid1.FixedRows+1;
  matrixes.clear;
end;

procedure TfrmDebugRPL.ListBox1Click(Sender: TObject);
var
  s: string;
  w, h, x, y: integer;
begin
  if ListBox1.ItemIndex<>-1 then
  begin
    s:= bitmapss[ListBox1.ItemIndex];
    w:= Getint(s, 16, 5);
    h:= Getint(s, 11, 5);
 {   BITMAPS.Width:= w*2+82;                      // wgg this keeps overriding the user size
    BITMAPS.Height:= 41-24+h*2;     }
    Image1.Picture.Bitmap.Width:= w;
    Image1.Picture.Bitmap.Height:= h;
    with Image1.picture.bitmap.canvas do
      for y:= 0 to h-1 do
        for x:=0 to w-1 do
          if (getint(s, 21+y*((w+7) div 8)*2+(x div 4), 1) and (1 shl (x mod 4)))=0 then
            pixels[x, y]:= clWhite
          else
            pixels[x, y]:= clBlack;
  end;
end;

function TfrmDebugRPL.AddMatrices(const data: string): string;
begin
  matrixes.Add(data);
  if getint(data, 16, 5)=1 then
    ListBox6.Items.Add(inttostr(matrixes.count)+' '+SymbolTable.GetFromAdr(getint(data, 11, 5))+' '+
                       inttostr(getint(data, 21, 5)))
  else
    ListBox6.Items.Add(inttostr(matrixes.count)+' '+SymbolTable.GetFromAdr(getint(data, 11, 5))+' '+
                       inttostr(getint(data, 21, 5))+'*'+inttostr(getint(data, 26, 5)));
  result:= inttostr(matrixes.count);
end;

procedure TfrmDebugRPL.ListBox6Click(Sender: TObject);
var
  s: string;
  w, h, d, x, y, p: integer;
  real: boolean;
  function gettext: string;
    function getrealtext: string;
    var
      v: int64;  // e int64
      i: integer;
    Begin
    { orig      v:= getint(s, p, 16);
      e:= (v and $f)+ 10 * (v shr 4 and $f) + 100 * (v shr 8 and $f);
      result:= '% ';
      if v shr 60 <>0 then result:= result+'-';
      result:= result+inttostr((v shr 56) and $f)+'.'+inttohex(v shr 12 and $fffffffffff, 11);
      while result[length(result)]='0' do result:= copy(result, 1, length(result)-1);
      if e <> 0 then
        if e>=500 then
          result:= result+'E-'+inttostr(1000-e)
        else
          result:= result+'E'+inttostr(e);
      p:= p+16;
    end;
  begin
    result:= getrealtext;
    if not real then result:= '('+result+', '+getrealtext+')';
  end; }
  // cdb changes 1/23/2003
      v:= getint(s, p, 16);
      i:= v and $fff; if (i and $f00)>=$500 then i:= i+$99000;
      result:= '% '+dreal(i, ((v shr 12) and $ffffffffffff) shl 12);
      p:= p+16;
    end;
  begin
    result:= getrealtext;
    if not real then result:= '('+result+', '+getrealtext+')';
  end;

begin
  if ListBox6.ItemIndex<>-1 then
  begin
    s:= matrixes[ListBox6.ItemIndex];
    d:= Getint(s, 16, 5);              // wgg number of dimensions
    w:= Getint(s, 21, 5);              // wgg get no items in dimension 1 (no in row)
    p:= 5 * d + 21;                    // wgg now added computation for p (1st number loc)
    if d=1 then                        // wgg get no dimensions
    begin
      h:= 1;
    end else begin
      h:= w;                           // wgg swap so looks like calculator
      w:= Getint(s, 26, 5);            // wgg get no items in dimension 2 (no cols)
    end;

    real:= SymbolTable.GetFromAdr(getint(s, 11, 5))='DOREAL';

    StringGrid1.ColCount:= w+1;
    StringGrid1.RowCount:= h+1;
    for x:=1 to w do StringGrid1.Cells[x, 0]:= inttostr(x);
    for y:=1 to h do StringGrid1.Cells[0, y]:= inttostr(y);
    for y:= 0 to h-1 do
      for x:=0 to w-1 do
        StringGrid1.Cells[x+1, y+1]:= gettext;
  end;
end;

procedure TfrmDebugRPL.Save1Click(Sender: TObject);
begin
  if SavePictureDialog1.Execute then
    Image1.Picture.SaveToFile(SavePictureDialog1.FileName);
end;

procedure TfrmDebugRPL.ButtonUpdateMemoryClick(Sender: TObject);
begin
   Memory_MapResize(Nil);
end;

procedure TfrmDebugRPL.FormMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  Screen.Cursor:= crDefault;
end;

End.
