{
  This form let you query throught the list of mnemonics
  used in the calculator. Allowing you to jump to the source,
  to see the list of references to the object ....
  It also allows you to see the unresolved symbols and to jump to the
  place where this symbols are used.
  This unit is copyright Hewlett Packard
}
unit fmEntryPoints;
interface

uses
  Classes, Controls, Forms, Dialogs, WindowsPosSave, StdCtrls, ComCtrls, Menus,
  lrWorking, ExtCtrls, Mandel, RplDesasm;

type
  TfrmEntryPoints = class(TForm)
    ListBox1: TListBox;
    ListBox2: TListBox;
    WindowPosSave1: TWindowPosSave;
    edtName: TEdit;
    chkbResolved: TCheckBox;
    edtAdrMin: TEdit;
    edtRefMin: TEdit;                                            
    lblAdress: TLabel;
    lblRefer: TLabel;
    lblName: TLabel;
    chkbUseSup: TCheckBox;
    Mandel1: TMandel;
    btnExec: TButton;
    btnLoadSup: TButton;
    OpenDialog1: TOpenDialog;
    Panel1: TPanel;
    ProgressBar1: TProgressBar;
    Label5: TLabel;
    Label6: TLabel;
    btnSaveLst: TButton;
    btnLoadLst: TButton;
    btnNew: TButton;
    edtNumMin: TEdit;
    lblNumber: TLabel;
    chkb3Nibs: TCheckBox;
    btnRecreate: TButton;
    SaveDialog1: TSaveDialog;
    PopupMenu1: TPopupMenu;
    Reset1: TMenuItem;
    chkb39: TCheckBox;
    btnFPTR: TButton;
    btnReadSup: TButton;
    edtAdrMax: TEdit;
    edtRefMax: TEdit;
    edtNumMax: TEdit;
    lblMinMax1: TLabel;
    Panel2: TPanel;
    lblROMDev: TLabel;
    chkbSortList: TCheckBox;
    chkbUserSymbols: TCheckBox;
    procedure chkbUserSymbolsClick(Sender: TObject);
    procedure chkbSortListClick(Sender: TObject);
    procedure ListBox1Click(Sender: TObject);
    procedure ListBox2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ListBox1DblClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure btnLoadSupClick(Sender: TObject);
    procedure btnExecClick(Sender: TObject);
    procedure btnSaveLstClick(Sender: TObject);
    procedure edtNameKeyPress(Sender: TObject; var Key: Char);
    procedure btnLoadLstClick(Sender: TObject);
    procedure btnNewClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure btnRecreateClick(Sender: TObject);
    procedure Mandel1DblClick(Sender: TObject);
    procedure Reset(Sender: TObject);
    procedure btnFPTRClick(Sender: TObject);
    procedure btnReadSupClick(Sender: TObject);
  private
    sup: TStringList;
    freeoncloce: boolean;
    DuringCreate: boolean;
    Function GetCurrentTable: TSymbolList;
    Function GetCurEntry: TEntry;
  public
    Procedure ReloadList;
  end;

var
  frmEntryPoints: TfrmEntryPoints;
  formKey: string;

implementation
uses
  SysUtils, Registry, RegistryValues, CDBShUtils, utils2, Debug, FmSourceEdit;
  
{$R *.DFM}

// When you select an object from the list1,
// the second list is filled with the list of
// the references to this symbol.
procedure TfrmEntryPoints.ListBox1Click(Sender: TObject);
var
  p: integer;
  s: TEntry;
begin
  try
    ListBox2.Items.Clear;
    s:= GetCurEntry;
    if s=nil then exit;
    for p:= 0 to high(s.References) do
      ListBox2.Items.add(IntToHex(s.Getreferences(p), 6));
  except
  end;
end;

// when you select an object from the second list,
// the editor opens ot the address the symbol is used in
procedure TfrmEntryPoints.ListBox2Click(Sender: TObject);
begin
  if ListBox2.ItemIndex=-1 then exit;
  debugger.EditAtSymbol(ListBox2.Items[ListBox2.ItemIndex]);
end;

// creation things.
// by default, the form does not destruc itself when
// close, byt in order to allow more than one instance to be
// created, the freeoncloce can be modified by the form creator.
procedure TfrmEntryPoints.FormCreate(Sender: TObject);
begin
  DuringCreate:= true;
  sup:= TStringList.Create;
  WindowPosSave1.ReadPos;
  freeoncloce:= false;
  formKey:= RegistryKey+'\'+WindowPosSave1.SubKey;             // wgg setup the various registry keys
  with TRegIniFile.Create(formKey) do
  Begin
    chkbSortList.Checked:= ReadBool('', 'SortByName', True);
    chkbUserSymbols.Checked:= ReadBool('', 'UserSymbols', True);
    chkbResolved.Checked:= ReadBool('', 'Resolved', True);
    chkb3Nibs.Checked:= ReadBool('', 'Use3Nibs', false);
    free;
  end;
  DuringCreate:= false;
end;

// This is the heart of the query system.
// This function creates a list of valid references depending
// upon the different fields.
procedure TfrmEntryPoints.ReloadList;
  Procedure GetMinMax(smin, smax: string; var mi, ma: integer);
  Begin
    mi:= SymbolTable.ValueFromText(smin);
    ma:= SymbolTable.ValueFromText(smax);
  end;
var
  wst: TSymbolList;
  st, Rel: string;
  i: integer;
  cb2, NotContain, only3nib: boolean;
  am1, am2, rm1, rm2, nbcls1, nbcls2: integer;
  crossref: integer;
begin
  wst:= GetCurrentTable;                           // fill the input list
  crossref:= 0;

  ListBox1.Clear;
  ListBox2.Clear;                                  // clear lists
  Label6.Caption:= inttostr(ListBox1.Items.Count)+', '+inttostr(crossref);
  ListBox1.Sorted:= chkbSortList.Checked;                                  // wgg
  if wst.count=0 then exit;

  ProgressBar1.Max:= wst.count-1;                  // progress bar
  Panel1.Visible:= True;
  Panel1.Repaint;

  st:= edtName.Text;                                 // st: text patern to look for
  NotContain:= (length(st)<>0) and (st[1]<>'/');   // do we look for the text or 'not the text'
  if not notcontain then st:= copy(st, 2, maxint);
  GetMinMax(edtAdrMin.Text, edtAdrMax.Text, am1, am2);                 // min/max of symbol adr
  GetMinMax(edtAdrMin.Text, edtAdrMax.Text, rm1, rm2);                 // min/max of referance adr
  GetMinMax(edtNumMin.Text, edtNumMax.Text, nbcls1, nbcls2);           // min/max of number of calls
  cb2:= not(chkbUseSup.Checked and (sup.count<>0)); // do we 'cross test' with the list of supported entry point?
  only3nib:= chkb3Nibs.Checked;                    // if this box is checked, the test are made only on the 3 first nibbles of the adr (usefull for flash/rompointers)

  for i:=0 to wst.count-1 do                       // for every object in the list
  Begin
    if i and $FF = 0 then                          // display the progress bar
    Begin
      ProgressBar1.Position:= i;
      label5.caption:= inttostr(i)+'/'+inttostr(wst.count-1);
      label5.Repaint;
    end;
    // the object has to be added if no text is asked
    // or the entry matches the text
    // or the entry does not match the text but the text starts with '/'
    if (length(st)=0) or
       (notContain and (pos(st, TEntry(wst[i]).Text)<>0)) or
       (not(notcontain) and (pos(st, TEntry(wst[i]).Text)=0)) then

      if ((chkbUserSymbols.Checked) And (TEntry(wst[i]).Vue=-1) Or (TEntry(wst[i]).Vue=0))       // wgg
         Or Not chkbUserSymbols.Checked then          // wggt
      begin
        // if 6 nibbles and adr in the boundaries    or 3 nibbles and adr in boundaries
        if ( not(only3nib) and
           ((am1=-1) or (TEntry(wst[i]).Value>=am1)) and
           ((am2=-1) or (TEntry(wst[i]).Value<=am2)) ) or
           ( only3nib and
           ((am1=-1) or (TEntry(wst[i]).Value and $fff>=am1)) and
           ((am2=-1) or (TEntry(wst[i]).Value and $fff<=am2)) ) then
          // if test with entrypoint list and text in entrypoint list
          if Cb2 or (sup.IndexOf(TEntry(wst[i]).Text)<>-1) then
            // test if the number of references is correct
            if (nbcls1=-1) or ((length(TEntry(wst[i]).References)>=nbcls1) and
                               (length(TEntry(wst[i]).References)<=nbcls2)) then
              // test if the references are in the interval
              if ((rm1=-1) and (rm2=-1)) or TEntry(wst[i]).RefBetween(rm1, rm2) then
              Begin
                // add the object
                if TEntry(wst[i]).Value<>-1 then
                begin
                  if TEntry(wst[i]).Vue = -1 then Rel:=' R'
                  else Rel:='';
                  ListBox1.Items.Add(TEntry(wst[i]).Text+' ('+inttohex(TEntry(wst[i]).Value,6)+')'+Rel)
                end else
                  ListBox1.Items.Add(TEntry(wst[i]).Text+' (Undef)');
                inc(crossref,length(TEntry(wst[i]).references));
              end;
      end;

  end;
  // upgrade the number of objects
  Label6.Caption:= inttostr(ListBox1.Items.Count)+', '+inttostr(crossref);
  // hide the progress bar
  panel1.visible:= False;
end;

// if you dblclick on the list1, it goes to the symbol declaration
procedure TfrmEntryPoints.ListBox1DblClick(Sender: TObject);
var
  s: TEntry;
begin
  s:= GetCurEntry;
  if s<>nil then
    debugger.EditAtAddress(s.value);
end;

// give the table of entry that has to be used depending upon the
// ref/unref flag.
// it allows to work with the list of entrypoints or the list
// of unreferenced entrypoints.
function TfrmEntryPoints.GetCurrentTable: TSymbolList;
begin
  if chkbResolved.Checked then
    result:= SymbolTable
  else
    result:= GetNoRefTAble;
end;

procedure TfrmEntryPoints.FormDestroy(Sender: TObject);
begin
  sup.Free;
end;

// load the list of suported entrypoints
procedure TfrmEntryPoints.btnLoadSupClick(Sender: TObject);
begin
  OpenDialog1.Title:= 'Open Reference List';
  OpenDialog1.Filter:='All files (*.*)|*.*';
  if OpenDialog1.Execute then
  Begin
    LoadSuportedEntryPointList(OpenDialog1.FileName, sup);
    if not FileExists(OpenDialog1.FileName) then
      raise exception.create('File does not exist');
  end;
end;

// recreate the list
procedure TfrmEntryPoints.btnExecClick(Sender: TObject);
begin
  ReloadList;
end;

//
procedure TfrmEntryPoints.btnSaveLstClick(Sender: TObject);
var
  i: integer;
  st: TStringList;
begin
  SaveDialog1.Title:='Save Reference List';
  SaveDialog1.Filter:='All files (*.*)|*.*';
  if SaveDialog1.Execute then
  Begin
    st:= TStringList.Create;
    try
      for i:=0 to ListBox1.Items.Count-1 do
        st.Add(ListBox1.items[i]);
      st.Sorted:= True;
      St.SaveToFile(SaveDialog1.FileName);
    finally
      st.Free;
    end;
  end;
end;

// if you press enter on any of the edit fields, it reload the list
procedure TfrmEntryPoints.edtNameKeyPress(Sender: TObject; var Key: Char);
begin
  if key=#13 then
  begin
    ReloadList;
    key:= #0;
  end;
end;

// gives the current entry depending upon the selected item in list1
function TfrmEntryPoints.GetCurEntry: TEntry;
begin
  result:= nil;
  if ListBox1.ItemIndex=-1 then exit;
  result:= TEntry(GetCurrentTable[GetCurrentTAble.IndexOfString(GetToken(ListBox1.Items[ListBox1.ItemIndex], 1))]);
end;

// allow you to load a list of entry to put in the list1
procedure TfrmEntryPoints.btnLoadLstClick(Sender: TObject);
begin
  OpenDialog1.Filter:='All files (*.*)|*.*';
  if Opendialog1.Execute then
    with TStringList.Create do
      try
        LoadFromFile(OpenDialog1.FileName);
        ListBox1.Items.Text:= Text;
      finally
        free;
      end;
end;

// spawn a new window
procedure TfrmEntryPoints.btnNewClick(Sender: TObject);
begin
  with TfrmEntryPoints.Create(application) do
  Begin
    freeoncloce:= true;
    Left:= Self.Left + 10;                                            // wgg stagger windows so user sees them
    Top:= Self.Top + 10;
    Show;
  end;
end;

// close the form and free it if needed
procedure TfrmEntryPoints.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  with TRegIniFile.Create(formKey) do
  Begin
    WriteBool('', 'SortByName', chkbSortList.Checked);
    WriteBool('', 'UserSymbols', chkbUserSymbols.Checked);
    WriteBool('', 'Resolved', chkbResolved.Checked);
    WriteBool('', 'Use3Nibs', chkb3Nibs.Checked);
    free;
  end;
  if freeoncloce then
    Action:= caFree;
end;

// This allows to recreate the suported entry point list
// you first need to load the .lr files
// then to load the supported entry point list
// and then to press this button to regenerate the list
// This will look for _sup and _asup entry
// and put warnings if the entry can not be supported anymore
procedure TfrmEntryPoints.btnRecreateClick(Sender: TObject);
var
  p: integer;
  i, result: integer;
  f, f1, f2, f3: TStringList;
  s1, s: string;
  a, c: integer;
  st: TSpeedStringList;
  st2: TSymbolList;
  o: TSpeedListObject;
  e: TEntry;
  bb: boolean;
  sup: TStringList;
  Procedure FinalTest;
  Begin
    // if not supported or not in vger 1, find a 48 or a flashptr
    if (o=nil) or
       ((((TEntry(o.pointer).vue <> $11) and NOT chkb39.checked) or    // wgg was $01
         ((TEntry(o.pointer).vue <> 0) and chkb39.checked) or
         ((TEntry(o.pointer).Value<a) and
          (TEntry(o.pointer).Value>c))) and
        (not (sup[i][1] in ['~','^']))) then
    Begin
      bb:= true;
      s:= '     Use old 48 entry';
      o:= st.Find('48'+sup[i]);
      // if no, 48, is there a flashpointer?
      if o=nil then
      Begin
        s:= '   Use flashpointer';
        o:= st.Find('^'+sup[i]);
        // if no flahsptr, the entry is not supported
        if o=nil then
        begin
          bb:= false;
          o:=st.find(sup[i]);
          s1:= '* ENTRY not in Vger1! or NON SUPPORTED!  ';
          s:= '';
        end;
      end;
    end;
  end;
begin
  OpenDialog1.Filter:='All files (*.*)|*.*';
  If not OpenDialog1.Execute then exit;
  sup:= TStringList.Create;
  try
    sup.LoadFromFile(OpenDialog1.FileName);
    p:= 0;

    ProgressBar1.Max:= sup.count-1; // progress bar
    Panel1.Visible:= True;
    Panel1.Repaint;

    while p<sup.count do
    Begin
      if length(sup[p])=0 then
        sup.delete(p)
      else
        if (sup[p][1]='=') then
        Begin
          sup[p]:= copy(GetToken(sup[p],1), 2, maxint);
//          Sup.Objects[p]:= pointer(SymbolTable.GetEntryValue(Sup[p]));
          inc(p);
        end else
          sup.delete(p);
      if p and $3F = 0 then
      Begin
        ProgressBar1.Position:= p;
        label5.caption:= inttostr(p)+'/'+inttostr(sup.count-1);
        label5.Repaint;
      end;
    end;

    // entry between these 2 values may change place (if we are on a HP49). and should produce error
    if chkb39.Checked then
    Begin
      a:= $10000; c:= $10000-1;
    end else Begin
      a:= SymbolTable.valuefromtext('LineW');
      c:= SymbolTable.valuefromtext('Chipconfig');
    end;

    f:= TStringList.Create;       // list of valid entry points
    f1:= TStringList.Create;      // list of entry points not in Vger1
    f2:= TStringList.Create;      // list of entry points not suported anymore

    ProgressBar1.Max:= sup.count-1; // progress bar
    Panel1.Visible:= True;
    Panel1.Repaint;

    // create a list of the entry sorted by name for faster search
    st:= TSpeedStringList.create;
    st2:= SymbolTable;
    for i:= 0 to st2.count-1 do
      st.Add(TEntry(st2[i]).text).pointer:= st2[i];

    // for every suported entry points
    for i:=0 to sup.count-1 do
    Begin
      // display progress
      if i and $3F = 0 then
      Begin
        ProgressBar1.Position:= i;
        label5.caption:= inttostr(i)+'/'+inttostr(sup.count-1);
        label5.Repaint;
      end;

      // is there a _sup version?
      s1:= '';
      bb:= false;
      s:= '     sup';
      o:=st.find(sup[i]+'_sup');
      // if not, is there a _asup version?
      if o=nil then
      Begin
        s:= '     asup';
        o:=st.find(sup[i]+'_asup');
        // if not, does the entry exists?
        if o=nil then
        Begin
          // if not, is there a ~_fp_?
          if (sup[i][1]='~') and (st.find('~_fp_'+copy(sup[i],2,Maxint))<>nil) then
          begin
            o:= st.find('~_fp_'+copy(sup[i],2,Maxint));
            s:= ' ~_fp_';
          end else begin
            o:=st.find(sup[i]);
            s:= '';
            FinalTest;
          end;
        end;
      end;

      // if the entry point exists
      if o=nil then
      begin
        o:= st.FindPartial(sup[i]);
        if (o= nil) and (sup[i][1]='~') then
          o:=st.FindPartial('~_fp_'+copy(sup[i],2,maxint));
        if o<>nil then
        begin
          s:= ' partial match';
          s1:= '';
          if sup[i][1]<>'~' then
            FinalTest;
        end;
      end;

      if o=nil then
        // This entry does not exists anymore
        f2.add('* UNEXISTING ENTRY! '+sup[i])
      else Begin
        e:= TEntry(o.pointer);
        result:= e.Value;
        if s1<>'' then
          f1.add(s1+'='+sup[i]+#9'EQU'#9'#'+inttohex(result,5))
        else Begin
          if bb then
          Begin
            f3:= f2;
            s1:= '* problem'#9;
          end else
            f3:= f;
          // flash or romptr?
          if (sup[i][1] in ['~', '^']) or (e.Text[1] in ['~', '^']) then
            // yes, add it to the list
            if length(sup[i])<7 then
              f3.add(s1+'='+sup[i]+#9#9'EQU'#9'#'+inttohex(result,7)+s)
            else
              f3.add(s1+'='+sup[i]+#9'EQU'#9'#'+inttohex(result,7)+s)
          else
            if length(sup[i])<7 then
              f3.add(s1+'='+sup[i]+#9#9'EQU'#9'#'+inttohex(result and $FFFFF,5)+s)
            else
              f3.add(s1+'='+sup[i]+#9'EQU'#9'#'+inttohex(result and $FFFFF,5)+s)
        end;
      end;
    end;

    // merge the lists
    f.add(f1.text);
    f.add(f2.text);
    // save the filan thing
    f.SaveToFile('EntryPointList.Vger');
    // free the stuff
    f.free;
    f1.free;
    f2.free;
    // hide the progress bar
    panel1.visible:= False;
    // open the source
    frmSourceEdit.display('EntryPointList.Vger',0);
  finally
    sup.free;
  end;
end;

procedure TfrmEntryPoints.Mandel1DblClick(Sender: TObject);
begin
  Mandel1.Reset;
end;

procedure TfrmEntryPoints.Reset(Sender: TObject);
begin
  Mandel1.Reset;
end;

procedure TfrmEntryPoints.btnFPTRClick(Sender: TObject);
var
  prolog: TPrologsList;
  bds: array [0..13+4] of integer;
  function TicR(s: string): boolean;
  var
    i, v: integer;
  begin
    i:= SymbolTable.ValueFromText(s);
    if i=-1 then begin result:= true; exit; end;
    v:= Debugger.ReadRom(i);
    if v=0 then begin result:= true; exit; end;
    If (v>$40000) then begin result:= false; exit; end;
    If (v<>SymbolTable.ValueFromText('DOCOL')) then begin result:= true; exit; end;
    result:= CheckFlashP(i, Debugger.ReadRom, prolog, bds);
  end;
var
  i, j, k: integer;
begin
  i:= 0;
  InitPrologues(prolog);
  InitBads(bds);
  Panel1.visible:= true;
  j:= ListBox1.Items.count;
  k:= 0;
  ProgressBar1.Max:= j;
  try
    while i<ListBox1.Items.count do
    begin
      inc(k);
      if (k and $F) = 0 then
      begin
        ProgressBar1.Position:= k;
        Label5.Caption:= inttostr(k)+'/'+inttostr(j)+' '+inttostr(ListBox1.Items.count)+'   entries left';
        application.ProcessMessages;
      end;
      if TicR(GetToken(ListBox1.Items[i],1)) then
        inc(i)
      else
        ListBox1.items.delete(i);
    end;
  finally
    Panel1.visible:= false;
  end;
end;

// litle helper: add n spaces at the end of a string
function addspace(s: string; tab: integer): string;
Begin
  result:= s;
  while length(result)<tab do result:= result+' ';
end;

procedure TfrmEntryPoints.btnReadSupClick(Sender: TObject);
type
  TFiles= record name: string; start: integer; stop: integer; entry: integer; end;
var
  files: array of TFiles;
  Procedure AddFile(f: string; s, e: integer);
  begin
    setlength(files, length(files)+1);
    with files[high(files)] do
    begin name:= f; start:= s; stop:= e; entry:= 0; end;
  end;
  procedure ReadLR(f: TFileName);
    function ExtractModuleDef(st: Tstrings; var scanLine: integer; var moduleName: string; var start, fin: integer): boolean;
    // Extract the first module definition from the ST strings after the ScanLine line
    var
      ps, pe, error: integer;
    Begin
      result:= false;
      while (scanLine<st.count) and (pos('Module=', st[scanLine])=0) do  // Scan for a line with 'Module='
        inc(ScanLine);
      if scanLine>=st.count then                                         // if does not exist: exit
        exit;
      inc(scanLine);
      ps:= pos('Start=', st[scanLine]);                                  // Extract Start and end
      pe:= pos('End=', st[scanLine]);
      if (pe=0) and (pos('Module Contains No Code', st[ScanLine])<>0) then
        Start:= -1
      else begin
        if (ps=0) or (pe=0) then exit;
        val('$'+copy(st[scanLine], ps+6, 5), start, error); if error<>0 then exit;
        val('$'+copy(st[scanLine], pe+4, 5), fin, error);   if error<>0 then exit;
        ModuleName:= copy(st[scanLine-1], 8, pos('.', st[scanLine-1])-8);  // extract the module name
        if copy(ModuleName, 1, 5)='objs/' then ModuleName:= Copy(ModuleName, 6, MaxInt);
        if copy(ModuleName, 1, 5)='objs\' then ModuleName:= Copy(ModuleName, 6, MaxInt);
        start:= (start and $3FFFF);
        fin:= (fin and $3FFFF);
      end;
      result:= true;
    end;
  var
    st: TStringList;
    p, start, fin: integer;
    s: string;
  Begin
    st:= TStringList.Create;
    try
      st.text:= FileToString(f, 20000);
      p:= 0;
      if not ExtractModuleDef(st, p, s, start, fin) then exit;     // extract the module definition
      while ExtractModuleDef(st, p, s, start, fin) do    // extract an input module definition
        if start<>-1 then
          AddFile(s, start, fin);
    finally
      st.free;
    end;
  end;
var
  sup: tstringlist;
  p: integer;
  st: TSpeedStringList;
  st2: TSymbolList;
  o: TSpeedListObject;
  i, j: integer;
begin
  OpenDialog1.Filter:='All files (*.*)|*.*';
  If not OpenDialog1.Execute then exit;
  sup:= TStringList.Create;
  try
    sup.LoadFromFile(OpenDialog1.FileName);
    p:= 0;

    while p<sup.count do
    Begin
      if length(sup[p])=0 then
        sup.delete(p)
      else
        if (sup[p][1]='=') then
        Begin
          sup[p]:= copy(GetToken(sup[p],1), 2, maxint);
          inc(p);
        end else
          sup.delete(p);
    end;

    If Not OpenDialog1.Execute then exit;
    ReadLR(OpenDialog1.FileName);

    // create a list of the entry sorted by name for faster search
    st:= TSpeedStringList.create;
    st2:= SymbolTable;
    for i:= 0 to st2.count-1 do
      st.Add(TEntry(st2[i]).text).pointer:= st2[i];

    Panel1.visible:= true;
    // for every suported entry points
    for i:=0 to sup.count-1 do
    Begin
      // display progress
      if i and $3F = 0 then
      Begin
        ProgressBar1.Position:= i;
        label5.caption:= inttostr(i)+'/'+inttostr(sup.count-1);
        label5.Repaint;
      end;

      // is there a _sup version?
      o:=st.find(sup[i]+'_sup');
      // if not, is there a _asup version?
      if o=nil then
      Begin
        o:=st.find(sup[i]+'_asup');
        // if not, does the entry exists?
        if o=nil then
            o:=st.find(sup[i]);
      end;

      if (o<>nil) and (sup[i][1]<>'~') then
        for j:=low(files) to high(files) do
          with files[j] do
            if (TEntry(o.pointer).Value>start) and (TEntry(o.pointer).Value<stop) then
              inc(entry);

    end;
    Panel1.visible:= False;

    sup.text:= '';
    for j:=low(files) to high(files) do
      with files[j] do
        sup.add(addspace(name, 20)+'  '+addspace(inttostr(entry),5)+'  '+floattostr(entry/(stop-start)*2048));

    sup.SaveToFile('entryspread');
    frmSourceEdit.display('entryspread', 0);

  finally
    sup.free;
  end;

end;

procedure TfrmEntryPoints.chkbSortListClick(Sender: TObject);
begin
  if Not DuringCreate then ReloadList;
end;

procedure TfrmEntryPoints.chkbUserSymbolsClick(Sender: TObject);
begin
  if Not DuringCreate then ReloadList;
end;

end.
