{
  this is the full page editor for the inform box editor.
  This unit is copyright Hewlett Packard
}
unit fmFullPageEdit;

interface

uses
  Windows, SysUtils, Classes, Controls, Forms, Buttons, ExtCtrls, SynEdit,
  ImgList, StdCtrls;

type
  TfrmFullPageEdit = class(TForm)
    Panel1: TPanel;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    SynEdit1: TSynEdit;
    ImageList1: TImageList;
    procedure Memo1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure SynEdit1Enter(Sender: TObject);
    procedure FormActivate(Sender: TObject);
  private
    { Private declarations }
    procedure SaveBookMarks(f: TFileName);                                     // wgg
  public
    { Public declarations }
    Function Execute(f:TFilename; s: String; title:string='Edit'): String;     // wgg
  end;

var
  frmFullPageEdit: TfrmFullPageEdit;

implementation

uses FmMainForm,  fmSourceEdit, Search, FmProject;

{$R *.DFM}

// wgg write any bookmarks to project file
procedure TfrmFullPageEdit.SaveBookMarks(f: TFileName);
var
  i, x, y: integer;
  b: string;
  found: boolean;
begin
  b:= '';
  found:= false;
  for i:= 0 to 9 do
  begin
    if SynEdit1.GetBookMark(i, x, y) then
      if y > 0 then
      begin
        b:= b + intToStr(y);
        found:= true;
      end;
    b:= b + ',';
  end;
  b:= copy(b, 1, length(b)-1);                             // remove final comma
  frmProject.WriteBookmarks(f, b, found);
end;

function TfrmFullPageEdit.Execute(f:TFilename; s: String; title:string='Edit'): String;
begin
  Synedit1.ClearAll;                                           // wgg clear any bookmarks etc. from other uses
  SynEdit1.text:= s;
  Caption:= title;                                             // wgg
  if f<>'' then LoadBookMarks(f, Synedit1);                    // wgg get from project file, must be after text is set
  ActiveControl:= SynEdit1;
  if ShowModal=mrOk then
  begin
    if f<>'' then SaveBookMarks(f);
    result:= SynEdit1.text;
  end
  else
  begin
    if f<>'' then SaveBookMarks(f);
    result:= s;
  end;
end;

procedure TfrmFullPageEdit.Memo1KeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  if (Shift = [ssCtrl]) And (Key=ord('F')) then Search.FindClick(Sender, Key);
  if (Shift = [ssCtrl]) And (Key=ord('R')) then Search.ReplaceClick(Sender, Key);
  if (Shift=[]) And (Key=VK_F3) then Search.NextClick(Sender, Key);

  if (Key=13) and (Shift = [ssCtrl]) then BitBtn1.Click;     // wgg note key 27 intercepted before here (btn CANCEL property)
end;

procedure TfrmFullPageEdit.SynEdit1Enter(Sender: TObject);
begin
  frmMainForm.EditEnter(Sender);                                                // wgg
end;

procedure TfrmFullPageEdit.FormActivate(Sender: TObject);
begin
  if ActiveControl is TSynEdit then frmMainForm.EditActivate(Sender);          // wgg
end;

end.


