{
  this forms allows you to create dialog boxes
  This unit is copyright Hewlett Packard

  Changes marked with WGG are copyright 2002, William G. Graves
 Inform Box designer is :
}

unit fmInformEdit;

interface

uses
  Windows, Classes, Graphics, Controls, Forms, Dialogs, StdCtrls, Spin, ExtCtrls, dib,
  SynEdit, windowsPosSave;

const
  GrowSz: integer = 4;                                                     // wgg for grow boxes on labels, fields
  Types : array [1..11] of string =
  ('IfObReal', 'IfObCmp', 'IfObStr', 'IfObArray', 'IfObInt', 'IfObList', 'IfObId', 'IfObPrg', 'IfObAlg', 'IfObHxs', 'IfObUnit');
  InformInternalDatas= '( Internal Datas: Do not touch!';
  InformHeader = '( Inform Box File ';
  InformHeader48 = InformHeader + '- 48 Style )';                           // wgg
  InformHeader49 = InformHeader + ')';                                      // wgg
  HeaderUseInline = '  ( Inline Text )';
  BeforeDCCP = '% Count for the Message Table ';         // wgg was '% Add this before the Error Message Table ';
  BeforeErrors = '( Messages added to the Library''s Message Table )';         // wgg
  LocalDef= '( Local Definitions )';                                           // wgg from ROM generator

  // wgg the order of the Field types (text, chooseedit, choose, check)
  // was (choose, check, text, chooseedit) in older debug2)
  // we use the following string to tell when we have an old file.
  oldDesigner = 'Inform Box designer is :';                 // wgg only old debug2 has this label
  oldCdB = 'by CdB InformBox Generator';                    // wgg only old ROM generator has this label

  type

  { this class contain a HP graphic and some usefull functions
    clear: clear the graphics
    tidle: create a 1 pixel on 2 grpahics
    copytodib: copy the grob to a dibobject
    copy: draw an object into an other one
    GetStringRep(x: integeR) gives a string representation of the grob in a nibles allined way already shifted for the x coordinate
  }

  THPGrob = class
  private
    Fheight: integer;
    Fwidth: integer;
    procedure Setheight(const Value: integer);
    procedure Setwidth(const Value: integer);
    function Getpixels(x, y: integer): boolean;
    Procedure Setpixels(x, y: integer; const Value: boolean);
  public
    pix: array of boolean;
    procedure Clear;
    procedure tidle;
    procedure copytodib(dib: TDib8; vis: boolean);
    procedure copy(grob: THPGrob; x,y: integer);
    Function GetStringRep(x: integer; zero: boolean = false): string;
    function SetFromStringRep(s: String; shift: integer): integer;
    property pixels[x, y: integer]: boolean read Getpixels write Setpixels;
    property width: integer read Fwidth write Setwidth;
    property height: integer read Fheight write Setheight;
  end;

  { this class is the basic inform field class.
    this is a component that can be draw on a wincontrol, can be move with the mouse (drag&drop)
    and call back if it the boudaries change
  }

   TGrowPanel = class (TPanel)
   Protected
     procedure Paint; override;
   Public
     property canvas;
   end;

 THPObjet = class(TCustomPanel)
  private
    FName: string;
    FModified: boolean;
    procedure SetFName(const Value: string);
  Protected
    p: TGrowPanel;                                                      // wgg
    pResize: TPoint;                                                    // for p above
    bt: TBitmap;
    dib: TDib8;
    FVisible: Boolean;
    lpx, lpy: integer;
    FOnChange: TNotifyEvent;
    Procedure OnPMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);  // wgg
    Procedure OnPMouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    Procedure OnPMouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
    procedure MouseDown(Button: TMouseButton; Shift: TShiftState; X, Y: Integer); override;
    procedure MouseUp(Button: TMouseButton; Shift: TShiftState; X, Y: Integer); override;
    procedure MouseMove(Shift: TShiftState; X, Y: Integer); override;
    Procedure Click; override;
    procedure Resize; override;
    procedure Paint; override;
    procedure SetVisible(const Value: Boolean);
    procedure SetOnChange(const Value: TNotifyEvent);
    procedure CreateP();                                                 // wgg
  public
    hpobj: THPGrob;
    Procedure SetBounds(ALeft, ATop, AWidth, AHeight: integer); override;
    constructor Create(aowner: TComponent); override;
    destructor Destroy; override;
    Function GetSRep: String; virtual;
    Function GetBin: string; virtual;
    Constructor CreateFromBin(s: string; var pos: integer; aowner: TComponent; newVersion: boolean); virtual;
  published
    property Visible2: Boolean read FVisible write SetVisible;
    property OnChange: TNotifyEvent read FOnChange write SetOnChange;
    Property Name: string read FName write SetFName;
    Property Modified: boolean read FModified write FModified;
  end;

  { This object is inherits from THPObjet, it adds one thing: Graphic edition
    By selecting the Edit property to true or false, you can select if the object
    is move when drag&drop occurs or if pixels are turned on or off (right click for of, left for on.
  }

  THPLabel= class(THPObjet)
  private
    FCaption: String;
    procedure SetCaption(const Value: String); virtual;
  protected
    FEditOnOff: boolean;
    Fedit: boolean;
    procedure MouseDown(Button: TMouseButton; Shift: TShiftState; X, Y: Integer); override;
    procedure MouseMove(Shift: TShiftState; X, Y: Integer); override;
  public
    constructor Create(aowner: TComponent); override;
    Procedure SetBounds(ALeft, ATop, AWidth, AHeight: integer); override;
    Function GetSRep: String; override;
    Function GetBin: string;  override;
    Constructor CreateFromBin(s: string; var pos: integer; aowner: TComponent; newVersion: boolean);  override;
  published
    property edit: boolean read Fedit write Fedit;
    Property Caption: String read FCaption write SetCaption;
  end;


  { this objects inherits from THPObj too. it add a help property for inform fields, a field type property
    and a label list property used for labels selection fields
  }

  THPFieldtype = (HPFText, HPFChooseEdit, HPFChoose, HPFChecked, HPFExtended, HPFAlg, HPFChooseLabel);
const
  THPFieldtypes : array [THPFieldtype] of string =('IfFieldTypeText', 'IfFieldTypeChooseEdit', 'IfFieldTypeChoose',
                               'IfFieldTypeCheck', 'IfFieldTypeExtended', 'IfFieldTypeAlg', 'IfFieldTypeLabelChoose');
  THPFieldTypeNames:  array [THPFieldtype] of string = ('Text', 'ChooseEdit', 'Choose',
                               'Check', 'Extended', 'Algebraic', 'LabelChoose');
                              // wgg above names must match the Items value of the combo box
  THPField48: array  [THPFieldtype] of boolean = (True, False, True, True, False, True, False);
  notInHP48: string = 'not in HP48';

type
  THPField= class(THPObjet)
  private
    FFieldtype: THPFieldtype;
    Fhelp: string;
    FChooseL: string;
    FReset: string;
    FInit: string;
    FChooseD: string;
    FAllowedTypes: string;
    FMessageHandler: String;
    FDecompObject: string;
    procedure SetFieldtype(const Value: THPFieldtype);
    procedure SetAllowedTypes(const Value: string);
    procedure SetChooseD(const Value: string);
    procedure SetChooseL(const Value: string);
    procedure SetDecompObject(const Value: string);
    procedure SetInit(const Value: string);
    procedure SetMessageHandler(const Value: String);
    procedure SetReset(const Value: string);
    procedure Sethelp(const Value: string);
  public
    Function GetSRep: String; override;
    procedure SetBounds(ALeft, ATop, AWidth, AHeight: integer); override;
    constructor Create(aowner: TComponent); override;
    Function GetBin: string;  override;
    Constructor CreateFromBin(s: string; var pos: integer; aowner: TComponent; newVersion: boolean);  override;
  published
    Property MessageHandler: String read FMessageHandler write SetMessageHandler;
    property Fieldtype: THPFieldtype read FFieldtype write SetFieldtype;
    property AllowedTypes: string read FAllowedTypes write SetAllowedTypes;
    Property DecompObject: string read FDecompObject write SetDecompObject;
    property ChooseL: string read FChooseL write SetChooseL;
    property ChooseD: string  read FChooseD write SetChooseD;
    Property Reset: string read FReset write SetReset;
    Property Init: string read FInit write SetInit;
    property help: string read Fhelp write Sethelp;
  end;

  { this object is a special type of label. designed to be use as the title.
    it force his own position to 0, 0, 131, 7 and provide a function (reset(s: String)) to
    reset his own grahic to a standard one.
    this field is always in edit mode
  }

  THPTitle = class (THPLabel)
  protected
    procedure SetCaption(const value: string); override;
  public
    procedure SetBounds(ALeft, ATop, AWidth, AHeight: Integer); override;
    constructor Create(aowner: TComponent); override;
    Constructor CreateFromBin(s: string; var pos: integer; aowner: TComponent; newVersion: boolean);  override;
    Function GetBin: string;  override;
  end;

  { The form itself }

  TfrmInformEdit = class(TForm)
    ScrollBox1: TScrollBox;
    PanelDisp: TPanel;
    Panel2: TPanel;
    ComboBox3: TComboBox;
    Label7: TLabel;
    Label8: TLabel;
    GroupBox1: TGroupBox;
    CheckBox5: TCheckBox;
    CheckBox6: TCheckBox;
    CheckBox7: TCheckBox;
    CheckBox8: TCheckBox;
    chkbZint: TCheckBox;
    CheckBox10: TCheckBox;
    CheckBox11: TCheckBox;
    CheckBox12: TCheckBox;
    CheckBox13: TCheckBox;
    CheckBox14: TCheckBox;
    CheckBox15: TCheckBox;
    Label10: TLabel;
    ComboBox4: TComboBox;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    teFieldName: TEdit;
    Panel3: TPanel;
    teLabelText: TEdit;
    Label14: TLabel;
    memHelpString: TEdit;
    Label15: TLabel;
    Label5: TLabel;
    btnGenSource: TButton;
    btnGenForm: TButton;
    Label16: TLabel;
    btnSave: TButton;
    SaveDialog1: TSaveDialog;
    OpenDialog1: TOpenDialog;
    btnOpen: TButton;
    Label18: TLabel;
    Label19: TLabel;
    memInitValue: TMemo;
    memResValue: TMemo;
    Label20: TLabel;
    RadioGroup1: TRadioGroup;
    CheckBox2: TCheckBox;
    CheckBox4: TCheckBox;
    chkbMiniFont: TCheckBox;
    CheckBox17: TCheckBox;
    CheckBox18: TCheckBox;
    CheckBox19: TCheckBox;
    teLabelName: TEdit;
    Label9: TLabel;
    Label21: TLabel;
    btnSaveAs: TButton;
    memDefine: TSynEdit;
    memInit: TSynEdit;
    memEnding: TSynEdit;
    memCode: TSynEdit;
    memSource: TSynEdit;
    Memo3: TSynEdit;
    memChoose: TSynEdit;
    chkbText: TCheckBox;
    Panel4: TPanel;
    Label17: TLabel;
    Label22: TLabel;
    LabelUnitName: TLabel;
    teTitle: TEdit;
    teAuthor: TEdit;
    memMsgHandler: TSynEdit;
    chkbNAMELESS: TCheckBox;
    teUnitName: TEdit;
    chkb48: TCheckBox;
    chkbUseMsgTable: TCheckBox;
    chkbName: TCheckBox;
    Label6: TLabel;
    chkbLocalName: TCheckBox;
    chkbAddDoInform: TCheckBox;
    CheckBoxHelpAddQuote: TCheckBox;
    LabelHelpAddQuote: TLabel;
    CheckBoxMsgAddQuote: TCheckBox;
    LabelMsgAddQuote: TLabel;
    CheckBoxTitleAddQuote: TCheckBox;
    LabelTitleAddQuote: TLabel;
    Panel1: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    ComboBox1: TComboBox;
    CheckBox1: TCheckBox;
    SpinTop: TSpinEdit;
    SpinLeft: TSpinEdit;
    SpinHeight: TSpinEdit;
    SpinWidth: TSpinEdit;
    btnNewLabel: TButton;
    btnNewField: TButton;
    btnDelete: TButton;
    WindowPosSave1: TWindowPosSave;
    procedure FormCreate(Sender: TObject);
    procedure btnNewLabelClick(Sender: TObject);
    procedure SpinTopChange(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure btnGenSourceClick(Sender: TObject);
    procedure CheckBox3Click(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
    procedure btnNewFieldClick(Sender: TObject);
    procedure teFieldNameChange(Sender: TObject);
    procedure memInitValueChange(Sender: TObject);
    procedure teTitleChange(Sender: TObject);
    procedure teUnitNameChange(Sender: TObject);                              // wgg
    procedure memChooseChange(Sender: TObject);
    procedure memResValueChange(Sender: TObject);
    procedure memHelpStringChange(Sender: TObject);
    procedure teLabelTextChange(Sender: TObject);
    procedure ComboBox3Change(Sender: TObject);
    procedure ComboBox4Change(Sender: TObject);
    procedure CheckBox5Click(Sender: TObject);
   { procedure Memo3Change(Sender: TObject);  // wgg BUG see objchange note }
    procedure btnDeleteClick(Sender: TObject);
    procedure btnGenFormClick(Sender: TObject);
    procedure btnSaveClick(Sender: TObject);
    procedure btnOpenClick(Sender: TObject);
    procedure memSourceDblClick(Sender: TObject);
    procedure memo3DblClick(Sender: TObject);
    procedure CheckBox2Click(Sender: TObject);
    procedure teLabelNameChange(Sender: TObject);
    procedure btnSaveAsClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    function Close2: boolean;                                              // wgg
    Procedure FileNames(list: TStringList);
    procedure SpinTopEnter(Sender: TObject);
    procedure SpinHeightEnter(Sender: TObject);
    procedure SpinLeftEnter(Sender: TObject);
    procedure SpinWidthEnter(Sender: TObject);
    procedure chkb48Click(Sender: TObject);
    procedure chkbUseMsgTableClick(Sender: TObject);
    procedure memDefineEnter(Sender: TObject);
    procedure chkbNameClick(Sender: TObject);
    procedure chkbNAMELESSClick(Sender: TObject);
    function CheckReadOnly(Sender: TObject): boolean;                        // wgg
    procedure SetFormCaption(s: string);                                     // wgg
    procedure memDefineKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormActivate(Sender: TObject);
    procedure teEnter(Sender: TObject);
    Procedure SetControlStates;                                              // wgg
    procedure teKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure Memo3Change(Sender: TObject);
    procedure ComboBox3DropDown(Sender: TObject);
    procedure chkbLocalNameClick(Sender: TObject);

  private
    title: THPTitle;  { This contains the title. note, even if the title is not visible, the object is created }
    ItemList: tlist;         { this TList contains all the THPLabel and THPField of the inform box }
    FSelected: THPObjet; { Contains the currently selected object }
    Update: Boolean;
    DCCPS: String;
   { CTESS: String;      }                                  // wgg
    name: String;
    justLF: boolean;                                        // wgg
    Modified: boolean;
    FReadOnly: boolean;                                                       // wgg
    ScreenMaxHeight: Integer;                                                 // wgg calc display height (50 or 80)
    Panel1DefTop: Integer;                                                    // wgg to handle calc display height changes
    Panel2DefTop: Integer;
    Panel3DefTop: Integer;
    Panel4DefTop: Integer;
    PanelDispDefHeight: Integer;
    FormDefHeight: Integer;
    ScrollBox1DefHeight: Integer;
    MemSourceDefHeight: Integer;
    procedure ObjChange(sender: TObject); { Event call back place on every HP Objects }
    Procedure RecreateList; { Recreate the objects selections ComboBox list }
    procedure SetSelected(const Value: THPObjet); { property wrapper on Selected property }
    Function CreateSBin(s: string): string;                                   // wgg just moved from Gen49Source
    procedure Gen48Source;                                                    // wgg
    procedure Gen49Source;
    procedure GenSourceBegin(var IFname:string; var ftab: integer; var NbLab: integer;
                                var NbField: integer; mes: TStringList; local: TStringList;
                                var MesBase: String); // wgg
    procedure GenSourceEnd(IFname:string; ftab: integer; mes: TStringList;
                           local: TStringList; MesBase: String);  // wgg
    procedure AddError(txt: string);                                          // wgg
    procedure OneSource(ind: integer; tab: integer; code: string; comment:string);  // wgg
    procedure DoWarnBox;                                                      // wgg
    procedure SetChkBoxes;                                                    // wgg

//    Procedure CheckAllItems;    { used if the size of the Inform change to verify if all objects ar in the combo box }
  public
    Property Selected: THPObjet read FSelected write SetSelected;
    procedure OpenFile(s: string; new: boolean);                              // wgg
    function EntryNameType: string;                                           // wgg
    function HandlerNameType: string;                                         // wgg
    Procedure NoModified;
    function IsModified: boolean;
    procedure CloseAll;                                                       // wgg
    procedure Set48(b: boolean);                                              // wgg
    function use48Verbs: boolean;                                             // wgg
    function useMsgTable: boolean;                                            // wgg
    property ReadOnly: boolean read FReadOnly write FReadOnly;
  end;

var
  frmInformEdit: TfrmInformEdit;
  fDown: boolean;                     // wgg was Protected in THPObjet
  grobWidth: integer;                 // wgg added to extract width of labels for HP48
  warning: boolean;
  debug2File: boolean;                // wgg loading old file
  UseLocalName: boolean;              // wgg use LOCALNAME for Handler names

implementation

uses
  SysUtils, math, CDBShUtils, fmFullPageEdit, fmMainForm, fmProject,
  fmSourceEdit;

{$R *.DFM}

{ Font creation utility. The font is store as a big string (fontec) that is created from the following HP48 program
<< "" 0 255
  FOR Q
    IF Q 8 MOD 0 ==  THEN 13 CHR 10 CHR + + END
    Q CHR 1 ->GROB ->STR 5 OVER SIZE SUB +
  NEXT
  " " "" SREPL DROP
>>
  then, the InitFonte function initialize an array of 256 hpgrobs used by the disp function.
  the disp function takes 4 arguements:
  A grob where to display the text, a string that is the text ('`' is a CR). and two integers.
  the first one describe the x position where to put the string. 0 is center, 1 is right 2 is left. if bigger than
  2, the mode1 div 16 is the x position.
  idem for mode2 ant y

  HexaStringManagement utilitys
  StringToInt2(s: String): integer;     // input string: hex. result: value represent by the two first chars of the string in lowendian mode
  StringToInt5(s: String): integer;     // idem for 5 nibbles
  StringToInt1(s: String): integer;     // idem for 1 nibble
  IntToString2(i: integer): String;     // Revert operation
  IntToString5(i: integer): String;     // idem for 5 nibbles
  IntToString1(i: integer): String;     // idem for 1 nibble

  the next provided function: InitChecked innitialize the GrobChecked and GrobNotchecked objects
}

var
  GrobChecked, GrobNotChecked: THPGrob;

procedure InitChecked;
  function CreateObj(s: String): THPGrob;
  var
    x, y, t, t2: integer;
  Begin
    result:= THPGrob.Create;
    result.width:= 5;
    result.height:= 8;
    for y:= 0 to result.Height-1 do
    Begin
      val('$'+s[y*2+2]+s[y*2+1], t, t2);
      for x:= 0 to result.width-1 do
        result.pixels[x,y]:= (t and (1 shl x))<>0;
    end;
  end;
Begin
  GrobChecked:= CreateObj('000181D07020F100');
  GrobNotChecked:= CreateObj('000000000000F100');
end;

Function Indend(s: string; i: integer): String;
var
  j: integer;
Begin
  with TStringList.Create do
    try
      text:= s;
      for j:=0 to count-1 do
        strings[j]:= copy('                     ', 1, i)+strings[j];
      result:= text;
    finally
      free;
    end;
end;

Function StringToInt1(s: String): integer;     // idem for 1 nibble
Begin
  if length(s)<1 then
    result:= 0
  else
    result:= pos(s[1],'0123456789ABCDEF')-1;
end;

Function StringToInt2(s: String): integer;     // input string: hex. result: value represent by the two first chars of the string in lowendian mode
Begin
  result:= StringtoInt1(s[1])+ StringtoInt1(s[2]) * 16;
end;

Function StringToInt5(s: String): integer;     // idem for 5 nibbles
Begin
  result:= StringtoInt1(s[1])+ StringtoInt1(s[2]) * 16+ StringtoInt1(s[3]) * 256+ StringtoInt1(s[4]) * 256*16+ StringtoInt1(s[5]) * 65536;
end;

Function IntToString1(i: integer): String;     // idem for 1 nibble
Begin
  result:= '0123456789ABCDEF'[i+1];
End;

Function IntToString2(i: integer): String;     // Revert operation
Begin
  result:= IntToString1(i and $f)+IntToString1((i div 16) and $f);
end;

Function IntToString3(i: integer): String;     // idem for 5 nibbles
Begin
  result:= IntToString1(i and $f)+ IntToString1((i div 16) and $f)+IntToString1((i div 256) and $f);
end;

Function IntToString5(i: integer): String;     // idem for 5 nibbles
Begin
  result:= IntToString1(i and $f)+ IntToString1((i div 16) and $f)+IntToString1((i div 256) and $f)+IntToString1((i div (16*256)) and $f)+IntToString1((i div 65536) and $f);
end;

const
  fontec =
'46007070700000'+
'4600707070000046007070700000460070707000004600707070000046007070700000460070707000004600707070000046007070700000'+
'4600707070000046007070700000460070707000004600707070000046007070700000460070707000004600707070000046007070700000'+
'4600707070000046007070700000460070707000004600707070000046007070700000460070707000004600707070000046007070700000'+
'4600707070000046007070700000460070707000004640607060400046707070707000460000000050004600000000500046000000000000'+
'4620202000200046505000000000462070207020004660302060300046504020105000462050A050B0004620200000000046201010102000'+
'4620404040200046005020500000460020702000004600000000201046000070000000460000000020004600402010000046605050503000'+
'4620302020700046704060107000467040204030004650507040400046701070403000466010305060004670402010100046605020503000'+
'4630506040300046002000200000460020002010004640201020400046007000700000461020402010004630402000200046207030106000'+
'4620507050500046305030503000466010101060004630505050300046701030107000467010301010004660105050600046505070505000'+
'4670202020700046404040506000465050305050004610101010700046507070505000463050505050004620505050200046305030101000'+
'4620505050600046305030505000466010204030004670202020200046505050507000465050505020004650507070500046505020505000'+
'4650502020200046704020107000463010101030004600102040000046604040406000462070202020004600000000700046204000000000'+
'4600605050600046103050503000460060101060004640605050600046006050306000466010301010004660506040300046103050505000'+
'4620003020700046200020201000461050305050004620202020400046005070505000460030505050004600205050200046003050301000'+
'4600605060400046006010101000460060304030004620702020400046005050506000460050505020004600505070500046005020205000'+
'4600506040300046007040207000466020102060004620202020200046302040203000460000A05000004650A050A0500046004020507000'+
'4670005020500046007050200000466020203020004640202020100046701020107000461030703010004600704050500046204060502000'+
'4640207000700046102070007000464070207010004600A05050A000460040F0400000460020F02000004600202070200046207020200000'+
'460040506020204620102050200046601070106000460050A0A080804620507050200046001020505000462050503010004600E050502000'+
'46007020204000460090B0F060004600205070000046F04050505000462050502050004600707070000046005090A0000046000000000000'+
'4620002020200046207010702000466020702070004600906060900046505020702000462020002020004660107060300046500000000000'+
'4600602060000046605060F000004600A050A000004600007040000046000070000000463050305000004670000000000046705070000000'+
'46002070207000461020201030004630203020300046201000000000460050507090004670C0D05050004600002000000046000000204030'+
'4630207000000046205020000000460050A0500000461090D0E080004610509040E0004630A0D0E0B0004620002010600046102050705000'+
'464020507050004620705070500046A07050705000465020507050004620205070500046E050F050D0004660101010603046701030107000'+
'467010301070004670103010700046701030107000461070202070004640702020700046207020207000465070202070004660A0B0A06000'+
'4660305050500046102050502000464020505020004620705050200046A07050502000465020505020004600502050000046407050701000'+
'4610205050700046402050507000462050005070004650005050700046102050702000461070507010004620503050301046102060506000'+
'462010605060004620506050600046A050605060004650006050600046200060506000460060F050E0004600601010603046206050306000'+
'4640605030600046207050306000465060503060004620403020700046402030207000462050302070004650003020700046102020502000'+
'46A0503050500046204020502000462010205020004620502050200046A05020502000465000205020004620007000200046006050503000'+
'46102000506000464020005060004620500050600046500050506000461020506040304610705070100046500050604030';
{'4600707070000046007070700000460070707000004600707070000046007070700000460070707000004600707070000046007070700000'+
'4600707070000046007070700000460070707000004600707070000046007070700000460070707000004600707070000046007070700000'+
'4600707070000046007070700000460070707000004600707070000046007070700000460070707000004600707070000046007070700000'+
'4600707070000046007070700000460070707000004600707070000046007070700000460070707000004600707070000066000000515100'+
'46000000000000261010100010004650500000000066A0F1A0F1A00066E150E041F000461040201040006620506190610026101000000000'+
'3620101010200036102020201000465020702050004600207020000036000000201000460000700000002600000000100046404020101000'+
'4620505050200046302020207000467040701070004670407040700046505070404000467010704070004660107050700046704020101000'+
'4670507050700046705070407000260010001000003600200020100046402010204000460070007000004610204020100046205040202000'+
'566090D010E00046205070505000463050305030004660101010600046305050503000467010701070004670107010100056E010D090E000'+
'46505070505000261010101010004640404050700056905030509000461010101070006611B1511111005690B0F0D0900046705050507000'+
'467050701010005660909050A000463050305050004660102040300046702020202000465050505070004650505020200066111151B11100'+
'4650502050500046505020202000467040201070003630101010300046101020404000363020202030004620500000000046000000007000'+
'3610200000000046205070505000463050305030004660101010600046305050503000467010701070004670107010100056E010D090E000'+
'46505070505000261010101010004640404050700056905030509000461010101070006611B1511111005690B0F0D0900046705050507000'+
'467050701010005660909050A000463050305050004660102040300046702020202000465050505070004650505020200066111151B11100'+
'46505020505000465050202020004670402010700046602030206000261010101010004630206020300056A0500000000046502050205000'+
'5680402050F000467000502050006600F111A04000466020203020004660202020300056F0204020F000461030703010006600F1A0A0A000'+
'562040E0906000564020F000F000562040F000F0006680F140F1200066006190906100562040F0402000564020F020400066404051E04000'+
'6640E0514040005680A0504040004620102050200046601070106000560050A0A080004620507050200056102040A090005640A060201000'+
'5600E05050200056007020A040006600901151A000660040A011F10066F1A0A0A0A00056609090609000460070707000006600A051A00000'+
'4600000000000026100010101000462070107020005660207020F000560090606090006611E040E040002610101010100046007070700000'+
'4650000000000046601010106000460070707000006641A050A0410046000070000000460000700000004630503050500046000070000000'+
'467050700000004600207020700046704070107000467040704070003620100000000056005050F010004600707070000026000010000000'+
'3600000020100046302020207000460070707000006650A041A0500046007070700000460070707000004600707070000046202010502000'+
'4620507050500046205070505000462050705050004620507050500046205070505000462050705050004670107010700046601010106000'+
'4670107010700046701070107000467010701070004670107010700026101010101000261010101010002610101010100026101010101000'+
'463050505030005690B0F0D09000467050505070004670505050700046705050507000467050505070004670505050700046005020500000'+
'6680E051E0200046505050507000465050505070004650505050700046505050507000465050202020004610705070100046205030503000'+
'4620507050500046205070505000462050705050004620507050500046205070505000462050705050004670107010700046601010106000'+
'4670107010700046701070107000467010701070004670107010700026101010101000261010101010002610101010100026101010101000'+
'462010205020005690B0F0D09000467050505070004670505050700046705050507000467050505070004670505050700046200070002000'+
'6680E051E0200046505050507000465050505070004650505050700046505050507000465050202020004610705070100046505020202000';
}
var
  fonte: array [0..255] of THPGrob;

procedure InitFonte;
var
  c, p, x, y, t, t2: integer;
Begin
  p:= 1;
  for c:=0 to 255 do
  begin
    fonte[c]:=  THPGrob.Create;
    fonte[c].width:=4; //remove proportion fonts ord(fontec[p])-ord('0');
    fonte[c].height:=ord(fontec[p+1])-ord('0');
    for y:= 0 to fonte[c].height-1 do
    Begin
      val('$'+fontec[p+2+y*2+1]+fontec[p+2+y*2], t, t2);
      for x:= 0 to fonte[c].width-1 do
        fonte[c].pixels[x,y]:=(t and (1 shl x))<>0;
    end;
    p:= p+14;
  end;
end;

function GetName(s: string): string;
var
  i: integer;
Begin
  for i:= 1 to length(s) do
    case s[i] of
      '0'..'9','A'..'Z','a'..'z' : begin end;
      else s[i]:= '_';
    end;
  result:= s;
end;

Procedure Disp(g: THPGrob; s: string; mode1, mode2: integer);
var
  x, y: integer;
  i, j: integer;
  rx, ry, rx2: integer;
Begin
  if not assigned(g) then exit;
  rx:= 0;
  ry:= 6;
  rx2:= 0;
  for i:= 1 to length(s) do
  Begin
    if (s[i]='`') then
    begin
      if Not frmInformEdit.use48Verbs then
      begin
        ry:= ry+6;
        rx:= max(rx2, rx);
        rx2:= 0;
      end;
    end else begin
      rx2:= rx2+fonte[ord(s[i])].width;
    end;
  end;

  rx:= max(rx2, rx);
  grobWidth:= min(rx*4, 131*4);                     // wgg this is a kludge for getting label widths
  case mode2 of
    0: y:= max((g.Height-ry) div 2, 0);           // wgg center, ry is height, y is added to start
    1: y:= 0;                                     // left
    2: y:= max(g.height-ry, 0);                   // right
    else y:= mode2 div 16;
  end;
  case mode1 of
    0: x:= max((g.width-rx) div 2, 0);            // wgg center, rx is the grob width, x offset from start to add
    1: x:= 0;                                     // wgg left justify
    2: x:= max(g.width-rx, 0);                    // wgg right justify
    else x:= mode1 div 16;
  end;
  rx:= x;
  i:= 1;
  while i<=Length(s) do
    case s[i] of
      '`':
          if Not frmInformEdit.use48Verbs then
          begin
            y:= y+6;
            rx:= x;
            inc(i);
          end;
      '\':
          if i<length(s) then
            if (i+1<length(s)) and (s[i+1]<>'\') then
            begin
              j:= $ff and ((pos(UpperCase(s[i+1]), '0123456789ABCDEF')-1)*16+ (pos(UpperCase(s[i+2]), '0123456789ABCDEF')-1));
              g.copy(fonte[j], rx, y);
              rx:= rx+fonte[j].width;
              inc(i,3);
            end else begin
              g.copy(fonte[ord(s[i])], rx, y);
              rx:= rx+fonte[ord(s[i])].width;
              inc(i,2);
            end
          else begin
            g.copy(fonte[ord(s[i])], rx, y);
            rx:= rx+fonte[ord(s[i])].width;
            inc(i);
          end;
      else
        g.copy(fonte[ord(s[i])], rx, y);
        rx:= rx+fonte[ord(s[i])].width;
        inc(i);
    end;
end;

Function intbin(i: integer): string;
Begin
  result:= '0123456789ABCDEF'[(i div 4096) and $F+1]+
           '0123456789ABCDEF'[(i div 256) and $F+1]+
           '0123456789ABCDEF'[(i div 16) and $F+1]+
           '0123456789ABCDEF'[(i div 1) and $F+1];
end;

Function binint(s: string; var posi: integer): integer;
Begin
  result:= (pos(s[posi], '0123456789ABCDEF')-1)*4096+
           (pos(s[posi+1], '0123456789ABCDEF')-1)*256+
           (pos(s[posi+2], '0123456789ABCDEF')-1)*16+
           (pos(s[posi+3], '0123456789ABCDEF')-1)*1;
  inc(posi, 4);
end;

Function strbin(s: string): string;
var
  i: integer;
Begin
  result:= intbin(length(s));
  for i:=1 to length(s) do
    result:= result+intbin(ord(s[i]));
end;

function binstr(s: string; var pos: integer): string;
var
  i, j: integer;
Begin
  result:= '';
  if length(s) > 0 then
  begin
    i:= binint(s, pos);
    for j:=1 to i do
      result:= result+chr(binint(s, pos));
  end;
end;

function binstr1(s: string): string;              // wgg just binstr with last arg=1
var
  j: integer;
begin
  j:= 1;
  result:= binstr(s, j);
end;

{ THPGrob }

procedure THPGrob.Clear;
var
  i: integer;
begin
  for i:= 0 to length(pix)-1 do
    pix[i]:= false;
end;

procedure THPGrob.copy(grob: THPGrob; x, y: integer);
var
  i, j: integer;
begin
  for i:=0 to grob.Width-1 do
    for j:=0 to grob.height-1 do
      try
        pixels[i+x,j+y]:= grob.pixels[i, j];
      except
      end;
end;

Function THPGrob.SetFromStringRep(s: String; shift: integer): integer;
var
  w, x, y, t, t2: integer;
  a: array [0..150] of boolean;
Begin
  // see GetStringRep for string structur
  shift:= shift and $3;
  w:= StringtoInt2(s);
  Height:= stringtoInt2(s[3]+s[4]);
  width:= stringtoInt2(s[5]+s[6]);
  for y:= 0 to height-1 do
  Begin
    for x:= 0 to w-1 do
    begin
      t:= StringToInt1(s[7+y*w+x]);
      for t2:=0 to 3 do
        a[x*4+t2]:= t and (1 shl t2)<>0;
    end;
    for x:=0 to width-1 do
      pixels[x,y]:= a[x+shift];
  end;
  result:= 6+height*w;
end;

Function THPGrob.GetStringRep(x: integer; zero: boolean = false): string;
var
  rx, y, t, t2, l: integer;
Begin
  // string structure:
  // 2: number of nibbles per lines,           wgg actually #nibbles/line shl 2
  // 3: height of the graphic in lines
  // 2: width in pixels
  // height times width in nibbles nibbles
  rx:= ((x and $3)+width+3) and $fc;
  result:= IntToString2(rx)+IntToString3(height)+IntToString2(width);
  for y:=0 to height-1 do
  Begin
    t:=0; t2:=x and $3;
    for l:=0 to width-1 do
    Begin
      if t2=4 then
      Begin
        result:= result+ IntToString1(t);
        t:=0;
        t2:=0;
      end;
      inc(t2);
      if zero then
        if pixels[l,y] then
          t:=t+(1 shl (t2-1));
    end;
    result:= result+ IntToString1(t);
  end;
end;

procedure THPGrob.copytodib(dib: TDib8; vis: boolean);
var
  i, j: integer;
begin
  try
  if vis then
    dib.colors[10]:= ClWhite
  else
    dib.colors[10]:= ClSilver;
  dib.colors[11]:= clBlack;
  dib.Width:= (width+3) and $ffffc;
  dib.height:= height;
  for i:= 0 to width-1 do
    for j:= 0 to height-1 do
      if pixels[i,height-j-1] then
        dib.pixels[i,j]:= 11
      else
        dib.pixels[i,j]:= 10;
  except
  end;
end;

function THPGrob.Getpixels(x, y: integer): boolean;
begin
  if (x<0) or (y<0) then
    raise Exception.create('can not access this pixel');
  if x>=width then
    raise Exception.create('can not access this pixel');
  if y>=height then
    raise Exception.create('can not access this pixel');
  result:= pix[y*width+x];
end;

procedure THPGrob.Setheight(const Value: integer);
var
  x: integer;
begin
  SetLength(pix, value*width);
  for x:=width*height to value*width-1 do
    pix[x]:= false;
  Fheight := Value;
end;

procedure THPGrob.Setpixels(x, y: integer; const Value: boolean);
begin
  if not assigned(self) then exit;
  if (x<0) or (y<0) then
    exit;
  if x>=width then
    exit;
  if y>=height then
    exit;
  pix[y*width+x]:= value;
end;

procedure THPGrob.Setwidth(const Value: integer);
var
  b: array of boolean;
  x, y: integer;
begin
  SetLength(b, height*value);
  for x:=0 to length(b)-1 do
    b[x]:= false;
  for x:=0 to min(width,value)-1 do
    for y:=0 to height-1 do
      b[y*value+x]:= pix[y*width+x];
  setlength(pix, length(b));
  for x:=0 to length(b)-1 do
    pix[x]:= b[x];
  Fwidth := Value;
end;

procedure THPGrob.tidle;
var
  x, y: integer;
begin
  for y:= 0 to 6 do
    for x:= 0 to 130 do
      pixels[x,y]:= ((x+y) and $1) = 0;
end;

 { THPObjet }

procedure THPObjet.Resize;
begin
  bt.Width:= Width div 4;
  bt.Height:= Height div 4;
  hpobj.width:= width div 4;
  hpobj.height:= height div 4;
  Modified:= true;
  p.SetBounds(Width-GrowSz-1, Height-GrowSz-1, GrowSz, GrowSz);     // wgg
end;

procedure THPObjet.paint;
begin
  if parent=nil then
    exit;
  hpobj.copytodib(dib, Visible2);
  dib.DrawToDC(bt.canvas.handle,0,0);
  Canvas.StretchDraw(Rect(0,0,width,height), bt); 
end;

procedure TGrowPanel.paint;                      // wgg
begin
  inherited;
  Canvas.Pen.Color := clGray;
  Canvas.MoveTo(0, height);
  Canvas.LineTo(width, 0);
//  Canvas.MoveTo(4, height);
//  Canvas.LineTo(width, 4);
end;

procedure THPObjet.SetVisible(const Value: Boolean);
begin
  if FVisible <> Value then Modified:= true;
  FVisible:= Value;
  Paint;
end;

procedure THPObjet.SetOnChange(const Value: TNotifyEvent);
begin
  FOnChange := Value;
end;

destructor THPObjet.destroy;
begin
  bt.free;
  dib.free;
  hpobj.Free;
  p.Free;                                         // wgg
  if assigned(FOnChange) then
    FOnChange(self);
  inherited destroy;
end;

procedure THPObjet.MouseDown(Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  if frmInformEdit.ReadOnly then exit;
  FDown:= true;
  lpx:= (X div 4)*4 + left;                          // wgg  lpx is coord relative to whole panel
  lpy:= (Y div 4)*4 + top;                           // X is relative to field or label
  if Assigned(FONChange) then                        // wgg show properties right away
    FOnChange(Self);
  if Not (self is THPTitle) then                     // wgg
    if FDown And Not frmInformEdit.ReadOnly then     // if field has errors, we lose focus
      Cursor:= crSizeAll;
end;

procedure THPObjet.MouseMove(Shift: TShiftState; X, Y: Integer);
var
  t1, t2, fx, fy: integer;
begin
  if FDown And Not frmInformEdit.ReadOnly then
    begin
      t1:= lpx;
      t2:= lpy;
      fx:= (X div 4)*4;
      fy:= (Y div 4)*4;
      lpx:= fx + left;
      lpy:= fy + top;
      t1:= left + (lpx-t1);             // wgg t1:= left + delta X
      t2:= top + (lpy-t2);
      if (t2 <> top) or (t1 <> left) then
        SetBounds(t1, t2, width, height);
    end
  else
    if Not (self is THPTitle) And Not frmInformEdit.ReadOnly then       // wgg
      Cursor:= crSizeAll
    else
      Cursor:= crDefault;
end;

procedure THPObjet.MouseUp(Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  Cursor:= crDefault;                             // wgg
  fdown:= false;
  if Not frmInformEdit.ReadOnly then SetBounds((left div 4) * 4, (top div 4) * 4, width, height);
end;

// wgg Grow Box events
procedure THPObjet.OnPMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  if (Button = mbLeft) then
  Begin
    if Assigned(FONChange) then                        // wgg show properties right away
      FOnChange(Self);

    pResize.x:= p.left + X; //(X div 4)*4;
    pResize.y:= p.top + Y;  //(Y div 4)*4;
    frmInformEdit.SpinHeightEnter(Sender);
    frmInformEdit.SpinWidthEnter(Sender);
  end;
  BringToFront;
end;

procedure THPObjet.OnPMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
var
  t: TPoint;
  fx, fy: integer;
begin
  (Sender as TPanel).Cursor:=crSizeNWSE;
  if pResize.x<>-1 then
  Begin
    fx:= (X div 4)*4;
    fy:= (Y div 4)*4;
    t:= pResize;
    t.x:= p.left + fx - t.x;
    t.y:= p.top + fy - t.y;
    inc(pResize.x, t.x);
    inc(pResize.y, t.y);
    pResize.x:= min(pResize.x, frmInformEdit.SpinWidth.MaxValue*4 - GrowSz-1);
    pResize.x:= max(pResize.x, frmInformEdit.SpinWidth.MinValue*4 - GrowSz-1);
    pResize.x:= max(pResize.x, 4);                 // or else we can't grab the grow bar
    pResize.y:= min(pResize.y, frmInformEdit.SpinHeight.MaxValue*4 - GrowSz-1);
    pResize.y:= max(pResize.y, frmInformEdit.SpinHeight.MinValue*4 - GrowSz-1);
    SetBounds(left, top, pResize.X+ GrowSz+1, pResize.y + GrowSz+1);
  end;
end;

procedure THPObjet.OnPMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  pResize.x:= -1;
  pResize.y:= -1;
end;

// wgg create a grow box
procedure THPObjet.CreateP();
begin
  pResize.X:= -1;
  p:= TGrowPanel.Create(Self);
  p.Parent:= Self;
  p.BevelOuter:= bvNone;
  p.Color:= Color;
  p.OnMouseDown:= OnPMouseDown;
  p.OnMouseUp:= OnPMouseUp;
  p.OnMouseMove:= OnPMouseMove;
end;

constructor THPObjet.Create(aowner: TComponent);
begin
  inherited create(aowner);
  bt:= TBitmap.Create;
  dib:= TDib8.Create;
  hpobj:= THPGrob.Create;
  Visible2:= true;
  width:= 60*2;
  height:= 8*4;
  fdown:= false;
  CreateP();
end;

constructor THPObjet.CreateFromBin(s: string; var pos: integer; aowner: TComponent; newVersion: boolean);
var
  flagTmp: integer;
begin
  inherited create (aowner);
  bt:= TBitmap.Create;
  dib:= TDib8.Create;
  hpobj:= THPGrob.Create;
  fdown:= false;
  Color:= clWhite;
  CreateP();

  top:= binint(s, pos);
  if top >= (frmInformEdit.ScreenMaxHeight-1)*4 then                                 // wgg for large screens
     top:= (frmInformEdit.ScreenMaxHeight-1)*4;
  left:= binint(s, pos);
  width:= binint(s, pos);
  height:= binint(s, pos);
  flagTmp:= binint(s, pos);
  Visible2:= boolean(flagTmp and 1);

  if newVersion then
    name:= binstr(s, pos);
  modified:= false;
end;

procedure THPObjet.SetBounds(ALeft, ATop, AWidth, AHeight: integer);
begin
  if parent<>nil then
  Begin
    ATop:= Max(ATop, 0);
    ALeft:= Max(ALeft, 0);
    AHeight:= min(AHeight, 40*4);
    if ATop + height > frmInformEdit.ScreenMaxHeight*4 then
      ATop:= frmInformEdit.ScreenMaxHeight*4 - Aheight;
    AWidth:= min(AWidth, 131*4);
    if ALeft + width > 131*4 then
      ALeft:= 131*4 - Awidth;
  end;
  if (ALeft<>Left) or (ATop<>top) or (AWidth<>Width) or (AHeight<>Height) then
  Begin
    inherited SetBounds(ALeft, ATop, AWidth, AHeight);
    modified:= True;                                                            // wgg
    if Assigned(FONChange) then
      FOnChange(Self);
  end;
end;

function THPObjet.GetBin: string;
var
  flagTmp: integer;
begin
  flagTmp:=ord(visible2);

  result:= intbin(top)+intbin(left)+intbin(width)+intbin(height)
         + intbin(flagTmp)
         + strbin(name);
end;

procedure THPObjet.SetFName(const Value: string);
begin
  FName := GetName(Value);
end;

procedure THPObjet.Click;
begin
  if Assigned(FONChange) then
    FOnChange(Self);
end;

function THPObjet.GetSRep: String;
begin
end;

{ THPLabel }

constructor THPLabel.Create(aowner: TComponent);
begin
  inherited create(aowner);
  width:= 60*2;
  height:= 6*4;
  edit:= false;
end;

constructor THPLabel.CreateFromBin(s: string; var pos: integer; aowner: TComponent; newVersion: boolean);
begin
  inherited CreateFromBin(s, pos, aowner, newVersion);
  caption:= binstr(s, pos);
  edit:= false;
end;

function THPLabel.GetBin: string;
begin
  SetCaption(FCaption);                      // wgg will force recalc for HP48 if needed
  result:= 'l'+(inherited GetBin)+strbin(Caption);
end;

function THPLabel.GetSRep: String;
begin
  result:= IntToString3(top div 4)+inttostring2(left div 4)+hpobj.GetStringRep(left div 4);
  result:= IntToString5(length(result)+5)+result;
  result:= IntToStr(ord(Visible2)) + result;
  inherited GetSRep;
end;

procedure THPLabel.MouseDown(Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  if edit then
  begin
    FEditOnOff:= MBLeft = Button;
    try
      hpobj.pixels[x div 4, y div 4]:= FEditOnOff;
    except
    end;
    paint;
    Fdown:= true;
  end else
    inherited MouseDown(Button, shift, x, y);
end;

procedure THPLabel.MouseMove(Shift: TShiftState; X, Y: Integer);
begin
  if FDown then
    if edit then
      begin
        try
          hpobj.pixels[x div 4, y div 4]:= FEditOnOff;
        except
        end;
        paint;
      end else
        inherited MouseMove(shift, x, y)
  else
    inherited MouseMove(shift, x, y);
end;

procedure THPLabel.SetBounds(ALeft, ATop, AWidth, AHeight: integer);
var
  i: integer;
begin
  if frmInformEdit.Use48Verbs And Not (self is THPTitle)then
  begin
    AHeight:= 5*4;
    if ATop > 40*4 then ATop:= 40*4;
    if ATop <7*4 then ATop:= 7*4;
  end;
  i:= width;                                                      // wgg deleted some stuff here
  inherited SetBounds(ALeft, ATop, AWidth, AHeight);
  if width <> i then Disp(HPObj, FCaption, 1, 0);                    // wgg ugly but it does work!
end;

procedure THPLabel.SetCaption(const Value: String);
var
  i: integer;
begin
  if Not (FCaption = Value) Then
    Modified:= true;
  FCaption := Value;
  HPObj.Clear;
  Disp(HPObj, Value, 1, 0);
  if frmInformEdit.use48Verbs then
  begin
    i:= width;
    Width:= grobWidth;
    SetBounds(Left, Top, Width, Height);                       // wgg 48 displays all the text, no width values
    if width <> i then Disp(HPObj, Value, 1, 0);               // wgg ugly but it does work!
  end;
  Paint;
end;

{ THPField }

constructor THPField.Create(aowner: TComponent);
begin
  inherited create(aowner);
  Fieldtype:= HPFText;
  width:= 160;
  height:= 8*4;
  Fieldtype:= HPFText;
  help:= '';
  MessageHandler:= '';
  ChooseL:= '';
  AllowedTypes:= '';
  Reset:= '';
  DecompObject:= 'BINT'+inttostr(2);
  Init:= '';
  ChooseD:= 'ONE';
  Modified:= true;
end;

constructor THPField.CreateFromBin(s: string; var pos: integer; aowner: TComponent; newVersion: boolean);

  // wgg map old debug2 field types to new field types
  function oldNew(f: integer): integer;
  begin
    result:= f;                   // assume new file standard
    if debug2File then            // map debug2 to Debug4x
    case f of
    0: result:= 2;               // Text
    1: result:= 3;               // ChooseEdit
    2: result:= 0;               // Choose
    3: result:= 1;               // Check
    else  result:= 0;
    end;
  end;

begin
  inherited CreateFromBin(s, pos, aowner, newVersion);
  Name          := binstr(s, pos);
  MessageHandler:= binstr(s, pos);
  Fieldtype     := THPFieldtype(oldNew(binint(s, pos)));
  AllowedTypes  := binstr(s, pos);
  DecompObject  := binstr(s, pos);
  ChooseL       := binstr(s, pos);
  ChooseD       := binstr(s, pos);
  Reset         := binstr(s, pos);
  Init          := binstr(s, pos);
  help          := binstr(s, pos);
  if frmInformEdit.use48Verbs And (Not THPField48[FieldType]) then
    FieldType:= HPFChoose ;  // wgg cheat if we find the ChooseEdit type
  Modified:= false;
end;

function THPField.GetBin: string;
begin
  if frmInformEdit.use48Verbs then                               // wgg correct field on way out
  begin
    if (Not THPField48[FieldType]) then FieldType:= HPFChoose ;  // wgg cheat if we find the ChooseEdit type
    SetBounds(Left, Top, Width, Height);                          // force bound change as required
    paint;
  end;
  result:= 'f'+(inherited GetBin)+
           strbin(Name)+
           strbin(MessageHandler)+
           intbin(ord(Fieldtype ))+
           strbin(AllowedTypes  )+
           strbin(DecompObject  )+
           strbin(ChooseL       )+
           strbin(ChooseD       )+
           strbin(Reset         )+
           strbin(Init          )+
           strbin(help          );
end;

function THPField.GetSRep: String;
var
  i: integer;
begin
  result:= IntToString3(top div 4)+inttostring2(left div 4);      
  case Fieldtype of
    HPFChecked:
      try
        i:= strtoint(copy(DecompObject, 5, MaxInt));
        if (i and 1)=0 then
          result:=result+'0'+GrobNotChecked.GetStringRep(left div 4, true)
                        +GrobChecked.GetStringRep(left div 4, true)
        else
          result:=result+'8'+GrobNotChecked.GetStringRep(left div 4, true)
                        +GrobChecked.GetStringRep(left div 4, true)
      except
        result:=result+'0'+GrobNotChecked.GetStringRep(left div 4, true)
                          +GrobChecked.GetStringRep(left div 4,true);
      end;
    else begin result:= result+'3' + hpobj.GetStringRep(left div 4) end;
  end;
//  result:= result+'12';
  result:= result+'00';
  for i:=0 to 31 do result:= result+'00'; // Help String
  result:= IntToString5(length(result)+5)+result;
  result:= IntToStr(ord(Visible2)) + result;
end;

procedure THPField.SetAllowedTypes(const Value: string);
begin
  FAllowedTypes := Value;
  Modified:= true;
end;

procedure THPField.SetBounds(ALeft, ATop, AWidth, AHeight: integer);
begin
  if Fieldtype = HPFChecked then
  begin
    AWidth:= 6*4;
    AHeight:= 8*4;
  end;
  if frmInformEdit.Use48Verbs then                                          // wgg
  begin
    if ATop > 41*4 then ATop:= 41*4;
    if AHeight < 9*4 then AHeight:= 9*4;
    if ATop+AHeight > frmInformEdit.ScreenMaxHeight*4 then ATop:=frmInformEdit.ScreenMaxHeight*4-AHeight;
  end;
  inherited SetBounds(ALeft, ATop, AWidth, AHeight);
end;

procedure THPField.SetChooseD(const Value: string);
begin
  FChooseD := Value;
  Modified:= true;
end;

procedure THPField.SetChooseL(const Value: string);
begin
  // wgg see bug described under TfrmInformedit.objChange before changing this!
  FChooseL := Value;
 { Modified:= true; }  // wgg we cannot do this or any field change leads to modified due to workaround!
end;

procedure THPField.SetDecompObject(const Value: string);
begin
  FDecompObject := Value;
  Modified:= true;
end;

procedure THPField.SetFieldtype(const Value: THPFieldtype);
begin
  if value = HPFChecked then
  Begin
    SetBounds(left, top, 5*4, 8*4);
    hpobj.copy(GrobChecked,0,0);
    Paint;
  end else
  Begin
    hpobj.Clear;
    paint;
  end;
  if FFieldtype = Value then exit;
  FFieldtype := Value;
  if Assigned(FonChange) then
    FOnChange(Self);
  Modified:= true;
end;

procedure THPField.Sethelp(const Value: string);
begin
  Fhelp := Value;
  Modified:= true;
end;

procedure THPField.SetInit(const Value: string);
begin
  FInit := Value;
  Modified:= true;
end;

procedure THPField.SetMessageHandler(const Value: String);
begin
  // wgg see bug described under TfrmInformEdit.objChange before changing this!
  FMessageHandler := Value;
 { Modified:= true; }  // wgg we cannot do this or any field change leads to modified due to workaround!
end;

procedure THPField.SetReset(const Value: string);
begin
  Modified:= true;
  FReset := Value;
end;

{ THPTitle }

constructor THPTitle.create(aowner: TComponent);
begin
  inherited create(aowner);
  SetBounds(0, 0, 131*4, 7*4);
  Resize;
  hpobj.tidle;
  Name:= 'Title';                                  // wgg useful for debug
end;

procedure THPTitle.SetCaption(const value: string);
begin
  hpobj.tidle;
  disp(hpobj, value, 0 , $10);
  if FCaption <> value then
    modified:= True;
  FCaption:= value;
  paint;
end;

procedure THPTitle.SetBounds(ALeft, ATop, AWidth, AHeight: Integer);
begin
  inherited SetBounds(0, 0, 131*4, 7*4);
  modified:= True;                                                            // wgg
end;

constructor THPTitle.CreateFromBin(s: string; var pos: integer; aowner: TComponent; newVersion: boolean);
var
  flagTmp: integer;
begin
  inherited create(aowner);
  SetBounds(0, 0, 131*4, 7*4);
  Resize;
  binint(s, pos);             // top - fields not used for title but keep a place
  binint(s, pos);             // left
  binint(s, pos);             // width
  binint(s, pos);             // height
  flagTmp:= binint(s, pos);   // flags
  frmInformEdit.CheckBoxMsgAddQuote.Checked:= (flagTmp and 2) = 0 ;
  frmInformEdit.CheckBoxHelpAddQuote.Checked:= (flagTmp and 4) = 0 ;
  frmInformEdit.CheckBoxTitleAddQuote.Checked:= (flagTmp and 8) = 0 ;
  // wgg I think this is a bug.  It requires first string to be 0 followed by the real string.
  // software has been out there for some time now, so I will leave it alone.
  caption:= binstr(s, pos);
  if newVersion then
    caption:= binstr(s, pos);
end;

function THPTitle.GetBin: string;
var
  flagTmp: integer;
begin
  flagTmp:=ord(visible2)
         + ord(Not frmInformEdit.CheckBoxMsgAddQuote.Checked) shl 1              // wgg use Not for backwards compatability
         + ord(Not frmInformEdit.CheckBoxHelpAddQuote.Checked) shl 2             // so 0 means checked
         + ord(Not frmInformEdit.CheckBoxTitleAddQuote.Checked) shl 3;

  result:= 'l'+intbin(top)+intbin(left)+intbin(width)+intbin(height)      // use new version flag
         + intbin(flagTmp)
         + '0000'                  // wgg Bug, see comment in Title.CreateFromSource
         + strbin(caption);
end;

{ TForm1 }

procedure TfrmInformEdit.btnNewLabelClick(Sender: TObject);
var
  o: THPLabel;
  i: integer;
  s: string;
begin
  o:= THPLabel.Create(self);
  o.top:= 10;
  o.left:= 10;
  o.parent:= PanelDisp;
  s:= 'Label';                                       // wgg was   Title.Caption+
  i:=1;
  while ComboBox1.Items.IndexOf('Label: '+s+inttostr(i))<>-1 do
    inc(i);
  o.Caption:= s+inttostr(i);
  o.name:= s+inttostr(i);
  o.OnChange:= ObjChange;
  ItemList.add(o);
  RecreateList;
  objchange(o);                                  // wgg was Selected:= o;
end;

procedure TfrmInformEdit.ObjChange(sender: TObject);
begin
  if Selected = Nil then exit;                 // wgg 2/15/05 fix an old exception

  if Sender<>Selected then
  Begin                                        // wgg there is a SynEdit bug if we drag over text, then press DEL
    if Selected <> Nil then                    // the OnChange is fired before the text is updated
      if Selected is THPField then             // move the Edit stuff into the object
        begin
          (Selected as THPField).MessageHandler:= Memo3.Text;
          (Selected as THPField).ChooseL:= MemChoose.Text;
        end;

     if Sender is THPField then
      ComboBox1.ItemIndex:= ComboBox1.Items.IndexOf('Field: '+(Sender as THPObjet).Name)
    else if sender is THPLabel then
      ComboBox1.ItemIndex:= ComboBox1.Items.IndexOf('Label: '+(Sender as THPObjet).Name);
    ComboBox1Change(Combobox1);
  end;

  if (not update) and (Sender=Selected) And (Selected <> Nil) then
    with Selected do
    begin
      Self.Update:= True;
      if SpinTop.Value <> top div 4 then
        SpinTop.Value:= top div 4;
      if SpinLeft.Value <> Left div 4 then
        SpinLeft.Value:= Left div 4;
      if SpinHeight.Value <> height div 4 then
        SpinHeight.Value:= height div 4;
      if SpinWidth.Value <> width div 4 then
        SpinWidth.Value:= width div 4;
      Self.Update:= False;
    end;
end;

procedure TfrmInformEdit.SpinTopChange(Sender: TObject);
begin
  if (not update) and (selected<>nil) then
  Begin
    Update:= True;
    Selected.SetBounds(SpinLeft.Value*4, SpinTop.Value*4, SpinWidth.Value*4, SpinHeight.Value*4);
    Update:= False;
  end;
end;

procedure TfrmInformEdit.CheckBox1Click(Sender: TObject);
begin
  if assigned(selected) then
    Selected.Visible2:= (Sender as TCheckBox).Checked;
end;

Function AddMes(s: string; sl: tStringlist; add: boolean = true): String;
Begin
  result:= '-1';
  if add then
    result:= inttostr(sl.indexof(s));
  if result='-1' then
  Begin
    result:= inttostr(sl.count);
    sl.add(s);
  end;
end;

// some functions used during code generation - shared between the two types of output
Function SourceToText(s: String; l: TStringList; local: TStringList; MesBase: String): String;
var
  i, j: integer;
  s2: String;
Begin
  if (Not frmInformEdit.useMsgTable) then      // wgg currently just pass everything back
  begin
    result:= s;
    exit;
  end;

  Result:= '';
  i:= 1;
  While i<=length(s) do
    if (i<length(s)) and (s[i] = '"') then
      if (s[i+1]<>'"') then
      Begin
        j:=i+1;
        inc(i);
        while (i<=length(s)) and (s[i]<>'"') and (s[i]>=' ') do
          inc(i);
        s2:= copy(s, j, i-j);
        if frmInformEdit.UseMsgTable then
          result:= result+ 'ASSEMBLEM $(5)DOBINT $(5)'+MesBase+'+#'+AddMes(s2,l)+' !RPL'
        else
          result:= result+ '"'+s2+'"';
        inc(i);
      end else begin
        result:= result+'"';
        inc(i, 2);
      end
    else
      if copy(s, i, 9)='LOCALNAME' then
      Begin
        result:= result+'LOCALNAME';
        inc(i, 9);
        j:= i; i:= SkipWhite(s, i); result:= result+copy(s, j, i-j);
        j:= i; i:= FindWhite(s, i); result:= result+copy(s, j, i-j);
        local.add('  LOCAL '+copy(s, j, i-j));
      end else begin
        result:= result+s[i];
        inc(i);
      end;
end;

Function compress(s: string): string;
var
  i, j: integer;
Begin
  result:= '';
  i:= 1;
  while i<=length(s) do
    if s[i]<>'0' then
    Begin
      result:= result+s[i];
      inc(i);
    end else begin
      result:= result+'0';
      inc(i);
      j:= 0;
      while (i<=length(s)) and (j<>15) and (s[i]='0') do begin inc(i); inc(j); end;
      result:= result+'0123456789ABCDEF'[j+1];
    end;
end;

// wgg pad the string, s, to a length, len, if possible, always add at least 1 space
function fixLength(s: string; len: integer): string;
var
  i: integer;
Begin
  result:= s+' ';
  i:= len-length(result);
  if i>0 then
    result:= result + StringOfChar(' ', i);
end;

// wgg convert int to string, prefix with 'BINT' and make length, len
function fixLBint(i: integer; len: integer): string;
Begin
  result:= fixLength('BINT'+inttostr(i), len);
end;

// wgg get line, line, from a long, possible multi-line string
function MemoBoxLine(s: string; line: integer): string;
begin
  with TStringList.Create do
    try
      text:= s;
      result:= '';
      if line<=count then result:= strings[0];
    finally
      free
    end;
end;

// wgg generate a line to memSource.lines
// with indent, ind, code section, padded to length tab and comment section
// code may be multiple lines (solves original problem with indend() adding extra line)
procedure TfrmInformEdit.OneSource(ind: integer; tab: integer; code: string; comment:string);
var
  j: integer;
  s: string;
  function ChkCmnts(sin: string): string;
  begin
    if sin <> '' then
      if sin[1]<>'*' then
        Result:= StringOfChar(' ', ind)+sin
      Else
        Result:= sin
    else
      Result:= sin;
  end;

begin
  with TStringList.Create do
    try
      text:= code;
      s:= '';
      if count>0 then s:= strings[0];
      memSource.Lines.Add(ChkCmnts(fixLength(s, tab)+comment));
      for j:=1 to count-1 do
        memSource.Lines.Add(ChkCmnts(strings[j]));
    finally
      free
    end;
end;

procedure TfrmInformEdit.btnGenSourceClick(Sender: TObject);
begin
  if Not CheckReadOnly(Nil) then
    if use48Verbs then Gen48Source
    else Gen49Source;
end;

// wgg add error message to generated source that will be found and shown by SourceForm scan
procedure TfrmInformEdit.AddError(txt: string);
begin
  memSource.Lines.Add('*| '+frmProject.ShortName(Name)+': '+inttostr(memSource.Lines.Count)+': error: '+txt);   // wgg removed '*| '+
  warning:= true;
end;

procedure TfrmInformEdit.DoWarnBox;
begin
    FDown:= false;                  // wgg warnings can occur during selection
 {   Application.MessageBox('Warning, error messages produced in Inform Box listing',
              'Warning', MB_OK); }       // wgg now we use central reporting
end;

// wgg The original function added #13#10 to break into lines
// this worked when written to the file BUT would fail if generated into
// the source window and then reparsed BECAUSE tSynEdit expects the
// .Add argument to be 1 and only 1 line thus the #13#10 etc becomes a
// giant line which fails on reparse.  If flushed to the disk this all
// would get worked out on the file read!!
Function TfrmInformEdit.CreateSBin(s: string): string;
var
  i: integer;
Begin
  memSource.Lines.Add(copy(s, 1, 100));
  i:= 101;
  while length(s)>=i do
  Begin
    memSource.Lines.Add('S'+copy(s, i, 100));
    inc(i, 100);
  end;
end;

  // Code generation function for HP49
procedure TfrmInformEdit.Gen49Source;
var
  i,k, LabNo, FldNo: integer;
  ftab, NbLab, NbField: integer;
  mes: tstringlist;
  local: tstringlist;                         // wgg from ROM generator code
  IfName, MesBase: String;
  result, def, S1, S2, S3, s: string;
begin
  mes:= TStringList.Create;
  local:= TStringList.Create;
  try
    GenSourceBegin(IFname, ftab, NbLab, NbField, mes, local, MesBase);
    OneSource(0, 0, '( Internal Graphical Datas )', '');
    OneSource(2, 0, 'ASSEMBLEM', '');
    OneSource(2, 0, 'STRING {', '');
    { wgg eventually things must print in this order:
       Uncompressed String Size
       Y Offset -> Number of Fields
       Start of Label Definitions
       Offset to Field Definitions
       Label Definitions
       Field Definitions

      so we have to save up the text and insert lines ahead of the saved portions
      S3 is the final, overall, source block
      S2 is for inner text blocks
      S1 is the inner binaries
    }
    S3:= '';
    S3:= S3 + fixLength('  $(3)#0', fTab)+'% Y offset'#13#10;
    S3:= S3 + fixLength('  $(2)#0', fTab)+'% Current Field'#13#10;
    S3:= S3 + fixLength('  $(2)#'+inttostr(NbLab), fTab)+'% Number of labels'#13#10;
    S3:= S3 + fixLength('  $(2)#'+inttostr(NbField), fTab)+'% Number of fields'#13#10;

    S1:= '';
    S2:= fixLength('% Start of label definitions', fTab)+#13#10;
    for i:= 0 to ItemList.Count-1 do
      if TObject(ItemList[i]) is THPLabel then
      Begin
        S1:=S1+ THPLabel(ItemList[i]).GetSRep;
        S2:= S2 + fixLength('  $'+compress(THPLabel(ItemList[i]).GetSRep), fTab+14)
                +'% Label '+THPLabel(ItemList[i]).name+' definition'#13#10;
      end;

    S3:= S3 + fixLength('  $(5)#'+inttostr(length(S1)+5),fTab)
                        +'% Offset to fields definition'#13#10#13#10 + S2;

    S3:= S3 + fixLength(#13#10'% Start of field definitions', fTab)+#13#10;
    S2:= '';
    for i:= 0 to ItemList.Count-1 do
      if TObject(ItemList[i]) is THPField then
      Begin
        S1:= S1+THPField(ItemList[i]).GetSRep;
        S2:= S2 + fixLength('  $'+compress(THPField(ItemList[i]).GetSRep), fTab+14)
                +'% Field '+THPField(ItemList[i]).name+' definition'#13#10;
      end;
    S3:= S3 + S2;

    S3:= fixLength('  $(5)#'+inttostr(length(S1)+5+9+33*7+1),fTab)
                        +'% Uncompressed string size'#13#10 + S3;
    OneSource(2,0, S3, '');
    OneSource(2,fTab, '}'#13#10, '');
    OneSource(2,fTab, '!RPL FLASHPTR IsUncompressDataString', '( Uncompress the string )');
    OneSource(2,0, '', '');

    if NbLab<>0 then
    Begin
      OneSource(2,fTab, '( Labels graphic, string on the stack )', '');

      result:='';
      LabNo:= 0;
      for i:= 0 to ItemList.count-1 do
        if TObject(ItemList[i]) is THPLabel then
          if UseMsgTable And CheckBoxMsgAddQuote.Checked then
            if result='' then                                 // wgg need 1st message number below
              result:= addmes(THPLabel(ItemList[i]).caption, mes, false)
            else
              addmes(THPLabel(ItemList[i]).caption, mes, false)
          else begin
            if CheckBoxMsgAddQuote.Checked then
              OneSource(2,fTab, fixLength('DUP '+ fixLBint(LabNo,7) + 'FALSE "'+THPLabel(ItemList[i]).caption+'"', 40)
                                         +'FLASHPTR IfSetGrob3', '')
            else
              OneSource(2,fTab, fixLength('DUP '+ fixLBint(LabNo,7) + 'FALSE '+THPLabel(ItemList[i]).caption, 40)
                                         +'FLASHPTR IfSetGrob3', '');
            inc(LabNo);
          end;

      if UseMsgTable And CheckBoxMsgAddQuote.Checked then
      begin
        OneSource(2,fTab, 'ASSEMBLEM $(5)DOBINT $(5)'+MesBase+'+#'+result
                                       +' $(5)DOBINT $(5)#'+inttostr(NbLab), '');
        OneSource(2,fTab, '!RPL FLASHPTR IfSetAllLabelsMessages', '');
      end;
      OneSource(2,0, '', '');
    end;

    if NbField<>0 then
    Begin
      FldNo:= 0;
      OneSource(2,fTab, '( Help strings, string on the stack )', '');
      S1:='';
      for i:= 0 to ItemList.count-1 do
        if TObject(ItemList[i]) is THPField then
          if UseMsgTable And CheckBoxHelpAddQuote.Checked then
            if S1='' then
              S1:= addmes(THPField(ItemList[i]).help, mes, false)
            else
              addmes(THPField(ItemList[i]).help, mes, false)
          else begin
            if CheckBoxHelpAddQuote.Checked then
              OneSource(2,fTab, fixLength(fixLBint(FldNo,7)+'"'+THPField(ItemList[i]).help+'"', 40)
                                              +'FLASHPTR IfSetHelpString', '')
            else
              OneSource(2,fTab, fixLength(fixLBint(FldNo,7)+THPField(ItemList[i]).help, 40)
                                              +'FLASHPTR IfSetHelpString', '');
            inc(FldNo);
          end;

      if UseMsgTable And CheckBoxHelpAddQuote.Checked then
      begin
        OneSource(2,fTab, 'ASSEMBLEM $(5)DOBINT $(5)'+MesBase+'+#'+S1
                                       +' $(5)DOBINT $(5)#'+inttostr(NbField), '');
        OneSource(2,fTab, '!RPL FLASHPTR IfSetAllHelpStrings', '');
      end;
      OneSource(2,0, '', '');
    end;

    if UseMsgTable And CheckBoxTitleAddQuote.Checked then
    begin
      OneSource(2,fTab, '( Title string, string on the stack )', '');
      OneSource(2,fTab, 'ASSEMBLEM $(5)DOBINT $(5)'+MesBase+'+#'+addmes(teTitle.Text, mes), '');
      OneSource(2,fTab, '!RPL FLASHPTR IfSetTitle', '');
    end else
      if CheckBoxTitleAddQuote.Checked then
        OneSource(2,fTab, '"'+teTitle.Text+'" FLASHPTR IfSetTitle', '( Title String )')
      else
        OneSource(2,fTab, teTitle.Text+' FLASHPTR IfSetTitle', '( Title String )');
    OneSource(2,0, '', '');

    OneSource(2,fTab, '( Inform Box Message Handler )', '');

    // wgg see message handler rules just before Field message handler below
    s:= copy(memMsgHandler.Text, SkipWhite(memMsgHandler.Text, 1), MaxInt);
    if (s='') then
      S1:= '''DROPFALSE'
    else
      if s[1]='''' then
        S1:= memMsgHandler.text
      else
        S1:= ''' '+IfName+'Handler';
    OneSource(2, fTab, S1, '( Inform Box Message Handler )');
    OneSource(2,0, '', '');

    if NbField<>0 then
    Begin
      OneSource(0, fTab, '( Field Definitions )', '');
      for i:= 0 to ItemList.Count-1 do
      if TObject(ItemList[i]) is THPField then
        with THPField(ItemList[i]) do
        Begin
          OneSource(2, fTab, '( '+THPField(ItemList[i]).Name+' definition )', '');

          // wgg rules for message handlers:
          // if text, then field will have ' FieldNameHandler
          //    and at end of code NULLNAME FieldNameHandler followed by text
          //
          // if ' name, then simply encode ' name into field table
          // if Nil, then generate 'DROPFALSE into field table
          s:= copy(MessageHandler, SkipWhite(MessageHandler, 1), MaxInt);
          if (s='') then
            S1:= '''DROPFALSE'
          else
            if s[1]='''' then
              S1:= MessageHandler
            else
              S1:= ''' '+Name+'Handler';
          OneSource(2, fTab, S1, '( Field Message Handler )');

          OneSource(2, fTab, THPFieldtypes[Fieldtype], '( Field Type )');
          if AllowedTypes='' then
            OneSource(2, fTab, 'MINUSONE', '( Every type possible )')
          else begin
            S1:= '{ ';
            for k:=1 to length(AllowedTypes) do
              S1:= S1+ Types[pos(AllowedTypes[k], '0123456789A')]+' ';
            OneSource(2, fTab, S1+' }', '( Allowed Types )');
          end;

          OneSource(2, fTab, DecompObject, '( Decomp object )');

          def:= 'MINUSONE';                                // wgg default initial and reset values
          if FieldType = HPFChecked then def:= 'FALSE';    // wgg set default initial and reset value

          if (ChooseL<>'') and (ChooseL<>#13#10) then
          begin
            OneSource(2, fTab, SourceToText(ChooseL, mes, local, mesbase), '( Choose list )');
            OneSource(0, 0, '', '');
            if (FieldType<>HPFChoose) And (FieldType<>HPFChooseEdit) And (FieldType<>HPFChooseLabel) then
              AddError('Choose List supplied but field is not Choose type');
          end else begin
            OneSource(2, fTab, 'MINUSONE', '( No choose list )');
            if (FieldType=HPFChoose) Or (FieldType=HPFChooseEdit) Or (FieldType=HPFChooseLabel) then
              AddError('Field Type is Choose but no Choose List supplied');
          end;

          if (ChooseD='') Or (FieldType=HPFText)
                        Or (FieldType=HPFChecked) then
            OneSource(2, fTab, 'MINUSONE', '( No choose decomp )')
          else
            OneSource(2, fTab, ChooseD, '( Choose decomp )');

          if Reset='' then
          begin
            OneSource(2, fTab, def, '( Reset Value - defaulted )');
            if (FieldType=HPFChoose) Or (FieldType=HPFChooseEdit) Or (FieldType=HPFChooseLabel) then
              AddError('No reset value supplied');
          end else
            OneSource(2, fTab, SourceToText(reset, mes, local, mesbase), '( Reset Value )');

          if Init='' then
          begin
            OneSource(2, fTab, def, '( Initial Value - defaulted )');
            if (FieldType=HPFChoose) Or (FieldType=HPFChooseEdit) Or (FieldType=HPFChooseLabel) then
              AddError('No initial value supplied');
          end else
            OneSource(2, fTab, SourceToText(init, mes, local, mesbase), '( Initial Value )');

          OneSource(0, fTab, '', '');
        end;

        OneSource(0,fTab, '( group the fields definitions in a list )', '');
        OneSource(2,fTab, 'ASSEMBLEM $(5)DOBINT $(5)#8*#'+inttostr(NbField), '');
        OneSource(2,fTab, '!RPL {}N', '');
        OneSource(2,0, '', '');
    end else
      OneSource(2,fTab, '{ }', '( No Fields )');

    OneSource(2,fTab, 'FLASHPTR IfMain2', '');
    OneSource(2,0, '', '');

    GenSourceEnd(IFname, ftab, mes, local, MesBase);
  finally
    mes.free;
    local.free;
  end;

  if warning then DoWarnBox;
end;

// Code generation function for HP48 - wgg (also can be used on 49 in DoInform mode)
procedure TfrmInformEdit.Gen48Source;
var
  i,k: integer;
  ftab, NbLab, NbField: integer;
  mes: tstringlist;
  local: tstringlist;
  IfName, MesBase: String;
  result, lst, def, s: string;
begin
  mes:= TStringList.Create;
  local:= TStringList.Create;
  try
    GenSourceBegin(IFname, ftab, NbLab, NbField, mes, local, MesBase);
    OneSource(0, 0, '( Label Definitions )', '');
    for i:= 0 to ItemList.Count-1 do
      if TObject(ItemList[i]) is THPLabel then
      Begin
        OneSource(2, fTab, fixLength(SourceToText('"'+THPLabel(ItemList[i]).Caption+'"', mes, local, mesbase), 16)
           +fixLBint(THPLabel(ItemList[i]).left div 4, 7)
           +fixLBint(THPLabel(ItemList[i]).top div 4, 7),
           '( '+THPLabel(ItemList[i]).name+' label definition )');
      end;
    OneSource(0, 0, '', '');

    OneSource(0, 0, '( Field Definitions )', '');
    for i:= 0 to ItemList.Count-1 do
      if TObject(ItemList[i]) is THPField then
        with THPField(ItemList[i]) do
        Begin
          OneSource(2, 0, '( '+Name+' field definition )', '');

          // wgg rules for message handlers:
          // if text, then field will have 'FieldNameHandler
          //    and at end of code NULLNAME FieldNameHandler followed by text
          //
          // if 'name, then simply encode 'name into field table
          // if Nil, then generate 'DROPFALSE into field table
          s:= copy(MessageHandler, SkipWhite(MessageHandler, 1), MaxInt);
          if (s='') then
            result:= '''DROPFALSE'
          else
            if s[1]='''' then
              result:= MessageHandler
            else
              result:= ''' '+Name+'Handler';
          OneSource(2, fTab, result, '( Field Message Handler )');

          OneSource(2, ftab, fixLBint(left div 4, 7)
             +fixLBint(top div 4, 7)
             +fixLBint(width div 4, 6)
             +fixLBint(height div 4, 6),
             '( x, y, width, height )');
          OneSource(2, fTab, THPFieldtypes[Fieldtype], '( Field Type )');

          if AllowedTypes='' then
            OneSource(2, fTab, 'MINUSONE', '( Every type possible )')
          else begin
            lst:= '{ ';
            for k:=1 to length(AllowedTypes) do
              lst:= lst+ Types[pos(AllowedTypes[k], '0123456789A')]+' ';
            OneSource(2, fTab, lst+' }', '( Allowed Types )');
          end;

          If DecompObject='BINT0' then DecompObject:= 'BINT1';  // wgg use as default HP48 only
          OneSource(2, fTab, DecompObject, '( Decomp object )');
          OneSource(2, fTab, SourceToText('"'+Help+'"', mes, local, mesbase), '( Help text )');

          def:= 'MINUSONE';         // wgg default initial and reset values
          if FieldType = HPFChecked then def:= 'FALSE';    // wgg set default initial and reset value

          if (ChooseL<>'') and (ChooseL<>#13#10) then
          begin
            OneSource(2, fTab, SourceToText(ChooseL, mes, local, mesbase), '( Choose list )');
            OneSource(0, 0, '', '');
            if (FieldType<>HPFChoose) And (FieldType<>HPFChooseEdit) And (FieldType<>HPFChooseLabel) then
              AddError('Choose List supplied but field is not Choose type');
          end else begin
            OneSource(2, fTab, 'MINUSONE', '( No choose list )');
            if (FieldType=HPFChoose) Or (FieldType=HPFChooseEdit) Or (FieldType=HPFChooseLabel) then
              AddError('Field Type is Choose but no Choose List supplied');
          end;

          if (ChooseD='') Or (FieldType=HPFText)
                        Or (FieldType=HPFChecked) then
            OneSource(2, fTab, 'MINUSONE', '( No choose decomp )')
          else
            OneSource(2, fTab, ChooseD, '( Choose decomp )');

          if Reset='' then
          begin
            OneSource(2, fTab, def, '( Reset Value - defaulted )');
            if (FieldType=HPFChoose) Or (FieldType=HPFChooseEdit) Or (FieldType=HPFChooseLabel) then
              AddError('No reset value supplied');
          end else
            OneSource(2, fTab, SourceToText(reset, mes, local, mesbase), '( Reset Value )');

          if Init='' then
          Begin
            OneSource(2, fTab, def, '( Initial Value - defaulted )');
            if (FieldType=HPFChoose) Or (FieldType=HPFChooseEdit) Or (FieldType=HPFChooseLabel) then
              AddError('No initial value supplied');
          end else
            OneSource(2, fTab, SourceToText(init, mes, local, mesbase), '( Initial Value )');

          OneSource(0, fTab, '', '');
        end;

    OneSource(0, fTab, '( Form Layout Definitions )', '');
    OneSource(2, fTab, fixLBint(NbLab, 7), '( number of labels )');
    OneSource(2, fTab, fixLBint(NbField, 7), '( number of fields )');

    // wgg see message handler rules just before Field message handler above
    s:= copy(memMsgHandler.Text, SkipWhite(memMsgHandler.Text, 1), MaxInt);
    if (s='') then
      result:= '''DROPFALSE'
    else
      if s[1]='''' then
        result:= memMsgHandler.text
      else
        result:= ''' '+IfName+'Handler';
    OneSource(2, fTab, result, '( Inform Box Message Handler )');

    OneSource(2, fTab, SourceToText('"'+teTitle.Text+'"', mes, local, mesbase), '( form title )');
    OneSource(2, fTab, 'DoInputForm', '');
    OneSource(0, fTab, '', '');

    GenSourceEnd(IFname, ftab, mes, local, MesBase);
  finally
    local.Free;
    mes.free;
  end;

  if warning then DoWarnBox;
end;

// wgg Generate the front portion of the form, User Definitions and User Initializations
procedure TfrmInformEdit.GenSourceBegin(var IFname:string; var ftab: integer; var NbLab: integer;
                                var NbField: integer; mes: TStringList; local: TStringList;
                                var MesBase: String);
var
  i: integer;
  s: string;
begin
  fTab:= 34;               // wgg #columns for field definition in source, keep source pretty
  warning:= false;
  modified:= true;
  objChange(Nil);                                               // wgg clear out any hanging edits
  if teUnitName.Text = '' then teUnitName.Text:= teTitle.text;
  teUnitName.Text:= GetName(teUnitName.Text);
  IfName:= teUnitName.text;
  MesBase:= IfName+'MesBase';

  if use48Verbs then s:= InformHeader48
  else s:= InformHeader49;
  if Not useMsgTable then s:= s+HeaderUseInline;
  memSource.Text:= s+'   ( Do not modify this line )'#13#10;

  OneSource(0, 0, '( Inform Box '+ teTitle.Text+' Source Code )', '');
  OneSource(0, 0, '( Generated on '+TimeToStr(now)+' '+DateToStr(now)
                      +' by HP InformBox Generator )', '');
  OneSource(0, 0, '( Inform Box Designer is '+teAuthor.text+' )', '');
  OneSource(0, 0, '', '');
  OneSource(0, fTab+2, 'INCLUDE Header.h', '( Include Standard RPL defs )');
  s:= '';
  if use48Verbs then s:= '48';
  OneSource(0, fTab+2, 'INCLUDE Informbox'+s+'.h', '( Include Definitions )');
  if frmProject.chkbIsLib.Checked then
    OneSource(0, fTab+2, 'INCLUDE '+QuoteIf(ChangeFileExt(ExtractFileName(frmProject.ProjectName), '.h')),
                                               '( Include Project Header )');
  OneSource(0, 0, '', '');

  NbLab:= 0;
  NbField:= 0;
  OneSource(0, 0, '( Field and Label Definitions )', '');
  for i:= 0 to ItemList.Count-1 do
    if TObject(ItemList[i]) is THPLabel then
    Begin
      OneSource(2, 0, 'DEFINE '+fixlength(THPLabel(ItemList[i]).name,20)+fixLBint(NbLab, 7),'');
      inc(NbLab)
    end else
      if TObject(ItemList[i]) is THPField then
      Begin
        OneSource(2, 0, 'DEFINE '+fixlength(THPField(ItemList[i]).name,20)+fixLBint(NbField, 7),'');
        inc(NbField);
      end;
  OneSource(0, 0, '', '');
  OneSource(0, 0, LocalDef, '');    // wgg used for ROMs but we must have this line for search
  OneSource(0, 0, '', '');

  If (memDefine.Lines.text<>'') And (memDefine.Lines.text<>#13#10) then
  Begin
    OneSource(0, 0, '( User Definitions )', '');
    OneSource(2, 0, SourceToText(memDefine.lines.text, mes, local, mesbase), '');
    OneSource(0, 0, '', '');
  end;

  if chkbAddDoInform.checked then OneSource(0, 0, EntryNameType+' Do'+IfName+'Inform', '')      // wgg
  else OneSource(0, 0, EntryNameType+' '+IfName, '');
  OneSource(0, 0, '::', '');
  If (memInit.Lines.text<>'') And (memInit.Lines.text<>#13#10) then
  Begin
    OneSource(0, 0, '( User Initialization Code )', '');
    OneSource(2, 0, SourceToText(memInit.lines.text, mes, local, mesbase), '');
    OneSource(0, 0, '', '');
  end;
end;

// wgg Generate the User EndCode, User Additional Code and Final (binary) section of form
procedure TfrmInformEdit.GenSourceEnd(IFname:string; ftab: integer; mes: TStringList;
                               local: TStringList; MesBase: String);
var
  idType: String;
  i: integer;
  s: string;
begin
    If (memEnding.Lines.text<>'') And (memEnding.Lines.text<>#13#10) then
    Begin
      OneSource(0, fTab, '( User End Code )', '');
      OneSource(2, 0, SourceToText(memEnding.lines.text, mes, local, mesbase), '');
      OneSource(0, 0, '', '');
    end;

    OneSource(0, fTab+2, ';', '( end of form procedure )');
    OneSource(0, 0, '', '');

    s:= copy(memMsgHandler.Text, SkipWhite(memMsgHandler.Text, 1), MaxInt);
    if (s<>'') and (s[1]<>'''') then                // wgg had memMsgHandler.Text<>#13#10 but SkipWhite fixes
    Begin
      OneSource(0, fTab, HandlerNameType+' '+IfName+'Handler', '( Inform Box Message Handler )'); // was EntryNameType
      if Not frmProject.chkbIsLib.Checked then AddError('Cannot have separate Form Message Handler outside of a library');
      OneSource(0, fTab, SourceToText(memMsgHandler.text, mes, local, MesBase), '');
      OneSource(0, 0, '', '');
    end;

    for i:= 0 to ItemList.Count-1 do
    if (TObject(ItemList[i]) is THPField) and (THPField(ItemList[i]).MessageHandler<>'') then
    begin
      s:= copy(THPField(ItemList[i]).MessageHandler, SkipWhite(THPField(ItemList[i]).MessageHandler, 1), MaxInt);
      if (s<>'') and (s[1]<>'''') then                // wgg had memMsgHandler.Text<>#13#10 but SkipWhite fixes
      Begin
        OneSource(0, fTab, HandlerNameType+' '+THPObjet(ItemList[i]).Name+'Handler',            // was EntryNameType
                          '( Field '+THPField(ItemList[i]).Name+' Message Handler )');
        if Not frmProject.chkbIsLib.Checked then AddError('Cannot have separate Field Message Handler outside of a library');
        OneSource(0, fTab, SourceToText(THPField(ItemList[i]).MessageHandler, mes, local, MesBase), '');
        OneSource(0, 0, '', '');
      end;
    end;

    if (memCode.text<>'') And (memCode.text<>#13#10) then
    Begin
      OneSource(0, fTab, '( User Additional Code )', '');
      OneSource(0, fTab, SourceToText(memCode.lines.text, mes, local, mesBase), '');
      OneSource(0, 0, '', '');
    end;

    if Local.Count > 0 then           // wgg insert local definitions that we found
    begin
      i:= 0; while pos(LocalDef, memSource.lines[i])=0 do inc(i);
      memSource.lines.Insert(i+1, Local.Text);    // wgg we have added 2 leading spaces already!
    end;

    OneSource(0, fTab, '(', '');
    OneSource(0, 0, BeforeDCCP, '');   // wgg must not be changed
    DCCPS:= 'DCCP '+inttostr(mes.count)+' '+MesBase;
    OneSource(0, 0, DCCPS, '');
    OneSource(0, 0, ')', '');
    OneSource(0, 0, '', '');

    OneSource(0, 0, '( Messages automatically copied by Inform Generator )', '');
    OneSource(0, 0, BeforeErrors, '');
    for i:= 0 to mes.count-1 do
      OneSource(0, 0, '*  "'+mes[i]+'"', '');
    OneSource(0, 0, '', '');

    OneSource(0, 0, InformInternalDatas, '');
    CreateSBin(title.GetBin);
    CreateSBin(strbin(memMsgHandler.text));
    CreateSBin(strbin(memCode.text));
    CreateSBin(strbin(memEnding.text));
    for i:= 0 to ItemList.count-1 do
      if TObject(ItemList[i]) is THPField then
        CreateSBin(THPField(ItemList[i]).GetBin);
    for i:= 0 to ItemList.count-1 do
      if TObject(ItemList[i]) is THPLabel then
        CreateSBin(THPLabel(ItemList[i]).GetBin);
    CreateSBin(strbin(memInit.text));
    CreateSBin(strbin(memDefine.text));
    CreateSBin(strbin(teAuthor.text));
    CreateSBin(strbin(teUnitName.text));                 // wgg added teUnitName
    idType:='FFFF';                                       // wgg and NULLNAME, xNAME, LOCALNAME flags after that!
    if chkbNAMELESS.Checked then idType[1]:= 'T';
    if chkbNAME.Checked then idType[2]:= 'T';
    if chkbLOCALNAME.Checked then idType[3]:= 'T';
    if chkbAddDoInform.Checked then idType[4]:= 'T';
    CreateSBin(strbin(idType));
    OneSource(0, fTab, ')', '');
end;

procedure TfrmInformEdit.CheckBox3Click(Sender: TObject);
begin
  if Selected is THPLabel then
    (Selected as THPLabel).edit:= (Sender as TCheckBox).Checked;
end;

procedure TfrmInformEdit.RecreateList;
var
  i: integer;
begin
  ComboBox1.Items.Clear;
  for i:=0 to ItemList.count-1 do
    if TObject(ItemList[i]) is THPLabel then
      ComboBox1.Items.Add('Label: '+THPObjet(ItemList[i]).name)
    else
      ComboBox1.Items.Add('Field: '+THPObjet(ItemList[i]).name);
  if Selected <> Nil then
    ComboBox1.ItemIndex:= ItemList.indexof(selected)
  else
    if ItemList.count > 0 then ComboBox1.ItemIndex:= 0;
end;

procedure TfrmInformEdit.ComboBox1Change(Sender: TObject);
begin
  With Sender As TComboBox do
    try
      Selected:= ItemList[Items.IndexOf(Text)];
    except
    end;
end;

procedure TfrmInformEdit.btnNewFieldClick(Sender: TObject);
var
  o: THPField;
  i: integer;
  s: string;
begin
  o:= THPField.Create(self);
  o.top:= 10;
  o.left:= 10;
  o.parent:= PanelDisp;
  o.OnChange:= ObjChange;
  s:= 'Field';                                                                 // wgg was  Title.Caption+
  i:=1;
  while ComboBox1.Items.IndexOf('Field: '+s+inttostr(i))<>-1 do
    inc(i);
  o.Caption:= s+inttostr(i);
  o.Name:= s+inttostr(i);
  ItemList.add(o);
  RecreateList;
  objchange(o);              // wgg was Selected:= o;
end;

procedure TfrmInformEdit.SetSelected(const Value: THPObjet);
  Procedure gc(c: TCheckBox; i: integer);
  Begin
    c.Checked:= (i and (1 shl c.tag)) <> 0;
  end;
var
  i: integer;
  orig: boolean;
begin
  if FSelected=Value then
    exit;
  FSelected := Value;
  orig:= False;                         // wgg just to avoid compiler init error
  if ComboBox1.ItemIndex <> ItemList.IndexOf(Selected) then
    ComboBox1.ItemIndex:= ItemList.IndexOf(Selected);

  if Selected = nil then
  Begin
    Panel2.visible:= False;
    Panel3.visible:= False;
  end else
  orig:= Selected.modified;           // wgg we do not want to change state when we just select the thing
  if Selected is THPLabel then
    With Selected As THPLabel do
    Begin
      if use48Verbs then CheckBox1.Visible:= false           // wgg
      else begin
        CheckBox1.Visible:= true;
        CheckBox1.Checked:= Visible2;
      end;
      SpinHeight.Visible:= Not Use48Verbs;
      SpinWidth.Visible:= Not Use48Verbs;
      Label3.visible:= Not Use48Verbs;
      Label4.visible:= Not Use48Verbs;
      Panel2.visible:= False;
      Panel3.visible:= True;
      teLabelText.Text:= Caption;
      Selected.FOnChange(Selected);
      teLabelName.Text:= name;
    end
  else
  if selected is THPField then
    with selected as THPField do
    Begin
      if use48Verbs then CheckBox1.Visible:= false           // wgg
      else begin
        CheckBox1.Visible:= true;
        CheckBox1.Checked:= Visible2;
      end;
      SpinHeight.Visible:= True;
      SpinWidth.Visible:= True;
      Label3.visible:= True;
      Label4.visible:= True;
      Panel2.visible:= True;
      Panel3.visible:= False;
      teFieldName.Text:= Name;
      ComboBox3.ItemIndex:= ord(FieldType);
      Memo3.Text:= MessageHandler;
      CheckBox5.tag:= -1;
      CheckBox5.Checked:=  pos('0', AllowedTypes)<>0;
      CheckBox6.Checked:=  pos('1', AllowedTypes)<>0;
      CheckBox7.Checked:=  pos('2', AllowedTypes)<>0;
      CheckBox8.Checked:=  pos('3', AllowedTypes)<>0;
      chkbZint.Checked:=  pos('4', AllowedTypes)<>0;
      CheckBox10.Checked:= pos('5', AllowedTypes)<>0;
      CheckBox11.Checked:= pos('6', AllowedTypes)<>0;
      CheckBox12.Checked:= pos('7', AllowedTypes)<>0;
      CheckBox13.Checked:= pos('8', AllowedTypes)<>0;
      CheckBox14.Checked:= pos('9', AllowedTypes)<>0;
      CheckBox15.Checked:= pos('A', AllowedTypes)<>0;
      CheckBox5.tag:= 0;
      ComboBox4.Text:= ChooseD;
      memChoose.Text:= ChooseL;
      memInitValue.lines.text:= Init;
      memResValue.lines.text:= Reset;
      memHelpString.text:= help;
      Selected.FOnChange(Selected);
      try
        i:= strtoint(copy(DecompObject, 5, MaxInt));
        gc(CheckBox2 ,i);
        gc(CheckBox4 ,i);
        if use48Verbs then gc(chkbText,i)
        else gc(chkbMiniFont,i);
        gc(CheckBox17,i);
        gc(CheckBox18,i);
        gc(CheckBox19,i);
      except
        Application.MessageBox('Unable to get Decomp Object, Please re-enter it', 'Unexpected user error!', mb_ok);
        FDown:= False;                                          // wgg in case we just selected field
        CheckBox2 .Checked:= False;
        CheckBox4 .Checked:= False;
        chkbText.Checked:= False;
        chkbMiniFont.Checked:= False;
        CheckBox17.Checked:= False;
        CheckBox18.Checked:= False;
        CheckBox19.Checked:= False;
      end;
    end
  else
  Begin
    Panel2.visible:= False;
    Panel3.visible:= False;
  end;
  if Selected <> nil then
    Selected.Modified:= orig;                                                  // wgg restore state of item
end;

procedure TfrmInformEdit.teFieldNameChange(Sender: TObject);
begin
  if Selected is THPField then
    (Selected as THPField).Name:= (Sender as TEdit).Text;
  RecreateList;
end;

{procedure TForm1.CheckAllItems;
var
  i: integer;
begin
  for i:= 0 to l.count-1 do
    with TObject(l[i]) As THPObjet do
      SetBounds(top, left, width, height);
end;}

procedure TfrmInformEdit.FormCreate(Sender: TObject);
begin
  ScreenMaxHeight:= 50;
  Panel1DefTop:= Panel1.Top;                                     // wgg in case of large calc display
  Panel2DefTop:= Panel2.Top;
  Panel3DefTop:= Panel3.Top;
  Panel4DefTop:= Panel4.Top;
  PanelDispDefHeight:= PanelDisp.Height;
  FormDefHeight:= Height;
  ScrollBox1DefHeight:= ScrollBox1.Height;
  MemsourceDefHeight:= MemSource.Height;

  chkbUseMsgTable.Checked:= True;                       // wgg default for now
  frmInformEdit.CheckBoxMsgAddQuote.Checked:= true;
  frmInformEdit.CheckBoxHelpAddQuote.Checked:= true;
  frmInformEdit.CheckBoxTitleAddQuote.Checked:= true;
  ItemList:= tlist.create;
  InitFonte;
  InitChecked;
  title:= THPTitle.Create(self);
  title.parent:= PanelDisp;
  title.Caption:= teTitle.text;

  Selected:= nil;
  chkb48.Checked:= False;                                 // wgg type of "generate" to use
  name:= '';
  WindowPosSave1.ReadPos;
  Hide;                              // wgg we dont want windowPosSave to make us visible
  NoModified;
  justLF:= False;
end;

procedure TfrmInformEdit.Set48(b: boolean);    // wgg use on new project open
begin
  chkb48.Checked:= b;
  chkb48Click(Nil);
  NoModified;
end;

procedure TfrmInformEdit.memInitValueChange(Sender: TObject);
begin
  if Selected is THPField then
    (Selected as THPField).Init:= (Sender as TMemo).lines.Text;
end;

procedure TfrmInformEdit.teTitleChange(Sender: TObject);
begin
  title.Caption:= teTitle.Text;
end;

procedure TfrmInformEdit.memResValueChange(Sender: TObject);
begin
  if Selected is THPField then
    if sender is Tmemo then
      (Selected as THPField).Reset:= (Sender as TMemo).Text
    else
      if sender is TSynEdit then
        (Selected as THPField).Reset:= (Sender as TSynEdit).Text
end;

procedure TfrmInformEdit.memHelpStringChange(Sender: TObject);
begin
  if Selected is THPField then
    (Selected as THPField).Help:= (Sender as TEdit).Text;
end;

procedure TfrmInformEdit.teLabelTextChange(Sender: TObject);
begin
  if Selected is THPLabel then
    with Selected as THPLabel do
      Caption:= (Sender as TEdit).Text;
end;

procedure TfrmInformEdit.Memo3Change(Sender: TObject);
begin
  // wgg see bug described under TfrmInformEdit.objChange before changing this!
  Modified:= true;
{  if Selected is THPField then
    with Selected as THPField do
      (Selected as THPField).MessageHandler:= Memo3.Text;  }
end;

procedure TfrmInformEdit.memChooseChange(Sender: TObject);
begin
  // wgg see bug described under TfrmInformEdit.objChange before changing this!
  Modified:= true;
 { if Selected is THPField then
    if sender is Tmemo then
      (Selected as THPField).ChooseL:= (Sender as TMemo).Text
    else
      if sender is TSynEdit then
        (Selected as THPField).ChooseL:= (Sender as TSynEdit).Text }
end;

procedure TfrmInformEdit.ComboBox3Change(Sender: TObject);
begin
  CheckReadOnly(Sender);
  if ReadOnly then exit;
  if Selected is THPField then              // wgg try to get a good field type
    with (Sender as TComboBox) do
      if text = notInHP48 then
        if THPField48[(Selected as THPField).Fieldtype] then
          ItemIndex:= ord((Selected as THPField).Fieldtype)
        else
        begin              // wgg we cheat a little here, because we know HPFChooseEdit is not allowed!
          (Selected as THPField).Fieldtype:= HPFChoose;    // so use HPFChoose instead!
          ItemIndex:= ord(HPFChoose)
        end
      else
        (Selected as THPField).Fieldtype:= THPFieldtype(items.indexOf(text));
end;

procedure TfrmInformEdit.ComboBox4Change(Sender: TObject);
begin
  CheckReadOnly(Sender);
  if ReadOnly then exit;
  if Selected is THPField then
    (Selected as THPField).ChooseD:= (Sender as TComboBox).Text;
end;

procedure TfrmInformEdit.CheckBox5Click(Sender: TObject);
const
  s = '0123456789A';
begin
  if CheckBox5.tag= -1 then exit;
  if Selected is THPField then
    With Selected as THPField do
    Begin
      AllowedTypes:= '';
      if CheckBox5.Checked  then
        AllowedTypes:= AllowedTypes+s[CheckBox5.tag+1];
      if CheckBox6.Checked  then
        AllowedTypes:= AllowedTypes+s[CheckBox6.tag+1];
      if CheckBox7.Checked  then
        AllowedTypes:= AllowedTypes+s[CheckBox7.tag+1];
      if CheckBox8.Checked  then
        AllowedTypes:= AllowedTypes+s[CheckBox8.tag+1];
      if chkbZint.Checked  then
        AllowedTypes:= AllowedTypes+s[chkbZint.tag+1];
      if CheckBox10.Checked then
        AllowedTypes:= AllowedTypes+s[CheckBox10.tag+1];
      if CheckBox11.Checked then
        AllowedTypes:= AllowedTypes+s[CheckBox11.tag+1];
      if CheckBox12.Checked then
        AllowedTypes:= AllowedTypes+s[CheckBox12.tag+1];
      if CheckBox13.Checked then
        AllowedTypes:= AllowedTypes+s[CheckBox13.tag+1];
      if CheckBox14.Checked then
        AllowedTypes:= AllowedTypes+s[CheckBox14.tag+1];
      if CheckBox15.Checked then
        AllowedTypes:= AllowedTypes+s[CheckBox15.tag+1];
    End;
end;

procedure TfrmInformEdit.btnDeleteClick(Sender: TObject);
var
  o: THPObjet;
begin
  if Selected<>nil then
  Begin
    o:= Selected;
    Selected:= nil;
    ItemList.Remove(o);
    o.free;
    RecreateList;
  end;
end;

procedure TfrmInformEdit.btnGenFormClick(Sender: TObject);
var
  i, j, dh: integer;
  kkk: string;
  HPtemp: THPObjet;

  Function GetSBin(var i: integer): string;
  begin
    result:= '';
    if i<memSource.lines.count then
    begin
      result:= memSource.lines[i];
      inc(i);
      while (i<memSource.lines.count) and (length(memSource.lines[i])>=1) and
            (memSource.lines[i][1]='S') do
      Begin
        result:= result+ copy(memSource.lines[i], 2, MaxInt);
        inc(i);
      end;
    end;
  end;

begin
  //frmProject.InformHeight:= 66;               // wgg either 66 or 50
  ScreenMaxHeight:= frmProject.InformHeight;
  dh:= (frmProject.InformHeight-50)*4;
  Panel1.Top:= Panel1DefTop + dh;                                                  // wgg in case of large calc display
  Panel2.Top:= Panel2DefTop + dh;
  Panel3.Top:= Panel3DefTop + dh;
  Panel4.Top:= Panel4DefTop + dh;
  PanelDisp.Height:= PanelDispDefHeight + dh;
  Height:= FormDefHeight + dh;
  ScrollBox1.Height:= ScrollBox1DefHeight + dh;
  MemSource.Height:= MemSourceDefHeight + dh;

  modified:= true;
  i:= 0;
  // wgg an old debug2 source file will have oldDesigner string in line 4
  debug2File:= (pos(oldDesigner, memsource.text)<>0) OR
               (pos(oldCdB, memsource.text)<>0);
  if debug2File then
  begin
    chkbAddDoInform.Checked:= True;           // wgg add Do...Inform to entry name
  end;
  chkb48.Checked:= pos(InformHeader48, memSource.Lines[i])<>0;         // wgg check for 48 files
  chkbUseMsgTable.Checked:= Not (pos(HeaderUseInline, memSource.Lines[i])<>0);  // wgg check for Inline Messages

  while (i<memSource.Lines.count) and (pos(InformInternalDatas, memSource.lines[i])=0) do inc(i);
  if i=memSource.lines.count then raise Exception.Create('Error, missing "Internal Data Codes"');

  while ItemList.count<>0 do
  Begin
    Selected:= NIl;                               // wgg stop objChange from access bad info
    HPtemp:= THPObjet(ItemList[0]);                      // must remove object then free it
    ItemList.Delete(0);                                  // or call back to objchange will get us
    HPTemp.free;                                  // if nil object still in list
  end;
  title.free;
  j:=2;
  inc(i);
  if memSource.lines[i][1]='L' then
    title:= THPTitle.CreateFromBin(GetSBin(i), j, self, false)
  else
    title:= THPTitle.CreateFromBin(GetSBin(i), j, self, true);
  title.parent:= PanelDisp;
  title.Paint;
  teTitle.text:= title.Caption;

  memMsgHandler.Text:= binstr1(GetSBin(i));
  memCode.Text:= binstr1(GetSBin(i));
  memEnding.Text:= binstr1(GetSBin(i));

  while (i<memSource.Lines.Count) and (memSource.lines[i][1] in ['L','F','l','f']) do
  begin
    j:= 2;
    case memSource.lines[i][1] of
      'L': ItemList.Add(THPLabel.CreateFromBin(GetSBin(i), j, self, false));
      'F': ItemList.Add(THPField.CreateFromBin(GetSBin(i), j, self, false));
      'l': ItemList.Add(THPLabel.CreateFromBin(GetSBin(i), j, self, true));
      'f': ItemList.Add(THPField.CreateFromBin(GetSBin(i), j, self, true));
    end;
  end;

  for j:=0 to ItemList.Count-1 do
  Begin
    THPObjet(ItemList[j]).parent:= PanelDisp;
    THPObjet(ItemList[j]).OnChange:= ObjChange;
    if THPObjet(ItemList[j]) is THPLabel then
      THPLabel(ItemList[j]).Caption:= THPLabel(ItemList[j]).Caption;
    if THPObjet(ItemList[j]) is THPField then
      THPField(ItemList[j]).Fieldtype:= THPField(ItemList[j]).Fieldtype;
    THPObjet(ItemList[j]).Paint;
  end;
  RecreateList;

  memInit.Text:= binstr1(GetSBin(i));
  memDefine.Text:= binstr1(GetSBin(i));
  teAuthor.Text:= binstr1(GetSBin(i));
  teUnitName.text:= '';                               // wgg added teUnitName to end of binaries
  teUnitName.Text:= binstr1(GetSBin(i));
  teUnitName.Text:= StringReplace(teUnitName.Text, ' ', '_');    // wgg                                          // wgg
  chkbNAMELESS.Checked:= false;
  chkbNAME.Checked:= false;
  kkk:= binstr1(GetSBin(i));                          // wgg and NULLNAME, xNAME, LOCALNAME flags after that!
  if kkk <> '' then
  begin
    if length(kkk)<4 then kkk:= kkk + StringOfChar(' ', 4-length(kkk));
    chkbNAMELESS.Checked:= (kkk[1] = 'T');
    chkbNAME.Checked:= (kkk[2] = 'T');
    chkbLOCALNAME.Checked:= (kkk[3] = 'T');
    chkbAddDoInform.Checked:= (kkk[4] = 'T');
  end;

  // wgg  to force consistency with combo box and rest of display
  if ComboBox1.Items.Count > 0 then
  begin
    ComboBox1.ItemIndex:= 0;
    ComboBox1Change(Combobox1);
  end;

end;

procedure TfrmInformEdit.btnSaveClick(Sender: TObject);
//var
//  fn, pa: String;
begin
  if (name = '') And Not IsModified then exit;
  if (Not IsModified) And ReadOnly then exit;
  if name='' then
    btnSaveAsClick(nil)
  else Begin
    if use48Verbs then Gen48Source
    else Gen49Source;
    if justLF then StringToFile(crRemove(memSource.text), name)              // wgg
    else StringToFile(memSource.text, name);
    frmSourceEdit.Refresh(name);
//    fn:= ExtractFileName(name);
//    pa:= ExtractFilePath(name);
//    StringToFile('ASSEMBLEM'#13#10+DCCPS+#13#10'!RPL', ChangeFileExt(pa+'ErrorNb_'+fn, '.inc'));
//    StringToFile(CTESS, ChangeFileExt(pa+'ErrorList_'+fn, '.inc'));
  end;
  NoModified;
end;

procedure TfrmInformEdit.btnOpenClick(Sender: TObject);
var
  f: TFileName;
begin
  OpenDialog1.Filter:= 'Source Files (*.s, *.h)|*.S;*.H|All Files (*.*)|*.*';
  OpenDialog1.Title:='Open Inform File';
  if OpenDialog1.Execute then
  begin
    f:= OpenDialog1.FileName;
    if Close2 then
      begin
        nomodified;
        name:= '';
        if pos(InformInternalDatas, FileTostring(f))<>0 then
          OpenFile(f, False)
        else
          frmSourceEdit.Display(f, 0);
      end;
  end;
end;

procedure TfrmInformEdit.memo3DblClick(Sender: TObject);                              // wgg added title strings
var
  t: string;
begin
  Case (Sender as TMemo).tag of                                                // wgg added titles
   0: t:= 'Initial Value';
   1: t:= 'Reset Value';
   else
      t:= 'Edit';
   end;
  (sender as TMemo).lines.text:= frmFullPageEdit.Execute('', (sender as TMemo).lines.text, t);
end;

procedure TfrmInformEdit.memSourceDblClick(Sender: TObject);
var
  t,f: string;
begin
  f:= '';
  Case (Sender as tSynEdit).tag of                                             // wgg added titles
   0: t:= 'Definitions';
   1: t:= 'Initialization Code';
   2: t:= 'Ending Code';
   3: t:= 'Additional Code';
   4: begin
        t:= 'Generated Source Code';
        f:= name;                                                              // need for bookmarks
      end;
   5: t:= 'Form Message Handler';                                              // wgg added title strings
   6: t:= 'Field Message Handler';
   7: t:= 'Choose Box';
   else
      t:= 'Edit';
   end;
  (sender as TSynEdit).text:= frmFullPageEdit.Execute(f, (sender as TSynEdit).text, t);
  if assigned((Sender as TSynEdit).OnEnter) then
    (Sender as TSynEdit).OnEnter(Sender);
  if assigned((Sender as TSynEdit).OnChange) then
    (Sender as TSynEdit).OnChange(Sender);
end;

procedure TfrmInformEdit.CheckBox2Click(Sender: TObject);
var
  i: integer;

  function pw(c: TCheckBox): integer;
  Begin
    if c.checked then
      result:= 1 shl c.tag
    else
      result:= 0;
  end;
begin
  if Selected is THPField then
  begin
    i:= pw(CheckBox2)+pw(CheckBox17)+pw(CheckBox19)+pw(CheckBox4)+pw(CheckBox18);
    if use48Verbs then  i:= i+pw(chkbText)
    else i:= i+pw(chkbMiniFont);
    (Selected as THPField).DecompObject:= 'BINT'+inttostr(i);
  end;
end;

procedure TfrmInformEdit.teLabelNameChange(Sender: TObject);
begin
  if Selected.name<>teLabelName.Text then
  begin
    Selected.name:= teLabelName.Text;
    Selected.Modified:= true;
  end;
  RecreateList;
end;

procedure TfrmInformEdit.SetFormCaption(s: string);                                // wgg
begin
  if s='' then s:= name;
  if ReadOnly then
    Caption:= 'Inform Edit: '+s+' (read-only)'
  else
    Caption:= 'Inform Edit: '+s;
end;

{$WARN SYMBOL_PLATFORM OFF}             // wgg dont warn about FileGetAttr call
procedure TfrmInformEdit.btnSaveAsClick(Sender: TObject);
begin
 SaveDialog1.InitialDir:= frmProject.ProjectDir;
 SaveDialog1.Filter:='Source files (*.s)';
 SaveDialog1.Title:='Save Inform File';
  if SaveDialog1.Execute then
  Begin
    SetFormCaption(ExtractFileName(SaveDialog1.FileName));          // wgg
    name:= SaveDialog1.FileName;
    btnSaveClick(nil);
    if (FileGetAttr(SaveDialog1.FileName) and faReadOnly) <> 0 then ReadOnly:= true    // wgg
    else ReadOnly:= false;
    SetControlStates;                               // wgg and set the form
  end;
  NoModified;
end;

procedure TfrmInformEdit.OpenFile(s: string; new: boolean);
var
  t: string;
begin
  if Close2 then                                                    // wgg
  begin                                                             // wgg needed here for cleanup
    NoModified;
    name:= (s);
    SetFormCaption(s);                                             // wgg
    if frmSourceEdit.UseRealTabs then                            // wgg
      t:= FileToString(s)
    else
       t:= RemoveTab(FileToString(s), frmSourceEdit.Editor.TabWidth);
    if (FileGetAttr(s) and faReadOnly) <> 0 then ReadOnly:= true    // wgg
    else ReadOnly:= false;
    justLF:= Not crScan(t);
    memSource.Text:= t;            // wgg was  memSource.Lines.LoadFromFile(s);
    show;                  // wgg used to be after btnSetFromClick but labels dont show
    btnGenFormClick(nil);

    // wgg  to force consistency with combo box and rest of display
    if ComboBox1.Items.Count > 0 then
    begin
      ComboBox1.ItemIndex:= 0;
      ComboBox1Change(Combobox1);
    end
    else
      Selected:= Nil;
    if Not new then NoModified;           // wgg needed 2nd time for state of the file, GenFormClick will set
  end;
  CheckReadOnly(Nil);                     // wgg just warn the user
  SetControlStates;                       // wgg and set the form
end;

// wgg this is used for the form entry point
function TfrmInformEdit.EntryNameType: string;
begin
    result:= 'NULLNAME';
    if chkbNAMELESS.Checked then result:= 'NAMELESS';
    if chkbNAME.Checked then result:= 'xNAME';
end;

// wgg this is used for the handlers entry point
function TfrmInformEdit.HandlerNameType: string;
begin
    if UseLocalName then result:= 'LOCALNAME'
    else result:= 'NULLNAME';
end;

procedure TfrmInformEdit.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  if Not Close2 then
    Action:= caNone    // wgg abort
  else
  begin
    nomodified;
    name:= '';         // signals empty file
  end;
end;

// warning: if Close2 returns True but user said "No" nomodified has NOT been called
Function TfrmInformEdit.Close2(): boolean;                              // wgg broke into this new routine
var
  i: integer;
begin                                                            // also changed wording of message
  result:= True;
  if IsModified And (name<>'') then
    begin
      i:= Application.MessageBox(PChar('Save form modifications in '+name+'?'),
                                      'Warning', mb_YESNOCANCEL);
      case i of
        IDYES: begin
          btnSaveClick(nil);
          nomodified;
          end;
        IDNO: ;
        IDCANCEL: result:= False;
      end;
    end
end;

// Forced clear and close of all files for switching projects
// Presume that a save dialog has already taken place
procedure TfrmInformEdit.CloseAll;
begin
    nomodified;
    name:= '';
    hide;
end;

procedure TfrmInformEdit.teUnitNameChange(Sender: TObject);                           // wgg added
begin
  Modified:= true;
end;

 // Return a list of files currently open in the inform editor (currently a max of 1!)
Procedure TfrmInformEdit.FileNames(list: TStringList);            // wgg
Begin
  if name <> '' then
    if UpperCase(ExtractFileDir(name))=UpperCase(frmProject.ProjectDir) then
      list.add('*' + ExtractFileName(name))
    else
      list.add('*' + name);
end;

procedure TfrmInformEdit.NoModified;
var
  i: integer;
begin
  modified:= false;
  for i:= 0 to ItemList.Count-1 do
    if TObject(ItemList[i]) is THPObjet then
      THPObjet(ItemList[i]).modified:= false;
  Title.Modified:= false;
end;

function TfrmInformEdit.IsModified: boolean;
var
  i: integer;
begin
  result:= modified;
  for i:= 0 to ItemList.Count-1 do
    if TObject(ItemList[i]) is THPObjet then
      result:= result or THPObjet(ItemList[i]).modified;
  result:= result or Title.Modified;
end;

procedure TfrmInformEdit.SpinTopEnter(Sender: TObject);
begin
  SpinTop.MinValue:= 0;
  SpinTop.MaxValue:= ScreenMaxHeight - SpinHeight.Value;
  if use48Verbs And (Selected is THPLabel) then
  begin
    SpinTop.MaxValue:= ScreenMaxHeight - 10;
  end;
end;

procedure TfrmInformEdit.SpinHeightEnter(Sender: TObject);
begin
  SpinHeight.MinValue:= 1;
  SpinHeight.MaxValue:= ScreenMaxHeight - SpinTop.Value;
  if use48Verbs And (Selected is THPField) then     // wgg disabled for Labels
  begin
    SpinHeight.MinValue:= 9;
    SpinHeight.MaxValue:= ScreenMaxHeight - SpinTop.Value;
  end;
end;

procedure TfrmInformEdit.SpinLeftEnter(Sender: TObject);
begin
  SpinLeft.MinValue:= 0;
  SpinLeft.MaxValue:= 131 - SpinWidth.Value;
end;

procedure TfrmInformEdit.SpinWidthEnter(Sender: TObject);    // wgg disabled for Labels
begin
  SpinWidth.MinValue:= 1;
  SpinWidth.MaxValue:= 131 - SpinLeft.Value;
end;

function TfrmInformEdit.use48Verbs: boolean;                           // wgg
begin
   result:= chkb48.Checked;
   if frmProject <> Nil then                                      // wgg to stop a startup problem
     result:= result Or frmProject.IsCalc48;
   if result <> chkb48.Checked then chkb48.Checked:= result;   // fix the setting, many side effects
end;

function TfrmInformEdit.useMsgTable: boolean;                           // wgg
begin
   result:= chkbUseMsgTable.Checked;
end;

// wgg set calculator mode settings
procedure TfrmInformEdit.SetChkBoxes;
begin
  Modified:= True;
  if use48Verbs then
  begin
   chkbText.Visible:= True;
   chkbMiniFont.Visible:= False;
   chkbZint.Visible:= False;
  end else begin
   chkbText.Visible:= False;
   chkbMiniFont.Visible:= True;
   chkbZint.Visible:= True;
  end;
end;

procedure TfrmInformEdit.chkb48Click(Sender: TObject);
var
  Value: THPObjet;
begin
  SetChkBoxes;
  if FSelected <> Nil then
  begin
  Value:= FSelected;
  FSelected:= Nil;
  SetSelected(Value);
  end;
end;

procedure TfrmInformEdit.ComboBox3DropDown(Sender: TObject);
var
  i: THPFieldType;
begin
  for i:= low(THPFieldTypeNames) to high(THPFieldTypeNames) do
    if use48Verbs And (Not THPField48[i]) then
      ComboBox3.Items[ord(i)]:= notInHP48
    else
      ComboBox3.Items[ord(i)]:= THPFieldTypeNames[i];
end;

procedure TfrmInformEdit.chkbUseMsgTableClick(Sender: TObject);
begin
  Modified:= True;
end;

procedure TfrmInformEdit.teEnter(Sender: TObject);                               // wgg
begin
  if Sender is Tedit then (sender as TEdit).ReadOnly:= ReadOnly;
  if Sender is TMemo then (sender as TMemo).ReadOnly:= ReadOnly;
end;

procedure TfrmInformEdit.teKeyDown(Sender: TObject; var Key: Word;               // wgg
           Shift: TShiftState);
begin
  if (ssCtrl in Shift) Or (ssAlt in Shift) then exit;
  case Key of
  ord('A')..ord('Z'),ord(' '),ord('0')..ord('9'): ;
  188..222: ;
  else exit;
  end;
  CheckReadOnly(Sender);
end;

procedure TfrmInformEdit.memDefineEnter(Sender: TObject);
begin
  frmMainForm.EditEnter(Sender);                                            // wgg
  (sender as TSynEdit).ReadOnly:= ReadOnly;
end;

function TfrmInformEdit.CheckReadOnly(Sender: TObject): boolean;                 // wgg
begin
  if ReadOnly then
  if Application.MessageBox(pchar('Warning, this file is read-only.'
                   +'  Would you like to set write permission?'),
                   pchar('Read-Only File'), MB_YESNOCANCEL) = IDYES then
    if FileSetAttr(Name, FileGetAttr(Name) And (Not faReadOnly)) = 0 then
    begin
      ReadOnly:= false;
      SetControlStates;
    end
    else beep;
  SetFormCaption('');
  Result:= ReadOnly;
  if Sender is TSynEdit then (sender as TSynEdit).ReadOnly:= ReadOnly;
  if Sender is TEdit then (sender as TEdit).ReadOnly:= ReadOnly;
  if Sender is TMemo then (sender as TMemo).ReadOnly:= ReadOnly;
end;

procedure TfrmInformEdit.memDefineKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if (ssCtrl in Shift) Or (ssAlt in Shift) then exit;
  case Key of
  ord('A')..ord('Z'),ord(' '),ord('0')..ord('9'): ;
  188..222: ;
  else exit;
  end;
  CheckReadOnly(Sender);
end;

procedure TfrmInformEdit.chkbNameClick(Sender: TObject);
begin
   if chkbName.Checked then chkbNAMELESS.Checked:= false;
end;

procedure TfrmInformEdit.chkbNAMELESSClick(Sender: TObject);
begin
  if chkbNAMELESS.Checked then chkbName.Checked:= false;
end;

// wgg we need this, if we have a cursor in a field then load a new form that
//  allows or not allows ReadOnly
procedure TfrmInformEdit.FormActivate(Sender: TObject);
begin
  if ActiveControl is TSynEdit then
  begin
    (ActiveControl as TSynEdit).ReadOnly:= ReadOnly;
    frmMainForm.EditActivate(Sender);                                  // wgg
  end;
  if ActiveControl is TEdit then (ActiveControl as TEdit).ReadOnly:= ReadOnly;
  if ActiveControl is TMemo then (ActiveControl as TMemo).ReadOnly:= ReadOnly;
end;

Procedure TfrmInformEdit.SetControlStates;                       // wgg
var
  i: integer;
  b: boolean;
begin
  if ReadOnly then b:=false else b:= true;
  for i:= 0 to componentCount-1 do
    if Components[i] is TCheckbox then (Components[i] as TCheckbox).Enabled:= b
    else if Components[i] is TSpinEdit then (Components[i] as TSpinEdit).Enabled:= b;
  ComboBox4.Enabled:= b;
  ComboBox3.Enabled:= b;
  btnNewLabel.Enabled:= b;
  btnNewField.Enabled:= b;
  btnDelete.Enabled:= b;
  btnGenSource.Enabled:= b;
  btnSave.Enabled:= b;
end;


procedure TfrmInformEdit.chkbLocalNameClick(Sender: TObject);
begin
  UseLocalName:= chkbLocalName.Checked;                               // wgg
end;

end.
