{
  This units contains the Debuger main window.
  This windows allows you to:
  Choose the emulator you wat to use
  Open the different debugging windows
  Jump in the source code at a specific address or symbol
  This unit is copyright Hewlett Packard

  Changes marked with WGG are copyright 2002, William G. Graves

  In project options, define UseConn4x for ConnectivityKit


}
unit fmMainForm;

interface

uses
  Windows,  SysUtils, Classes, Graphics, Controls, Forms, StdCtrls,
  WindowsPosSave, ExtCtrls, utils2, Menus, SynEdit, SynCompletionProposal,
  SynEditSearch, fmSourceEdit, SynEditMiscClasses;

type
  TfrmMainForm = class(TForm)
    WindowPosSave1: TWindowPosSave;
    MainMenu1: TMainMenu;
    Debugging1: TMenuItem;
    DebuggerASM1: TMenuItem;
    DebuggerRPL1: TMenuItem;
    Breakpoints1: TMenuItem;
    MemoryMap1: TMenuItem;
    Project1: TMenuItem;
    ViewProject1: TMenuItem;
    FilesLoading1: TMenuItem;
    Entrypoints1: TMenuItem;
    Help1: TMenuItem;
    Emulator1: TMenuItem;
    Emulate: TMenuItem;
    unvisible: TMenuItem;
    open1: TMenuItem;
    build1: TMenuItem;
    openprg1: TMenuItem;
    SavePrg1: TMenuItem;
    NewProject1: TMenuItem;
    AddToPrj1: TMenuItem;
    StepIn1: TMenuItem;
    stepover1: TMenuItem;
    newfile1: TMenuItem;
    NewProjectFile1: TMenuItem;
    GroupBox1: TGroupBox;
    Editor1: TMenuItem;
    NewInformBox1: TMenuItem;
    Timer1: TTimer;
    TextEval1: TMenuItem;
    ConnectivityKit1: TMenuItem;
    N2: TMenuItem;
    InformEditor1: TMenuItem;
    gotoEdit: TSynEdit;
    SynCompletionProposal1: TSynCompletionProposal;
    SynAutoComplete1: TSynAutoComplete;
    mnuHelp: TMenuItem;
    mnuAbout: TMenuItem;
    N3: TMenuItem;
    SynCompletionProposal2: TSynCompletionProposal;
    Find1: TMenuItem;
    SynEditSearch1: TSynEditSearch;
    Replace1: TMenuItem;
    FindAgain1: TMenuItem;
    N4: TMenuItem;
    N1: TMenuItem;
    Continue1: TMenuItem;
    Stop1: TMenuItem;
    Redraw1: TMenuItem;
    tmrAbout: TTimer;
    procedure Button1Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Button8Click(Sender: TObject);
    procedure gotoEditKeyPress(Sender: TObject; var Key: Char);
    procedure gotoEditKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure Button5Click(Sender: TObject);
    procedure About1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button12Click(Sender: TObject);
    procedure EmulateClick(Sender: TObject);
    procedure open1Click(Sender: TObject);
    procedure build1Click(Sender: TObject);
    procedure openprg1Click(Sender: TObject);
    procedure SavePrg1Click(Sender: TObject);
    procedure NewProject1Click(Sender: TObject);
    procedure AddToPrj1Click(Sender: TObject);
    procedure newfile1Click(Sender: TObject);
    procedure NewProjectFile1Click(Sender: TObject);
    procedure StepIn1Click(Sender: TObject);
    procedure stepover1Click(Sender: TObject);
    procedure Editor1Click(Sender: TObject);
    procedure NewInformBox1Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure MemoryMap1Click(Sender: TObject);
    procedure TextEval1Click(Sender: TObject);
    procedure Emulator1Click(Sender: TObject);
    procedure Project1Click(Sender: TObject);
    procedure Debugging1Click(Sender: TObject);
    procedure InformEditor1Click(Sender: TObject);
    procedure mnuHelpClick(Sender: TObject);
    procedure SynCompletionProposal2Execute(Kind: SynCompletionType;
      Sender: TObject; var CurrentInput: String; var x, y: Integer;
      var CanExecute: Boolean);
    procedure SynCompletionProposal2Close(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure SynCompletionProposal1CodeCompletion(Sender: TObject;
      var Value: String; Shift: TShiftState; Index: Integer;
      EndToken: Char);
    procedure Find1Click(Sender: TObject);
    procedure gotoEditEnter(Sender: TObject);
    procedure Replace1Click(Sender: TObject);
    procedure FindAgain1Click(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure ConnectivityKit1Click(Sender: TObject);
    procedure Continue1Click(Sender: TObject);
    procedure Stop1Click(Sender: TObject);
    procedure Redraw1Click(Sender: TObject);
    procedure tmrAboutTimer(Sender: TObject);
  Private
    StkName: TStringList;                                           // wgg
    StkArgs: TStringList;                                           // wgg
    procedure LoadStackArgs;                                        // wgg
  Protected
    Params: TStringList;                                                   // wgg
    procedure StateChange(Sender: TObject);
    Procedure LoadCompletion(list: TMyList);
  public
    RegRootKey: string;                                                    // wgg passed in App.tag
    function ApplicationOnHelp(Command: Word; Data: Longint; var CallHelp: Boolean): Boolean; // wgg
    procedure EditEnter(Sender: TObject);                                  // wgg
    procedure EditActivate(Sender: TObject);                               // wgg
    procedure TopicHelp(topic: string);                                    // wgg
    procedure ContextHelp(id: integer);                                    // wgg
    procedure ShowStack(Sender: TObject; var key: word);                   // wgg
    Procedure LoadLR(p: pchar);
  end;

const
  PopupFileName = 'cshelp.txt';                                             // wgg also in HPDir

var
  frmMainForm: TfrmMainForm;
  Startup: boolean = false;

implementation

uses
  CDBShUtils, SynEditHighlighter, lrWorking, Debug,
  ActiveX, HtmlHelpAPI, RegistryValues, fmDebugRPL, fmDebugEMU, fmRamView,
  fmBreakPointChoice, fmEntryPoints, fmMapLRFiles, Search,
  fmAbout, fmProject, fmInformEdit, fmTextEval
{$IFDEF UseConn4x}
  , HPDir, Logit, ScreenCapt
{$ENDIF}
  ;

{$R *.DFM}

function GetParamStr(P: PChar; var Param: string): PChar;
var
  Len: Integer;
  Buffer: array[Byte] of Char;
begin
  while True do
  begin
    while (P[0] <> #0) and (P[0] <= ' ') do Inc(P);
    if (P[0] = '"') and (P[1] = '"') then Inc(P, 2) else Break;
  end;
  Len := 0;
  while P[0] > ' ' do
    if P[0] = '"' then
    begin
      Inc(P);
      while (P[0] <> #0) and (P[0] <> '"') do
      begin
        Buffer[Len] := P[0];
        Inc(Len);
        Inc(P);
      end;
      if P[0] <> #0 then Inc(P);
    end else
    begin
      Buffer[Len] := P[0];
      Inc(Len);
      Inc(P);
    end;
  SetString(Param, Buffer, Len);
  Result := P;
end;

function ParamCount(param: pchar): Integer;
var
  P: PChar;
  S: string;
begin
  P := GetParamStr(param, S);
  Result := 0;
  while True do
  begin
    P := GetParamStr(P, S);
    if S = '' then Break;
    Inc(Result);
  end;
end;

function ParamStr(param: pchar; Index: Integer): string;
var
  P: PChar;
  Buffer: array[0..260] of Char;
begin
  if Index = 0 then
    SetString(Result, Buffer, GetModuleFileName(0, Buffer, SizeOf(Buffer)))
  else
  begin
    P := param;
    while True do
    begin
      P := GetParamStr(P, Result);
      if (Index = 0) or (Result = '') then Break;
      Dec(Index);
    end;
  end;
end;

// show the CPU debug window
procedure TfrmMainForm.Button1Click(Sender: TObject);
begin
  if (sender as TMenuItem).Checked then frmDebugEMU.hide
  else frmDebugEMU.show;
end;

// when this form shows,
// it initialize a couple of things
procedure TfrmMainForm.FormShow(Sender: TObject);
begin
  WindowPosSave1.ReadPos;               // read saved form position
  Debugger.OnStateChange:= StateChange; // some call backs
end;

procedure TfrmMainForm.LoadLR(p: pchar);
var
  i: integer;
begin
  if ParamCount(p)<>0 then                 // load the .lr files
  Begin
    Params.Clear;
    for i:= 1 to ParamCount(p) do
      Params.add(ParamStr(p,i));
    frmMapLRFiles.NotValid;                                    // wgg, so we rebuild later
    frmMapLRFiles.LoadLR(params);                              // wgg must be here, InitTable destroys params
    if frmMapLRFiles.Visible then
      frmMapLRFiles.Reload(Nil);                               // wgg update file display list, here to speed startup

    SymbolTable.InitTable(params, LoadCompletion);
    frmDebugRPL.LoadLR;                                   // wgg must be after InitTable
    frmEntryPoints.ReloadList;                                  // wgg
    LoadStackArgs;                                        // wgg
    frmSourceEdit.reloadBP;
  end;
end;

// show memory map window
procedure TfrmMainForm.Button4Click(Sender: TObject);
begin
  frmRamView.Show;
end;

// show the RPL debugging form
procedure TfrmMainForm.Button3Click(Sender: TObject);
begin
  if (sender as TMenuItem).Checked then frmDebugRPL.hide
  else frmDebugRPL.show;
end;

// show the breakpoint list window
procedure TfrmMainForm.Button2Click(Sender: TObject);
begin
  if (sender as TMenuItem).Checked then frmBreakPointChoice.hide
  else frmBreakPointChoice.show;
end;

// when the form closes, it record informations on every visible form
// and then kill the process. I need to kill the process, either, the
// emu48.dll just crash (is not able to close corectly)
procedure TfrmMainForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Action:= caFree;
  frmProject.IniEditList;                            // wgg must do before we close files
  if frmSourceEdit.SaveAll2 then                 // wgg user can answer "cancel"
    frmSourceEdit.WindowPosSave1.SavePos
  else
    Action:= caNone;

  if (Action <> caNone) And frmInformEdit.Close2 then     // wgg user can answer "cancel"
  begin
    frmInformEdit.hide;                                   // so it wont open on next startup unless we do it
    frmInformEdit.WindowPosSave1.SavePos;                  // wgg was ReadPos
  end else
    Action:= caNone;

  if (Action <> caNone) And frmProject.CloseProject(True) then        // wgg mark with EndSession
    frmProject.WindowPosSave1.SavePos
  else
    Action:= caNone;

  if Action <> caNone then
  begin
    WindowPosSave1.SavePos;
    frmDebugEMU.WindowPosSave1.SavePos;
    frmMapLRFiles.WindowPosSave1.SavePos;
    frmRamView.WindowPosSave1.SavePos;
    frmDebugRPL.WindowPosSave1.SavePos;
    frmBreakPointChoice.WindowPosSave1.SavePos;
    frmEntryPoints.WindowPosSave1.SavePos;
    frmEntryPoints.Close;
{$IFDEF UseConn4x}
    FHPDir.WindowPosSave1.SavePos;
    if FLogForm<> Nil then FLogForm.close;  // wgg so we do SavePos
    if FCapture<> Nil then FCapture.close;  // wgg so we do SavePos
{$ENDIF}

    TerminateProcess(GetCurrentProcess, 0); // and kill everything killing badly allow to avoid unexpected crashes :-(
  end;
end;

// show the database thing
procedure TfrmMainForm.Button8Click(Sender: TObject);
begin
  if (sender as TMenuItem).Checked then frmEntryPoints.hide
  else frmEntryPoints.show;
end;

// avoid carage returns in the editor and
// remove any starting spaces
procedure TfrmMainForm.gotoEditKeyPress(Sender: TObject; var Key: Char);
begin
  if key=#13 then
    key:= #0;
end;

// edit the source at the specified symbol
procedure TfrmMainForm.gotoEditKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if key=13 then
  Begin
    Debugger.EditAtSymbol(gotoEdit.Text);
    key:= 0;
  end;
end;

// show the file map
procedure TfrmMainForm.Button5Click(Sender: TObject);
begin
  if (sender as TMenuItem).Checked then frmMapLRFiles.hide
  else frmMapLRFiles.show;
end;

// when the emulator change, update the radiogroup
procedure TfrmMainForm.StateChange(Sender: TObject);
begin
end;

// Open about box
procedure TfrmMainForm.About1Click(Sender: TObject);
begin
  frmAbout.ShowModal;
end;

// the create is responsible to ensure that the emu49.ini file is corect and
// to create the params string list
procedure TfrmMainForm.FormCreate(Sender: TObject);
begin
 { with tinifile.create(extractfilepath(application.exename)+'emu49.ini') do    // wgg removed
    try
      if readstring('Files','Emu48Directory', '')='default' then
        writeString('Files','Emu48Directory', extractFiledir(application.exename));
      if readstring('Files','LastDocument', '')='default' then
        writeString('Files','LastDocument', ExtractFilePath(application.exename)+'ram.e49');
    finally
      free;
    end;  }
  RegRootKey:= RegistryKey;
  Application.Tag:=Integer(@RegRootKey);       // wgg used by WindowPosSave

  SetThreadPriority(GetCurrentThread, THREAD_PRIORITY_BELOW_NORMAL);
  Params:= TStringList.Create;
  StkName:= TStringlist.Create;
  StkArgs:= TStringlist.Create;
end;

procedure TfrmMainForm.Button12Click(Sender: TObject);
begin
  if (sender as TMenuItem).Checked then frmProject.hide
  else frmProject.show;
end;

procedure TfrmMainForm.EmulateClick(Sender: TObject);
begin
  if Emulate.Checked = true then
  begin
    Debugger.DebugType:= DtNone;
    if frmTextEval.visible = True then frmTextEval.hide;
  end
  else frmProject.DebugStart;                                      // wgg find the load address
end;

procedure TfrmMainForm.open1Click(Sender: TObject);
begin
  frmSourceEdit.Open1.Click;
end;

procedure TfrmMainForm.build1Click(Sender: TObject);
begin
  frmProject.build1.Click;
end;

procedure TfrmMainForm.openprg1Click(Sender: TObject);
begin
  frmProject.Open1.Click;
end;

procedure TfrmMainForm.SavePrg1Click(Sender: TObject);
begin
  frmProject.Save1.Click;
end;

procedure TfrmMainForm.NewProject1Click(Sender: TObject);
begin
  frmProject.NewProject1.Click;
end;

procedure TfrmMainForm.AddToPrj1Click(Sender: TObject);
begin
  frmProject.Addtoproject1.Click;
end;

procedure TfrmMainForm.newfile1Click(Sender: TObject);
begin
    frmSourceEdit.New1.Click;
end;

procedure TfrmMainForm.NewProjectFile1Click(Sender: TObject);
begin
  frmProject.Newfile1.Click;
end;

procedure TfrmMainForm.StepIn1Click(Sender: TObject);
begin
  Debugger.StepIn;
end;

procedure TfrmMainForm.stepover1Click(Sender: TObject);
begin
  Debugger.StepOver;
end;

procedure TfrmMainForm.InformEditor1Click(Sender: TObject);
begin
  if (sender as TMenuItem).Checked then frmInformEdit.hide
  else frmInformEdit.show;
end;

procedure TfrmMainForm.Editor1Click(Sender: TObject);
begin
  if (sender as TMenuItem).Checked then frmSourceEdit.hide
  else frmSourceEdit.show;
end;

procedure TfrmMainForm.NewInformBox1Click(Sender: TObject);
begin
  frmProject.NewInformBox1.click;
end;

procedure TfrmMainForm.LoadCompletion(list: TMyList);
var
  s1: TStringList;
  s: string;

begin
  s1:= TStringList(frmMainForm.SynCompletionProposal1.ItemList);   // sb item
  s1.Clear;
  s1.sorted:= false;
  s1.CaseSensitive:= false;
  With list do
  Begin
    BOL;
    while not EOL do
      begin
    // wgg to add columns, define n-1 columns in the control column properties
    // Options - add scoUsePrettyText
    // then add to text string: +' \column{}\color{clRed}abcd  \column{}\color{clGreen}efg'
    // where abcd and efg are the text strings for the 2nd, 3rd columns

        s:= TEntry(NextItem).Text+' ';         // wgg add space so we can search for it later
        case s[1] of
        // wgg note we must have lead space for ROM or FLASH in case string is embedded in RPL name
        '~': if length(s)>1 then s1.add(copy(s, 2, maxint)+'\column{}\color{clRed} ROM');
        '^': if length(s)>1 then s1.add(copy(s, 2, maxint)+'\column{}\color{clRed} FLASH');
        else s1.Add(s);
        end;
      end
  end;
  s1.sorted:= true;
end;

// wgg just before we insert text
procedure TfrmMainForm.SynCompletionProposal1CodeCompletion(Sender: TObject;
  var Value: String; Shift: TShiftState; Index: Integer; EndToken: Char);

var
  k: integer;
  padd, dumbstr:string;
  attr:TSynHighlighterAttributes;
  p:TPoint;

begin
  padd:= '';
{  k2:= pos(' ROM', value);       // is there a ROM or FLASH ?
  if k2<>0 then padd:='ROMPTR ';
  k2:= pos(' FLASH', value);     // note lead space is required to avoid embedded rom or flash
  if k2<>0 then padd:='FLASHPTR '; }

  k:= pos(' ', value);
  if k<>0 then value:= copy(value, 1, k-1);
  if padd <> '' then
  begin
    p:= SynCompletionProposal1.Editor.CaretXY;
    SynCompletionProposal1.Editor.GetHighlighterAttriAtRowCol(p, dumbstr, attr);
    if attr=Nil then  // maybe we are at the end of the line, try again at 1 left
    begin
      p.X:= p.X-1;
      if p.X > 0 then SynCompletionProposal1.Editor.GetHighlighterAttriAtRowCol(p, dumbstr, attr);
    end;
    if attr<> Nil then
      if attr.Name = 'Rpl' then
        Value:= padd + Value;
  end;
end;
// wgg Summary of command line arguments
//  name.hpp Open this project file
//  -GETLAM unpublished command to use nnGETLAM for {{   }} Nullam items
//        this effectively allows reuse of these names anywhere in the source
//        If -GETLAM is processed, a flag will be save in the project file.
//  -V b name.lr file, process as fixed ROM locations for bank b
//       if address>$80000 use as is, else and with $3ffff and add bank as b3ffff
//  -A name.lr, process as fixed locations (rarely used option)
//  -R name.lr, process as relocatable RAM locations
//  -ER suppress error reports
//
procedure TfrmMainForm.Timer1Timer(Sender: TObject);
var
  p: string;
begin
  Timer1.Enabled:= false;
  if (ParamCount(GetCommandLine)<>0) and (copy(ParamStr(GetCommandLine, 1), 1, 1)='-')
      And (UpperCase(ParamStr(GetCommandLine, 1)) <> '-GETLAM') then
  begin
    frmSourceEdit.ListBox1.Items.clear;                             // wgg
    frmProject.chkbLoadOnly.Checked:= True;                             // wgg no default .LR files
    LoadLR(GetCommandLine);
  end
  else if (ParamCount(GetCommandLine)<>0) then
  Begin
    p:= ParamStr(GetCommandLine, 1);
    frmProject.GUseGetlam:= 0;
    if UpperCase(p) = '-GETLAM' then                                  // wgg must be first argument only
    begin
      frmProject.GUseGetLam:= 1;
      p:= ParamStr(GetCommandLine, 2);
    end;
    if LowerCase(ExtractFileExt(p)) ='.hpp' then
    begin
      frmSourceEdit.ListBox1.Items.clear;                           // wgg
      frmProject.LoadProject(p);
      LoadLR(pchar(frmProject.LRList));                                // wgg
      frmProject.OpenProjectSources;
      frmSourceEdit.GetLErrors;                                       // wgg scan for errors
     end;
    if (LowerCase(ExtractFileExt(p)) = '.s') Or (LowerCase(ExtractFileExt(p)) = '.h') then
    begin
      frmProject.Caption:= ExtractFilePath(p)+frmProject.Caption;           // wgg like it was projectDir
      if pos(InformInternalDatas, FileTostring(p))<>0 then
        frmInformEdit.OpenFile(p, False)
      else
        frmSourceEdit.Display(p, 0);
    end;
  end;
end;

procedure TfrmMainForm.MemoryMap1Click(Sender: TObject);
begin
  if (sender as TMenuItem).Checked then frmRamView.hide
  else frmRamView.show;
end;

procedure TfrmMainForm.TextEval1Click(Sender: TObject);
begin
  if (sender as TMenuItem).Checked = True then frmTextEval.hide
  else
  begin
    frmTextEval.Show;
    if Debugger.DebugType = DtNone then frmProject.DebugStart;
  end;
end;

procedure TfrmMainForm.Emulator1Click(Sender: TObject);
begin
  Emulate.Checked:= Debugger.DebugType <> DtNone;
  TextEval1.Checked:= frmTextEval.visible = true;
  Emulate.Checked:=  Debugger.DebugType <> DtNone;
end;

procedure TfrmMainForm.Project1Click(Sender: TObject);
begin
  ViewProject1.Checked:= frmProject.visible = True;
  FilesLoading1.Checked:= frmMapLRFiles.visible = True;
  EntryPoints1.Checked:= frmEntryPoints.visible = True;
  Editor1.Checked:= frmSourceEdit.visible = True;
  InformEditor1.Checked:= frmInformEdit.visible = True;
{$IFDEF UseConn4x}
  ConnectivityKit1.Checked:= FHPDir.visible = true;      // wgg
{$ELSE}
  ConnectivityKit1.Visible:= false;      // wgg
{$ENDIF}
end;

procedure TfrmMainForm.Debugging1Click(Sender: TObject);
begin
    DebuggerASM1.Checked:= frmDebugEMU.visible = True;
    DebuggerRPL1.Checked:= frmDebugRPL.visible = True;
    Breakpoints1.Checked:= frmBreakPointChoice.visible = True;
    MemoryMap1.Checked:= frmRamView.visible = True;
end;

procedure TfrmMainForm.mnuHelpClick(Sender: TObject);                    // wgg
begin
 { Application.HelpCommand(HELP_FINDER, 0);   }                        // wgg - old style help command
  HtmlHelp(0, nil, HH_CLOSE_ALL, 0);                                   // wgg - HTLM help commands
  HtmlHelp(0, PChar(ApplicationPath+'\'+Application.HelpFile), HH_DISPLAY_TOC, 0);
end;

// wgg for Html help API - display popup text
procedure TfrmMainForm.TopicHelp(topic: string);
begin
HtmlHelp(0, PChar(ApplicationPath+'\'+Application.HelpFile), HH_DISPLAY_TOPIC,
                    DWORD(PChar(topic)));
end;

// wgg we call this to display HTML context help
procedure TfrmMainForm.ContextHelp(id: integer);
begin
  HtmlHelp(0, PChar(ApplicationPath+'\'+Application.HelpFile), HH_HELP_CONTEXT, id);
end;
// wgg Schema for Control HelpContext IDs
// 0, 1	Used when no help topic is defined.  1 is a system default page.
//
// Remaining IDs are a 7 digit number FFFnnnn where
//
// FFF	form number
//  	01 = MainForm
//   	02 = Project Form
//    	03 = FmSourceEdit Form
//     	04 = MapVger
//      05 = FRamView
//      06 = frmTextEval
//      07 = FBreakpointChoice
//      08 = UnRef
//      09 = ASMDebug
//      10 = RPLDebug
//      11 = InformEdit
//      12 = Connectivity
//
// nnnn:	topic for the form:
// 0000-4999 Text help for pop-ups.  These are defined in cshelp.txt
// 5000-9999 Context help that goes to a topic page, mapped in cshelp.ali and cshelp.h
//
// CSHelp.ali:  List symbolic ID and the path to the html
// CSHelp.h:    Lists symbolic id and the number from the program
// CSHelp.txt:  Lists .topic nnnn, where nnn is used in the program, text follows immediately
//
// wgg form's BorderIcons\biHelp must be true for pop-up help
procedure ShowHelp(Pt: TPoint; ContextId: Integer);
var
  Popup: THHPopup;
begin
  if (ContextID Mod 10000) >= 5000 then frmMainForm.ContextHelp(ContextID)     // wgg show in the help window
  else
  begin
    FillChar(Popup, SizeOf(Popup), 0);
    Popup.cbStruct := SizeOf(Popup);
    Popup.hinst := 0;
    Popup.idString := ContextId;
    Popup.pszText := nil;
    Popup.pt := Pt;
    Popup.clrForeGround := TColorRef(-1);
    Popup.clrBackground := TColorRef(-1);
    Popup.rcMargins := Rect(-1, -1, -1, -1);
    Popup.pszFont := '';
    if (ContextId <= 1) then                    // wgg 1 is a default error msg
      if Screen.ActiveControl.Hint <> '' then   // show hint if we have one
      begin
        Popup.pszText := PChar(Screen.ActiveControl.Hint);
        Popup.idString := 0;
        HtmlHelp(0, PChar(ApplicationPath+'\'+Application.HelpFile+'::/'+PopupFileName),
               HH_DISPLAY_TEXT_POPUP, DWORD(@Popup));
      end else                                  // else nothing happens
    else
      HtmlHelp(0, PChar(ApplicationPath+'\'+Application.HelpFile+'::/'+PopupFileName),
               HH_DISPLAY_TEXT_POPUP, DWORD(@Popup));
  end;
end;

function TfrmMainForm.ApplicationOnHelp(Command: Word; Data: Integer; var CallHelp: Boolean): Boolean;
const
  Pos: TPoint = (X:0; Y:0);              // the mouse pos
begin
  CallHelp := False;                     // Instruct Delphi not to call WinHelp
  Result := True;
  case Command of
    HELP_SETPOPUP_POS: Pos := SmallPointToPoint(TSmallPoint(Data));  // Remember mouse position
    // This is our chance to show help. The Data parameter is the helpcontext
    // property of the control beneath the mouse cursor when help was requested,
    // either through F1 or What's This Help.
    HELP_CONTEXTPOPUP: ShowHelp(Pos, Data);
    else Result := False;
  end;
end;

// wgg find name of current verb for showing stack diagrams
// and build item list for display.
procedure TfrmMainForm.SynCompletionProposal2Execute(Kind: SynCompletionType;
  Sender: TObject; var CurrentInput: String; var x, y: Integer;
  var CanExecute: Boolean);
var
  line: string;
  xf, xs, ix: integer;
begin
  with TSynCompletionProposal(Sender).Editor do
  begin
    line := LineText;
    xs:= CaretX;
  end;
  xf:= xs;
  while (line[xf]<>' ') and (xf<=length(line)) do inc(xf);
  CurrentInput:= CurrentInput+copy(line, xs, xf-xs);
  SynCompletionProposal2.ItemList.Clear;
  ix:= StkName.IndexOf(CurrentInput);
  while ix <> -1 Do
  begin
    SynCompletionProposal2.ItemList.Add('"'+StkArgs[ix]+'"');  // " makes it all same font
    inc(ix);
    if CompareText(StkName[ix], CurrentInput)<>0 then ix:= -1;
  end;
  if SynCompletionProposal2.ItemList.Count>0 then
    CanExecute:= true
  else begin
    CanExecute:= false;  // wgg if we return false, we mess up both CompletionProposals 
    Beep;
    SynCompletionProposal1.Editor:= (Sender as TSynCompletionProposal).Editor;
    SynCompletionProposal2.Editor:= Nil;
  end;
end;

// wgg restore editor to CompletionProposal1
procedure TfrmMainForm.SynCompletionProposal2Close(Sender: TObject);
begin
  SynCompletionProposal1.Editor:=
       ((Sender as TSynBaseCompletionProposalForm).CurrentEditor as TSynEdit);
   SynCompletionProposal2.Editor:= Nil;
end;

// wgg initiate CompletionProposal2: stack diagrams for current verb
procedure TfrmMainForm.ShowStack(Sender: TObject; var key: word);
begin
   frmMainForm.SynCompletionProposal2.Editor:= (Sender as TCustomSynEdit);
   key:= 0;
   frmMainForm.SynCompletionProposal2.Font.Size:= frmSourceEdit.Editor.Font.Size;
   frmMainForm.SynCompletionProposal2.ActivateCompletion;
end;

// wgg this code loads the stackFile and StackArgs lists which are
// used in the ctrl-J stack picture pop-up.
procedure TfrmMainForm.LoadStackArgs;
var
  stackFile: TStringList;
  line, pos: integer;

  // wgg function scans for ending on current line
  function pScan(s: string; var i: integer): integer;
  begin
    while (i <= length(s)) And (s[i]<>#13) And (s[i]<>#10) do inc(i);
    result:= i-1;
  end;

  // wgg start at pos, skip white then get the stack description
  procedure addList;
  begin
  pos:= skipWhite(stackFile[line], pos);
  if pos > length(stackFile[line]) then StkArgs.add(' ')
  else StkArgs.add(copy(stackFile[line], pos, length(stackFile[line])-pos+1));  // stack diagram
  end;

begin
  stackFile:= TStringList.Create;
  stackFile.LoadFromFile(frmProject.Suprom+'.stk');
  StkName.Clear;
  StkArgs.Clear;

  for line:= 0 to stackFile.Count-1 Do
    if (length(stackFile[line])>0) then
      case stackFile[line][1] of
      '*': ;                                 // skip comment line
      ' ': if StkName.Count>0 then           // skip first lines starting with ' '
             begin
               StkName.add(StkName[StkName.Count-1]);   // dup previous name
               pos:= 2;
               addList;
             end;
      else
        begin
          pos:= 1;
          if (stackFile[line][1] in ['~','^']) and (length(stackFile[line])>1) then pos:= 2;
          StkName.add(TokenAtPos(stackFile[line], pos));
          addList;
        end;
      end;
end;

// wgg hook up a TSynEditor when we enter the control
procedure TfrmMainForm.EditEnter(Sender: TObject);
begin
  if Sender is TSynEdit then
  begin
    frmMainForm.SynAutoComplete1.Editor:= sender as TSynEdit;                 // wgg
    frmMainForm.SynCompletionProposal1.Editor:= sender as TSynEdit;
    frmMainForm.SynCompletionProposal1.Font.Size:= frmSourceEdit.Editor.Font.Size;
    frmSourceEdit.SetEditProps(sender as TSynEdit);                       // wgg
  end;
end;

// wgg hook up a TSynEditor when we activate the form and the control is the editor
procedure TfrmMainForm.EditActivate(Sender: TObject);
begin
  if Screen.ActiveControl is TSynEdit then
  begin
    frmMainForm.SynAutoComplete1.Editor:= (Screen.ActiveControl as TSynEdit);           // wgg
    frmMainForm.SynCompletionProposal1.Editor:= (Screen.ActiveControl as TSynEdit);     // wgg
    frmSourceEdit.SetEditProps(Screen.ActiveControl as TSynEdit);                   // wgg
  end;
end;

procedure TfrmMainForm.Find1Click(Sender: TObject);
var
  x: word;
begin
  Search.FindClick(Sender, x);
end;

procedure TfrmMainForm.Replace1Click(Sender: TObject);
var
  x: word;
begin
  Search.ReplaceClick(Sender, x);
end;

procedure TfrmMainForm.FindAgain1Click(Sender: TObject);
var
  x: word;
begin
  Search.NextClick(Sender, x);
end;

procedure TfrmMainForm.FormActivate(Sender: TObject);                         // wgg
begin
  if Not Startup then
  begin
    Startup := True;
    tmrAbout.Interval:= 100;
    tmrAbout.Enabled:= true;
  end;
  if ActiveControl is TSynEdit then EditActivate(Sender);                                                   // wgg
end;

procedure TfrmMainForm.tmrAboutTimer(Sender: TObject);
begin
  if tmrAbout.Interval = 100 then
  begin
    tmrAbout.Interval:= 1000;
    frmAbout.ShowModal;
 //   About.visible:= false;;
  end
  else begin
    tmrAbout.Enabled:= false;
    frmAbout.close;
  end;
end;

procedure TfrmMainForm.gotoEditEnter(Sender: TObject);                         // wgg
begin
  if Sender is TSynEdit then EditEnter(Sender);
end;

procedure TfrmMainForm.FormDestroy(Sender: TObject);
begin
  HtmlHelp(0, nil, HH_CLOSE_ALL, 0);                     // wgg
end;

procedure TfrmMainForm.ConnectivityKit1Click(Sender: TObject);
begin
{$IFDEF UseConn4x}
  if (sender as TMenuItem).Checked then FHPDir.hide
  else FHPDir.show;
{$ENDIF}
end;

procedure TfrmMainForm.Continue1Click(Sender: TObject);
begin
  Debugger.ContinueRPL;
end;

procedure TfrmMainForm.Stop1Click(Sender: TObject);
begin
  Debugger.StopRpl;
end;

procedure TfrmMainForm.Redraw1Click(Sender: TObject);
begin
  frmDebugRPL.RedrawData;
end;

end.