{
  This units contains a form that let the user walk throught
  the files that are part of the project (as described inthe .lr files)
}
unit fmMapLRFiles;

interface

uses
  SysUtils, Classes, Controls, Forms, StdCtrls, ComCtrls, ExtCtrls,
  WindowsPosSave;

type
  TfrmMapLRFiles = class(TForm)
    TreeView1: TTreeView;
    Panel1: TPanel;
    Edit1: TEdit;
    WindowPosSave1: TWindowPosSave;
    procedure Reload(Sender: TObject);
    procedure TreeView1DblClick(Sender: TObject);
    procedure TreeView1MouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure Edit1KeyPress(Sender: TObject; var Key: Char);
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    lr: TStringList;
    node: ttreenode;
    valid: boolean;                                                            // wgg
    procedure ReadLR(f: TFileName; tn: TTreeNode; top: boolean = true);
  public
    Procedure LoadLR(f: TStringList);
    procedure NotValid;                                                        // wgg
  end;

var
  frmMapLRFiles: TfrmMapLRFiles;

implementation

uses CDBShUtils, fmSourceEdit;

{$R *.DFM}

// litle helper: add n spaces at the end of a string
function addspace(s: string; tab: integer): string;
Begin
  result:= s;
  while length(result)<tab do result:= result+' ';
end;

// This recursive function scan a .lr file and extract every file
// informations in it (recursively)
// and I am to lazy to comment it :-)
procedure TfrmMapLRFiles.ReadLR(f: TFileName; tn: TTreeNode; top: boolean = true);
  function ExtractModuleDef(st: Tstrings; var scanLine: integer; var moduleName: string; var start, fin: integer): boolean;
  // Extract the first module definition from the ST strings after the ScanLine line
  var
    ps, pe, error: integer;
  Begin
    result:= false;
    while (scanLine<st.count) and (pos('Module=', st[scanLine])=0) do  // Scan for a line with 'Module='
      inc(ScanLine);
    if scanLine>=st.count then                                         // if does not exist: exit
      exit;
    inc(scanLine);
    ps:= pos('Start=', st[scanLine]);                                  // Extract Start and end
    pe:= pos('End=', st[scanLine]);
    if (pe=0) and (pos('Module Contains No Code', st[ScanLine])<>0) then
      Start:= -1
    else begin
      if (ps=0) or (pe=0) then exit;
      val('$'+copy(st[scanLine], ps+6, 5), start, error); if error<>0 then exit;
      val('$'+copy(st[scanLine], pe+4, 5), fin, error);   if error<>0 then exit;
      ModuleName:= copy(st[scanLine-1], 8, pos('.', st[scanLine-1])-8);  // extract the module name
      if copy(ModuleName, 1, 5)='objs/' then ModuleName:= Copy(ModuleName, 6, MaxInt);
      if copy(ModuleName, 1, 5)='objs\' then ModuleName:= Copy(ModuleName, 6, MaxInt);
      start:= (start and $3FFFF);
      fin:= (fin and $3FFFF);
    end;
    result:= true;
  end;
var
  st: TStringList;
  p, start, fin, lf: integer;
  s: string;
  tn2: TTreeNode;
Begin
  st:= TStringList.Create;
  try
    st.text:= FileToString(f, 20000);
    p:= 0;
    if not ExtractModuleDef(st, p, s, start, fin) then exit;     // extract the module definition
    lf:= -1;
    while ExtractModuleDef(st, p, s, start, fin) do    // extract an input module definition
    Begin
      if fin-start>2 then
      Begin
        if (lf<>-1) and (start-lf>10) then
          if (start-lf-1) and $1 = 0 then
            TreeView1.Items.addChild(tn, addspace('Space',15)+inttostr((start-lf-1) div 2))
          else
            TreeView1.Items.addChild(tn, addspace('Space',15)+inttostr((start-lf-1) div 2)+'.5');
        if start<>-1 then
        Begin
          application.processMessages;
          if (fin-start+1) and $1 =0 then
            tn2:= TreeView1.Items.AddChild(tn, addspace(s, 15)+ inttohex(start,5)+' '+inttohex(fin,5)+' '+inttostr((fin-start+1)div 2))
          else
            tn2:= TreeView1.Items.AddChild(tn, addspace(s, 15)+ inttohex(start,5)+' '+inttohex(fin,5)+' '+inttostr((fin-start+1)div 2)+'.5');
          If FileExists(ExtractFilePath(f)+s+'\'+s+'.lr') then
            ReadLR(ExtractFilePAth(f)+s+'\'+s+'.lr', tn2, false);
        end;
        lf:= fin;
      end;
    end;
    if top then tn.Text:= tn.text+' '+inttostr((lf and $3FFFF) div 2);
  finally
    st.free;
  end;
end;

// This will run the function above
procedure TfrmMapLRFiles.Reload(Sender: TObject);
var
  i: integer;
begin
  TreeView1.Items.Clear;
  TreeView1.Items.addchild(nil, '   Name           Start Stop  Size (Bytes)');
  try
    i:= 0;
    While i<>lr.count do
    Begin
      if lr[i]='-V' then inc(i,3) else
      if (lr[i]='-R') or (lr[i]='-A') then inc(i,2);
      ReadLR(lr[i-1], TreeView1.Items.Addchild(nil, lr[i-1]));
    end;
  except
   { Application.MessageBox('Error Reading File', 'error', MB_OK); }         // wgg we get system msg anyway!
  end;
  Valid:= true;
end;

// save the main .lr mask
procedure TfrmMapLRFiles.LoadLR(f: TStringList);
begin
  lr.assign(f);
end;

// edit the file you dblclick on.
procedure TfrmMapLRFiles.TreeView1DblClick(Sender: TObject);
var
  s: string;
  n: TTreeNode;
begin
  if node=nil then exit;
  s:= copy(node.text, 1, pos(' ', node.text)-1);
  n:= node.parent;
  while n<>nil do
  Begin
    if pos('.LR', uppercase(n.text)) <> 0  then
      s:= ExtractFilePath(copy(uppercase(n.text), 1, pos('.LR', n.text)-1))+s   // wgg deleted '\'
    else
      s:= copy(n.text, 1, pos(' ', n.text)-1)+s;                                // wgg deleted '\'
    n:= n.parent;
  end;
  if FileExists(s+'.s') then
    frmSourceEdit.display(s+'.s',0)
  else if FileExists(s+'.a') then
    frmSourceEdit.display(s+'.a',0)
end;

// select the node you click on
procedure TfrmMapLRFiles.TreeView1MouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  node:= TreeView1.GetNodeAt(x,y);
end;

// expand every branch containing the text
// in edit1
procedure TfrmMapLRFiles.Edit1KeyPress(Sender: TObject; var Key: Char);
var
  i, j{, k }: integer;
begin
  if Key=#13 then
    Begin
      for i:=0 to TreeView1.Items.Count-1 do
        for j:= 0 to TreeView1.Items[i].Count-1 do
            if pos(edit1.text, TreeView1.Items[i].Item[j].Text)<>0 then
            begin
              TreeView1.Items[i].Expand(false);
              TreeView1.Selected:= TreeView1.Items[i].Item[j];
            end;
        {  for k:= 0 to TreeView1.Items[i].Item[j].count-1 do                  // wgg seems one level too many!
            if pos(edit1.text, TreeView1.Items[i].Item[j].item[k].Text)<>0 then
            begin
              TreeView1.Items[i].Expand(false);
              TreeView1.Items[i].Item[j].Expand(false);
              TreeView1.Selected:= TreeView1.Items[i].Item[j].item[k];
            end;      }
    end;
end;

procedure TfrmMapLRFiles.FormCreate(Sender: TObject);
begin
  lr:= TStringList.Create;
end;

// wgg mark the file map as invalid, needs to be reloaded
procedure TfrmMapLRFiles.NotValid;
begin
  Valid:= False;
end;

procedure TfrmMapLRFiles.FormShow(Sender: TObject);
begin
  if Not Valid then
     Reload(Nil);                                 // wgg update file display list, here to speed startup
end;

end.
