{
  This form let the user manage his projects.
  This unit is copyright Hewlett Packard.

  Changes marked with WGG are copyright 2002, William G. Graves

}
unit fmProject;

interface

uses
  Windows, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Menus, ComCtrls, HexaEdit, WindowsPosSave, fmProgress, DropTarget,
  DropSource
{$IFDEF UseConn4x}
  , YModem, HPDir
{$ENDIF}
  ;

type
  TfrmProject = class(TForm)
    MainMenu1: TMainMenu;
    Project1: TMenuItem;
    Open1: TMenuItem;              
    Save1: TMenuItem;
    SaveAs1: TMenuItem;
    build1: TMenuItem;
    N1: TMenuItem;
    Addtoproject1: TMenuItem;
    removefromproject1: TMenuItem;
    Newfile1: TMenuItem;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    OpenDialog2: TOpenDialog;
    SaveDialog2: TSaveDialog;
    Buildproject1: TMenuItem;
    WindowPosSave1: TWindowPosSave;
    NewProject1: TMenuItem;
    RecreateHeader1: TMenuItem;
    NewInformBox1: TMenuItem;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    gboxLib: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label5: TLabel;
    Label4: TLabel;

    Title         : TEdit;
    ExtPrg        : TEdit;
    Config        : TEdit;
    Message       : TEdit;
    Romid         : THexaEdit;                                         // wgg
    Slot          : THexaEdit;                                         // wgg
    Emu48Ram      : TEdit;
    Emu49Ram      : TEdit;
    FilePath      : TEdit;
    RPL_INCLUDE   : TEdit;
    SasmParams    : TEdit;
    EntryPointList: TEdit;
    LRFiles       : TEdit;
    Memo1         : TMemo;
    Calc48        : TCheckBox;
    KeepAllBox    : TCheckBox;
    chkbIsLib: TCheckBox;
    chkbEntry     : TCheckBox;

    TabSheet2: TTabSheet;
    ListView1: TListView;
    TabSheet3: TTabSheet;
    TabSheet4: TTabSheet;
    GroupBox3: TGroupBox;
    GroupBox4: TGroupBox;
    GroupBox5: TGroupBox;
    GroupBox2: TGroupBox;
    Button11: TButton;
    GroupBox6: TGroupBox;
    Button9: TButton;
    Button10: TButton;
    Search: TButton;
    FileAdr: THexaEdit;
    btnEntryPointList: TButton;
    TabSheet5: TTabSheet;
    GroupBox9: TGroupBox;
    Button4: TButton;
    Button5: TButton;
    AutoLoad: TCheckBox;
    Label6: TLabel;
    GroupBox10: TGroupBox;
    LabelMsgName: TLabel;
    chkbLoadOnly: TCheckBox;
    chkbIsDir: TCheckBox;
    gboxDir: TGroupBox;
    lblDirPath: TLabel;
    DirPath: TEdit;
    PopupMenu1: TPopupMenu;
    RemoveFileFromProject1: TMenuItem;
    AddFile1: TMenuItem;
    NewSource1: TMenuItem;
    NewInformBox2: TMenuItem;
    DropFileTarget1: TDropFileTarget;
    OpenFiles1: TMenuItem;
    OpenFiles2: TMenuItem;
    GroupBox1: TGroupBox;
    Emu48Port2: TEdit;
    Button6: TButton;
    chkb80Rows: TCheckBox;
    procedure chkb80RowsClick(Sender: TObject);

    procedure KeepAllBoxClick(Sender: TObject);
    procedure chkbIsLibClick(Sender: TObject);
    procedure Open1Click(Sender: TObject);
    procedure Save1Click(Sender: TObject);
    procedure SaveAs1Click(Sender: TObject);
    procedure Addtoproject1Click(Sender: TObject);
    procedure RemoveFromProject1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Newfile1Click(Sender: TObject);
    procedure ListView1DblClick(Sender: TObject);
    procedure build1Click(Sender: TObject);
    procedure Button9Click(Sender: TObject);
    procedure SearchClick(Sender: TObject);
    procedure FileAdrChange(Sender: TObject);
    procedure FilePathKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure Button10Click(Sender: TObject);
    procedure Button11Click(Sender: TObject);
    procedure NewProject1Click(Sender: TObject);
    procedure RecreateHeader1Click(Sender: TObject);
    procedure NewInformBox1Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure btnEntryPointListClick(Sender: TObject);
    procedure TitleChange(Sender: TObject);
    procedure ListView1KeyPress(Sender: TObject; var Key: Char);
    procedure Memo1DblClick(Sender: TObject);
    procedure DebugStart;
    procedure Calc48Click(Sender: TObject);
    procedure chkbEntryClick(Sender: TObject);
    procedure chkbLoadOnlyClick(Sender: TObject);
    procedure chkbIsDirClick(Sender: TObject);
    procedure DirPathKeyPress(Sender: TObject; var Key: Char);
    procedure DropFileTarget1Drop(Sender: TObject; ShiftState: TShiftState;
      Point: TPoint; var Effect: Integer);
    procedure OpenFiles1Click(Sender: TObject);
  private
    FModified: boolean;
    FilesOpenLast : TStringList;                             // wgg because we can't open until after :R files read
    FUseGetLam: boolean;                                     // wgg pass GETLAM to RPLCompiler instead of lamaddr
    FGUseGetLam: integer;                                    // wgg =1, default is Getlam; =0, not
    FInformHeight: Integer;                                  // wgg Inform Screen Height 50 or 80
    function GetModified: boolean;
    procedure ProjectInit;                                                      // wgg
    procedure BuildLib(p: TfrmProgress);                                           // wgg
    procedure BuildSimple(p: TfrmProgress);                                        // wgg
    procedure BuildDir(p: TfrmProgress);                                           // wgg
    procedure Build1Load(code: string; f: string);                              // wgg
    procedure Link1Load(f: string; dotExt: string);                             // wgg
    procedure BuildAutoLoad;                                                    // wgg
    procedure BuildAutoLoadDir;                                                 // wgg
    procedure LoadtoEMU;                                                        // wgg
    procedure LoadFull(force:boolean=false);                                    // wgg
  {  procedure LogIt(tag: string; m: integer); }                                   // wgg - testing
  private
    Property Modified: boolean read GetModified write FModified;
  public
    function SaveProject: boolean;
    function SaveProjectAs: boolean;
    function CloseProject(EndSession: boolean=false): boolean;                  // wgg
    Procedure LoadProject(f: TFileName);
    Procedure AddFile(f:TFileName);
    Procedure CompileAllFiles;
    Procedure CreateHeader;
    Function  CreateMessages: boolean;
    Procedure CreateConfigure;                                                  // wgg
    Procedure SetProjectDir;
    Procedure rsasm(s: string);
    Procedure rsasm2(s: string);
    Procedure rsload(s1, s2: string);
    Procedure rsload2(s: string);
    procedure rmakerom(f1, f2: TFileName);
    procedure rrplcomp(s: string);
    procedure rrplcomp2(f1, f2: TFileName);
    Function EntryPointFile: string;
    Function ProjectDir: string;
    Function ProjectName: string;                                               // wgg
    function AutoLoadName(ends: string): string;                                // wgg
    function TargetName: string;                                                // wgg
    function ShortName(f: string): string;                                      // wgg
    Function IsNewProject: boolean;
    Function HPHeader: string;                                                  // wgg
    Function Suprom: string;                                                    // wgg
    Function IsCalc48: boolean;                                                 // wgg
    Function KeepAll: boolean;                                                  // wgg
    Function LRList: string;                                                    // wgg
    Function ReadBookmarks(f: TFilename): string;                               // wgg
    Procedure WriteBookmarks(f: TFilename; s:string; HasMarks: boolean);        // wgg
    Procedure OpenProjectSources;                                               // wgg
    procedure IniEditList;                                                      // wgg
    property UseGetLam: boolean read FUseGetlam write FUseGetlam;               // wgg
    property GUseGetLam: integer read FGUseGetlam write FGUseGetlam;            // wgg
    property InformHeight: integer read FInformHeight write FInformHeight;      // wgg
    procedure SetAsRelative(E: TEdit; news: string);                            // wgg
    procedure BrowseRelative(E: TEdit; t: string; s: string);                   // wgg
{$IFDEF UseConn4x}
    procedure LoadToReal(server: TXModemServer);                                // wgg
{$ENDIF}
    function FetchProjectFile: TFileName;                                       // wgg
  end;

var
  frmProject: TfrmProject;
  LoadingProj: boolean;                               // wgg primarily to inhibit Calc48Click actions

  implementation

uses
  inifiles, fmSourceEdit, FmMainForm, hptoolsdll, fmFullPageEdit, emu48dll,
  fmDebugEMU, Debug, CDBShUtils, fmInformEdit, lrWorking;      // wgg

{$R *.DFM}
const
  NewProject = 'New_Project';
  NoProject = 'No Project';

procedure TfrmProject.chkbIsLibClick(Sender: TObject);
begin
  gboxLib.Enabled:= chkbIsLib.Checked;
  gboxLib.Visible:= chkbIsLib.Checked;
  If chkbIsLib.checked then chkbIsDir.checked:= false;
  Modified:= true;
  if Sender <> Nil then chkbIsDirClick(Nil);                                  // wgg set the other box
end;

procedure TfrmProject.chkbIsDirClick(Sender: TObject);                          // wgg
begin
  gboxDir.Enabled:= Not chkbIsLib.Checked;
  gboxDir.Visible:= Not chkbIsLib.Checked;
  If chkbIsDir.Checked then chkbIsLib.checked:= false;
  Modified:= true;
  if Sender <> Nil then chkbIsLibClick(Nil);                                  // wgg set the other box
end;

procedure TfrmProject.chkb80RowsClick(Sender: TObject);                         // wgg
begin
  if chkb80Rows.Checked then InformHeight:= 66           // wgg 80 - 14 is all calc will do
  else InformHeight:= 50;                                // 64 - 14 is all older ones do
  Modified:= true;
end;

// wgg return a string of encoded LR Files to load
// We always start with -V 1 Suprom.lr
// if the file exists, add - R projectname.lr
// and any requests from LRFiles.text
//
// we are simulating a command line here.  The 1st item must be a dummy
// program name.  anything will do, we use 'a'
function TfrmProject.LRList: string;
begin
  result:= 'a ' + frmProject.LRFiles.text;
  if Not chkbLoadOnly.Checked then
  begin
    if isCalc48 then result:= result + ' -A "'+Suprom+'.LR"'      // wgg -A for 48!!
    else result:= result + ' -V 1 "'+Suprom+'.LR"';               // wgg was -V 1, need 0 for decomps
    if FileExists(ChangeFileExt(ProjectName, '.lr')) then
      result:= result + ' -R "'+ChangeFileExt(ProjectName, '.lr')+'"';
  end;
end;

// wgg EMU will callback when file opened/saved with current file name
// if the name changes, we will ask the user whether we should make the
// change to the project.
// When EMU is started, we make names relative to the project directory
// so we must change to that directory, check and then change back!
procedure DocumentNotify(lpszFileName: PChar) stdcall;

 procedure AskChangeRam(E: TEdit; news: string);
 var
   dir: string;
 begin
   dir:= GetCurrentDir;
   frmProject.SetProjectDir;
   if ExtractFileDir(UpperCase(news))=UpperCase(frmProject.ProjectDir) then
     news:= ExtractFileName(news);                // wgg set path relative to project
  if UpperCase(ExpandFileName(news)) <>
     UpperCase(ExpandFileName(E.Text)) then
  begin
    if Application.MessageBox(PChar('EMU RAM file name has changed.'#13#10+
            'Would you like '+news+' to be set as the Project''s EMU Ram file?'),
                               pchar('Warning'), mb_YESNO) = IDYES then
      E.text:= news;                // wgg do not set unless we have to
   end;
   SetCurrentDir(dir);
 end;

begin
  if frmProject.IsCalc48 then AskChangeRam(frmProject.Emu48RAM, String(lpszFileName))
  else AskChangeRam(frmProject.Emu49RAM, String(lpszFileName));
end;

procedure TfrmProject.DebugStart;
begin
    Debugger.Port2File:= '';
    if IsCalc48 then
    begin
      Debugger.RamFile:= ExpandFileName(Emu48Ram.text);  // wgg must expand from project dir view
      if Emu48Port2.text<>'' then Debugger.Port2File:= ExpandFileName(Emu48Port2.text);
    end
    else
      Debugger.RamFile:= ExpandFileName(Emu49Ram.text);

    SetCurrentDir(ApplicationPath+'\EMU\');   // wgg so EMU can default if required
    Debugger.DebugType:= DtEMU49;             // wgg this starts the debugger
    SetProjectDir;                            // wgg back to the project
    EmuCallBackDocumentNotify(DocumentNotify); // wgg will callback when file opened/saved

    if Debugger.DebugType <> DtNone then   // wgg if it worked then
    begin
      SearchClick(Nil);                                                        // wgg find the load address
  {    frmDebugRPL.RefreshAll;         // wgg initially have screen clear when EMU is running
      frmDebugRPL.BuildTempOb(Nil);                                            // wgg tempobj
      frmDebugRPL.ButtonHomeClick(Nil); }                                      // wgg home dir
    end;
end;

{$WARN SYMBOL_PLATFORM OFF}             // wgg dont warn about FileGetAttr call
// wgg modified for 3 way warning box and cancel return
function TfrmProject.CloseProject(EndSession: boolean=false): boolean;
var
  i: integer;
begin
  result:= True;
  if Modified then
    if (FileGetAttr(Caption) and faReadOnly) <> 0 then    // wgg can't save, better warn
    begin
      i:= Application.MessageBox('This project is read-only and has been modified, do you want to discard the changes?',
                                 'Warning', mb_OKCANCEL);
      case i of
        IDCANCEL: result:= false;
        IDOK:     result:= true;
      end;
    end else
    begin
      i:= Application.MessageBox('Do you want to save the current project?',
                                 'Warning', mb_YESNOCANCEL);
      case i of
        IDNO:     result:= true;
        IDCANCEL: result:= false;
        IDYES:    result:= SaveProject;
      end;
    end;
  // wgg hopefully we already cleared modification flags and did save stuff!
  frmSourceEdit.CloseAll;                                                     // wgg
  frmInformEdit.CloseAll;

  if result And (Not EndSession) then           // ProjectInit > Calc48Click > ReloadLr and Search, so we have EndSession
  begin
     Debugger.DebugType:= DtNone;     // wgg needed: ProjectInit will set Calc48, which will change EMU if its alive
     ProjectInit;                     // wgg moved code to ProjectInit
     Caption            := NoProject;           
     Title         .text:= NoProject;           // NoProject means no warning if we close
     FilePath      .text:= '';
     Modified:= False;
  end;
end;

procedure TfrmProject.ProjectInit;
begin
  frmSourceEdit.ListBox1.Items.clear;             // wgg make sure errors of older projects are gone
  while ListView1.Items.Count<>0 do
    ListView1.Items[0].free;
  Caption            := NewProject;
  Title         .text:= NewProject;
  ExtPrg        .text:= '';
  Config        .text:= '';
  Romid         .text:= '200';
  Slot          .text:= '0';                 // wgg
  InformHeight       := 50;                  // wgg
  Message       .text:= '';                  // wgg
  Emu48Ram      .text:= ApplicationPath+'\Emu\default.e48';
  Emu48Port2    .text:= ApplicationPath+'\Emu\default.bin';
  Emu49Ram      .text:= ApplicationPath+'\Emu\default.e49';
  FilePath      .text:= NewProject+'.hp';
  RPL_INCLUDE   .text:= '';
  SasmParams    .text:= '';
  EntryPointList.text:= '';
  LRFiles       .text:= '';
  FileAdr       .text:= '';
  Memo1         .text:= '';
  DirPath       .text:= '';                  // wgg does not include HOMEDIR, last word is dir name
  FUseGetLam         := (GUseGetLam=1);      // wgg
  chkbLoadOnly  .Checked:= false;            // wgg
  chkbEntry     .Checked:= True;             // wgg depend on load state being false to get a trigger here!
  chkbIsLib     .Checked:= True;
  chkbIsDir     .Checked:= False;            // wgg
  AutoLoad      .Checked:= False;
  Calc48        .Checked:= False;            // wgg  this will trigger activity
  KeepAllBox    .Checked:= False;            // wgg
  Modified              := True;
  frmInformEdit.Set48(IsCalc48);                                                // wgg
  chkbIsLibClick(Nil);                                                   // wgg setup tab appearence
  chkbIsDirClick(Nil);
end;

procedure TfrmProject.LoadProject(f: TFileName);
var
  st: Tstringlist;
  th: integer;
begin
  f:= ExpandFileName(f);
  SetCurrentDir(ExtractFileDir(f));                 // wgg switch to proper directory
  if not fileexists(f) then
    raise exception.create('File '+f+' does not exist.');                   // wgg make english
  with TIniFile.Create(f) do
    try
      LoadingProj:= true;                           // wgg primarily to inhibit Calc48click actions
      caption:= f;
      Title         .text:= ReadString('Main', Title         .Name, '');
      ExtPrg        .text:= ReadString('Main', ExtPrg        .Name, '');
      Config        .text:= ReadString('Main', Config        .Name, '');
      Romid         .text:= ReadString('Main', Romid         .Name, '');
      Slot          .text:= ReadString('Main', Slot          .Name, '');        // wgg
      Message       .text:= ReadString('Main', Message       .Name, '');        // wgg
      Emu48Ram      .text:= ReadString('Main', Emu48Ram      .Name, ApplicationPath+'\Emu\default.e48');
      Emu48Port2    .text:= ReadString('Main', Emu48Port2    .Name, ApplicationPath+'\Emu\default.bin');
      Emu49Ram      .text:= ReadString('Main', Emu49Ram      .Name, ApplicationPath+'\Emu\default.e49');
      FilePath      .text:= ReadString('Main', FilePath      .Name, '');
      RPL_INCLUDE   .text:= ReadString('Main', RPL_INCLUDE   .Name, '');
      SasmParams    .text:= ReadString('Main', SasmParams    .Name, '');
      EntryPointList.text:= ReadString('Main', EntryPointList.Name, '');
      LRFiles       .text:= ReadString('Main', LRFiles       .Name, '');
      DirPath       .text:= ReadString('Main', DirPath       .Name, '');            // wgg
      Memo1         .text:= StringReplace(ReadString('Main', Memo1.Name, ''), #243#246, #13#10); // wgg used to do separately, caused probs
      PageControl1  .ActivePageIndex:= ReadInteger('Main', 'ProjectTab', 0);             // wgg
      th:=                     ReadInteger('Main', 'InformHeight', 0);              // wgg
      //if th<>0 then chkb80Rows.Visible:= true;                                      // wgg
      InformHeight:= 50;                                 // wgg
      if (th<>50) then InformHeight:= 66;                // wgg
      if InformHeight <> 50 then chkb80Rows.checked:= true
      else chkb80Rows.checked:= false;

      chkbLoadOnly  .Checked:= ReadInteger('Main', 'LoadOnly', 0)=1;                // wgg
      FUseGetLam            := ReadInteger('Main', 'UseGetLAM', GUseGetLam)=1;         // wgg
      chkbEntry     .Checked:= ReadInteger('Main', 'UseDefaultEntryList', 1)=1;     // wgg
      chkbIsLib     .Checked:= ReadInteger('Main', 'library', 1)=1;
      chkbIsDir     .Checked:= ReadInteger('Main', 'directory', 0)=1;               // wgg
      if chkbIsLib.checked then chkbIsDir.checked:= false;                          // wgg
      AutoLoad      .Checked:= ReadInteger('Main', 'AutoLoad', 1)=1;
      Calc48        .Checked:= ReadInteger('Main', 'Calc48', 0)=1;     // wgg  must be after LRFiles set because this causes Calc48Click event
      KeepAllBox    .Checked:= ReadInteger('Main', 'KeepAll', 0)=1;
      chkbIsLibClick(Nil);                                                   // wgg setup tab appearence
      chkbIsDirClick(Nil);
      frmInformEdit.Set48(IsCalc48);                                                // wgg

      if (ReadInteger('Main', 'EMUVisible', 0)=1) And
         (Debugger.DebugType= DtNone) then  DebugStart;     // wgg may have been started by Calc48.checked

      // wgg, Get strings for the project Message Text box
      // replaces older 'Memo1' entry which is left for read compatability
      st:= tstringlist.create;
      try
        ReadSection('MsgText', st);
        while st.count<>0 do
        Begin
          Memo1.Lines.Add(ReadString('msgtext', st[0], ''));
          st.delete(0);
        end;
      finally
        st.free;
      end;

       // Get list of files for the project list box
      st:= tstringlist.create;
      try
        ReadSection('Files', st);
        while st.count<>0 do
        Begin
          AddFile(ReadString('files', st[0], ''));
          st.delete(0);
        end;
      finally
        st.free;
      end;

      // Now get files in the editor that the user had open last time         wgg
      FilesOpenLast:= TStringList.create;
      st:= tstringlist.create;
      try
        ReadSection('Edit', st);
        while st.count<>0 do
          Begin
            FilesOpenLast.add(ReadString('edit', st[0], ''));
            st.delete(0);
          end;
      finally
        st.free;
      end;

    finally
      free;
      Modified:= false;                                               // wgg must be after all changes
      LoadingProj:= false;                                            // wgg
    end;
end;

// wgg Restore Source Edit and Inform Edit windows to last used state
// if we open any files, the window will be left open as a clue
// else WindowPosSave will rule window status of frmSourceEdit
// frmInformEdit will be hidden unless a previously opened form is found
Procedure TfrmProject.OpenProjectSources;
var
  dir: TFileName;
Begin
   try
     dir:= GetCurrentdir;
     SetProjectDir;
     while FilesOpenLast.count<>0 do
       Begin
         if pos('*',FilesOpenLast.Strings[0]) = 1 then
           frmInformEdit.OpenFile(copy(FilesOpenLast.Strings[0],2,255), False)
         else
           frmSourceEdit.Display(FilesOpenLast.Strings[0], 0);
         FilesOpenLast.delete(0);
       end;
   finally
     SetCurrentDir(dir);
     FilesOpenLast.free;
   end;
end;

procedure TfrmProject.Open1Click(Sender: TObject);
begin
  OpenDialog1.Filter:='Project files (*.hpp)|*.HPP';
  OpenDialog1.Title:= 'Open Project';
  if OpenDialog1.Execute then
    if CloseProject then
    Begin
      LoadProject(OpenDialog1.FileName);
       // wgg added LoadLR code else open leads to missing ffile info
      frmMainForm.LoadLr(pchar(frmProject.LRList));                              // wgg
      frmProject.OpenProjectSources;                                           // wgg
      Search.Click;                                                          // wgg find the load address in emu
      frmSourceEdit.GetLErrors;                                             // scan for errors
    end;
end;

function TfrmProject.SaveProject: boolean;
  procedure WriteCheck(inf:TIniFile; key:string; sec: string; fld:TCheckBox);
  begin
    if fld.checked then inf.WriteInteger(key, sec, 1)
    else inf.WriteInteger(key, sec, 0);
  end;
var
  i, j: integer;
  ini: TIniFile;
begin
  result:= True;                               // wgg means we were not canceled, build could still fail
  if IsNewProject then
    result:= SaveProjectAs                     // wgg if goes well, calls here recursively after get a filename
  else
  begin
    ini:= TIniFile.Create(caption);
    with ini do
    try
      EraseSection('Main');                                                   // wgg
      WriteCheck(ini, 'Main', 'library',             chkbIsLib);
      WriteCheck(ini, 'Main', 'directory',           chkbIsDir);              // wgg
      WriteCheck(ini, 'Main', 'AutoLoad',            AutoLoad);
      WriteCheck(ini, 'Main', 'Calc48',              Calc48);
      WriteCheck(ini, 'Main', 'KeepAll',             KeepAllBox);
      WriteCheck(ini, 'Main', 'UseDefaultEntryList', chkbEntry);
      WriteCheck(ini, 'Main', 'LoadOnly',            chkbLoadOnly);            // wgg
      if Debugger.DebugType=DtNone then WriteInteger('Main', 'EMUVisible', 0)  // wgg
      else WriteInteger('Main', 'EMUVisible', 1);
      if UseGetlam then                                                       // wgg don't show this unless forced
            WriteInteger(   'Main', 'UseGetLAM', 1);
      WriteInteger('Main', 'ProjectTab', Ord(PageControl1.TabIndex));         // wgg
      if chkb80Rows.Visible then
            WriteInteger('Main', 'InformHeight', InformHeight);               // wgg
      WriteString('Main', EntryPointList.Name, EntryPointList.text);
      WriteString('Main', Title         .Name, Title         .text);
      WriteString('Main', Config        .Name, Config        .text);
      WriteString('Main', ExtPrg        .Name, ExtPrg        .text);
      WriteString('Main', Message       .Name, Message       .Text);          // wgg
      WriteString('Main', Romid         .Name, Romid         .text);
      WriteString('Main', Slot          .Name, Slot          .text);          // wgg
      WriteString('Main', Emu48Ram      .Name, Emu48Ram      .text);          // wgg added 2 rams
      WriteString('Main', Emu48Port2    .Name, Emu48Port2    .text);          // wgg
      WriteString('Main', Emu49Ram      .Name, Emu49Ram      .text);
      WriteString('Main', FilePath      .Name, FilePath      .text);
      WriteString('Main', DirPath       .Name, DirPath       .text);          // wgg
      WriteString('Main', RPL_INCLUDE   .Name, RPL_INCLUDE   .text);
      WriteString('Main', SasmParams    .Name, SasmParams    .text);
      WriteString('Main', LRFiles       .Name, LRFiles       .text);
 
      // wgg, Get strings for the project Message Text box
      // replaces older 'Memo1' entry which is left for read compatability
      EraseSection('MsgText');
      j:= 0;
      for i:=0 to Memo1.Lines.Count-1 do
      begin
        inc(j);
        WriteString('MsgText', pchar('msgtext'+inttostr(j)), Memo1.Lines[i]);
      end;

      EraseSection('Files');                                                  // wgg may be fewer files the  before
      j:= 0;
      for i:=0 to ListView1.Items.Count-1 do
      begin
        inc(j);
        WriteString('Files', pchar('file'+inttostr(j)), ListView1.Items[i].Caption);
      end;
      IniEditList;
      Modified:= false;
    finally
        free;
      end;
  end;
end;

 // write a list of open files to the project ini
procedure TfrmProject.IniEditList;
var
  i,j: integer;
  list: TStringList;
begin
  if Not IsNewProject then
    if (FileGetAttr(Caption) and faReadOnly) = 0 then          // wgg don't let read only cause errors
      with TIniFile.Create(caption) do
      try
        list:= TStringList.create;
        j:= 0;
        try
          EraseSection('Edit');
          frmInformEdit.FileNames(list);                    // puts a '*' in front of file names
          frmSourceEdit.FileNames(list);           // wgg find what files are currently open
          for i:= 0 to list.Count-1 do
          begin
            inc(j);
            WriteString('Edit', pchar('edit'+inttostr(j)), list.Strings[i]);
          end;
        finally
          list.free;
        end;
      finally
        free;
      end;
end;

// read the bookmarks for a file
function TfrmProject.ReadBookmarks(f: TFilename): string;
begin
  Result:= '';
  if Not IsNewProject then
    if (FileGetAttr(Caption) and faReadOnly) = 0 then          // wgg don't let read only cause errors
      with TIniFile.Create(caption) do
      try
        Result:= ReadString('Bookmarks', ShortName(f), '');
      finally
        free;
      end;
end;

// write the bookmarks for a file
// s = 12,34,56 etc. for bookmarks 0 through 9.  ,,, means no marks for that entry
procedure TfrmProject.WriteBookmarks(f: TFilename; s:string; HasMarks: boolean);
begin
  if Not IsNewProject then
    if (FileGetAttr(Caption) and faReadOnly) = 0 then          // wgg don't let read only cause errors
      with TIniFile.Create(caption) do
      try
        if HasMarks then
          WriteString('Bookmarks', f, s)
        else
          DeleteKey('Bookmarks', f);
      finally
        free;
      end;
end;

procedure TfrmProject.Save1Click(Sender: TObject);
begin
  SaveProject;
end;

procedure TfrmProject.SaveAs1Click(Sender: TObject);
begin
  SaveProjectAs;
end;

procedure TfrmProject.Addtoproject1Click(Sender: TObject);
var
  i: integer;
begin
  if IsNewProject then
    begin
      application.MessageBox('You must save the project before adding new files in it', 'error', MB_OK);
      exit;
    end;
  OpenDialog2.InitialDir:= ProjectDir;
  OpenDialog2.Filter:= 'Source Files (*.s, *.h)|*.S;*.H|All Files (*.*)|*.*';
  OpenDialog2.Title:='Open Source File';
  if OpenDialog2.Execute then
  Begin
    for i:= 0 to ListView1.items.count-1 do
      if OpenDialog2.files.indexof(ListView1.items[i].caption)<>-1 then
        OpenDialog2.Files.delete(OpenDialog2.files.indexof(ListView1.items[i].caption));
    while OpenDialog2.files.count<>0 do
    Begin
      AddFile(OpenDialog2.files[0]);                                      // wgg does modified
      OpenDialog2.Files.Delete(0);
    end;
  end;
end;

function TfrmProject.SaveProjectAs: boolean;
begin
  SaveDialog1.InitialDir:= ProjectDir;
  SaveDialog1.Filter:='Project files (*.hpp)|*.HPP';
  SaveDialog1.Title:= 'Save Project';
  SaveDialog1.Options:= [ofOverwritePrompt, ofNoReadOnlyReturn];
  if SaveDialog1.Execute then
  Begin
    caption:= SaveDialog1.FileName;
    Modified:= true;
    FilePath.text:= ChangeFileExt(ProjectName, '.hp');
    result:= SaveProject;
    frmMainForm.LoadLr(pchar(frmProject.LRList));                              // wgg
  end else
    result:= false;
end;

procedure TfrmProject.OpenFiles1Click(Sender: TObject);
var
  i: integer;
  f: TFileName;
  dir: tfilename;
begin
  dir:= GetCurrentdir;
  try
    SetProjectDir;
    with ListView1 do
      for i:= 0 to Items.Count-1 do         // wgg added multi-select
        if Items[i].Selected then
        begin
          f:= ExpandFileName(ListView1.Items[i].caption);
          if pos(InformInternalDatas, FileTostring(f))<>0 then
            frmInformEdit.OpenFile(f, False)
          else
            frmSourceEdit.Display(f, 0);
        end;
  finally
    SetCurrentDir(dir);
    ListView1.ClearSelection;
  end;
end;

procedure TfrmProject.RemoveFromProject1Click(Sender: TObject);
var
  i: integer;
begin
  with ListView1 do
  for i:= Items.Count-1 downto 0 do         // wgg added multi-select
    if Items[i].Selected then
      Items[i].Free;
{  if assigned(ListView1.Selected) then
    ListView1.Selected.Free; }
  modified:= true;
end;

procedure TfrmProject.FormCreate(Sender: TObject);
begin
  WindowPosSave1.ReadPos;
  ProjectInit;                                           // wgg uninitialized projects are problems
  Caption:= Noproject;                                   // wgg these twp lines come after ProjectInit
  Modified:= false;
  PageControl1.ActivePage:= TabSheet1;                   // wgg force project info tab
  DropFileTarget1.Register(ListView1);
{$IFDEF UseConn4x}
  FHPdir.SetLoadToReal(LoadToReal);                      // wgg for later callbacks
  FHPdir.SetProjectFile(FetchProjectFile);               // wgg for later callbacks
{$ENDIF}
end;

function TfrmProject.FetchProjectFile: TFileName;
begin
  SetProjectDir;
  Result:= TargetName;
end;

procedure TfrmProject.Newfile1Click(Sender: TObject);
var
  f: TFileName;
begin
  if IsNewProject then
    begin
      if application.MessageBox('You must save the project first', 'error', MB_OKCANCEL) = IDCANCEL then
         exit;
    end;
  SaveDialog2.InitialDir:= ProjectDir;
  SaveDialog2.Options:= [ofOverwritePrompt, ofNoReadOnlyReturn];
  SaveDialog2.Filter:= 'Source Files (*.s, *.h)|*.S;*.H|All Files (*.*)|*.*';
  SaveDialog2.Title:='New Source File';
  If SaveDialog2.Execute then
  Begin
    modified:= true;
    with TStringList.Create do
      try
        f:= SaveDialog2.Filename;
        add('RPL ');
        add('( '+f+', part of the '+ProjectName+' project, created by <> on '+datetostr(now)+' )');
        add('');
        if chkbIsLib.Checked And (UpperCase(ExtractFileExt(f)) = '.S') then
          add('INCLUDE '+QuoteIf(ChangeFileExt(ProjectName, '.h'))+#13#10);
        SaveToFile(f);
        frmSourceEdit.display(f, 0);
        if UpperCase(ExtractFileExt(f)) = '.S' then AddFile(f);
      finally
        free;
      end;
  end;
end;

function TfrmProject.ShortName(f: string): string;
begin
  result:= f;
  if ExtractFileDir(UpperCase(f))=UpperCase(ProjectDir) then   // wgg added UpperCase
    result:= ExtractFileName(f);
end;

procedure TfrmProject.AddFile(f: TFileName);
begin
  f:= ShortName(f);
  if ListView1.FindCaption(0, f, false, true, false) = Nil then              // wgg do not load file twice
  begin
    ListView1.Items.add.caption:= f;
    modified:= True;
  end;
end;

procedure TfrmProject.ListView1DblClick(Sender: TObject);
var
  f: TFileName;
  dir: tfilename;
begin
  dir:= GetCurrentdir;
  try
    SetProjectDir;
    if ListView1.Selected <> nil then
    Begin
      f:= ExpandFileName(ListView1.selected.caption);
      if pos(InformInternalDatas, FileTostring(f))<>0 then
        frmInformEdit.OpenFile(f, False)
      else
        frmSourceEdit.Display(f, 0);
    end;
  finally
    SetCurrentDir(dir);
    ListView1.ClearSelection;
  end;
end;


// wgg you must now call SaveProject before using this procedure
// and frmSourceEdit.SaveAll
// and frmInformEdit.btnSaveClick(Nil)       because these routines can cancel a save and hence the build!
Procedure TfrmProject.CompileAllFiles;
var
  i: integer;
  s, link: string;
Begin
  s:= GetCurrentDir;
  try
    frmSourceEdit.ListBox1.Items.clear;
    with TfrmProgress.Create(self) do
      try
        caption:= 'Compiling';
        show;

        // wgg compile the Suprom.o and .lr files if out of date
        SetCurrentDir(ExtractFilePath(Suprom));
        if Not FileExists(Suprom+'.lr')
           Or (FileDateToDateTime(FileAge(Suprom+'.a')) > FileDateToDateTime(FileAge(Suprom+'.lr'))) then
        begin
          rsasm2(ExtractFileName(Suprom+'.a'));
          link:= 'LLIST '+ChangeFileExt(ExtractFileName(Suprom+'.a'), '.lr')+#13#10
                  +'REL '+ChangeFileExt(ExtractFileName(Suprom+'.a'), '.o');
          rsload2(link);
        end;
        SetProjectDir;

        if chkbIsLib.Checked then
        Begin
          Display('Creating header file');
          CreateHeader;
        end
        else
          deleteFile(ChangeFileExt(ProjectName, '.h'));        // wgg in case it exists, so we get warned

        for i:=0 to ListView1.items.count-1 do
        begin
          display('compiling '+ListView1.items[i].caption);
          rrplcomp(ListView1.items[i].caption);
          rsasm(ListView1.items[i].caption);
       if Not KeepAll then                                               // wgg keep partial products
          DeleteFile(ChangeFileExt(ListView1.items[i].caption, '.a'));
        end;
    finally
      free;
    end;

  finally
    SetCurrentDir(s);
  end;
end;


// Build the entire project                                                     // wgg reorganized this proc
// All source files will be saved by the CompileAllFiles procedure called here
// The project file is also saved
procedure TfrmProject.build1Click(Sender: TObject);
var
  clrSave: TColor;
  i: integer;
  p: TfrmProgress;
begin
  if Not SaveProject then exit;                       // forced save everything, user said "build"
  frmSourceEdit.SaveAll;
  frmInformEdit.btnSaveClick(Nil);                           // wgg
  CompileAllFiles;
  SetProjectDir;

  if Debugger.InAsmStep Or Debugger.InRplStep then
    begin
      Application.MessageBox(pchar('Cannot build, EMU is halted.  Do "Continue" or close EMU.'),pchar('Halted'), mb_OK);
      Exit;
    end;

  p:= TfrmProgress.Create(self);
  try
    p.caption:= 'Building project';
    p.show;
    if chkbIsLib.Checked then
    begin
      BuildLib(p);
      if AutoLoad.Checked then BuildAutoLoad;
    end else begin
      if AutoLoad.Checked And (DirPath.text <> '') then BuildAutoLoadDir;
      if chkbIsDir.Checked then BuildDir(p)
      else BuildSimple(p);
    end;
  finally
    p.free;
  end;

  if Not KeepAll then                            // wgg keep partial products
    for i:=0 to ListView1.items.count-1 do       // delete temporary files
      DeleteFile(ChangeFileExt(ListView1.items[i].caption, '.o'));

  // add an HPHP4x extention on front and save file                    // wgg
  if Not chkbIsDir.Checked then StringToFile(HPHeader+'-C'+FileToString(TargetName), TargetName);

  LoadFull;                                                            // wgg load to emu and update all
  frmSourceEdit.GetLErrors;                                          // wgg

  if frmSourceEdit.listBox1.Items.Count > 0 then   // wgg need a reminder to read error msgs
  if frmSourceEdit.Visible then
  begin
    clrSave:= frmSourceEdit.ListBox1.Color;      // wgg flash memo box red
    frmSourceEdit.ListBox1.Color:= clRed;
    frmSourceEdit.ListBox1.Repaint;
    beep;
    Sleep(500);
    frmSourceEdit.ListBox1.Color:= clrSave;
  end
  else  Application.MessageBox('Warning, errors reported, open editor',
            'Build Errors', MB_OK);
end;

procedure TfrmProject.LoadFull(force:boolean=false);         // wgg complete load and update pack
begin;
  Debugger.SaveBPSource;                         // wgg save info so we can restore them later
  frmMainForm.LoadLr(pchar(frmProject.LRList));      // reload the .LR
  if AutoLoad.Checked Or force then LoadtoEMU;   // load into the EMU

  frmSourceEdit.reloadAdrs;                    // wgg fix FFiles
  frmSourceEdit.TabControl1Change(Nil);        // wgg need to reload FFile
  Search.Click;                                  // has to be done again!!
  Debugger.recomputeBP;                          // wgg reset all the bPs
end;

// wgg delete any .ext files in the directory
procedure deleteExt;
var
  srchRec: TSearchRec;
  r: integer;
begin
  r:= FindFirst('*.ext', faAnyFile, SrchRec);
  While r=0 do
  begin
    deleteFile(SrchRec.Name);
    r:=FindNext(SrchRec);
  end;
  FindClose(SrchRec);
end;

// *** the project is a lib, build it                                          // wgg
procedure TfrmProject.BuildLib(p: TfrmProgress);
var
  Messages, Configure: boolean;
  i: integer;
  m: string;
begin
  with TStringList.Create do
  begin
    try
      // creating the .mn file and compile it
      p.display('Creating lib infos');
      add('OUTPUT temp.o');
      add('LLIST '+QuoteIf(ChangeFileExt(ProjectName, '.lr')));
      add('SU LX');
      add('SU UN');
      if Title.Text<>'' then add('NAME '+Title.Text);
      if CONFIG.Text<>'' then add('CONFIGURE '+CONFIG.Text)
      else
      begin
        CreateConfigure;
        add('CONFIGURE CONFIG')
      end;

      m:= 'Messages';
      Messages:= false;
      if Message.Text = '' then
        Messages:= CreateMessages         // wgg Message.Text (the name) must be blank for auto build of Inform Texts
      else
        m:= Message.Text;
      if Messages Or (Message.text <> '') then
        add('MESSAGE ' + m);                           // wgg define if CreateMessage or if user asked for it

      if Messages then                                 // wgg only if default name
      Begin
        rrplcomp2('_message.s', '_message.a');
        rsasm2('_message.a');
      end;

      Configure:= false;
      if CONFIG.Text='' then                                 // wgg only if default name
      Begin
        Configure:= true;
        rrplcomp2('_config.s', '_config.a');
        rsasm2('_config.a');
      end;

      add('ROMPHEAD _head.a');
      if ExtPrg.text<>'' then
      Begin
        StringToFile(#9'CON(5)'#9'#0C5D0'#13#10#9'CON(5)'#9'=DOROMP'#13#10#9'CON(6)'#9'=~'
            +ExtPrg.text+#13#10, '_extprg.a');

        rsasm2('_extprg.a');
        add('REL _extprg.o');
      end;
      add('TABLE _table.a');
      for i:=0 to ListView1.items.count-1 do
        add('REL '+QuoteIf(ChangeFileExt(ListView1.items[i].caption, '.o')));     // wgg long file anme
      if Messages then add('REL _message.o');
      if Configure then add('REL _config.o');
      add('FINISH _end.a'#13#10'END'#13#10);
      SaveToFile(ChangeFileExt(ProjectName, '.MN'));
      rmakerom(ChangeFileExt(ProjectName, '.MN'), ChangeFileExt(ProjectName, '.M'));
      // compile the files created by makerom
      rsasm2('_head.a');
      rsasm2('_table.a');
      rsasm2('_end.a');
      if Not KeepAll then                                                  // wgg keep partial products
        deleteFile(ChangeFileExt(ProjectName, '.MN'));
      // create the .m file (to link all the files together)
      p.display('Linking phase 1');
      rsload(ChangeFileExt(ProjectName, '.M'), '');
      if Not KeepAll then                                                  // wgg keep partial products
      begin
        deleteFile(ChangeFileExt(ProjectName, '.MN'));
        deleteFile(ChangeFileExt(ProjectName, '.M'));
      end;
      clear;
      // now, add the supported entry point list file
      // and generate the output
      p.display('Linking phase 2');
      add('OUTPUT '+QuoteIf(TargetName));
      add('OPTION CODE');
      add('LLIST '+QuoteIf(ChangeFileExt(ProjectName, '.LRERR')));
      add('SU XR');
      add('REL temp.o');       // wgg MUST be before SEARCH so user's names will be used if a conflict
      add('SEARCH '+QuoteIf(Suprom+'.O'));
      add('CK LIB'+ROMID.text+' SYSEND'+ROMID.text);
      add('END');
      SaveToFile(ChangeFileExt(ProjectName, '.M'));
      rsload('-H', ChangeFileExt(ProjectName, '.M'));
      if Not KeepAll then                                                   // wgg keep partial products
      begin
        // delete temporary files
        deletefile('temp.o');
        deletefile(ChangeFileExt(ProjectName, '.M'));
        deleteFile('_head.a');
        deleteFile('_table.a');
        deleteFile('_end.a');
        deleteFile('_head.o');
        deleteFile('_table.o');
        deleteFile('_end.o');
        deleteFile(ChangeFileExt(ProjectName, '.LRERR'));
        deleteExt;
        if Messages then                                                   // wgg
        begin
          deletefile('_message.s');
          deletefile('_message.a');
          deletefile('_message.o');
        end;
        if Configure then                                                   // wgg
        begin
          deletefile('_config.s');                                           // wgg
          deletefile('_config.a');
          deletefile('_config.o');
        end;
       end;
    finally
      free;
    end;
  end;
end;

// *** the project, is not a lib, do simple things                              // wgg
procedure TfrmProject.BuildSimple(p: TfrmProgress);
var
  i: integer;
begin
  with TStringList.Create do
  begin
    try
      // create the .M file and link it
      p.display('Linking phase 1');
      add('OUTPUT temp.o');
      add('LLIST '+QuoteIf(ChangeFileExt(ProjectName, '.lr')));
      add('SU LX');
      add('SU UN');
      for i:=0 to ListView1.items.count-1 do
        add('REL '+QuoteIf(ChangeFileExt(ListView1.items[i].caption, '.o')));
      SaveToFile(ChangeFileExt(ProjectName, '.M'));
      rsload(ChangeFileExt(ProjectName, '.M'), '');
      if Not KeepAll then                                                  // wgg keep partial products
        deleteFile(ChangeFileExt(ProjectName, '.M'));
      clear;
      // now, link the supported entry point list and generate the output
      p.display('Linking phase 2');
      add('OUTPUT '+QuoteIf(TargetName));
      add('OPTION CODE');
      add('LLIST '+QuoteIf(ChangeFileExt(ProjectName, '.LRERR')));
      add('SU AL');          // was just add('SU XR');
      add('LI UN');
      add('REL temp.o');       // wgg MUST be before SEARCH so user's names will be used if a conflict
      add('SEARCH '+QuoteIf(Suprom+'.O'));
      add('END');
      SaveToFile(ChangeFileExt(ProjectName, '.M'));
      rsload('-H', ChangeFileExt(ProjectName, '.M'));
      if Not KeepAll then                                                     // wgg keep partial products
        begin
          deletefile('temp.o');
          deletefile(ChangeFileExt(ProjectName, '.M'));
          deleteFile(ChangeFileExt(ProjectName, '.LRERR'));
          deleteExt;                                                          // wgg
        end;
    finally
      free;
    end;
  end;
end;


// wgg *** the project, is a dir, build it
procedure TfrmProject.BuildDir(p: TfrmProgress);
var
  i,j, len: integer;
  prevEntPos, totalSzPos: integer;
  f, st, s, buffer: string;
  HPFile: THPStream;
  list: TStringList;

  function GetHex(s: string; i: integer): integer;
  Begin
    result:= ((pos(s[i], HexStr)-1) shl 16) + ((pos(s[i+1], HexStr)-1) shl 12) +
             ((pos(s[i+2], HexStr)-1) shl 8) + ((pos(s[i+3], HexStr)-1) shl 4) +
             (pos(s[i+4], HexStr)-1);
    if s[i+5] in ['0'..'F'] then result:= (result * 16 + (pos(s[i+5], HexStr)-1));
  end;

  procedure buildList(f:string);
  var
    sl: TStringList;
    i, j, index, hx: integer;
  begin
    sl:= TStringList.Create;
    try
      sl.text:= FileToString(f);
      for i:= 0 to sl.Count-1 do
        if (length(sl.strings[i])>56) then
          if sl.Strings[i][1] = '=' then
            if copy(sl.strings[i], 36, 3)='Rel' then
            begin
              index:= list.Count;
              hx:= GetHex(sl.strings[i], 52);
              for j:= 0 to list.Count-1 do
                if hx<Integer(list.Objects[j]) then
                begin
                  index:= j;
                  break;
                end;
              list.insert(index, copy(sl.strings[i], 2, pos(' ',sl.strings[i])-2));  // make new the Ith entry
              list.Objects[index]:= TObject(hx);   // retrieve by k2:= Integer((list.Objects[listcount-1]));
            end;
    finally
      sl.Free;
    end;
  end;

begin
  // wgg now build up the directory file
  HPFile:= THPStream.create;
  list:= TStringList.Create;
  with HPFile, TStringList.Create  do
  begin
    try
      WriteInt($02A96);
      WriteInt($7FF, 3);
      totalSzPos:= Position;                       // backfill later with total length
      WriteInt(0);                                 // place marker for pointer to last item
      prevEntPos:= Position;                       // first entry will be 0

      p.display('Linking phase 1');
      // wgg link each module in reverse order (so entries follow user view)
      for i:=ListView1.items.count-1 downto 0 do
      begin
        f:= ListView1.items[i].caption;
        add('OUTPUT temp.o');
        add('OPTION CODE');
        add('LLIST '+QuoteIf(ChangeFileExt(ProjectName, '.lr')));  // wgg must have the XR listing to get undef errors
        add('REL '+QuoteIf(ChangeFileExt(f, '.o')));
        add('SEARCH '+QuoteIf(Suprom+'.O'));
        add('END');
        st:= ChangeFileExt(f, '.M');
        SaveToFile(st);
        rsload('-H', st);
        if Not KeepAll then  deleteFile(st);              // keep partial products
        clear;

        s:= HPFileToString('temp.o');                     // get the object as nibbles
        buildList(ChangeFileExt(f, '.l'));                // find the directory name entries
        list.add('##end##');                              // so we can have the final address in list
        list.objects[list.Count-1]:= TObject(length(s));  // counts are in nibbles

        for j:= list.Count-2 downto 0 do
        begin
          WriteInt(Position-prevEntPos);                  // size of previous entry
          prevEntPos:= Position;
          WriteName(list.Strings[j]);                     // name of entry
          len:=Integer(list.Objects[j+1])-Integer(list.Objects[j]);
          buffer:= copy(s,Integer(list.objects[j])+1, len);
          Write(buffer[1], len);
        end;
        list.Clear;
      end;
      Seek(totalSzPos, soFromBeginning);    // offset to final entry pointer
      WriteInt(prevEntPos-totalSzPos);
      SaveToHPFile(TargetName, HPHeader+'-C');

      if Not KeepAll then                                 // wgg keep partial products
        begin
          deletefile('temp.o');
          deleteExt;
        end;
    finally
      free;
      HPFile.free;
      list.Free;
    end;
  end;
end;

// ***  wgg link the file, f without HPHP header
procedure TfrmProject.Link1Load(f: string; dotExt: string);
begin
  with TStringList.Create do
  try
    add('OUTPUT '+QuoteIf(f+dotExt));
    add('OPTION CODE');
    add('LLIST tmp.lr');
    add('SU XR');
    add('SEARCH '+QuoteIf(Suprom+'.O'));                        //wgg
    add('REL '+QuoteIf(f+'.o'));
    add('END');
    SaveToFile(f+'.M');
    rsload('-H', f+'.M');
    if Not KeepAll then                                                     // wgg keep partial products
    begin
     deleteFile(f+'.a');
     deletefile(f+'.o');
     deletefile(f+'.M');
     deletefile('tmp.lr');
     deletefile(f+'.ext');
    end;
  finally
    free;
  end;
end;

// ***  wgg build a file, f, using source, code
procedure TfrmProject.Build1Load(code: string; f: string);
begin
  with TStringList.Create do
  try
    Add(code);                                                              // wgg added slot
    SaveToFile(f+'.s');
    clear;
    rrplcomp(f+'.s');
    rsasm(f+'.s');
    Link1Load(f, '.hp');
    StringToFile(HPHeader+'-C'+FileToString(f+'.hp'), f+'.hp');             //wgg
    if Not KeepAll then                                               // wgg keep partial products
    begin
      DeleteFile(f+'.s');
      DeleteFile(f+'.l');
    end;
  finally
    free;
  end;
end;

// wgg build autoload file name, add ends to ending
function TfrmProject.AutoLoadName(ends: string): string;
begin
  if Calc48.Checked then result:= ChangeFileExt(ProjectName, '')+'_A48'+ends
  else result:= ChangeFileExt(ProjectName, '')+'_A49'+ends;
end;

// ***  wgg build the autoload procedure                                       // wgg
procedure TfrmProject.BuildAutoLoad;
var
  code: string;
begin
  if IsCalc48 then                                                          // wgg added HP-48 autoload
  begin                                                                     // wgg HP-48 autoload
    code:= (':: xIFERR :: TAG '+inttostr(Slot.value)+' % '+inttostr(Romid.value)
       +' DUP xDETACH xPURGE ; xTHEN xDROP xIFEND % '+inttostr(Slot.value)+' xSTO '
       +'CODE'#13#10+'  GOVLNG  =Warmstart'#13#10+'ENDCODE'#13#10+' ;');
  end else
  begin
   code:= (':: xIFERR :: TAG '+inttostr(Slot.value)+' % '+inttostr(Romid.value)
       +' DUP xDETACH xPURGE ; xTHEN xDROP xIFEND % '+inttostr(Slot.value)+' xSTO % '
       +inttostr(Romid.value)+' xATTACH % '+inttostr(Romid.value)+' xMENU ;');
  end;
  Build1Load(code, AutoLoadName(''));
  if IsCalc48 then
  begin
    code:= (':: % '+inttostr(Romid.value)+' xMENU ;');  
    Build1Load(code, AutoLoadName('2'));
  end;
end;

// ***  wgg build the autoload procedure for a directory (or simple verb)
// Plan: user gives a path A B C D (D is the one we built!)
//       We create A B C if they do not exist
//       if they do exist, they better be directories or !!!
// we try to traverse A B C, clear D and save D
procedure TfrmProject.BuildAutoLoadDir;
var
  code, s, v: string;
  i: integer;
begin
  with TStringlist.Create do
  try
    i:= 1;
    while i <= length(DirPath.Text) do
    begin
      s:= TokenAtPos(DirPath.Text, i);
      if s<> '' then add(s);
    end;

    code:= ':: HOMEDIR ';
    if Count > 1 then
    for i:=0 to Count-2 do
      code:= code + ''' ID '+Strings[i]+' DUP @ ITE DROP :: DUP CREATEDIR ; EVAL ';  // wgg create directories as we go

    if chkbIsDir.Checked then v:= ' XEQPGDIR'
    else v:= ' xPURGE';

    if Count > 0 then
      code:= code + ''' ID '+Strings[Count-1]+v+' '' ID '+Strings[Count-1]
        +' STO ';
    if chkbIsDir.Checked then code:= code+'ID '+Strings[Count-1]+' ';    // wgg if a directory, enter and display vars
    Code:= Code + '%2 xMENU ;';
    Build1Load(code, AutoLoadName(''));
  finally
    clear;
    free;
  end;
end;

{procedure TfrmProject.LogIt(tag: string; m: integer);    // wgg for testing
var
  i: integer;
  b: byte;
begin
      for i:= 1 to m do
      begin
   //     SearchClick(Nil);
   //     OutputDebugString(pChar(tag+' '+inttostr(FileAdr.value)));
        Debugger.ReadMemory(b, $10C, 1);
        OutputDebugString(pChar(tag+' '+inttostr(b)));
        sleep(100);
      end;
end; }

// *** load the file in the emulator
procedure TfrmProject.LoadtoEMU;
var
   t:char;
begin
  if chkbIsLib.Checked then    // make sure no pointers to the lib
  begin
    if IsCalc48 then debugger.ExecKey(#16#01, Nil)  // wgg clear the calc
    else debugger.ExecKey(#19#02, Nil);             // wgg clear the calc
    Sleep(500);
  end;
  Debugger.WaitShutDn;                          // Make sure not busy before a load
  Debugger.loadFile(TargetName);                // load the project .hp file
  if AutoLoad.Checked then                      // wgg auto attach the lib, dir or verb if asked
    if chkbIsLib.Checked Or (DirPath.Text <> '') then    // else we require a path
    begin
      Debugger.WaitShutDn;                              // Make sure not busy before a load
      Debugger.loadFile(AutoLoadName('')+'.hp');
      If IsCalc48 then
      begin                                             // wgg procedure for autoload on HP-48
        debugger.ExecKey('O', Nil);                     // EVAL
        Debugger.WaitShutDn;                            // wgg wait for ready
        if chkbIsLib.Checked then                       // wgg need a 2nd step for libs on HP48
        begin
          Sleep(1200);                                  // wgg allow time (maybe settings=real speed)
          Debugger.WaitShutDn;                          // Make sure not busy before a load
          Debugger.loadFile(AutoLoadName('2')+'.hp');
          debugger.ExecKey('O', NIL);                   // EVAL
          Debugger.WaitShutDn;                          // wgg wait for ready
        end;
        Sleep(500);                                     // wgg allow time for addresses to be valid
        Debugger.WaitShutDn;                            // wgg wait for ready
        SearchClick(Nil);
      end else begin
        Debugger.WaitShutDn;                            // wgg wait for ready
        t:= EmuCalculatorType;
        if (t = '2') Or (t = 'Q') then
          debugger.ExecKey('N', Nil)                    // wgg EVAL for 49G+ or 48GII
        else
          debugger.ExecKey(#19'P', Nil);                // EVAL wgg for HP49 had  Search.Click
        Debugger.WaitShutDn;                            // wgg wait for ready
        Sleep(500);                                     // wgg allow time for addresses to be valid
        Debugger.WaitShutDn;                            // wgg wait for ready
        SearchClick(Nil);
      end;
    end;
end;

{$IFDEF UseConn4x}
// wgg, load the file using XModem to real calculator
procedure TfrmProject.LoadtoReal(server: TXModemServer);
const
  tname: string='$$$t';
begin
  SetProjectDir;
  with server do
  begin
    Put(tname, TargetName);                                // load the project .hp file
    DoCommand(''''+tname+''' DUP RCL SWAP PURGE');         // and put on stack
    if AutoLoad.Checked then                               // wgg auto attach the lib, dir or verb if asked
      if chkbIsLib.Checked Or (DirPath.Text <> '') then    // else we require a path
      begin
        Put(tname, AutoLoadName('')+'.hp');
        Sleep(1500);
        DoCommand(''''+tname+''' DUP RCL SWAP PURGE EVAL');
        If IsCalc48 then
        begin                                              // wgg procedure for autoload on HP-48
           Com:= '';               // if a lib and a 48, it is already dead due to warmstart!
         end else begin
           //Sleep(2000);         // only needed if we will shut down the connection
        end;
      end;
  end;
end;
{$ENDIF}

procedure TfrmProject.SetAsRelative(E: TEdit; news: string);
begin
  if ExtractFileDir(UpperCase(news))=UpperCase(ProjectDir) then
    news:= ExtractFileName(news);                // wgg set path relative to project
  if news<>E.Text then E.text:= news;                // wgg do not set unless we have to
end;

procedure TfrmProject.BrowseRelative(E: TEdit; t: string; s: string);
begin
  Browse(E, t, s);
  SetAsRelative(E, E.Text);
end;

procedure TfrmProject.Button9Click(Sender: TObject);
begin
  BrowseRelative(FilePath, 'Project Target File', 'Calc Files (*.hp)|*.HP|All Files (*.*)|*.*');
end;

//  search for your file in RAM and update HexaEdit1. This will also update the RamBase variable
procedure TfrmProject.SearchClick(Sender: TObject);
var
  a: string;
  s: string;
  m: array of byte;
  i: integer;
  dir: string;
begin
  FileAdr.Text:='';                                                           // wgg in case we fail
  if Debugger.DebugType = DTNone then exit;
  dir:= GetcurrentDir;
  try
    SetProjectDir;

    if FileExists(TargetName) then
    begin
    {   if not FileExists(TargetName) then    // wgg we are quiet about this because new projects wont have .hp file
      raise exception.Create('Error, the file does not exists');  }
    s:= HPFileToString(TargetName);
    if length(s) > 0 then
    begin
      // wgg if odd # bytes will end with $00 and only first 0 will be loaded!!!
      if length(s)>2 then s:= copy(s, 1, length(s)-1);
      SetLength(m,256*1024*2);  // copy the ram data into a string
      for i:=0 to 511 do
        Debugger.ReadMemory(m[i*1024],i*1024+256*1024*2,1024);
      SetLength(a, length(m));
      for i:= 0 to Length(a)-1 do
        a[i+1]:= chr(m[i]);
      // in order to avoid detecting an instance of the object in
      // the TEMPOB, we look backward in the strings
      // this means, we can look forward in the reversed string!
      RevString(s);
      RevString(a);
      i:= pos(s, a);   // look for the file
      if i<>0 then
        FileAdr.value:= 1024*1024-i-length(s)+1;
      end;    // wgg of file exists
    end;
  finally
    SetCurrentDir(dir);
  end;
end;

// update the RamBase variable
procedure TfrmProject.FileAdrChange(Sender: TObject);
begin
  SetRamBase(FileAdr.value);
  Debugger.RebuiltBreakPointList;
end;

procedure TfrmProject.FilePathKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  if Key=13 then
    Search.Click;
end;

procedure TfrmProject.Button10Click(Sender: TObject);
begin
  LoadFull(True);                                        // wgg will update search adrs and bps will autoload
 { Debugger.loadFile(TargetName); }                      // wgg very limited load
end;

procedure TfrmProject.Button11Click(Sender: TObject);
begin
  frmSourceEdit.ListBox1.Items.clear;                                       // wgg
  frmMainForm.LoadLr(pchar(frmProject.LRList));                                   // wgg
end;

procedure TfrmProject.NewProject1Click(Sender: TObject);
begin
  if CloseProject then
  begin
    ProjectInit;                                                                  // wgg moved init code to ProjectInit
    SaveProjectAs;
  end;
end;

procedure TfrmProject.CreateHeader;
var
  i, j, k: integer;
  s, h: TStringList;
  dir: string;
begin
  dir:= GetCurrentDir;
  try
    SetProjectDir;
    s:= TStringlist.Create;
    try
      h:= TStringList.Create;
      try
        h.add('* This Header file has been automaticaly');
        h.add('* generated from the '+caption+' project files');
        h.add('* including:');
        for i:= 0 to ListView1.Items.Count-1 do
          h.add('* '+ListView1.Items[i].caption);
        h.add('');
        h.Add('ASSEMBLEM DC RomId '+ROMID.text+' !RPL');
        h.add('xROMID '+ROMID.text+#13#10);
        for i:= 0 to ListView1.Items.Count-1 do
        Begin
          h.add('* entries of the file '+ListView1.Items[i].caption);
          s.LoadFromFile(ListView1.Items[i].caption);

          for j:= 0 to s.count-1 do
          begin
              k:= pos('NULLNAME', s[j]);
              if k<>0 then
                h.Add('EXTERNAL '+GetToken(s[j], 2))
              else begin
                k:= pos('xNAME', s[j]);
                if k<>0 then
                  h.Add('EXTERNAL x'+GetToken(s[j], 2))
            end;
          end;
          h.add('');
        end;
        h.SaveToFile(ChangeFileExt(ProjectName, '.h'));   
      finally
        h.free;
      end;
    finally
      s.free;
    end;
  finally
    SetCurrentDir(dir);
  end;
end;

procedure TfrmProject.RecreateHeader1Click(Sender: TObject);
begin
  CreateHeader;
end;

Function TfrmProject.CreateMessages: boolean;
var
  i, j, dccpplace, nberrs: integer;
  s: TStringList;
  m: string;
  dir: string;
begin
  dir:= GetCurrentdir;
  try
    SetProjectDir;
    nberrs:= 0;
    s := TStringList.Create;
    try
      with TStringList.Create do
        try
          Add('* Message table of the project '+caption);

          // add the place for the DCCPs of the inform boxes
          Add('ASSEMBLEM');
          dccpplace:= count;
          add('!RPL');

          if Message.Text = '' then                                         // wgg
            m:= 'Messages'
          else
            m:= Message.Text;

          add('NULLNAME '+ m +' ARRY [');                                    // wgg
          // add the errors of the memo
          for i:= 0 to Memo1.lines.count-1 do
            if length(Memo1.lines[i])<>0 then
            begin
              inc(NbErrs);
              add('"'+Memo1.lines[i]+'"');
            end;

          // add the correct CP=
          insert(dccpplace, 'CP='+ROMID.text+IntToHex2(NbErrs+1, 2));
          inc(dccpplace);

          // add the error messages defined in the inform box file
          for i:=0 to ListView1.Items.Count-1 do
          Begin
            s.LoadFromFile(ListView1.Items[i].caption);
            if (s.count>0) and (pos(InformInternalDatas, s.text)<>0) then
            Begin
              j:= 0;
              while j<s.count do
                if pos(BeforeDCCP, s[j])<>0 then
                begin
                  inc(j);
                  if j<s.count then
                  Begin
                    insert(dccpplace, s[j]);             
                    inc(dccpplace);
                    inc(j);
                  end;
                end else
                  if pos(BeforeErrors, s[j])<>0 then
                  Begin
                    inc(j);
                    while (j<s.count) and (length(s[j])>0) and (s[j][1]='*') do
                    Begin
                      add(copy(s[j], 3, maxint));
                      inc(j);
                      inc(NbErrs);
                    end;
                  end else
                    inc(j);
            end;
          End;

          add(']');
          if NbErrs<>0 then
            SaveToFile('_message.s');
        finally
          Free;
        end;
    finally
      s.Free;
    end;
    result:= NbErrs<>0;
  finally
    SetCurrentDir(dir);
  end;
end;

// wgg autocreate a config routine for the library
Procedure TfrmProject.CreateConfigure;
begin
  with TStringList.Create do
  try
    add('RPL'#13#10);
    add('INCLUDE '+QuoteIf(ChangeFileExt(ProjectName, '.h'))+#13#10);
    add('* This is the $CONFIG program (attaches to home directory)');
    add('NULLNAME CONFIG'#13#10'::'#13#10+
        'HOMEDIR #'+ROMID.text+ ' XEQSETLIB'#13#10';'#13#10);
    SaveToFile('_config.s');
  finally
    Free;
  end;
end;

// as arguments for the C code, we have to
// give pchars.
// st is used to keep track of the original string
// and avoid the automatic free of the string by delphi
var
  st: TStringList;

procedure TfrmProject.SetProjectDir;
begin
  if RPL_INCLUDE.text = '' then
    SetEnvironmentVariable('RPL_INCLUDE', Pchar(ProjectDir
                           +';'+ApplicationPath+'\Include'))
  else
    SetEnvironmentVariable('RPL_INCLUDE', Pchar(RPL_INCLUDE.text
                           +';'+ProjectDir
                           +';'+ApplicationPath+'Include'));
  SetCurrentDir(ProjectDir);
  st.clear;
  if UseGetLam then SetEnvironmentVariable('ADRLAM', 'GETLAM')
  else if IsCalc48 then
    SetEnvironmentVariable('ADRLAM', '0')
  else
    SetEnvironmentVariable('ADRLAM', '34616');
end;

Procedure AddParam(var a: TMyArgv; const s: string);
Begin
  SetLength(a, Length(a)+1);
  st.add(s);
  a[High(a)]:= pchar(s);
end;

procedure TfrmProject.Calc48Click(Sender: TObject);
begin
  if Not Assigned(frmProject) then exit;
  Modified:= true;
  if Debugger.DebugType <> DtNone then
  begin
    Debugger.DebugType:= DtNone;
    frmSourceEdit.ListBox1.Items.clear;                            // wgg
    frmMainForm.LoadLr(pchar(frmProject.LRList));                        // wgg
    DebugStart;                        // will do SearchClick
  end else begin
    if Not LoadingProj then            // wgg during load we do not want to do LoadLR twice!
    begin                              // once here and once in MainForm.Timer1
      frmMainForm.LoadLr(pchar(frmProject.LRList));                        // wgg
      SearchClick(Nil);
    end;
  end;
  frmDebugEMU.setCalcModel;                                // wgg
  chkb80Rows.checked:= Not Calc48.Checked;
end;

procedure TfrmProject.KeepAllBoxClick(Sender: TObject);
begin
  if Not Assigned(frmProject) then exit;
  Modified:= true;
end;

procedure TfrmProject.rmakerom(f1, f2: TFileName);
var
  a: TMyArgv;
begin
  AddParam(a, 'MakeRom.exe');
  AddParam(a, f1);
  AddParam(a, f2);
  HPTMakeRom(length(a), @(a[0]));
end;

procedure TfrmProject.rrplcomp(s: string);
var
  a: TMyArgv;
begin
  AddParam(a, 'rplcomp.exe');
  AddParam(a, s);
  AddParam(a, ChangeFileExt(s, '.a'));
  AddParam(a, ChangeFileExt(s, '.ext'));   
  HPTRplComp(length(a), @(a[0]));
end;

procedure TfrmProject.rsasm(s: string);
var
  a: TMyArgv;
  i, j: integer;
  s1: string;
begin
  addParam(a, 'sasm.exe');
  addParam(a, '-c');
  addParam(a, '500');
  addParam(a, '-B');
  addParam(a, '-W');
  addParam(a, '-e');
  addParam(a, '-N');

  s1:= SasmParams.text;     // wgg this code used to come first but then user cannot override params
  i:= 1;
  while i<=length(s1) do
  Begin
    j:= SkipWhite(s1, i);
    i:= FindWhite(s1, j);
    AddParam(a, copy(s1, j, i-j));
  end;

  addParam(a, '-a');
  addParam(a, ChangeFileExt(s, '.l'));
  addParam(a, '-o');
  addParam(a, ChangeFileExt(s, '.o'));
  addParam(a, ChangeFileExt(s, '.a'));
  HPTSasm(length(a), @(a[0]));
end;

procedure TfrmProject.rsasm2(s: string);
var
  a: TMyArgv;
begin
  addParam(a, 'sasm.exe');
  addParam(a, '-c');
  addParam(a, '500');
  addParam(a, '-B');
  addParam(a, '-W');
  addParam(a, '-e');
  addParam(a, '-N');
  addParam(a, '-o');
  addParam(a, ChangeFileExt(s, '.o'));
  addParam(a, ChangeFileExt(s, '.a'));
  HPTSasm(length(a), @(a[0]));
end;

procedure TfrmProject.rrplcomp2(f1, f2: TFileName);
var
  a: TMyArgv;
begin
  AddParam(a, 'rplcomp.exe');
  AddParam(a, f1);
  AddParam(a, f2);
  HPTrplcomp(length(a), @(a[0]));
end;

procedure TfrmProject.rsload(s1, s2: string);
var
  a: TMyArgv;
begin
  AddParam(a, 'sload.exe');
  AddParam(a, '-e');                          // wgg - tell SLOAD to put errors to stderr
  AddParam(a, s1);
  if s2<>'' then AddParam(a, s2);
  HPTSload(length(a), @(a[0]));
end;

procedure TfrmProject.NewInformBox1Click(Sender: TObject);
const
  NewFile =
  #13#10+InformInternalDatas+#13#10'l00000000020C001C000100000005005400690074006C0065'#13#10+
  '0002000D000A'#13#10'0002000D000A'#13#10'0002000D000A'#13#10'0002000D000A'#13#10'0002000D000A'#13#10+
  '00090059006F007500720020004E0061006D0065'#13#10')';
var
  s: string;
begin
  if IsNewProject then
    begin
      if application.MessageBox('You must save the project first', 'error', MB_OKCANCEL) = IDCANCEL then
         exit;
    end;
  SaveDialog2.InitialDir:= ProjectDir;
  SaveDialog2.Filter:= 'Source Files (*.s, *.h)|*.S;*.H|All Files (*.*)|*.*';
  SaveDialog2.Title:= 'New Inform File';
  If SaveDialog2.Execute then
  Begin
    if isCalc48 then s:= InformHeader48+NewFile
    else s:= InformHeader49+NewFile;
    StringToFile(s,SaveDialog2.FileName);
    AddFile(SaveDialog2.FileName);                  // wgg does modified
    frmInformEdit.OpenFile(SaveDialog2.FileName, True);    // wgg True means a new file
  end;
end;

procedure TfrmProject.Button4Click(Sender: TObject);
begin
  BrowseRelative(Emu48Ram, 'HP48 Emulator File', 'HP48 EMU files (*.e48)|*.e48');
end;

procedure TfrmProject.Button6Click(Sender: TObject);
begin
  BrowseRelative(Emu48Port2, 'HP48 Port2 (.bin) File', 'HP48 port2 files (*.bin)|*.bin');
end;

procedure TfrmProject.Button5Click(Sender: TObject);
begin
  BrowseRelative(Emu49Ram, 'HP49 Emulator File', 'HP49 EMU files (*.e49)|*.e49');
end;

procedure TfrmProject.btnEntryPointListClick(Sender: TObject);
begin
  try
    SetCurrentDir(ApplicationPath);
    Browse(EntryPointList, 'Calculator Entries List',
                'Entry files (Suprom*.a)|SUPROM*.A|SASM Files (*.a)|*.A');     // wgg
  finally                                                                      //wgg
    SetCurrentDir(ProjectDir);
  end;
end;

procedure TfrmProject.rsload2(s: string);
begin
  StringToFile(s, '_temp.m');
  rsload('_temp.m', '');
  DeleteFile('_temp.m');
end;

function TfrmProject.ProjectDir: string;
begin
  result:= ExtractFileDir(caption);
end;

function TfrmProject.ProjectName: string;
begin
//  result:= StringReplace(ExtractFileName(caption), ' ', '_');   // wgg no longer needed
  result:= ExtractFileName(caption);
end;

function TfrmProject.TargetName: string;
begin
  //   FilePath.Text:= ShortName(FilePath.Text);
  if FilePath.Text <> '' then
    result:= ChangeFileExt(FilePath.Text, '.hp.')   // StringReplace(ChangeFileExt(FilePath.Text, '.hp.'), ' ', '_')
  else result:= ChangeFileExt(ProjectName, '.hp');
end;

procedure TfrmProject.TitleChange(Sender: TObject);
begin
  Modified:= true;
end;

procedure TfrmProject.ListView1KeyPress(Sender: TObject; var Key: Char);
begin
  if key = #8 then
    removefromproject1.Click;
end;

procedure TfrmProject.Memo1DblClick(Sender: TObject);
begin
  (sender as TMemo).lines.text:= frmFullPageEdit.Execute('', (sender as TMemo).lines.text, 'Project Messages');
  if assigned((Sender as TMemo).OnEnter) then
    (Sender as TMemo).OnEnter(Sender);
  if assigned((Sender as TMemo).OnChange) then
    (Sender as TMemo).OnChange(Sender);
end;

function TfrmProject.GetModified: boolean;
begin
  Result := FModified and (caption<>NoProject);
end;

Function TfrmProject.IsNewProject: boolean;
Begin
  result:= false;
  if ExtractFileName(caption) = NoProject then result:= true;     // wgg when we get command line of x.h x.s we might set a directory
  if ExtractFileName(caption) = NewProject then result:= true;
end;

function TfrmProject.EntryPointFile: string;                    //wgg completly redone
var
  s: string;
begin
  if (EntryPointList.text='') Or chkbEntry.Checked then
    begin
      if Calc48.Checked then s:= 'Suprom48'
      else s:= 'Suprom49';
      result:= ApplicationPath+'\Include\'+s+'.a'
    end
  else
    result:= EntryPointList.text;
end;

Function TfrmProject.HPHeader: string;                                            // wgg
Begin
  if Calc48.Checked then
    result:= 'HPHP48'
  else
    result:= 'HPHP49'
end;

Function TfrmProject.Suprom: string;                                              // wgg
Begin
    result:= ChangeFileExt(EntryPointFile, '');              // wgg returns with no .xxx
end;

Function TfrmProject.IsCalc48: boolean;                                           // wgg
Begin
  result:= Calc48.Checked;
end;

Function TfrmProject.KeepAll: boolean;                                           // wgg
Begin
  result:= KeepAllBox.Checked;
end;

procedure TfrmProject.chkbEntryClick(Sender: TObject);                          // wgg
begin
  if chkbEntry.Checked then entryPointList.Text:= '';
  entryPointList.Enabled:= chkbEntry.Checked=False;
  btnEntryPointList.Enabled:= chkbEntry.Checked=False;
  Modified:= true;
end;

procedure TfrmProject.chkbLoadOnlyClick(Sender: TObject);               // wgg for big ROM development
begin                                                                // inhibit auto set of project lr files
  Modified:= true;
end;

// wgg this is here to stop the beep on #13
// I tried everything else, TEdit just seems to hate the #13!
procedure TfrmProject.DirPathKeyPress(Sender: TObject; var Key: Char);
begin
  if key=#13 then key:=#0;
end;

// wgg drag and drop files
procedure TfrmProject.DropFileTarget1Drop(Sender: TObject;
  ShiftState: TShiftState; Point: TPoint; var Effect: Integer);
var
  i: integer;
begin
  application.ProcessMessages;
  if IsNewProject then
  begin
    Application.MessageBox('You must save the project before adding new files in it', 'error', MB_OK);
    exit;
  end;
  try
    with DropFileTarget1 do
      for i := 0 to files.count-1 do
        if (UpperCase(ExtractFileExt(Files[i]))='.S') then
          AddFile(Files[i]);                                      // wgg does modified
  finally
  end;
end;

initialization
  st:= TStringList.Create;

finalization
  st.free;

end.
