{
  This form let you look at the memory.
  it lets you walk throught the memory.
  you can also type an expression in the edit and press enter
  to go at the address
  This unit is copyright Hewlett Packard
}
unit fmRamView;

interface

uses
  Classes, Forms, StdCtrls, ExtCtrls, WindowsPosSave, CDBShUtils, SynEdit,
  Controls;

type
  TfrmRamView = class(TForm)
    ScrollBar1: TScrollBar;
    WindowPosSave1: TWindowPosSave;
    HexaView1: THexaView;
    CheckBox1: TCheckBox;
    Panel1: TPanel;
    Memo1: TMemo;
    SynEdit1: TSynEdit;
    procedure ScrollBar1Change(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure SynEdit1KeyPress(Sender: TObject; var Key: Char);
    procedure FormResize(Sender: TObject);
    function HexaView1Read(Sender: TObject; const adr: Integer): Byte;
    procedure HexaView1Write(Sender: TObject; const adr: Integer; const Value: Byte; const Nibble: Boolean);
    procedure CheckBox1Click(Sender: TObject);
    procedure SynEdit1KeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure FormActivate(Sender: TObject);
    procedure SynEdit1Enter(Sender: TObject);
  public
  end;

var
  frmRamView: TfrmRamView;

implementation

uses
  SysUtils, lrworking, Debug, fmMainForm;

{$R *.DFM}

procedure TfrmRamView.ScrollBar1Change(Sender: TObject);
begin
  HexaView1.CurrentTop:= ScrollBar1.Position * 16;        // wgg scroll bar now works in lines not bytes
end;

procedure TfrmRamView.FormCreate(Sender: TObject);
begin
  WindowPosSave1.ReadPos;
end;

// go to a specific address in the memory if Enter is pressed in the editor
procedure TfrmRamView.SynEdit1KeyPress(Sender: TObject; var Key: Char);
var
  value: integer;
begin
  if key=#13 then
  begin
    Value:= SymbolTable.ValueFromText(SynEdit1.Text);
    if Value<>-1 then
      ScrollBar1.Position:= (Value And $FFFFF) div 16;          // wgg scroll bar is now steps of lines
    Key:= #0;
  end;
end;

procedure TfrmRamView.FormResize(Sender: TObject);
begin
  HexaView1.SetBounds(0, SynEdit1.Top+ SynEdit1.Height+1,
        ClientWidth-ScrollBar1.Width-1, ClientHeight-SynEdit1.Height-1);
  // wgg now compute highest line based on size of window
  Scrollbar1.Max:= 65536-((Hexaview1.Height-2) div 15);         // wgg 15 pixels / line
  Scrollbar1.LargeChange:= ((Hexaview1.Height-2) div 15) - 1;   // wgg one line overlap
  ScrollBar1.SetBounds(HexaView1.left+HexaView1.width, HexaView1.top,
        scrollbar1.width, HexaView1.Height);
end;

function TfrmRamView.HexaView1Read(Sender: TObject;
  const adr: Integer): Byte;
begin
  try
    result:= Debugger.ReadInteger(adr) and $ff;
  except
    result:= 0;
  end;
end;

procedure TfrmRamView.HexaView1Write(Sender: TObject; const adr: Integer;
  const Value: Byte; const Nibble: Boolean);
var
  b: array [0..1] of byte;
  n, i: integer;
begin
  if nibble then
    n:= 1
  else
    n:= 2;
  for i:= 0 to n-1 do
    b[i]:= (value shr (i*4)) and $f;
  Debugger.WriteMemory(b, adr, n);
  Caption:= inttohex(adr,5);
end;

procedure TfrmRamView.CheckBox1Click(Sender: TObject);
begin
  Panel1.visible:= checkBox1.Checked;
  Hexaview1.Visible:= Not checkBox1.Checked;
  ScrollBar1.Visible:= Not checkBox1.Checked;
end;

procedure TfrmRamView.SynEdit1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var
  value: integer;
begin
  if key=13 then
  Begin
    Value:= SymbolTable.ValueFromText(SynEdit1.Text);
    if Value<>-1 then
      ScrollBar1.Position:= (Value And $FFFFF) div 16;           // wgg now in lines
    key:= 0;
  end;
end;

procedure TfrmRamView.FormActivate(Sender: TObject);
begin
  if ActiveControl is TSynEdit then frmMainForm.EditActivate(Sender);                 // wgg
end;

procedure TfrmRamView.SynEdit1Enter(Sender: TObject);
begin
  if Sender is TSynEdit then frmMainForm.EditEnter(Sender);
end;

end.
