{+--------------------------------------------------------+---------------------+
 |   1: 17/07/99 Cyrille de brebisson
 |     - addapt it for the HP Debugger
 |
 |
 |  Changes marked with WGG are copyright 2002, William G. Graves
 |
 +----------------------------------------------------------------------------+}

unit fmSourceEdit;

{$I SynEdit.inc}
{$WARN SYMBOL_PLATFORM OFF}             // wgg dont warn about FileGetAttr call

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, ComCtrls, Menus, Spin, WindowsPosSave, SynEditPrint,
  SynEditKeyCmdsEditor, SynEditPrintTypes, lrworking, SynCompletionProposal,
  SynEdit, DropTarget, SynHighlighterHP48, ImgList, DropSource,
  SynEditHighlighter;

  // This type is used to store a file.
// A list of this object represents all the files opened in the editor
type
  TFiles = class
    cx, cy: integer;  // cursor position
    mList: TList;     // list of bookmarks for file         wgg added
    FjustLF: boolean; // file had LF not CRLF when read     wgg added
    ReadOnly: boolean; // file is read only                 wgg added
    TopLine: integer; // first line on display              wgg added
    t: string;        // the file text
    modif: boolean;   // has the file been modified
    name: string;     // wgg the LONG file name
    FFile: TLFile;    // Point on a FFile object
    constructor create(f: TFileName);
end;

type
   TfrmSourceEdit = class(TForm)
    OpenDialog1: TOpenDialog;
    FontDialog1: TFontDialog;
    ImageList1: TImageList;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Save1: TMenuItem;
    Open1: TMenuItem;
    mnuEdit: TMenuItem;
    Find2: TMenuItem;
    Next1: TMenuItem;
    Breakpoints1: TMenuItem;
    RplBreak1: TMenuItem;
    Timer1: TTimer;
    WindowPosSave1: TWindowPosSave;
    Visibles1: TMenuItem;
    ListBox1: TListBox;
    Splitter1: TSplitter;
    StatusBar1: TStatusBar;
    TabControl1: TTabControl;
    SaveAll1: TMenuItem;
    CloseFile: TMenuItem;
    Labels1: TMenuItem;
    Compilation1: TMenuItem;
    Errors2: TMenuItem;
    Built1: TMenuItem;
    CompileAll1: TMenuItem;
    InformEdit1: TMenuItem;
    New1: TMenuItem;
    Addfiletoproject1: TMenuItem;
    Back1: TMenuItem;
    Replace1: TMenuItem;
    Sumary1: TMenuItem;
    PageControl1: TPageControl;
    tabDisplay: TTabSheet;
    Label12: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    Label16: TLabel;
    Label26: TLabel;
    inpRightEdge: TSpinEdit;
    cbxScrollBars: TComboBox;
    cbxColor: TComboBox;
    cbxForeground: TComboBox;
    cbxBackground: TComboBox;
    btnFont: TButton;
    inpExtraLineSpacing: TSpinEdit;
    tabCaret: TTabSheet;
    Label7: TLabel;
    Label8: TLabel;
    cbxInsertCaret: TComboBox;
    cbxOverwriteCaret: TComboBox;
    cbInsertMode: TCheckBox;
    tabHighlighter: TTabSheet;
    Label23: TLabel;
    Label24: TLabel;
    Label22: TLabel;
    cbxAttrSelect: TComboBox;
    cbxAttrBackground: TComboBox;
    cbxAttrForeground: TComboBox;
    grbAttrStyle: TGroupBox;
    cbStyleBold: TCheckBox;
    cbStyleStrikeOut: TCheckBox;
    cbStyleUnderline: TCheckBox;
    cbStyleItalic: TCheckBox;
    TabSheet1: TTabSheet;
    KeyCmdList: TListView;
    btnEdKeys: TButton;
    Print1: TMenuItem;
    Memo1: TMemo;
    N1: TMenuItem;
    N2: TMenuItem;
    N3: TMenuItem;
    N4: TMenuItem;
    Und1: TMenuItem;
    Redo1: TMenuItem;
    N7: TMenuItem;
    E1: TMenuItem;
    EditSourceTemplates1: TMenuItem;
    NewInformBox1: TMenuItem;
    Open2: TMenuItem;
    RescanAllErrors1: TMenuItem;
    SynHP48Syn1: TSynHP48Syn;
    Editor: TSynEdit;
    SynEditPrint: TSynEditPrint;
    PrinterSetupDialog: TPrinterSetupDialog;
    PageSetup: TMenuItem;
    PrinterSetup: TMenuItem;
    PrintPreview: TMenuItem;
    View: TMenuItem;
    N6: TMenuItem;
    inpTabWidth: TSpinEdit;
    lblTabWidth: TLabel;
    cbRealTabs: TCheckBox;
    mnuHelp: TMenuItem;
    mnuHelpKeys: TMenuItem;
    mnuAbout: TMenuItem;
    N5: TMenuItem;
    mnuLineEnd: TMenuItem;
    cbUseCRLF: TCheckBox;
    mnuHelpFile: TMenuItem;
    PrintDialog: TPrintDialog;
    mnuEscKeys: TMenuItem;
    PopupMenu1: TPopupMenu;
    Save2: TMenuItem;
    Close1: TMenuItem;
    N8: TMenuItem;
    BuildProject1: TMenuItem;
    CloseWindow1: TMenuItem;
    Open3: TMenuItem;
    GoToDefinition1: TMenuItem;
    ShowStack1: TMenuItem;
    PopupMenu2: TPopupMenu;
    RescanThisFilesErrors1: TMenuItem;
    RescanAllErrors2: TMenuItem;
    Clear1: TMenuItem;
    DropFileTarget1: TDropFileTarget;
    mnuSymbolFile: TMenuItem;
    N9: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure btnUndoClick(Sender: TObject);
    procedure EditorKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure EditorChange(Sender: TObject);
    procedure cbxScrollBarsChange(Sender: TObject);
    procedure cbxColorChange(Sender: TObject);
    procedure cbxForegroundChange(Sender: TObject);
    procedure cbxBackgroundChange(Sender: TObject);
    procedure btnFontClick(Sender: TObject);
    procedure cbxInsertCaretChange(Sender: TObject);
    procedure cbxOverwriteCaretChange(Sender: TObject);
    procedure cbInsertModeClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure cbxAttrSelectChange(Sender: TObject);
    procedure cbxAttrBackgroundChange(Sender: TObject);
    procedure inpRightEdgeChange(Sender: TObject);
    procedure btnEdKeysClick(Sender: TObject);
    procedure inpExtraLineSpacingChange(Sender: TObject);
    procedure btnRedoClick(Sender: TObject);
    procedure Visibles1Click(Sender: TObject);
    procedure Save1Click(Sender: TObject);
    procedure Open1Click(Sender: TObject);
    procedure Find2Click(Sender: TObject);
    procedure AsmBreak1Click(Sender: TObject);
    procedure RplBreak1Click(Sender: TObject);
    procedure Errors1Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure ListBox1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Next1Click(Sender: TObject);
    procedure EditorCtrlClick(Sender: TObject; const s: String);
    procedure TabControl1Change(Sender: TObject);
    procedure TabControl1Changing(Sender: TObject; var AllowChange: Boolean);
    procedure SaveAll1Click(Sender: TObject);
    procedure CloseFileClick(Sender: TObject);
    procedure Labels1Click(Sender: TObject);
    procedure Built1Click(Sender: TObject);
    procedure FormShortCut(var Msg: TWMKey; var Handled: Boolean);
    procedure CompileAll1Click(Sender: TObject);
    procedure InformEdit1Click(Sender: TObject);
    procedure Addfiletoproject1Click(Sender: TObject);
    function CreateProcess1Read(Sender: TObject): String;
    procedure btnEdTemplateClick(Sender: TObject);
    procedure Back1Click(Sender: TObject);
    procedure Replace1Click(Sender: TObject);
    procedure Sumary1Click(Sender: TObject);
    procedure EditorSpecialLineColors(Sender: TObject; Line: Integer;
      var Special: Boolean; var FG, BG: TColor);
    procedure EditorMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure New1Click(Sender: TObject);
    procedure NewInformBox1Click(Sender: TObject);
    procedure File1Click(Sender: TObject);
    procedure OpenAsSource(Sender: TObject);
    procedure OpenClick(Sender: TObject; asSource:boolean=false);
    procedure GetLErrors;                             // wgg
    procedure RescanAllErrors1Click(Sender: TObject); // wgg
    procedure ErrorScanFile(f: string);
    procedure EditorGutterClick(Sender: TObject; X, Y, Line: Integer;
      mark: TSynEditMark);
    procedure EditorMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure PrintCmd(Sender: TObject);
    procedure PrinterSetupCmd(Sender: TObject);
    procedure PrintPreviewCmd(Sender: TObject);
    procedure PageSetupCmd(Sender: TObject);
    procedure inpTabWidthChange(Sender: TObject);
    procedure cbRealTabsClick(Sender: TObject);
    function UseRealTabs: boolean;                                           // wgg
    procedure EditorEnter(Sender: TObject);
    procedure mnuAboutClick(Sender: TObject);
    procedure mnuEditClick(Sender: TObject);
    procedure mnuLineEndClick(Sender: TObject);
    procedure cbUseCRLFClick(Sender: TObject);
    procedure EditorKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure mnuHelpFileClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure mnuEscKeysClick(Sender: TObject);
    procedure CloseWindowClick(Sender: TObject);
    procedure GoToDefinition1Click(Sender: TObject);
    procedure ShowStack1Click(Sender: TObject);
    procedure Clear1Click(Sender: TObject);
    procedure DropFileTarget1Drop(Sender: TObject; ShiftState: TShiftState;
      Point: TPoint; var Effect: Integer);
    procedure mnuSymbolFileClick(Sender: TObject);

  private
//    fName: string;
//    disableMarkButtons: boolean;
    FFile: TLFile;      // .l or .LR file for current, short path and names
    SFile: TFiles;      // source TFiles for current, long path and name
    linePos: TPos;      // wgg where the marker line is; need to have line & file info
    lineTFiles: Tfiles; // wgg pointer to source object (used with linePos)
    mPos: TPos;         // wgg where the emu program counter is; need to have line & file info
    mTFiles: TFiles;    // wgg pointer to source object (used with m)
    m: TSynEditMark;           // wgg Editor mark for above
    files: TStringList;
    NoUpdate: boolean;
    Back: TStringlist;
    formKey: string;               // wgg various registry keys used, see form.create
    epriKey: string;               // wgg SourceEdit Form primary key
    esubKey: string;               // wgg sub key for the editor
    hpriKey: string;               // wgg sub key for the highlighter
    psubKey: string;               // wgg sub key for the page setup dialog

    procedure LoadSettings;
    procedure SaveSettings;                                                   // wgg
    procedure PageSetupIniLoad;                                               // wgg
    procedure PageSetupIniSave;                                               // wgg
    function ColorToIndex(col: TColor): integer;
    function IndexToColor(index: integer): TColor;
    procedure UpdateKeystrokesList;
    procedure ReloadAttributes;
    procedure EditAtAdr(Sender: TObject; adr: integer; doPC: boolean); // wgg
    procedure WriteLine;
    Function OpenFile(f: TFileName): integer;
    function SelectFile(f: TFileName): integer;
    Procedure SaveFile(f: TFileName; blnForce: boolean = false);
    Function SaveFile2(f: TFileName): boolean;                                 // wgg
    Function FileName: string;                                // wgg the short (8.3) file + path
    procedure SetLF(b: boolean);                              // wgg
    function GetLF: boolean;                                  // wgg
    procedure SetFormCaption;                                 // wgg
    procedure SaveBookMarks(f: TFileName; mlist:TList);                        // wgg
  protected
    procedure Loaded; override;
  public
    procedure reloadBP;
    procedure reloadAdrs;                                                      // wgg
    Procedure SaveAll;
    Function SaveAll2: boolean;                                                // wgg
    procedure Display(f: TFileName; line: Integer; fil: TLFile=nil);
    Procedure FileNames(list: TStringList);          // wgg
    function  ShortLongName(f: TFileName): TFileName;// wgg
    procedure CloseAll;                              // wgg
    procedure ClearAdrsMark;                         // wgg
    procedure Refresh(f: TFileName);                 // wgg
    function  SubKey: string;                        // wgg
    procedure SetEditProps(Ed: TSynEdit);            // wgg
    property justLF: boolean read GetLF write SetLF; // wgg
    property priKey: string read eprikey;            // wgg
    procedure AddErrorMsg(s: string);                // wgg
  end;

var
  frmSourceEdit: TfrmSourceEdit;
  TimerCount: Integer;                              // wgg see Timer1 and EditAtAdr
  FastClear: boolean;
  lastMouseButton: TMouseButton;  // wgg see EditAtAdr and ClearAdrsMark

  procedure LoadBookMarks(f: TFileName; e:TSynedit); forward;                    // wgg

implementation

uses
  CDBShUtils, registry, RegistryValues, SynEditKeyCmds,
  fmMainForm, fmInformEdit, hptoolsdll, fmProject, Search, HtmlHelpAPI,
  fmFullPageEdit, fmBreakPointChoice, dlgPrintPreview, dlgPageSetup,
  fmAbout, Debug;

type
  TMrk = class
    mi, mx, my: integer;
    constructor create(i, x, y: integer);
end;

{$R *.DFM}

Procedure HPTOut(s: pchar); stdcall; forward;
Procedure HPTError(s: pchar); stdcall; forward;


function TfrmSourceEdit.SubKey;                                              // wgg
begin
 result:= WindowPosSave1.SubKey;
end;

procedure TfrmSourceEdit.FormCreate(Sender: TObject);
var
  AFont: TFont;
begin
  formKey:= RegistryKey+'\'+WindowPosSave1.SubKey;             // wgg setup the various registry keys
  epriKey:= formKey;
  esubKey:= 'Editor';                                      // wgg Source area Editor registry subkey
  hpriKey:= formKey +'\Highlight';                         // wgg Highlighter registry key
  psubKey:= 'PageSetup';                                   // wgg page setup registry subkey

  ReloadAttributes;
  UpdateKeystrokesList;
  m := TSynEditMark.Create(Editor);
  m.line:= -1;
  m.ImageIndex:= 15;
  m.Visible:= true;
  m.Column:= 1;
  Editor.Marks.Add(m);
  linePos.FileName:='';                                                        // wgg
  mPos.FileName:='';                                                           // wgg

  with TRegIniFile.Create(epriKey) do
    try
      frmMainForm.SynAutoComplete1.AutoCompleteList.text:= ReadString('',
            'Autocomplete', frmMainForm.SynAutoComplete1.AutoCompleteList.text); // wgg
    finally
      free;
    end;

  Debugger.OnEditAdr:= frmSourceEdit.EditAtAdr;
  Files:= TStringList.Create;
  SFile:= TFiles.Create('scratch');                                // wgg scratch used to not have this
  Files.Objects[Files.Add('scratch')]:= SFile;
  Back:= TStringList.create;
  justLF:= false;                                                  // wgg need a default set to get consistent
  HPTInitDll(HPTOut, HPTError);
  WindowPosSave1.ReadPos;

  // wgg printer dialogs initialize
  AFont := TFont.Create;
  with SynEditPrint.Header do begin
    Add('Title: $title$', nil, taLeftJustify, 1);  // default font, left aligned
    Add('Page: $pagenum$ of $pagecount$', nil, taRightJustify, 1);
  end;
  with SynEditPrint.Footer do begin
   { AFont.Assign(DefaultFont)
    AFont.Size := 6; }
    Add('Page: $pagenum$ of $pagecount$', nil, taRightJustify, 1);
    Add('Printed by MyName', nil, taLeftJustify, 1);    // wgg font was AFont
  end;    
  AFont.Free;
  DropFileTarget1.Register(Editor);
end;

procedure TfrmSourceEdit.btnUndoClick(Sender: TObject);
begin
  Editor.Undo;
end;

procedure TfrmSourceEdit.EditorKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if (ssCtrl in Shift) Or (ssAlt in Shift) then exit;
  case Key of
  ord('A')..ord('Z'),ord(' '),ord('0')..ord('9'): ;
  188..222: ;
  else exit;
  end;
  if Editor.ReadOnly And (key<>0) then
    if Application.MessageBox(pchar('Warning, this file is read-only.'
                     +'  Would you like to set write permission?'),
                     pchar('Read-Only File'), MB_YESNOCANCEL) = IDYES then
      if FileSetAttr(Filename, FileGetAttr(Filename) And (Not faReadOnly)) = 0 then
          Editor.ReadOnly:= false
      else beep;
  SetFormCaption;
end;

procedure TfrmSourceEdit.EditorKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  cbInsertMode.Checked := Editor.InsertMode;
end;

procedure TfrmSourceEdit.SetFormCaption;                         // wgg
var
  s: string;
begin
  s:= SFile.Name;              // wgg was FileName
  if Editor.Modified then s:= s +' (modified)';
  if SFile.ReadOnly then s:= s+' (read-only)';
  if Caption <> s then
    Caption:= s;
end;

procedure TfrmSourceEdit.EditorChange(Sender: TObject);
begin
  SetFormCaption;
end;

procedure TfrmSourceEdit.ReloadAttributes;
var
  i: integer;
begin
  if not assigned(Editor.HighLighter) then exit;
  cbxAttrSelect.Items.Clear;
  for i := 0 to Editor.HighLighter.AttrCount - 1 do
    cbxAttrSelect.Items.Add(Editor.HighLighter.Attribute[i].Name);
  cbxAttrSelect.ItemIndex := 0;
  cbxAttrSelectChange(Self);
end;

const
  Colors: array[1..43 {sic!}] of TColor = (clBlack, clMaroon, clGreen, clOlive,
    clNavy, clPurple, clTeal, clDkGray, clLtGray, clRed, clLime,
    clYellow, clBlue, clSkyBlue, clFuchsia, clAqua, clWhite, clScrollBar,        // wgg skyblue added
    clBackground, clActiveCaption, clInactiveCaption, clMenu, clWindow,
    clWindowFrame, clMenuText, clWindowText, clCaptionText,
    clActiveBorder, clInactiveBorder, clAppWorkSpace, clHighlight,
    clHighlightText, clBtnFace, clBtnShadow, clGrayText, clBtnText,
    clInactiveCaptionText, clBtnHighlight, cl3DDkShadow, cl3DLight,
    clInfoText, clInfoBk, clNone);

function TfrmSourceEdit.ColorToIndex(col: TColor): integer;
var
  i: integer;
begin
  Result := 0;
  for i := 1 to 42 do
    if Colors[i] = col then begin
      Result := i - 1;
      Exit;
    end;
end;

function TfrmSourceEdit.IndexToColor(index: integer): TColor;
begin
  Result := Colors[index + 1];
end;

procedure TfrmSourceEdit.LoadSettings;
var
  r: TRegIniFile;
begin
  r:= TRegIniFile.Create(epriKey);

{  if r.ReadBool(esubKey, 'ScroolPast', eoScrollPastEOL in Editor.options) then
    Editor.Options := Editor.Options+[eoScrollPastEOL]
  else
    Editor.Options := Editor.Options-[eoScrollPastEOL];      }                // wgg
  Editor.Font.Name:=   r.ReadString(esubKey, 'font', Editor.Font.Name);
  Editor.Font.Size:=   r.ReadInteger(esubKey, 'fsize', Editor.Font.Size);
  Editor.Font.Color:= StringToColor(r.ReadString(esubKey, 'fcolor', ColorToString(editor.Font.Color)));
  Editor.RightEdge:=   r.ReadInteger(esubKey, 'REdge', Editor.RightEdge);
  Editor.ExtraLineSpacing:= r.ReadInteger(esubKey, 'XLnSpc', Editor.ExtraLineSpacing);    // wgg
  Editor.Color:= TColor( r.ReadInteger(esubKey, 'color1', Editor.Color));
  Editor.SelectedColor.Foreground:= TColor(r.ReadInteger(esubKey, 'color2', Editor.SelectedColor.Foreground));
  Editor.SelectedColor.Background:= TColor(r.ReadInteger(esubKey, 'color3', Editor.SelectedColor.Background));
  Editor.InsertMode:=    r.ReadBool(esubKey, 'insert', Editor.InsertMode);
  Editor.BookMarkOptions.LeftMargin:= r.ReadInteger(esubKey, 'leftmargin', Editor.BookMarkOptions.LeftMargin);
  inpTabWidth.Value:=    r.ReadInteger(esubKey, 'TabWidth', inpTabWidth.Value);     // wgg
  cbRealTabs.Checked:=   r.ReadBool(esubKey, 'UseRealTabs', cbRealTabs.Checked);    // wgg
  Listbox1.Height:=      r.ReadInteger(esubKey, 'MsgHeight',  Listbox1.Height);     // wgg

  r.free;

  inpRightEdge.Value := Editor.RightEdge;
  inpExtraLineSpacing.Value := Editor.ExtraLineSpacing;
  cbxScrollBars.ItemIndex := Ord(Editor.Scrollbars);
  cbxColor.ItemIndex := ColorToIndex(Editor.Color);
  cbxForeground.ItemIndex := ColorToIndex(Editor.SelectedColor.Foreground);
  cbxBackground.ItemIndex := ColorToIndex(Editor.SelectedColor.Background);
  cbxInsertCaret.ItemIndex := Ord(Editor.InsertCaret);
  cbxOverwriteCaret.ItemIndex := Ord(Editor.OverwriteCaret);
  cbInsertMode.Checked := Editor.InsertMode;
  {begin}                                                                       //Carlos 27.12.1998
  cbxAttrForeground.Items.Assign(cbxColor.Items);
  cbxAttrBackground.Items.Assign(cbxColor.Items);
  cbxAttrSelect.ItemIndex := 0;
  cbxAttrSelectChange(Self);
  {end}                                                                         //Carlos 27.12.1998
  SynHP48Syn1.LoadFromRegistry(HKEY_CURRENT_USER, hpriKey);                    // wgg
end;

procedure TfrmSourceEdit.SaveSettings;
var
  r: TRegIniFile;
begin
  r:= TRegIniFile.Create(epriKey);

  r.WriteString(esubKey,  'font',   Editor.Font.Name);
  r.WriteInteger(esubKey, 'fsize',  Editor.Font.Size);
  r.WriteString(esubKey,  'fcolor', ColorToString(editor.Font.Color));
  r.WriteInteger(esubKey, 'REdge',  Editor.RightEdge);
  r.WriteInteger(esubKey, 'XLnSpc', Editor.ExtraLineSpacing);                 // wgg
  r.WriteInteger(esubKey, 'color1', Editor.Color);
  r.WriteInteger(esubKey, 'color2', Editor.SelectedColor.Foreground);
  r.WriteInteger(esubKey, 'color3', Editor.SelectedColor.Background);
  r.Writebool(   esubKey, 'insert', Editor.InsertMode);
  r.WriteString(      '', 'Autocomplete',                                             
            frmMainForm.SynAutoComplete1.AutoCompleteList.text);       // wgg
  r.WriteInteger(esubKey, 'TabWidth', Editor.TabWidth);              // wgg
  r.Writebool(   esubKey, 'UseRealTabs', cbRealTabs.Checked);        // wgg
  r.WriteInteger(esubKey, 'MsgHeight',  Listbox1.Height);            // wgg

  SynHP48Syn1.SaveToRegistry(HKEY_CURRENT_USER, hpriKey);
  r.free;
end;

procedure TfrmSourceEdit.inpRightEdgeChange(Sender: TObject);
begin
  try Editor.RightEdge := inpRightEdge.Value;
  except
  end;
end;

procedure TfrmSourceEdit.cbxScrollBarsChange(Sender: TObject);
begin
  Editor.Scrollbars := TScrollStyle(cbxScrollBars.ItemIndex);
end;

procedure TfrmSourceEdit.cbxColorChange(Sender: TObject);
begin
  Editor.Color := IndexToColor(cbxColor.ItemIndex);
end;

procedure TfrmSourceEdit.cbxForegroundChange(Sender: TObject);
begin
  Editor.SelectedColor.Foreground := IndexToColor(cbxForeground.ItemIndex);
end;

procedure TfrmSourceEdit.cbxBackgroundChange(Sender: TObject);
begin
  Editor.SelectedColor.Background := IndexToColor(cbxBackground.ItemIndex);
end;

procedure TfrmSourceEdit.btnFontClick(Sender: TObject);
begin
  FontDialog1.Font:= Editor.Font;       // wgg
  if FontDialog1.Execute then begin
    Editor.Font.Assign(FontDialog1.Font);
  end;
end;

procedure TfrmSourceEdit.cbxInsertCaretChange(Sender: TObject);
begin
  Editor.InsertCaret := TSynEditCaretType(cbxInsertCaret.ItemIndex);
end;

procedure TfrmSourceEdit.cbxOverwriteCaretChange(Sender: TObject);
begin
  Editor.OverwriteCaret := TSynEditCaretType(cbxOverwriteCaret.ItemIndex);
end;

procedure TfrmSourceEdit.cbInsertModeClick(Sender: TObject);
begin
  Editor.InsertMode := cbInsertMode.Checked;
end;

procedure TfrmSourceEdit.FormShow(Sender: TObject);
const
  first: boolean = true;
begin
  if first then begin
    first := false;
    LoadSettings;
  end;
end;

function AttributeNameToIndex(s: string): Integer;    // wgg so we are independent of order in cbxAttrSelect box
var
  i: integer;
begin
  result:= -1;
  for i := 0 to frmSourceEdit.Editor.HighLighter.AttrCount - 1 do
    if frmSourceEdit.Editor.HighLighter.Attribute[i].Name = s then result:= i;
end;

{begin}                                                                         //Carlos 27.12.1998

procedure TfrmSourceEdit.cbxAttrSelectChange(Sender: TObject);
var
  Attr: TSynHighLighterAttributes;
  index: integer;
begin
  NoUpdate:= true;
  try
    index:= AttributeNameToIndex(cbxAttrSelect.Items.Strings[cbxAttrSelect.ItemIndex]); // wgg
    Attr := TSynHighLighterAttributes.Create('');
    if assigned(Editor.Highlighter) then
      Attr.Assign(Editor.Highlighter.Attribute[index]);

    cbxAttrForeground.ItemIndex := ColorToIndex(Attr.Foreground);
    cbxAttrBackground.ItemIndex := ColorToIndex(Attr.Background);
    cbStyleBold.Checked := (fsBold in Attr.Style);
    cbStyleItalic.Checked := (fsItalic in Attr.Style);
    cbStyleUnderLine.Checked := (fsUnderline in Attr.Style);
    cbStyleStrikeOut.Checked := (fsStrikeOut in Attr.Style);

    Memo1.Visible:= true;
    case TtkTokenKind(index) of
      tkAsmKey: memo1.Lines.text:= SynHP48Syn1.AsmKeywords.Text;
      tkRplKey: memo1.Lines.text:= SynHP48Syn1.RplKeywords.Text;
    else
      Memo1.Visible:= false;
    end;

  finally
    NoUpdate:= false;
  end;
end;

procedure TfrmSourceEdit.cbxAttrBackgroundChange(Sender: TObject);
var
  Attr: TSynHighLighterAttributes;
  AttrStyle: TFontStyles;
  index: integer;
begin
  if NoUpdate then exit;
  index:= AttributeNameToIndex(cbxAttrSelect.Items.Strings[cbxAttrSelect.ItemIndex]);  // wgg
  Attr := TSynHighLighterAttributes.Create(cbxAttrSelect.Items[cbxAttrSelect.ItemIndex]);
  AttrStyle := [];
  Attr.Foreground := IndexToColor(cbxAttrForeground.ItemIndex);
  Attr.Background := IndexToColor(cbxAttrBackground.ItemIndex);
  if cbStyleBold.Checked then
    Include(AttrStyle, fsBold);
  if cbStyleItalic.Checked then
    Include(AttrStyle, fsItalic);
  if cbStyleUnderLine.Checked then
    Include(AttrStyle, fsUnderline);
  if cbStyleStrikeOut.Checked then
    Include(AttrStyle, fsStrikeOut);
  Attr.Style := AttrStyle;

  case TtkTokenKind(index) of
    tkAsmKey: SynHP48Syn1.AsmKeywords.Text:= memo1.Lines.text;
    tkRplKey: SynHP48Syn1.RplKeywords.Text:= memo1.Lines.text;
  end;

  Editor.HighLighter.Attribute[Index].Assign(Attr);                     // wgg
  Editor.Invalidate;
end;
{end}                                                                           //Carlos 27.12.1998

procedure TfrmSourceEdit.inpTabWidthChange(Sender: TObject);
begin
  Editor.TabWidth:= inpTabwidth.value;
  Editor.Invalidate;
end;

procedure TfrmSourceEdit.cbRealTabsClick(Sender: TObject);
begin
   if cbRealTabs.checked then
     Editor.Options:= Editor.Options-[eoTabsToSpaces]
   else
     Editor.Options:= Editor.Options+[eoTabsToSpaces];
end;

function TfrmSourceEdit.UseRealTabs: boolean;
begin
  result:= cbRealTabs.Checked;
end;

procedure TfrmSourceEdit.UpdateKeystrokesList;
var
  x: integer;
begin
  KeyCmdList.Items.BeginUpdate;
  try
    KeyCmdList.Items.Clear;
    for x := 0 to Editor.Keystrokes.Count-1 do
    begin
      with KeyCmdList.Items.Add do
      begin
        Caption := EditorCommandToCodeString(Editor.Keystrokes[x].Command);
        if Editor.Keystrokes[x].ShortCut = 0 then
          SubItems.Add('<none>')
        else
          SubItems.Add(Menus.ShortCutToText(Editor.Keystrokes[x].ShortCut));
      end;
    end;
  finally
    KeyCmdList.Items.EndUpdate;
  end;
end;

procedure TfrmSourceEdit.btnEdKeysClick(Sender: TObject);
var
  Dlg: TSynEditKeystrokesEditorForm;
begin
  Application.CreateForm(TSynEditKeystrokesEditorForm, Dlg);
  try
    Dlg.Caption := 'Key Assignments';                       // wgg
    Dlg.Keystrokes := Editor.Keystrokes;
    if Dlg.ShowModal = mrOk then
    begin
      Editor.Keystrokes := Dlg.Keystrokes;
      UpdateKeystrokesList;
    end;
  finally
    Dlg.Free;
  end;
end;

procedure TfrmSourceEdit.inpExtraLineSpacingChange(Sender: TObject);
begin
  try Editor.ExtraLineSpacing := inpExtraLineSpacing.Value;
  except
  end;
end;

procedure TfrmSourceEdit.btnRedoClick(Sender: TObject);
begin
  Editor.Redo;
end;

procedure TfrmSourceEdit.Visibles1Click(Sender: TObject);
begin
  Visibles1.Checked:= not Visibles1.Checked;
  PageControl1.visible:= Visibles1.Checked;
end;

procedure TfrmSourceEdit.Save1Click(Sender: TObject);
var
  f: string;
begin
  if TabControl1.TabIndex<>-1 then
  Begin
    f:=Files.Strings[TabControl1.TabIndex] ;                          // wgg was f:= TabControl1.tabs[TAbControl1.TabIndex];
    SaveFile(f, true);                                                // wgg force the save
    if FileExists(ChangeFileExt(f, '.o')) then
      DeleteFile(ChangeFileExt(f, '.o'));
  end;
end;

procedure TfrmSourceEdit.OpenClick(Sender: TObject; asSource:boolean=false); // wgg added asSource
begin
  OpenDialog1.InitialDir:= frmProject.ProjectDir;
  OpenDialog1.Filter:= 'Source Files (*.s, *.h)|*.S;*.H|All Files (*.*)|*.*';
  OpenDialog1.Title:='Open Source File';
  if OpenDialog1.execute then
    if (Not asSource) And (pos(InformInternalDatas, FileTostring(OpenDialog1.FileName))<>0)
       then frmInformEdit.OpenFile(OpenDialog1.FileName, False)
    else
      Display(OpenDialog1.FileName, 0);
end;

procedure TfrmSourceEdit.OpenAsSource(Sender: TObject);               // wgg added
begin
  OpenClick(Sender, True);
end;

procedure TfrmSourceEdit.Open1Click(Sender: TObject);                // wgg added
begin
  OpenClick(Sender, False);
end;

// wgg if the file, f, is currently open - close it w/out saving
// then open it again - this is used by frmInformEdit when a form is compiled/saved
procedure TfrmSourceEdit.Refresh(f: TFilename);
var
  i, last, x, y: integer;
  b: boolean;
begin
  if (TabControl1.TabIndex=-1) then exit;
  last:= TabControl1.TabIndex;
  f:= Removeslashslash(f);
  f:= ExpandFileName(f);
  i:= files.IndexOf(f);
  if i=-1 then exit;

  TabControl1Changing(Nil, b);
  TabControl1.TabIndex:= i;
  TabControl1Change(Nil);
  x:= Editor.CaretX;
  y:= Editor.CaretY;
  Files.Objects[i].free;
  Files.objects[i]:= TFiles.Create(f);
  with Files.objects[i] as Tfiles do
  begin
    cx:= x;
    cy:= y;
    modif:= false;
  end;
  TabControl1Change(Nil);                  // this reloads all file data

 {  SelectFile(f);
  Editor.CaretX:= x;                       // these get wiped out by reload of TFile
  Editor.CaretY:= y;
  Editor.Modified:= False;
  line:= Editor.CaretY;
  self.FFile:= GetFileFromFileName(f);
  Editor.Invalidate;
  SelectFile(lastf);}

  TabControl1Changing(Nil, b);
  TabControl1.TabIndex:= last;
  TabControl1Change(Nil);
end;

// wgg check if ok to set a breakpoint, arg is TLFile.RamBased
function bpSetValid(RamBased: boolean): boolean;
begin
  if RamBased then
    result:= (Debugger.DebugType<>DtNone) And (frmProject.Fileadr.Text<>'')
  else
    result:= (Debugger.DebugType<>DtNone);
end;

procedure TfrmSourceEdit.AsmBreak1Click(Sender: TObject);
var
  RPL: boolean;
  i: integer;
begin
  if FFile=Nil then
    FFile:= GetFileFromFileName(Filename);                 // wgg in case, no build or load: EMU already has image
  if FFile<>nil then
    try
      i:= FFile.AdrFromLine(FileName ,Editor.CaretY, RPL);                    // wgg RPL is returned
      if (I>0) And bpSetValid(FFile.Rambased) then DEbugger.SetBreakPoint(i, RPL, true);                                         // wgg RPL was False
    except
      ffile:= nil;
    end;
end;

procedure TfrmSourceEdit.RplBreak1Click(Sender: TObject);
var
  i: integer;
  RPL: boolean;
begin
  if FFile=Nil then
    FFile:= GetFileFromFileName(Filename);                 // wgg in case, no build or load: EMU already has image
  if FFile<>nil then
    try
      i:= FFile.AdrFromLine(FileName ,Editor.CaretY, RPL);         // wgg RPL is returned
      if (I>0) And bpSetValid(FFile.Rambased) then DEbugger.SetBreakPoint(i, RPL, true);
    except
      ffile:= nil;
    end;
end;

procedure TfrmSourceEdit.ErrorScanFile(f: string);
var
  i, p, line: integer;
  s: string;
begin
  try
    line:= 1;
      with TStringList.Create do
        try
          LoadFromFile(ChangeFileExt(f, '.l'));         // wgg
          for i:= 0 to count-1 do
          begin
            s:= Strings[i];
            p:= pos('* File', S);               // if this line contain the '* File' mark, save it { * File  kerheader.s     5 }
            if p<>0 then
            Begin
              s:= copy(s, SkipWhite(s, p+6), MaxInt);
              try
                Line:= StrToInt(copy(s, SkipWhite(s, BackToName(s)+1), MaxInt));
              except
                Line:= 0;
              end;
            end else
              if (pos('ERROR:', s)<>0) Or (pos('error:', s)<>0) then
                if pos('| ', s) <> 0 then
                  AddErrorMsg(copy(strings[i], SkipWhite(strings[i], pos('|', strings[i])+1), MaxInt))
                else
                begin
                  s:= f+': '+inttostr(line)+': '+strings[i];
                  if pos('ERROR', strings[i+1])=0 then s:= s+copy(strings[i+1], 26, MaxInt); // wgg 26 for SASM
                  AddErrorMsg(s);  // wgg removed '*| '+
                end;
          end;
        finally
          free;
        end;
  except
  end;
end;

procedure TfrmSourceEdit.GetLErrors;            // wgg get errors from .l files
var
  i: integer;
begin
    for i:=0 to frmProject.ListView1.Items.Count-1 do
    begin
      ErrorScanFile(frmProject.ListView1.Items[i].Caption);
    end;
end;

procedure TfrmSourceEdit.RescanAllErrors1Click(Sender: TObject);            // wgg added feature
begin
    ListBox1.Items.Clear;
    GetLErrors;
    frmMainForm.LoadLr(pchar(frmProject.LRList));                                // wgg get any link errors too
end;

procedure TfrmSourceEdit.Errors1Click(Sender: TObject);
begin
  ListBox1.Items.Clear;
  if Caption<>'' then ErrorScanFile(ChangeFileExt(FileName, '.l'));        // wgg was caption
end;

procedure TfrmSourceEdit.Timer1Timer(Sender: TObject);
begin
  if TimerCount > 0 then             // wgg this code causes a momentary flash during cursor positioning
  begin
    Dec(TimerCount, Timer1.Interval);  //  see EditAtAdr in this unit
    if TimerCount <= 0 then
    begin
      TimerCount:= 0;
      lineTFiles:= Nil;
      linePos.line:=-1;
      Editor.Invalidate;             // force redisplay
    end;
  end;
  WriteLine;
end;

Procedure TfrmSourceEdit.WriteLine;
var
  i: integer;
  s: string;
  RPL: boolean;
Begin
  if Sfile <> Nil then
    if justLF then
      StatusBar1.Panels[4].Text:= 'LF, no CR (Unix)'
    else
      StatusBar1.Panels[4].Text:= 'CR+LF (Windows)';
    if Editor.ReadOnly then StatusBar1.Panels[5].Text:= 'Read-Only'
    else StatusBar1.Panels[5].Text:= '';
  try
    StatusBar1.Panels[0].Text := 'Line ' + inttostr(Editor.CaretY);
    if FFile=Nil then FFile:= GetFileFromFileName(Filename); // wgg in case, no build or load: EMU already has image
    if FFile<>nil then
    begin
      StatusBar1.Panels[1].Text := 'Start ' + inttohex(FFile.start, 6);
      StatusBar1.Panels[2].Text := 'Stop ' + inttohex(FFile.stop, 6);
      s:= 'adr from line ';                                                   // wgg suppressed FFFFFF
      i:= FFile.AdrFromLine(FileName ,Editor.CaretY, RPL);                         // wgg RPL is returned
       if i > 0 then
      begin
        s:= s + inttohex(i, 6);
        if RPL then s:= s + '   RPL'                                           // wgg added indicators
        else  s:= s + '   ASM';
      end;
      StatusBar1.Panels[3].text:=  s;
    end else begin
      Statusbar1.Panels[1].Text:= '';
      Statusbar1.Panels[2].Text:= '';
      Statusbar1.Panels[3].Text:= '';
    end;
  except
  end;
End;

Procedure TfrmSourceEdit.EditAtAdr(Sender: TObject; adr: integer; doPC: boolean);  // wgg added doPC
Var                                                                 // wgg doPC means set the program counter
  SaveP: PPos;
begin
  SaveP:= SourceFromAdr(adr);
  if SaveP<>nil then
  Begin
    frmSourceEdit.Display(ShortLongName(SaveP^.fileName), SaveP^.line, SaveP^.fil);
    if FastClear then
    begin                                                            // wgg clear right now
      SetFocus;
      FastClear:= False;
      mTFiles:= Nil;                                                 // fastClear only set in SourceForm.ClearAdrs
      mPos.line:=-1;
      Editor.Invalidate;                                             // force redisplay
      exit;
    end;

    if Not doPC then
    begin
      linePos.adr:= adr;                                               // wgg set blue bar coordinates, adr needed for clear later
      linePos.line:= SaveP^.line;                                      // line and
      lineTFiles:= TFiles(Files.Objects[TabControl1.TabIndex]);        // source object
      SetFocus;                                                        // wgg if not break, place cursor
      TimerCount:= 750;                                                // else cause momentary flash (ms)
    end else begin
      mPos.adr:= adr;                                                  // wgg track independent of linePos
      mPos.line:= SaveP^.line;
      mTFiles:= TFiles(Files.Objects[TabControl1.TabIndex]);
      m.line:= mPos.line;                                              // show the mark
    end;
  end;
end;

procedure TfrmSourceEdit.ListBox1Click(Sender: TObject);
var
  fn: TFileName;
  i, j: integer;
  s: string;
begin
  if ListBox1.itemIndex<>-1 then
  begin
    s:= UpperCase(listBox1.items[listBox1.itemindex]);
    j:= 1;
    i:= pos('| ', s);                                          // wgg for SASM errors
    if i <> 0 then j:= SkipWhite(s, i + 1);
  {  try
      Editor.CaretY:= strtoint(GetToken(listBox1.items[listBox1.itemindex],1));  // wgg removed
      Editor.CaretX:= 0;
      ActiveControl:= Editor;
    except        }
      // wgg problem here in original code, does not allow embeded spaces in path names!
      // we resort to looking for the terminal '.' in the file name
      i:= pos('.', s)+2;
      fn:= ShortLongName(copy(listBox1.items[listBox1.itemindex], j, i-j));
      if s[i] = ':' then inc(i);
      i:= SkipWhite(s, i);                 // skip to the line number
      s:= TokenAtPos(s, i);                // returns line number + :
      if fileExists(fn) then
      Begin
        ListBox1.ClearSelection;
        OpenFile(fn);
        Editor.CaretY:= strtoint(copy(s, 1, length(s)-1));
        Editor.CaretX:= 0;
        ActiveControl:= Editor;

        TimerCount:= 750;                               // wgg cause momentary flash (ms)
        lineTFiles:= SFile;
        linePos.line:= Editor.CaretY;
        Editor.Invalidate;
      end;
    end;
end;

// wgg try to normalize format of error msgs so the sort works!
procedure TfrmSourceEdit.AddErrorMsg(s: string);
var
  i, j, n: integer;
begin
  j:= pos('.', s)+2;
  if j>=1 then
  begin
    if s[j] = ':' then inc(j);
    i:= j;
    n:= length(TokenAtPos(s, j));        // returns line number + :
    if n<7 then
      s:= copy(s, 1, i)+StringOfChar(' ', 7-n)+copy(s, i+1, 999);       // insert some spaces
  end;
  ListBox1.Items.Add(s);
end;

procedure TfrmSourceEdit.reloadBP;
var
  i, j: integer;
  p: PPos;
  m: TSynEditMark;
begin
  // delete the existing break marks
  j:= 0;
  for i:= 0 to Editor.Marks.Count-1 do
    if (Editor.Marks[j].ImageIndex=10) Or (Editor.Marks[j].ImageIndex=11) then
    Begin
      Editor.Marks[j].free;
      Editor.Marks.delete(j);
    end else
      inc(j);

  for j:=0 to debugger.BreakCount-1 do
  Begin
    try
      p:= SourceFromAdr(Debugger.BList[j].Adresse);
      if (p<>nil) and
         ((RemoveSlashSlash(UpperCase(p^.fileName))=UpperCase(FileName)) or
         (ExtractFileName(RemoveSlashSlash(UpperCase(p^.fileName)))=ExtractFileName(UpperCase(FileName)))) then
      Begin
        m:= TSynEditMark.Create(Editor);
        m.Line:= p^.line;
        m.Column:= 1;
        if Debugger.BList[j].Active then m.ImageIndex:= 11
        else m.ImageIndex:= 10;
        m.Visible:= true;
        m.InternalImage:= False;
        Editor.Marks.Add(m);
      end;
    except
    end;
  end;
end;

procedure TfrmSourceEdit.reloadAdrs;                  // wgg reloads all FFile after a build
var
  i: integer;
  f: TFileName;
begin
  for i:= 0 to Files.count-1 do
  Begin
    f:= TFiles(Files.Objects[i]).Name;
    TFiles(Files.Objects[i]).FFile:= GetFileFromFileName(f);;
  end;

end;

// wgg write any bookmarks to project file
// file must be the current editor file
procedure TfrmSourceEdit.SaveBookMarks(f: TFileName; mlist:TList);
var
  i, j: integer;
  b: string;
  found: boolean;
begin
  b:= '';
  found:= false;
  for i:= 0 to 9 do
  begin
    for j:= 0 to mlist.count-1 do
      with TObject(mList.Items[j]) as TMrk do
      begin
        if mi = i then
        begin
          if my > 0 then
          begin
            b:= b + intToStr(my);
            found:= true;
          end;
        end;
      end;
    b:= b + ',';
  end;
  b:= copy(b, 1, length(b)-1);                             // remove final comma
  frmProject.WriteBookmarks(f, b, found);
end;

// wgg read in any bookmarks from project file and set them
procedure LoadBookMarks(f: TFileName; e:TSynedit);
var
  mi, my: integer;
  pos: integer;
  b: string;
begin
  b:= frmProject.ReadBookmarks(f) + ',';                                 // wgg make scan easy by having final ,
  mi:= 0;
  my:= 0;
  pos:= 1;
  while (pos<=length(b)) and (mi<=9) do
  begin
    case b[pos] of
      ',': begin
             if my >0 then
               e.SetBookMark(mi, 1, my);
             my:= 0;
             inc(mi);
           end;
      '0'..'9': my:= my *10 + (ord(b[pos])-ord('0'));
    end;
    inc(pos);
  end;
end;

  Procedure TfrmSourceEdit.Display(f: TFileName; line: Integer; fil: TLFile=nil);
var
  i: integer;
Begin
  i:= OpenFile(f);
  with (files.objects[i] as tfiles) do
  Begin
    if (FileGetAttr(Filename) and faReadOnly) <> 0 then ReadOnly:= true    // wgg
    else ReadOnly:= false;
    Editor.CaretX:= 1;
    Editor.CaretY:= line;                                                // wgg
    Editor.ReadOnly:= ReadOnly;                                         // wgg
    justLF:= Not crScan(t);                                             // wgg
    if fil <> nil then
      self.FFile:= fil                                                  // wgg added self.
    else
      self.FFile:= GetFileFromFileName(f);                              // wgg added self.
  end;
  if not visible then
    show;
  LoadBookMarks(f, Editor);                                            // wgg
  Editor.Invalidate;
  SetFormCaption;
End;

procedure TfrmSourceEdit.loaded;
begin
  inherited loaded;
end;

procedure TfrmSourceEdit.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  if not (csLoading in ComponentState) then
    If Not SaveAll2 then
      action:= caNone;
end;

procedure TfrmSourceEdit.EditorCtrlClick(Sender: TObject; const s: String);
var
  value: integer;
  s2: string;
begin
  if (length(s)>0) and (s[1]='=') then
    s2:= copy(s, 2, Maxint)
  else
    s2:= s;
  Value:= SymbolTable.ValueFromText(s2);
  if Value<>-1 then
    if SourceFromAdr(Value) <> Nil then
  begin                                                                                     // wgg below was caretX
    Back.objects[Back.add(Files.Strings[TabControl1.TabIndex])]:= pointer(Editor.caretY);   // wgg Files.Strings was TabControl1.Tabs for short tab names
    EditAtAdr(Sender, value, false);   //wgg was Debugger.EditAtAddress(Value);  but fails if emu present, unloaded
  end;
end;

Function TfrmSourceEdit.OpenFile(f: TFileName): integer;
var
  i: integer;
begin
  f:= Removeslashslash(f);
  f:= ExpandFileName(f);
  i:= files.IndexOf(f);
  if i=-1 then
  Begin
    Files.objects[Files.add(f)]:= TFiles.Create(f);
    TabControl1.Tabs.add(ExtractFileName(f));

    i:= files.IndexOf(f);             // for jya crlf problem 12/12/2004
    with (files.objects[i] as tfiles) do
    begin
      if (FileGetAttr(f) and faReadOnly) <> 0 then ReadOnly:= true
      else ReadOnly:= false;
      justLF:= Not crScan(t);
    end;

  end;                               //wgg added extractfilename(f) so tab names do not show path
  result:= SelectFile(f);
end;

Function TfrmSourceEdit.SelectFile(f: TFileName): integer;
var
  a: boolean;
begin
  if f='' then f:= 'scratch';
  if (TabControl1.TabIndex=-1) or (Uppercase(Files.Strings[TabControl1.TabIndex])<>Uppercase(f)) then  // wgg Files.Strings was TabControl1.Tabs for short tab names
  Begin
    TabControl1Changing(self, a);
    TabControl1.TabIndex:= files.IndexOf(f);
    TabControl1Change(self);
  end;
  result:= TabControl1.TabIndex;
end;

procedure TfrmSourceEdit.TabControl1Change(Sender: TObject);
var
  i: integer;
  fi: TFiles;
begin
  if TabControl1.TabIndex<>-1 then
  Begin
    fi:= TFiles(Files.Objects[TabControl1.TabIndex]);
    SFile:= fi;                               // wgg need the source object for TfrmSourceEdit.EditorSpecialLineColors
    Editor.text      :=fi.t ;
    Editor.CaretX    :=fi.cx;
    Editor.CaretY    :=fi.cy;
    Editor.TopLine   :=fi.TopLine;                        // wgg
    Editor.modified  :=fi.modif;
    Editor.ReadOnly  :=fi.ReadOnly;
    FFile            :=fi.FFile;

    if SFile = mTFiles then m.Line:= mPos.line
    else m.Line:= -1;
    // wgg now we retrieve previous bookmarks and set them
    for i:= 0 to fi.MList.count-1 do
      with (TObject(fi.mList.Items[0]) as TMrk) do
      begin
        Editor.SetBookMark(mi, mx, my);
        Free;
        fi.mList.Delete(0);
      end;

    if FFile = nil then
      FFile:= GetFileFromFileName(fi.name);
  {  if fi.modif then
      caption:= fi.name+' (modified)'
    else
      caption:= fi.name;
  end else caption:= '';  }
  end;
  SetFormCaption;                                                  // wgg
  reloadBP;
end;

procedure TfrmSourceEdit.TabControl1Changing(Sender: TObject;
                             var AllowChange: Boolean);
var
  fi: TFiles;
  i: integer;
  x, y: integer;
begin
  if TabControl1.TabIndex<>-1 then
  Begin
    fi:= TFiles(Files.Objects[TabControl1.TabIndex]);  // wgg maybe we could be using SFile here?
    fi.TopLine:= Editor.TopLine;                       // wgg
    fi.cx:= Editor.CaretX;
    fi.cy:= Editor.CaretY;
    fi.t:= Editor.text;
    fi.modif:= Editor.modified;
    fi.ReadOnly:= Editor.ReadOnly;
    fi.FFile:= ffile;
    // wgg because we have just 1 editor, we must save/restore the bookmarks
    for i:= 0 to 9 do
      if Editor.GetBookMark(i, x, y) then
      begin
        if y > 0 then fi.mList.Add(TMrk.Create(i, x, y));
        Editor.ClearBookMark(i);
      end;
  end;
end;

procedure TfrmSourceEdit.SaveAll;
var
  i: integer;
begin
  for i:= 0 to Files.count-1 do
      SaveFile(Files[i]);
end;

Function TfrmSourceEdit.SaveAll2(): boolean;
var
  fi: TFiles;
  a: boolean;
  i,j: integer;
begin
  SaveSettings;                                         // wgg always save the registry changes
  result:= true;
  TabControl1.OnChanging(self,a);
  TabControl1.OnChange(self);
  for j:= 0 to Files.count-1 do
  Begin
    fi:= TFiles(files.objects[j]);
    if fi.name<>'scratch' then
      if Files.Strings[TabControl1.TabIndex]=fi.name then                 // wgg then mlist is clear
      begin
        TabControl1.OnChanging(self,a);                                   // wgg bookmarks to the mlist
        SaveBookMarks(frmProject.ShortName(fi.name), fi.mlist);             // wgg
        TabControl1.OnChange(self);                                       // wgg now put back in the file
      end
      else
        SaveBookMarks(frmProject.ShortName(fi.name), fi.mlist);             // wgg
    if fi.Modif then
    begin
      i:= Application.MessageBox(PChar('Save modifications in '+fi.name+'?'),
                                      'Warning', mb_YESNOCANCEL);
      case i of
        IDYES: begin
            try
              StringToFile(fi.t, fi.name);
              fi.Modif:= false;
              if Files.Strings[TabControl1.TabIndex]=fi.name then   // wgg Files.Strings was TabControl1.Tabs for short tab names
              Begin
                Editor.Modified:= false;
                SetFormCaption;                      // wgg was caption:= fi.name;
              end;
            except
              raise Exception.create('Can not save the file '+fi.name);
            end;
          end;
        IDNO:  ;
        IDCANCEL: begin
          result:= False;
          break;
          end;
      end;
    end;
  end;
end;

// Close all the files (without save or warning), then hide the form
// Used when the project is switching and we just want to get rid of this form
procedure TfrmSourceEdit.CloseAll;
var
  i: integer;
  f: string;
begin
  while TabControl1.Tabs.Count > 1 do
  Begin
    i:= TabControl1.Tabs.Count-1;
    f:= Files.Strings[i];                                // wgg Files.Strings was TabControl1.Tabs for short tab names
    TabControl1.Tabs.Delete(i);
    Files.Objects[i].free;
    files.Delete(i);
    SelectFile(Files.Strings[i-1]);                    // wgg Files.Strings was TabControl1.Tabs for short tab names
  end;
 { hide;   }  // wgg messes up for NewProject then cancel the save
end;

procedure TfrmSourceEdit.SaveFile(f: TFileName; blnForce: boolean = false);
var
  fi: TFiles;
  a: boolean;
begin
  if Files.IndexOf(f)=-1 then exit;
  fi:= TFiles(files.objects[files.IndexOf(f)]);
  TabControl1.OnChanging(self,a);
  SaveBookMarks(frmProject.ShortName(fi.name), fi.mlist);                    // wgg
  TabControl1.OnChange(self);
  if fi.Modif Or blnForce then
    try
      if fi.FjustLf then StringToFile(crRemove(fi.t), fi.name)             // wgg LF only
      else StringToFile(fi.t, fi.name);                                    // CRLF
      fi.Modif:= false;
      if Files.Strings[TabControl1.TabIndex]=f then                        // wgg Files.Strings was TabControl1.Tabs for short tab names
      Begin
        Editor.Modified:= false;
        SetFormCaption;                         // wgg as caption:= f;
      end;
    except
      raise Exception.create('Can not save the file '+f);
    end;
end;

Function TfrmSourceEdit.SaveFile2(f: TFileName): boolean;
var
  fi: TFiles;
  a: boolean;
  i: integer;
begin
  result:= True;
  if Not (Files.IndexOf(f)=-1) then
  begin
    fi:= TFiles(files.objects[files.IndexOf(f)]);              // wgg modified for 3 way prompt
    TabControl1.OnChanging(self,a);                            // also changed wording of message
    SaveBookMarks(frmProject.ShortName(fi.name), fi.mlist);      // wgg
    TabControl1.OnChange(self);
    if fi.Modif then
      begin
        i:= Application.MessageBox(PChar('Save modifications in '+f+'?'),
                                        'Warning', mb_YESNOCANCEL);
        case i of
          IDYES: begin
              try
                StringToFile(fi.t, fi.name);
                fi.Modif:= false;
                if Files.Strings[TabControl1.TabIndex]=f then                 // wgg Files.Strings was TabControl1.Tabs for short tab names
                Begin
                  Editor.Modified:= false;
                  SetFormCaption;                         // wgg was caption:= f;
                end;
              except
                raise Exception.create('Can not save the file '+f);
              end;
            end;
          IDNO: fi.Modif:= False;
          IDCANCEL: result:= False;
        end;
      end;
  end;
end;

// wgg return a file name with the name part the long name
// and the path shortened by the project path if possible
// we try to always show user the long path name from windows
function TfrmSourceEdit.ShortLongName(f: TFileName): TFileName;
begin
  if UpperCase(ExtractFileDir(f))=UpperCase(frmProject.ProjectDir) then
    result:= ExtractFileName(f)
  else
    result:= f;
end;

// Return a list of files currently open in the editor
Procedure TfrmSourceEdit.FileNames(list: TStringList);            // wgg
var
  i: integer;
  fi: TFiles;
  f: TfileName;
Begin
 for i:= 0 to Files.count-1 do
  Begin
    fi:= TFiles(files.objects[i]);
    f:= ShortLongName(fi.name);                       // wgg
    if f <> 'scratch' then
      list.add(f);
  end;
end;

{ TFiles }

constructor TFiles.create(f: TFileName);
begin
  inherited create;
  if F<>'scratch' then
    if frmSourceEdit.UseRealTabs then                   // wgg
      t:= FileToString(f)
    else
      t:= RemoveTab(FileToString(f), frmSourceEdit.Editor.TabWidth);
  modif:= false;
  name:= f;
  mlist:= TList.Create;
  FjustLF:= Not crScan(t);                                                   // wgg
end;

{ TMrk }

constructor TMrk.create(i, x, y:integer);
begin
  inherited create;
  mi:= i;
  mx:= x;
  my:= y;
end;

procedure TfrmSourceEdit.SaveAll1Click(Sender: TObject);
begin
  SaveAll;
end;

procedure TfrmSourceEdit.CloseFileClick(Sender: TObject);
var
  f: string;
  i: integer;
  a: boolean;
begin
  if TabControl1.TabIndex>0 then
  Begin
    i:= TabControl1.TabIndex;
    f:= Files.Strings[i];                                // wgg Files.Strings was TabControl1.Tabs for short tab names
    if SaveFile2(f) then
    begin
      TabControl1Changing(self, a);                     // wgg - must clear bookmarks before any switch
      TabControl1.Tabs.Delete(i);
      Files.Objects[i].free;
      files.Delete(i);
      if i>=TabControl1.Tabs.Count then
        i:= TabControl1.Tabs.Count-1;
      SelectFile(Files.Strings[i]);                    // wgg Files.Strings was TabControl1.Tabs for short tab names
    end;
  end;
end;

procedure TfrmSourceEdit.Labels1Click(Sender: TObject);
var
  i: integer;
begin
  ListBox1.Clear;
  for i:= 0 to Editor.Lines.Count-1 do
    if (length(Editor.lines[i])>1) and
       (((Editor.lines[i][1]='*') and (Editor.lines[i][2]<>'*') and (Editor.lines[i][2]<>'.') and (Editor.lines[i][2]>' ')) or
       (Editor.lines[i][1]='=') or
       (copy(Editor.Lines[i], 1, 8)='NULLNAME') or                              // wgg added 'NULLNAME'
       (copy(Editor.Lines[i], 1, 8)='NAMELESS') or
       (copy(Editor.Lines[i], 2, 4)='NAME') or                                 // wgg was 2,8,'xNAME) !
       (copy(Editor.Lines[i], 1, 9)='LOCALNAME')) then
    begin
      AddErrorMsg(FileName+'  '+inttostr(i+1)+':  '+Editor.lines[i]);  // wgg added filename
    end;
end;

function TfrmSourceEdit.FileName: string;
begin
  if TabControl1.TabIndex<>-1 then
    result:= TFiles(Files.Objects[TabControl1.TabIndex]).name
  else
    result:= 'scratch';
end;

// This small function transform %i in filename and %i. in changefileext(filename, ext)
// it is a purly crappy function but, sorry, no time...
function parse(s: string; f: tfilename): string;
var
  s2: string;
Begin
  result:= '';
  while length(s)<>0 do
  Begin
    if copy(s, 1, 3)='%i.' then
    begin
      s2:= '.';
      s:= copy(s, 4, maxint);
      while (length(s)>0) and (s[1] > ' ') do
      Begin
        s2:= s2+s[1];
        s:= copy(s, 2, maxint);
      end;
      result:= result+changeFileExt(f, s2);
    end else if copy(s, 1, 2)='%i' then
    Begin
      result:= result+f;
      s:= copy(s, 3, maxint);
    end else begin
      result:= result+s[1];
      s:= copy(s, 2, maxint);
    end;
  end;
end;

procedure TfrmSourceEdit.Built1Click(Sender: TObject);
var
  s: string;
begin
  ListBox1.Items.clear;
  s:= caption;
  Caption:= 'Compiling';
  Application.ProcessMessages;
  SaveFile(Files.Strings[TabControl1.TabIndex]);       // wgg was filename but that cannot be found in index!
  frmProject.rrplcomp(filename);
  frmProject.rsasm(filename);
  Caption:= s;
  Errors1Click(Nil)
end;

procedure TfrmSourceEdit.FormShortCut(var Msg: TWMKey; var Handled: Boolean);
var
  Shift, ctrl: boolean;
begin
  Shift:= (GetKeyState(VK_SHIFT) and $80) <>0;
  ctrl:= (GetKeyState(VK_CONTROL) and $80) <>0;
  if msg.CharCode = 9 then                             // wgg handle just the tabs
  Begin
    msg.CharCode:= 0;
    if ctrl and not shift then                  // wgg ctrl-tab & shift ctrl-tab moves between tabs
      if TabControl1.TabIndex=TabControl1.Tabs.Count-1 then
        SelectFile('')
      else
        SelectFile(Files.Strings[TabControl1.TabIndex+1])               // wgg Files.Strings was TabControl1.Tabs for short tab names
    else
      if Ctrl and Shift then
        if TabControl1.TabIndex=0 then
          SelectFile(Files.Strings[TabControl1.Tabs.Count-1])    // wgg Files.Strings was TabControl1.Tabs for short tab names
        else
          SelectFile(Files.Strings[TabControl1.TabIndex-1])      // wgg Files.Strings was TabControl1.Tabs for short tab names
      else                                   // wgg must not be ctrl, let editor handle it
     { Begin
        Editor.CommandProcessor(ecChar, ' ', nil);       // wgg - we already handle tabs in Editor!
        while ((Editor.CaretX-1) mod 8)<>0 do
          Editor.CommandProcessor(ecChar, ' ', nil);
      end;  }
  end;
end;

procedure TfrmSourceEdit.CompileAll1Click(Sender: TObject);
begin
  frmProject.Build1Click(Nil);
end;

procedure TfrmSourceEdit.InformEdit1Click(Sender: TObject);
begin
  if (sender as TMenuItem).Checked then frmInformEdit.hide
  else frmInformEdit.show;
end;

procedure TfrmSourceEdit.Addfiletoproject1Click(Sender: TObject);
begin
  if FileName<>'scratch' then
    frmProject.addFile(FileName);
end;

function TfrmSourceEdit.CreateProcess1Read(Sender: TObject): String;
begin
  result:= #13#10;
end;

// wgg so all source editors have the same (dynamic) functionality
// call this when editor gets the focus
procedure TfrmSourceEdit.SetEditProps(Ed: TSynEdit);                       // wgg
var
  b: boolean;
begin
  with Editor do
  begin
    if Ed.Height > 42 then            // wgg change some settings only in bigger boxes!
    begin
      if Ed = Editor then b:= true
      else b:= false;
      Open3.Enabled:= b;
      Save2.Enabled:= b;
      Close1.Enabled:= b;
      if Ed = Editor then exit;
      Ed.PopupMenu:= PopupMenu;

      Ed.TabWidth:= TabWidth;
      Ed.Options:= Options;
      Ed.RightEdge:= RightEdge;
      Ed.RightEdgeColor:= RightEdgeColor;
      Ed.WantTabs:= WantTabs;
      Ed.ExtraLineSpacing:= ExtraLineSpacing;
      Ed.Highlighter:= Highlighter;
    end else begin
      Ed.Options:=[eoDragDropEditing, eoTabsToSpaces, eoTrimTrailingSpaces]
    end;

    Ed.InsertCaret:= InsertCaret;
    Ed.OverwriteCaret:= OverwriteCaret;
    Ed.Keystrokes:= Keystrokes;
    Ed.Font:= Font;
    Ed.SelectedColor:= SelectedColor;
    Ed.Color:= Color;

    Ed.Invalidate;
  end;
end;

function RemoveGarbage(s: string): string;
begin
  result:= '';
  while length(s)<>0 do
  begin
    if s[1]>=' ' then result:= result+s[1];
    s:= copy(s, 2, maxint);
  end;
end;

procedure HPTError(s: pchar); stdcall;
var
  s2: string;
begin
  s2:= RemoveGarbage(strpas(s));
  if Tool = ThpRplComp then
//    if pos('error in RPL source', s)=0 then
    begin
//      frmSourceEdit.AddErrorMsg(s2);              // wgg these will be found by scalling the .l files
      Application.ProcessMessages;
    end;
  if Tool = ThpSasm then
//    if (pos('ERROR', s2)<>0) or (pos('WARNING', s2)<>0) then
    begin
//      frmSourceEdit.AddErrorMsg(s2);
      Application.ProcessMessages;
    end;
  if Tool = ThpSload  then                        // wgg allow SLOAD messages
    begin
      frmSourceEdit.AddErrorMsg(s2);
      Application.ProcessMessages;
    end;
end;

procedure HPTOut(s: pchar); stdcall;
begin
  frmSourceEdit.AddErrorMsg(RemoveGarbage(strpas(s)));
  Application.ProcessMessages;
end;

procedure TfrmSourceEdit.btnEdTemplateClick(Sender: TObject);
var
  obj: TObject;
const
  hlp = '# This is a list of templates'#13#10+
        '# To use a template in the editor,'#13#10+
        '# type the template name and press ALT INS'#13#10+
        '# For example type :: then ALT INS in the editor'#13#10+
        '# to add the program template'#13#10+
        '# '#13#10+
        '# The syntax of this file is:'#13#10+
        '# TemplateName'#13#10+
        '# =Template Line 1'#13#10+
        '# =Template Line 2 ...'#13#10+
        '# =Template Line n'#13#10+
        '# Next Template name'#13#10+
        '# '#13#10+
        '# Note: if the | chr is encountered in the template'#13#10+
        '# definition, the cursor will be set on the |'#13#10+
        '# after the template expansion.'#13#10+
        '# '#13#10;
begin
  with TStringList.Create do
    try
      text:= hlp+frmMainForm.SynAutoComplete1.AutoCompleteList.Text;
      text:= frmFullPageEdit.Execute('', Text,'Source Templates');                 // wgg
      while (count>0) and (length(strings[0])>0) and (strings[0][1]='#') do
        delete(0);
      frmMainForm.SynAutoComplete1.AutoCompleteList.text:= text;

      //obj:= ((sender as TMenuItem).owner as TfrmSourceEdit).Editor;
      obj:= frmSourceEdit.Editor;                     // wgg if pop-up the templates, we might loose completion
      if assigned((obj as TSynEdit).OnEnter) then
        (obj as TSynEdit).OnEnter(obj);
      if assigned((obj as TSynEdit).OnChange) then
        (obj as TSynEdit).OnChange(obj);
    finally
      free;
    end;
end;

procedure TfrmSourceEdit.Back1Click(Sender: TObject);
begin
  if back.Count<>0 then
  begin
    display(back[back.count-1], integer(back.Objects[back.count-1]));
    back.delete(back.count-1);
  end;
end;

procedure TfrmSourceEdit.Sumary1Click(Sender: TObject);
var
  i, j: integer;
  s: TStringList;
begin
  s:= TStringList.Create;
  ListBox1.Clear;
  for i:= 0 to Editor.Lines.Count-1 do
    if (length(Editor.lines[i])>1) and
       ((Editor.lines[i][1]='*') and (Editor.lines[i][2]<>'*') and
         (Editor.lines[i][2]<>'.') and (Editor.lines[i][2]>' ')) and
         (i>0) and (length(Editor.lines[i-1])>0) and (Editor.lines[i-1][1]='%') then
    begin
      j:= i-1;
      while (j>=0) and (length(Editor.lines[j])>0) and (Editor.lines[j][1]='%') do dec(j);
      inc(j);
      while j<>i+1 do begin s.add(Editor.lines[j]); inc(j); end;
      s.add('');
    end;
  frmFullPageEdit.Execute('', s.text, 'Summary');
  s.free;
end;

procedure TfrmSourceEdit.PrinterSetupCmd(Sender: TObject);
begin
  PrinterSetupDialog.Execute;
end;

procedure TfrmSourceEdit.PrintPreviewCmd(Sender: TObject);
begin
  PageSetupIniLoad;
  SynEditPrint.SynEdit:= Editor;
  SynEditPrint.Title:= FileName;
  with PrintPreviewDlg do begin
    SynEditPrintPreview.SynEditPrint:= SynEditPrint;
    ShowModal;
  end;
end;

procedure TfrmSourceEdit.PrintCmd(Sender: TObject);
begin
 if PrintDialog.Execute then begin
    PageSetupIniLoad;
    SynEditPrint.SynEdit:= Editor;
    SynEditPrint.Title:= FileName;
    SynEditPrint.Print;
 end;
end;

procedure TfrmSourceEdit.PageSetupCmd(Sender: TObject);
begin
  PageSetupIniLoad;
  PageSetupDlg.SetValues(SynEditPrint);
  if PageSetupDlg.ShowModal = mrOk then
    PageSetupDlg.GetValues(SynEditPrint);
  PageSetupIniSave;
end;


// wgg load / save registry settings for the printer page setup box
procedure TfrmSourceEdit.PageSetupIniLoad;
var
  r: TRegIniFile;
begin
  r:= TRegIniFile.Create(epriKey);
  with SynEditPrint do
  begin
    with Margins do try
        Bottom:=            StrToFloat(r.ReadString(psubKey, 'MBtm', FloatToStr(Bottom)));
        Footer:=            StrToFloat(r.ReadString(psubKey, 'MFtr', FloatToStr(Footer)));
        Gutter:=            StrToFloat(r.ReadString(psubKey, 'MGtr', FloatToStr(Gutter)));
        Header:=            StrToFloat(r.ReadString(psubKey, 'MHdr', FloatToStr(Header)));
        HFInternalMargin:=  StrToFloat(r.ReadString(psubKey, 'MHFI', FloatToStr(HFInternalMargin)));
        Left:=              StrToFloat(r.ReadString(psubKey, 'MLft', FloatToStr(Left)));
        LeftHFTextIndent:=  StrToFloat(r.ReadString(psubKey, 'MLHF', FloatToStr(LeftHFTextIndent)));
        MirrorMargins:=                r.ReadBool(  psubKey, 'MMMg',            MirrorMargins);
        Right:=             StrToFloat(r.ReadString(psubKey, 'MRgt', FloatToStr(Right)));
        RightHFTextIndent:= StrToFloat(r.ReadString(psubKey, 'MRHF', FloatToStr(RightHFTextIndent)));
        Top:=               StrToFloat(r.ReadString(psubKey, 'MTop', FloatToStr(Top)));
        UnitSystem:=       TUnitSystem(r.ReadInteger(psubKey,'MUnit', ord(UnitSystem)));

    finally
    end;

    LineNumbers:=                  r.ReadBool(psubKey,   'LNos', LineNumbers);
    LineNumbersInMargin:=          r.ReadBool(psubKey,   'LinM', LineNumbersInMargin);
    Highlight:=                    r.ReadBool(psubKey,   'Hlgt', Highlight);
    Colors:=                       r.ReadBool(psubKey,   'Clrs', Colors);
    Wrap:=                         r.ReadBool(psubKey,   'Wrap', Wrap);
    Color:=          StringToColor(r.ReadString(esubKey, 'Color', ColorToString(Color)));

    try
      Font.Name:=                    r.ReadString(psubKey, 'FName', Font.Name);
      Font.Size:=                    r.ReadInteger(psubKey,'FSize', Font.Size);
      Font.Color:=     StringToColor(r.ReadString(esubKey, 'FColor', ColorToString(Font.Color)));
      Header.AsString:=              r.ReadString(psubKey, 'Header', Header.AsString);
      Footer.AsString:=              r.ReadString(psubKey, 'Footer', Footer.AsString);
    finally
    end;
    // a few miscellaneous settings
    TabWidth:= Editor.TabWidth;
  end;
end;

procedure TfrmSourceEdit.PageSetupIniSave;
var
  r: TRegIniFile;
begin
  r:= TRegIniFile.Create(epriKey);
  with SynEditPrint do
  begin
    with Margins do try
      r.WriteString(psubKey, 'MBtm', FloatToStr(Bottom));
      r.WriteString(psubKey, 'MFtr', FloatToStr(Footer));
      r.WriteString(psubKey, 'MGtr', FloatToStr(Gutter));
      r.WriteString(psubKey, 'MHdr', FloatToStr(Header));
      r.WriteString(psubKey, 'MHFI', FloatToStr(HFInternalMargin));
      r.WriteString(psubKey, 'MLft', FloatToStr(Left));
      r.WriteString(psubKey, 'MLHF', FloatToStr(LeftHFTextIndent));
      r.WriteBool(  psubKey, 'MMMg',            MirrorMargins);
      r.WriteString(psubKey, 'MRgt', FloatToStr(Right));
      r.WriteString(psubKey, 'MRHF', FloatToStr(RightHFTextIndent));
      r.WriteString(psubKey, 'MTop', FloatToStr(Top));
      r.WriteInteger(psubKey,'MUnit',       ord(UnitSystem));
    finally
    end;

    r.WriteBool(psubKey,   'LNos', LineNumbers);
    r.WriteBool(psubKey,   'LinM', LineNumbersInMargin);
    r.WriteBool(psubKey,   'Hlgt', Highlight);
    r.WriteBool(psubKey,   'Clrs', Colors);
    r.WriteBool(psubKey,   'Wrap', Wrap);
    r.WriteString(esubKey, 'Color', ColorToString(Color));

    try
      r.WriteString(psubKey, 'FName',  Font.Name);
      r.WriteInteger(psubKey,'FSize',  Font.Size);
      r.WriteString(esubKey, 'FColor', ColorToString(Font.Color));
      r.WriteString(psubKey, 'Header', Header.AsString);
      r.WriteString(psubKey, 'Footer', Footer.AsString);
    finally
    end;
  end;
end;


procedure TfrmSourceEdit.EditorSpecialLineColors(Sender: TObject;
                 Line: Integer; var Special: Boolean; var FG, BG: TColor);
begin
  if ((SFile = lineTFiles) And (linePos.line = line))
      Or ((SFile = mTFiles) And (mPos.line = line)) then    // wgg use both file and line info
  begin
    BG:= clAqua;
    special:= true;
  end;
end;

procedure TfrmSourceEdit.ClearAdrsMark;                   // wgg remove program counter mark
begin
  if mTFiles <> Nil then
  begin
    mTFiles:= Nil;
    mPos.line:=-1;
    m.line:= -1;                                            // clear the mark
    FastClear:= True;                                       // no blink, clear the cursor quickly
    EditAtAdr(Nil, mPos.adr, False);                     // wgg quickly clear the displayed line
  end;
end;

procedure TfrmSourceEdit.EditorGutterClick(Sender: TObject; X, Y,
            Line: Integer; mark: TSynEditMark);
var
  i: integer;
  bp: TBreakPoint;
  RPL: boolean;
begin
  if lastMouseButton = mbLeft then
     frmSourceEdit.RplBreak1Click(Nil);               // wgg set/clear breakpoint
  if lastMouseButton <> mbRight then exit;              // wgg activate/not breakpoint
  if FFile=Nil then
    FFile:= GetFileFromFileName(Filename);                 // wgg in case, no build or load: EMU already has image
  if FFile<>nil then
    try
      i:= FFile.AdrFromLine(FileName ,Editor.CaretY, RPL);
      if i <> -1 then i:= Debugger.GetBreakPointIndex(i);
      if i <> -1 then
      begin
         bp:= debugger.BList[i];
         bp.Active:= Not bp.Active;
         Debugger.RebuiltBreakPointList;
         frmBreakPointChoice.FillListBox;
      end;
    except
      ffile:= nil;
    end;
end;

procedure TfrmSourceEdit.EditorMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  if X >  Editor.Gutter.Width then
    if (Shift = [ssCtrl]) and (lastMouseButton = mbLeft) then
      GoToDefinition1Click(Sender)
    else
      if (lastMouseButton = mbRight) then PopupMenu1.Popup(X+Self.Left, Y+Self.Top);
end;

// SynEdit: caret posit is NOT good until after this routine
procedure TfrmSourceEdit.EditorMouseDown(Sender: TObject;
                      Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  lastMouseButton:= Button;                           // save for gutter click, mouse up etc
end;

procedure TfrmSourceEdit.New1Click(Sender: TObject);
begin
  frmProject.Newfile1Click(Nil);
end;

procedure TfrmSourceEdit.NewInformBox1Click(Sender: TObject);
begin
  frmProject.NewInformBox1Click(Nil);
end;

procedure TfrmSourceEdit.File1Click(Sender: TObject);
begin
  InformEdit1.Checked:= frmInformEdit.visible = True;
end;

// wgg we use a common search and replace code for the entire system
procedure TfrmSourceEdit.Find2Click(Sender: TObject);
var
  x: word;
begin
  Search.FindClick(Sender, x);
end;

procedure TfrmSourceEdit.Replace1Click(Sender: TObject);
var
  x: word;
begin
  Search.ReplaceClick(Sender, x);
end;

procedure TfrmSourceEdit.Next1Click(Sender: TObject);
var
  x: word;
begin
  Search.NextClick(Sender, x);
end;

procedure TfrmSourceEdit.EditorEnter(Sender: TObject);
begin
  frmMainForm.EditEnter(Sender);
end;

procedure TfrmSourceEdit.mnuAboutClick(Sender: TObject);
begin
  frmAbout.ShowModal;
end;

function TfrmSourceEdit.GetLF: boolean;
begin
  result:= SFile.FjustLF;
end;

procedure TfrmSourceEdit.SetLF(b: boolean);
begin
  SFile.FjustLF:= b;
  cbUseCRLF.Checked:= Not justLF;
end;

procedure TfrmSourceEdit.mnuEscKeysClick(Sender: TObject);
begin
  frmMainForm.ContextHelp((Sender as TMenuItem).HelpContext);            // wgg
end;

procedure TfrmSourceEdit.mnuHelpFileClick(Sender: TObject);           // wgg
begin
  frmMainForm.mnuHelpClick(Sender);
end;

procedure TfrmSourceEdit.mnuEditClick(Sender: TObject);
begin
  if justLF then
    mnuLineEnd.Caption:= 'Line Ending (Unix: LF)'
  else
    mnuLineEnd.Caption:= 'Line Ending (Win: CR+LF)';
  if Editor.ReadOnly then
  begin
    Und1.Enabled:= false;
    Redo1.Enabled:= false;
    Replace1.Enabled:= false;
  end else begin
    Und1.Enabled:= true;
    Redo1.Enabled:= true;
    Replace1.Enabled:= true;
  end;
end;

procedure TfrmSourceEdit.mnuLineEndClick(Sender: TObject);
begin
  justLF:= Not justLF;
end;

procedure TfrmSourceEdit.cbUseCRLFClick(Sender: TObject);
begin
  justLF:= Not cbUseCRLF.Checked;
end;

procedure TfrmSourceEdit.FormActivate(Sender: TObject);
begin
  if ActiveControl is TSynEdit then frmMainForm.EditActivate(Sender);             // wgg
  if ActiveControl.Name = 'ListBox1' then                    // wgg this can get confusing
    frmSourceEdit.SetFocusedControl(Editor);
end;

procedure TfrmSourceEdit.CloseWindowClick(Sender: TObject);
begin
  Screen.ActiveForm.close;
end;

procedure TfrmSourceEdit.GoToDefinition1Click(Sender: TObject);
begin
    frmMainForm.SynAutoComplete1.Editor.SetSelWord;               // wgg is same as SetWordBlock(Editor.CaretXY)
    EditorCtrlClick(frmMainForm.SynAutoComplete1.Editor, frmMainForm.SynAutoComplete1.Editor.SelText);
end;

procedure TfrmSourceEdit.ShowStack1Click(Sender: TObject);      // wgg
var
  key: word;
begin
  frmMainForm.ShowStack(frmMainForm.SynAutoComplete1.Editor, key);
end;

procedure TfrmSourceEdit.Clear1Click(Sender: TObject);
begin
  ListBox1.Items.Clear;
end;

procedure TfrmSourceEdit.DropFileTarget1Drop(Sender: TObject;
  ShiftState: TShiftState; Point: TPoint; var Effect: Integer);
var
  i: integer;
  dir: tfilename;
begin
  application.ProcessMessages;
  dir:= GetCurrentdir;
  try
    frmProject.SetProjectDir;
    with DropFileTarget1 do
      for i := 0 to files.count-1 do
        if (UpperCase(ExtractFileExt(Files[i]))='.S') Or (UpperCase(ExtractFileExt(Files[i]))='.H') Or
          (UpperCase(ExtractFileExt(Files[i]))='.TXT') Or (UpperCase(ExtractFileExt(Files[i]))='') then
          frmSourceEdit.Display(Files[i], 0);
  finally
    SetCurrentDir(dir);
  end;
end;

procedure TfrmSourceEdit.mnuSymbolFileClick(Sender: TObject);
begin
  Display(frmProject.EntryPointFile, 0);
end;

end.

