{
  This unit allows to run the HPTools.
  This unit is copyright Hewlett Packard.

  implementation notes:
  It is not possible to load the DLL once and then to call the
  entries sequencaly because of some flaws in the HPTools design.
  The HPTools has been created as run once program, using globals
  variables initialised at process creation time (standard C declarations)
  Therfore, after running the first time, this global variables have been
  changed and you can not run the program again.
  In order to force this variables to be reinitialised, I had to
  load and unload the DLL all the time.
  Talking of timing: the first load time of the DLL is .3 second the first time
  and around .1 s after.

  Personal notes: If the hptools where developed in PASCAL, this would have never
  hapend. PASCAL rulez !!!!!

  The HPTools dll throws an exception when they exit.
  The problem is that the original rpl tools were designed as a standalone C non
  re-entrant code. they are using exit() to exit the program anywhere in the
  program, and of course, the exit in the dll closes debug2! so, I changes
  called to exit(n) to char *a= (char*)n, *a=0; (generates an exception) and
  in the text of the exception, I can read the exit code (I am not sure I
  actually use it, but I could).                                        // wgg added from Cyrille e-mail

}
unit hptoolsdll;

interface
uses
  windows, sysutils;

type
  THPTCallBack = procedure(s: pchar); stdcall;
  TArgv = ^Pchar;
  TMyArgv = array of PChar;

Procedure HPTInitDll(outcb: THPTCallBack; errcb: THPTCallBack);
Function HPTMakeRom(argc: integer; argv: TArgv): integer;
Function HPTRplComp(argc: integer; argv: TArgv): integer;
Function HPTSasm(argc: integer; argv: TArgv): integer;
Function HPTSload(argc: integer; argv: TArgv): integer;

type
  tHPTInitDll= Procedure (outcb: THPTCallBack; errcb: THPTCallBack); stdcall;
  tHPTMakeRom= Function  (argc: integer; argv: TArgv): integer; stdcall;
  tHPTRplComp= Function  (argc: integer; argv: TArgv): integer; stdcall;
  tHPTSasm   = Function  (argc: integer; argv: TArgv): integer; stdcall;
  tHPTSload  = Function  (argc: integer; argv: TArgv): integer; stdcall;

  THPTool    = (ThpNone, ThpMakeRom, ThpRplComp, ThpSasm, ThpSload);

var
  tool: THPTool;

implementation

var
  voutcb: THPTCallBack;
  verrcb: THPTCallBack;
  dll: THandle;
  vHPTInitDll :tHPTInitDll;
  vHPTMakeRom :tHPTMakeRom;
  vHPTRplComp :tHPTRplComp;
  vHPTSasm    :tHPTSasm   ;
  vHPTSload   :tHPTSload  ;

Procedure HPTInitDll(outcb: THPTCallBack; errcb: THPTCallBack);
Begin
  voutcb:= outcb;
  verrcb:= errcb;
end;

Procedure loaddll;
Begin
  dll:= LoadLibrary('hptoolsdll.dll');
  if dll=0 then
    raise exception.create('can not load hptoolsdll');
  vHPTInitDll := GetProcAddress(dll, '_initdll@8');
  vHPTMakeRom := GetProcAddress(dll, '_makerom@8');
  vHPTRplComp := GetProcAddress(dll, '_rplcomp@8');
  vHPTSasm    := GetProcAddress(dll, '_sasm@8');
  vHPTSload   := GetProcAddress(dll, '_sload@8');
  vHPTInitDll(voutcb, verrcb);
end;

Function HPTMakeRom(argc: integer; argv: TArgv): integer;
Begin
  loaddll;
  Tool:=   ThpMakeRom;
  try
    result:= vHPTMakeRom(argc, argv);
  except
    result:= -1;
  end;
  freeLibrary(dll);
  Tool:=   ThpNone;
end;

Function HPTRplComp(argc: integer; argv: TArgv): integer;
Begin
  loaddll;
  Tool:=   ThpRplComp;
  try
    result:= vHPTrplcomp(argc, argv);
  except
    result:= -1;
  end;
  freeLibrary(dll);
  Tool:=   ThpNone;
end;

Function HPTSasm(argc: integer; argv: TArgv): integer;
Begin
  loaddll;
  Tool:=   ThpSasm;
  try
    result:= vHPTsasm(argc, argv);
  except
    result:= -1;
  end;
  freeLibrary(dll);
  Tool:=   ThpNone;
end;

Function HPTSload(argc: integer; argv: TArgv): integer;
Begin
  loaddll;
  Tool:=   ThpSload;
  try
    result:= vHPTsload(argc, argv);
  except
    result:= -1;
  end;
  freeLibrary(dll);
  Tool:=   ThpNone;
end;

end.
