{$A+,B-,C+,D+,E-,F-,G+,H+,I+,J+,K-,L+,M-,N+,O+,P+,Q-,R-,S-,T-,U-,V+,W-,X+,Y+,Z1}
{$MINSTACKSIZE $00004000}
{$MAXSTACKSIZE $00100000}
{$IMAGEBASE $00400000}
{$APPTYPE GUI}
{
  This unit is the head of the symbol to value
  and address to file conversions.
  It includes 2 main classes:
  TSymbolList (list of symboles)
  and TLFile (sourcefile to address and address to sourcefile)

  This unit is copyright HP

  loading :LR files:
  -A option => (absolute) just store the address                   
  -R option => (relocate) add the base value of the binary to all listed addresses
  -V bank option => if >= $80000, use as is
                    if <  $80000, use value + bank * $100000     wgg was value AND $3FFFF
                          example $43000 in bank 5 => $5030000
                          also add $1,000,000 to show it is in ROM       // wgg
  -ER suppress error reports

  Changes marked with WGG are copyright 2002, William G. Graves

}
unit lrworking;

interface
uses classes, sysutils, windows, CDBShUtils, utils2, forms, math;
type
  TSortString =  Procedure (l: TMyList) of object;

  TEntry = class
  private
    fValue: integer;
    function RamBased: boolean;
    function GetValue: integer;
  public
    Vue: integer;
    Text: string[33];
    References: array of integer;
    Constructor create(const s: string; TS, TL, SA, SR, RE: integer; vu: integer;
            Abs: boolean); overload;                          // wgg added Abs
    Constructor create(s: string); overload;
    Procedure Merge(e: TEntry);
    Function RefBetween(a, b: integer): boolean;
    property Value: integer read GetValue write FValue;
    Function Getreferences(i: integer): integer;
  end;

  ATEntry= array of TEntry;

  TSymbolList = class (TMyList)
  Private
    Constructor create;  // This function is here intentionaly in order to avoid any creation of TSymbolList object by the user.
                         // This must be done like this because the class uses global variables and is in fact a 'kind of singleton' object
  Protected
    function GetFullLine(const s: string; Start, Stop: integer; var TokenLenght,
              StartAdr, StartRef: integer; Var Abs: boolean): integer;             // wgg added Abs
    function LoadFile(const s: string; vue: integer; var Table: ATEntry): string;
    Function GetStringRep(o: TObject): string; override;
    Function GetFromName(s: string): integer;
  public
    Function indexofUpperCaseString(s: string): integer;
    function GetFromAdr2(i: integer): string;
    function GetFromAdr(i: integer): string;
    Function ValueFromText(s: string): integer;
    Procedure InitTable(f: TStringList; BeforeSort: TSortString);
    Function GetEntryValue(s: string): integer;
    Function GetTEntry(s: string): TEntry;                     // wgg
  end;

type
  TLFile = class;

  TPos = record
    fileName: string;
    adr: integer;
    line: integer;
    fil: TLFile;                                   // wgg short path and file names
    isRPL: boolean;                                // wgg added flag to guess type of the line
  end;

  PPos = ^TPos;

  TLFile = class
  private
    function GetStart: integer;
    function GetStop: integer;
  protected
    lineTable: array of TPos;
    Loaded: boolean;
    FileName: TFileName;                // wgg: short path, short file name
    AdrFix: Boolean;                    // wgg: true=Absolute address, if false, add fStart to address
    Vue: integer;
    fStart, fstop: integer;             // wgg fStart is module's load address
    RPLresult: boolean;                                                      // wgg
    Procedure Load;
    Function GetRealAdr(adr: integer): PPos;
    Function ReWork(f: TFileName; lrStart, vue, adr: integer): PPos;
  public
    Errors: array of TPos;
    property start: integer read GetStart write fstart;
    property stop: integer read GetStop write fstop;
    constructor create(f: string; start, stop: integer; vue: integer);
    Function LineFromAdr(adr: integer): PPos;
    function AdrFromLine(f: TFileName; line: integer; var RPLresult: boolean): integer;
    function RamBased: boolean;                                            // wgg made public
  End;

  Function SourceFromAdr(adr: integer): PPos;
  Function GetFileFromFileName(s: string): TLFile;
  Function LoadSuportedEntryPointList(f: TFileName; sup: TStringList): Boolean;
  Function SymbolTable: TSymbolList;
  Function GetNoRefTAble: TSymbolList;
  Procedure SetRamBase(i: integer);

implementation

uses
  Debug, FmProgress, FmSourceEdit;   // wgg

var
  RamBase: integer;
  // This variables ares used during file loading in order
  Tables: array of ATEntry;     // list of entry founds by each table
  files: array of string;       // the text of the files
  filesNames: array of string;  // the name of the files
  vues: array of integer;       // contain the file infos (vue, rom, ram)
  Index: array of Integer;      // some internal things (used to scan the tables)

  Table: TSymbolList;      // List of the symbols
  NoRefTable: TSymbolList; // list of th referenced but unexistings symbols
  LFiles: TMyList;         // list of the files of the project we know about (with there address and address per line)

// This functions are here to give access to the variables
Function GetNoRefTAble: TSymbolList;
Begin
  result:= NoRefTable;
end;

Function SymbolTable: TSymbolList;
Begin
  result:= Table;
end;

procedure ReaddotLR2(f: TFileName; lrstart: integer; vue: integer; fil: string = '');
  function ExtractModuleDef(st: Tstrings; var scanLine: integer;
           var moduleName: string; var start, fin: integer; var fndObj: boolean): boolean;
  // Extract the first module definition from the ST strings after the ScanLine line
  var
    ps, pe, error: integer;
  Begin
    fndObj:= false;   // wgg did not find JYA's objs/ directory
    result:= false;
    while (scanLine<st.count) and (pos('Module=', st[scanLine])=0) do  // Scan for a line with 'Module='
      inc(ScanLine);
    if scanLine>=st.count then                                         // if does not exist: exit
      exit;
    inc(scanLine);
    ps:= pos('Start=', st[scanLine]);                                  // Extract Start and end
    pe:= pos('End=', st[scanLine]);
    if (pe=0) and (pos('Module Contains No Code', st[ScanLine])<>0) then
      Start:= -1
    else begin
      if (ps=0) or (pe=0) then exit;
      val('$'+copy(st[scanLine], ps+6, 5), start, error); if error<>0 then exit;
      val('$'+copy(st[scanLine], pe+4, 5), fin, error);   if error<>0 then exit;
      ModuleName:= copy(st[scanLine-1], 8, pos('.', st[scanLine-1])-8);  // extract the module name
      // wgg - this is patched for JYA's directory structure for the ROM
      if copy(ModuleName, 1, 5)='objs/' then fndObj:= true;  // wgg
      if copy(ModuleName, 1, 5)='objs\' then fndObj:= true;  // wgg
      if fndObj then ModuleName:= Copy(ModuleName, 6, MaxInt);
    end;
    result:= true;
  end;
  // The aim of this function is to know if the filename is a
  // full filename description or a local filename
  Function FullName(s: TFileName): boolean;
  Begin
    result:= false;
    if length(s)>2 then
      if s[2]=':' then
          result:= true;
  end;

var
  st: TStringList;
  p, start, fin: integer;
  s: string;
  fndObj: boolean;   // wgg found JYA objs/ in name
Begin
  st:= TStringList.Create;
  fndObj:= false;      // wgg just to remove compiler msg
  try
    if fil ='' then
      st.LoadFromFile(f)
    else
      st.Text:= fil;
    p:= 0;
    // wgg if 1st ("output") entry has no code, exit; else skip the "output" entry and continue
    if not ExtractModuleDef(st, p, s, start, fin, fndObj) then exit;     // extract the module definition
    if start<>0 then lrstart:= 0;
    while ExtractModuleDef(st, p, s, start, fin, fndObj) do        // extract an input module definition
      // wgg, some rules:
      // if fndObj then (definitely a JYA directory structure for ROM)
      //   ** if crnt file name = module name then ignore this entry
      //      process crnt module path / module name / module.lr
      // else add crnt module path / module.l
      { if (start<>-1) and (ExtractFileName(f)<>s+'.lr') then }   // wgg this inhibits a .s name=project name
      if (start<>-1) then                                        // wgg allow matching names, cant see the problem!
        if FullName(s) then
          LFiles.add(TLFile.create(s+'.l', lrstart+start, lrstart+fin, vue))
        else           // wgg ExtractFilePath(), embed the folder name of the higher .lr into TLFile
          if fndObj then
            if FileExists(ExtractFilePath(f)+s+'\'+s+'.lr') then
              ReaddotLR2(ExtractFilePath(f)+s+'\'+s+'.lr', lrstart+start, vue)
            else
          else
            LFiles.add(TLFile.create(ExtractFilePath(f)+s+'.l', lrstart+start, lrstart+fin, vue));
  finally
    st.free;
  end;
end;

{ Entry }

Constructor TEntry.create(const s: string; TS, TL, SA, SR, RE: integer; vu: integer; Abs: boolean);
          // wgg added Abs=> an '=' found in defining line
  function GetHex(s: string; i: integer): integer;
  Begin
    result:= ((pos(s[i], HexStr)-1) shl 16) + ((pos(s[i+1], HexStr)-1) shl 12) +
             ((pos(s[i+2], HexStr)-1) shl 8) + ((pos(s[i+3], HexStr)-1) shl 4) +
             (pos(s[i+4], HexStr)-1);
    if s[i+5] in ['0'..'F'] then result:= (result * 16 + (pos(s[i+5], HexStr)-1));
  end;
var
  j: integer;
begin
  inherited create;
  with self do
  Begin
    tl:= max(min(tl, re-ts), 0);
    text:= copy(s, TS, TL);
    while (SA<=re-5) and (s[SA]=' ') do inc(SA);
    while (SR<=RE-5) and (s[SR]=' ') do inc(SR);
    if (sr+5>re) and (sa+5>re) then
      Text:= '*'
    else begin
      if s[SA] in ['0'..'F'] then
      Begin
        Value:= GetHex(s, sa);
      end else
        Value:= -1;
      Vue:= vu;
      SetLength(References, 30);
      j:= 0;
      while (sr<=re-5) and not(s[sr]in ['0'..'F']) do inc(sr);
      while sr<=re-5 do
      Begin
        if High(References)<j then
          SetLength(References, length(References)+200);
        References[j]:= (Vue shl 20) + GetHex(s, sr) and $3ffff;
        sr:= sr+5;
        inc(j);
        while (sr<=re-5) and not(s[sr]in ['0'..'F']) do inc(sr);
      end;
      SetLength(References, j);
    end;
  end;
  if (Vue = -1) And Abs then Vue:= 0;        // wgg for absolute defines in relative modules
  if (value<>-1) and (not ((Text[1] in ['^','~']) or self.RamBased)) and (value<$80000) then
    Value:= (Value and $3ffff)+Vue shl 20;
end;

constructor TEntry.create(s: string);
begin
  inherited create;
  Text:=s;
end;

function TEntry.GetValue: integer;
begin
  if RamBased and not (FValue=-1) and not (Text[1] in ['^','~']) and not (fvalue>=$80000) then
    Result:= FValue+RamBase
  else
    Result := FValue;
end;

procedure TEntry.Merge(e: TEntry);
var
  i, j: integer;
begin
  if Value=-1 then
  Begin
    Value:= e.Value;
    Vue:= e.Vue;
  end;
  j:= Length(References);
  SetLength(References, j+Length(e.References));
  for i:=0 to Length(e.References)-1 do
    References[i+j]:= e.References[i];
end;

function TEntry.RefBetween(a, b: integer): boolean;
var
  i: integer;
begin
  i:= Low(References);
  while (i<=high(References)) and ((GetReferences(i)<a) or (GetReferences(i)>b)) do
    inc(i);
  result:= (High(References)<>-1) And (i<=High(References));  // wgg original was always false!
end;

Function TEntry.Getreferences(i: integer): integer;
Begin
  result:= References[i];
  if result<0 then
    result:= result-(-1*$100000)+RamBase;
end;
// Find an entry from it's address
// Because the entry list is sorted by address,
// we can use a binary partitioning algo
function TSymbolList.GetFromAdr2(i: integer): string;
var
  r, l, m: integer;
Begin
  result:= '';
  l:= 0;
  r:= count-1;
  while l<=r do
  Begin
    m:= (l+r) div 2;
    if TEntry(Items[m]).Value=i then
    begin
      result:= TEntry(Items[m]).Text;
      exit;
    end;
    if TEntry(Items[m]).Value<i then
      l:= m+1
    else
      r:= m-1;
  end;
end;

Function TSymbolList.GetTEntry(s: string): TEntry;            // wgg added function
var
  i: integer;
Begin
  result:= Nil;
  i:=table.indexofString(s);
  if i<>-1 then
    result:= TEntry(table[i])
  else begin
    i:=table.indexofUpperCaseString(s);
    if i<>-1 then
      result:= TEntry(table[i]);
  end;
end;

Function TSymbolList.GetEntryValue(s: string): integer;
Begin
  result:=table.indexofString(s);
  if result<>-1 then
    result:= TEntry(table[result]).Value
  else begin
    result:=table.indexofUpperCaseString(s);
    if Result<>-1 then
      result:= TEntry(table[Result]).Value;
  end;
end;

// Get the value of an expression
// wgg original code would do a number convert if leading 0-9 or $
// this has been changed because many symboles start with 0-9 or $
function TSymbolList.GetFromName(s: string): integer;

  Function GetFromName2(s: string; var i: integer): integer;

    Function GetF(s: string; var i: integer): integer;
    var
      j, err: integer;
      st: string;
    Begin
      case s[i] of
        '(': Begin inc(i); result:= GetFromName2(s, i); end;
             // wgg [adr] = indirection, append same vue to result
        '[': Begin
               inc(i);
               result:= GetFromName2(s, i);
               result:= Debugger.ReadInteger(result) + result And $1F00000;
             end;
        else
          j:= i;
          while (i<=Length(s)) and (not (s[i] in [')', ']'])) do inc(i);
          st:= copy(s, j, i-j);
          if st='A' then begin result:= DEbugger.Chipset.A and $fffff; exit; end;
          if st='B' then begin result:= DEbugger.Chipset.B and $fffff; exit; end;
          if st='C' then begin result:= DEbugger.Chipset.C and $fffff; exit; end;
          if st='D' then begin result:= DEbugger.Chipset.D and $fffff; exit; end;
          if st='D0' then begin result:= DEbugger.Chipset.D0 and $fffff; exit; end;
          if st='D1' then begin result:= DEbugger.Chipset.D1 and $fffff; exit; end;
          if st='PC' then begin result:= DEbugger.Chipset.PC and $fffff; exit; end;
          result:=table.indexofString(st);
          if result<>-1 then begin result:= TEntry(table[result]).Value; exit; end;
          result:=table.indexofUpperCaseString(st);
          if result<>-1 then begin result:= TEntry(table[result]).Value; exit; end;
          // wgg not in table try number conversions
          val(st, result, err);     // wgg a leading '$' gives hex, else dec
          // wgg if we got here, a numeric was attempted, did it work?
          if err <> 0 then
          begin
            Raise Exception.Create(st)
          end;
      end; // of case
    end;   // of Function GetF

  Begin   // code for Function GetFromName2
    result:= GetF(s, i);
    if i>length(s) then exit;
    while (i<=length(s)) and (s[i] in ['-','+']) do
    Begin
      inc(i);
      case s[i-1] of
        '+' : result:= result+GetF(s, i);
        '-' : result:= result-GetF(s, i);
      end;
    end;
    if (i<=length(s)) then
      case s[i] of
        ')' : inc(i);
        ']' : inc(i);
        else raise exception.Create('');
      end;
  end;

var          // Function GetFromName 
  i: integer;
Begin
  try
    i:= 1;
    result:= GetFRomName2(s, i);
  except
    result:= -1;
  end;
end;

Function TSymbolList.ValueFromText(s: String): Integer;
var
  er: integer;
begin
  while (length(s)>0) and (s[length(s)]<=' ') do s:= copy(s, 1, length(s)-1);
  val('$'+s, Result, er);
  if er<>0 then
    Result:= GetFromName(s);
  if Result > $100000 then Result:= Result Or $1000000;   // wgg make sure FLASH is set
end;

const
  StartStr= 'Saturn Cross Reference Listing';
  EndStr= #$C'Unresolved';
  EndStr2= '/SLOAD';

Function TSymbolList.GetFullLine(Const s: string; Start, Stop: integer; Var TokenLenght, StartAdr,
         StartRef: integer; Var Abs: boolean): integer;                    // wgg added Abs=> found '=' sign
var
  p : Pchar;
Begin
  Abs:= false;
  if (Stop-Start)<10 then
    Result:= -1
  else
    if ((s[Start]=EndStr[1]) and (copy(S, Start, length(EndStr))=EndStr)) or ((s[Start]=EndStr2[1]) and (copy(S, Start, length(EndStr2))=EndStr2)) then
      result:= -2
    else Begin
      p:= @(s[Start]);
      result:= Start;
      While (result<=Stop) and (p[0]>' ') do Begin inc(result); inc(p); end;
      TokenLenght:= result-Start;
      while (Result<=Stop) and (p[0]<>'=') and (p[0]<>'*') do Begin inc(Result); inc(p); end;
      if p[0]='=' then Abs:= true;                  // wgg found '=' treat as absolute address
      StartAdr:= Result+1;
      while (Result<=Stop) and (p[0]<>'-') do Begin inc(Result); inc(p); end;
      StartRef:= result+1;
      while (result<Stop) and ((p[0]<>#10) or ((p[1]<=' ')) and (p[1]<>#$C)) do Begin inc(result); inc(p); end;
      result:= result+1;
      if result>=stop then
        result:= -1;
    end;
end;

Function TSymbolList.LoadFile(Const s: string; vue: integer; var Table: ATEntry): string;
var
  p2, p, l: integer;
  TL, SA, SR: integer;
  ue: integer;
  Abs: boolean;
Begin
  SetLength(Table, 0);
  l:= Length(s);
  p:= pos(StartStr, s);
  if p=0 then exit;
  result:= copy(s, 1, p);
  while (p<l) and ((s[p]<>#10) or (s[P+1]<=' ')) do inc(p);
  ue:= 0;
  inc(p);
  p2:= GetFullLine(s, p, l, TL, SA, SR, Abs);
  while p2<>-2 do
  Begin
    if p2<>-1 then
    Begin
      if ue>=Length(Table) then
        SetLength(Table, ue+1000);
        Table[ue]:= TEntry.Create(s, p, TL, SA, SR, p2, Vue, Abs);
        inc(ue);
      p:= p2;
    end;
    p2:= GetFullLine(s, p, l, TL, SA, SR, Abs);
  end;
  SetLength(Table, ue);
end;

Function AdrSort(Item1, Item2: Pointer): Integer;
Begin
  result:= TEntry(Item1).Value-TEntry(Item2).Value;
end;

// This functions give the source and line from
// a given adr in a format that can be put in the
// editor listbox
Function GetFileLineFromAdr(a: integer): string;
var
  p: ppos;
begin
  p:= SourceFromAdr(a);
  if p=nil then
    result:= ''
  else
    result:= frmSourceEdit.ShortLongName(p.fileName)+': '+inttostr(p.line)+': ';
end;


// Re initialize the symbols entries from the files
// vue=0: bank, get bankNo from [1]   =1: rel adrs  =-1: abs adrs
// i is index where filename begins (if [2] then [1] is bank number from - V bankNo
Procedure TSymbolList.InitTable(f: TStringList; BeforeSort: TSortString);
  Procedure OneMoreFile(i: integer; vue: integer);
  var
    fn, s: string;
  Begin
    if f.count<i+1 then
    Begin
      while f.count<>0 do f.delete(0);
      raise Exception.Create('Error, invalid command line : More expected arguments');
    end;
    // wgg f[i] comes from the paramter list.  It is the beginning of a chain of expansion
    // using names found in .lr files.  Each lower level appends the path of the higher level
    // unless the lower already has a full path name. This is needed so that LFiles[] will have
    // full path names.
    // The problem comes when we start the chain.  The params list may have some arguments with
    // partial path names.  These should be completed using the current directory which may be
    // the project directory (if we have a project file) or the application directory if not.
    // I added the next few lines to insure that f[i] is a full path!
    fn:= f[i];
    if (fn[2]<>':') then
      fn:= ExpandFileName(fn);
    s:= f[1];
    while i>-1 do begin f.delete(0); dec(i); end;
    if not FileExists(fn) then                                            
      raise Exception.Create('Error, file '+fn+' does not exist.');       // wgg just make english
    SetLength(Tables, Length(Tables)+1);
    SetLength(Tables[High(Tables)], 0);
    SetLength(files, Length(files)+1);
    Files[High(files)]:= '';
    SetLength(vues, Length(vues)+1);
    SetLength(Index, Length(Index)+1);
    SetLength(FilesNames, Length(FilesNames)+1);
    FilesNames[high(FilesNames)]:= fn;
    // wgg changed the way vue is communicated
    // caller vue=-1 is rel, 0 is FLASH, 999 is abs
    if vue=-1 then vues[high(vues)]:= vue;
    if vue=999 then vues[high(vues)]:= 0;
    if vue=0 then vues[high(vues)]:= StrToInt(s)+$10;       // wgg will later flag $1,000,000 = Flash
    Files[high(vues)]:= FileToString(fn);
  end;
var
  i, j, MinL: integer;
  e: TEntry;
  s: String;
  fo: TfrmProgress;
  error: boolean;
Begin
  try
    // erase existing stuff
    While table.Count<>0 do Table.Delete(Table.count-1).free;
    While NoRefTable.Count<>0 do NoRefTable.Delete(NoRefTable.count-1).free;
    while LFiles.count<>0 do LFiles.Delete(LFiles.count-1).Free;
    SetLength(filesNames,0);
    SetLength(vues,0);
    SetLength(Index,0);
    For i:=low(Tables) to high(Tables) do
      SetLength(Tables[i], 0);
    SetLength(Tables,0);

    // create a progress form
    fo:= TfrmProgress.Create(Application);
    with fo do
      try
        Display('Loading files');

        // by default, show the loading error
        error:= true;

        While f.count<>0 do
          try
            if Uppercase(f[0])='-ER' then begin error:= false; f.delete(0); end else
            if Uppercase(f[0])='-V' then OneMoreFile(2, 0) else
            if Uppercase(f[0])='-R' then OneMoreFile(1, -1) else
            if Uppercase(f[0])='-A' then OneMoreFile(1, 999) else
            raise Exception.Create('Error, invalid command line ''' +f[0]+'''');
          except
            on e: Exception do
              begin
                application.MessageBox(pchar(e.message), 'Error', MB_Ok);
                f.delete(0);
              end;
          end;

        // for each loaded file, process it.
        for i:= low(vues) to high(vues) do
        Begin
          fo.Display('File '+filesNames[i]);
          ReadDotLR2(filesNames[i], 0, vues[i], LoadFile(Files[i], vues[i], Tables[i]));
          Files[i]:= '';
        end;

        // we now have up to n differents tables.
        // we need to merge the commons entries (same name)
        // note: the .lr files are in alphabetic order. Therfore, the values
        // in the tables struct are alphabetically sorted. This is used in the algorithm
        display('Merging Tables');
        for i:= low(vues) to high(vues) do
          if (Length(TAbles[i])=0) then
            Index[i]:= -1
          else
            Index[i]:= 0;
        MinL:= 0;
        while MinL<>-1 do
        Begin
          MinL:= -1;
          for i:= low(vues) to high(vues) do
            if (Index[i]<>-1) and ((MinL=-1) or (Tables[i][Index[i]].Text<s)) then
            Begin
              MinL:= i;
              s:= Tables[i][Index[i]].text;
            end;
          if MinL<>-1 then
          Begin
            e:=Tables[Minl][Index[Minl]];
            if e.Text[1]<>'*' then
              if (Table.count<>0) and (TEntry(Table.Last).Text=e.Text) then
                TEntry(Table.Last).Merge(e)
              else
                Table.Add(e);
            Inc(Index[Minl]);
            if Index[MinL]>=Length(Tables[Minl]) then
              Index[Minl]:= -1
          end;
        end;

        // put in a separate table all entries with a value of -1 (undefined)
        display('Ref Error table');
        i:= 0;
        while i<Table.Count do
          if TEntry(Table[i]).Value=-1 then
          Begin
            e:= TEntry(Table.Delete(i));
            NoRefTable.add(e);
            if error then
              for j:= 0 to high(e.References) do
                frmSourceEdit.AddErrorMsg(GetFileLineFromAdr(e.Getreferences(j))
                                           +'Entry '+e.Text+' does not exist.');
          end else
            if (Length(TEntry(Table[i]).Text)>0) then
              inc(i)
            else
              Table.Delete(i);
        // a litle call back used to add the stuff in the completion proposal.
        display('Building Helpers');
        if assigned(BeforeSort) then
          BeforeSort(Table);

        // sort the list by address
        display('Sorting table');
        Table.Sort(AdrSort);
      finally
      Free;
      Application.ProcessMessages;     // wgg so there is a chance to remove (frmProgress)
      end;
  except
    on e: Exception do
      Application.MessageBox(pchar(e.Message), 'Error while loading files', MB_OK);
  end;
end;

Procedure SetRamBase(i: integer);
Begin
  RamBase:= i;
//  display('Sorting table');
  Table.Sort(AdrSort);
end;

// This load the list of supported entry points from
// an official entry point list file
Function LoadSuportedEntryPointList(f: TFileName; sup: TStringList): Boolean;
var
  p: integer;
Begin
  Try
    sup.LoadFromFile(f);
    p:= 0;
    while p<sup.count do
      if length(sup[p])=0 then
        sup.delete(p)
      else
        if (sup[p][1]='=') then
        Begin
          Sup.Objects[p]:= pointer(SymbolTable.GetEntryValue(copy(sup[p], NxtToken(sup[p], NxtToken(sup[p], 1))+1, MaxInt)));
          sup[p]:= copy(sup[p], 2, FindWhite(sup[p], 2)-2);
          inc(p);
        end else
          sup.delete(p);
    Sup.Sorted:= True;
    result:= true;
  Except
    sup.Clear;
    result:= false;
  end;
end;

function TSymbolList.GetStringRep(o: TObject): string;
begin
  result:= TEntry(o).Text;
end;

function TSymbolList.indexofUpperCaseString(s: string): integer;
begin
  s:= UpperCase(s);
  result:= 0;
  while (result<count) and (UpperCase(GetStringRep(Items[result]))<>s) do
    inc(result);
  if result=count then
    result:= -1;
end;

constructor TSymbolList.create;
begin
  inherited;
end;

// This function gived a TLFile object associated to the given filename
Function GetFileFromFileName(s: string): TLFile;
Var
  i: integer;
  s2: string;
begin
  s:= Uppercase(Removeslashslash(s));
  result:= nil;
  for i:= 0 to LFiles.count-1 do
  Begin
    s2:= changeFileExt(Uppercase(Removeslashslash((LFiles[i] as TLFile).FileName)), '.S');
    if s2=s then
    Begin
      (LFiles[i] as TLFile).Load;
      result:=(LFiles[i] as TLFile);
      exit;
    end;
  end;
end;

// This function gives you the file and line corresponding to
// a specified address
Function SourceFromAdr(adr: Integer): PPos;
Var
  i: integer;
begin
  result:= nil;
  for i:= 0 to LFiles.count-1 do
  Begin
    result:= (LFiles[i] as TLFile).LineFromAdr(adr);
    if result<>nil then Exit;
  end;
end;

{ TLFile }

// This function will give you the address corresponding to a line and a file.
// This is used in order to allow you to place a breakpoint from the source
// wgg added RPLresult flag - RETURNS A VALUE!
function TLFile.AdrFromLine(f: TFileName; line: integer; var RPLresult: boolean): integer;
var
  i: integer;
  f3: string;
begin
  f:= Uppercase(removeslashslash(f));
//  f2:= ExtractFileName(f);          // wgg TLFile now has only full paths
  // we built TLFile paths as short names but JYA compiler has long file names!
  f3:= UpperCase(ExtractFilePath(f)+ExtractFileName(GetLongName(f)));
  result:= 0;
  RPLresult:= false;
  for i:= low(LineTable) to high(LineTable) do
    if ((Uppercase(LineTable[i].fileName)=f) or
    //    (Uppercase(LineTable[i].fileName)=f2) or
        (Uppercase(LineTable[i].fileName)=f3))   // wgg added uppercase
           and (lineTable[i].line>=line) then
      Begin
        result:= linetable[i].adr;
        RPLresult:= linetable[i].isRPL;         // wgg watch out, this must be avail in next function!
        if (result <> -1) And (not AdrFix) then
          result:= result+Start;
        exit;
      end;
end;

//constructor TLFile.create(f: string; start, stop: integer; error: TNotifyEvent; vue: integer);
constructor TLFile.create(f: string; start, stop: integer; vue: integer);
begin
  inherited Create;
  FileName:= Removeslashslash(f);    // wgg removed UpperCase
  Self.Start:= Start;
  Self.Stop:= Stop;
  Self.Loaded:= False;
  SetLength(LineTable, 0);
  SetLength(Errors, 0);
//  FonError:= error;
  Self.Vue:= Vue;
end;

function TLFile.GetRealAdr(adr: integer): PPos;
var
  j, i: integer;
begin
  if not AdrFix then
    Adr:= Adr-Start;
  if AdrFix then
    adr := adr and $FFFFF;
  If High(LineTable)=0 then
    result:=@(LineTable[0])
  else Begin
    for i:=1 to High(LineTable) do
      if adr<LineTable[i].adr then
      Begin
        j:= i-1;
        while (j>0) and (LineTable[j].adr=-1) do dec(j);
        result:=@(LineTable[j]);
        exit;
      end;
    result:= nil;
  end;
end;

function TLFile.GetStart: integer;
begin
  if not RamBased then
    Result := fstart and $3ffff+(vue shl 20)
  else
    Result:= fstart+RamBase;
end;

function TLFile.GetStop: integer;
begin
  if not RamBased then
    Result := fstop and $3ffff+(vue shl 20)
  else
    Result:= fstop+RamBase;
end;

function TLFile.LineFromAdr(adr: integer): PPos;
const
  lastf: string = '';
var
  f: string;
begin
  result:= nil;
  if (Adr<Start) or (Adr>=Stop) then exit;
  if Loaded then
    result:= GetRealAdr(adr)
  else Begin
    f:= ChangeFileExt(ExtractFileName(FileName), '');
    if FileExists(FileName) then
      If not FileExists(ChangeFileExt(FileName, '.s')) then
        Application.MessageBox(pchar('Cannot load data because '+f+'.a Is the source file'), 'error', mb_ok)
      else begin
        Load;
        result:= GetRealAdr(adr);
      end
    else begin
     {  d:= ExtractFilePath(fileName)+f+'\'+f+'.lr';   // wgg now handled in readdorlt2
      if FileExists(d) then
        result:= ReWork(d, fstart, vue, adr)
      else   }
        if Not (copy(f,1,1) = '_') then
        begin
          if lastf <> f then
            Application.MessageBox(pchar('Cannot find file '+f+'.*'), 'Error', mb_ok);
          lastf:= f;                              // wgg avoid endless msgs if Suprom.a not there!
        end;
    end
  end;
end;

procedure TLFile.Load;
var
  UsedInList: integer;
  i, j, k, m, p: integer;
  s, f, sline: string;
  FirstAdr, RPL: boolean;
  st: TStringList;

begin
  if loaded then exit;
  UsedInList:= Length(LineTable);
  st:= TStringList.Create;

  with st do
    try
      AdrFix:= False;
      FirstAdr:= True;
      LoadFromFile(self.FileName);
      for i:= 0 to count-1 do                            // parse the file looking for the address
      begin
        s:= Strings[i];                                 // wgg (old .L version) process an external definition
     {   if (Length(s)>42) then
          if (s[1] = '=') And (pos('Abs ', copy(s, 36, 5))<> 0) then  // wgg only need External, Abs definitions
          begin
            T:= SymbolTable.GetTEntry(copy(s, 2, pos(' ', s)-2));
            if T <> Nil then
              if T.Vue = -1 then
                T.Vue:= 0;
          end;
      }
        p:= pos('* File', S);  // if this line contain the '* File' mark, save it { * File  kerheader.s     5 }
        if p<>0 then           // wgg a little repetition because we want to look at file names
        begin
          sline:=  copy(s, SkipWhite(s, pos('* File', S)+6), MaxInt);
          if (length(sline)>=2) and (sline[2]=':') then
            f:= copy(sline, 1, BackToName(sline))
          else
            f:= ExtractFilePath(self.FileName)+(copy(sline, 1, BackToName(sline))); // wgg was uppercase
        end;
        // wgg do not include lines that point to .h files (included files)
        if (p<>0) And (pos('.h', sline)=0) then
        Begin
          if UsedInList=Length(lineTable) then
            SetLength(lineTable, UsedInList+1000);
          with lineTable[UsedInList] do
          Begin
            FileName:= f;
            isRPL:= True;                                                   // wgg we will assume
            try
              Line:= StrToInt(copy(sline, SkipWhite(sline, BackToName(sline)+1), MaxInt));
            except
              Line:= 0;
            end;
            adr:= -1;
          end;
          if (UsedInList<>0) and (lineTable[UsedInList-1].FileName=lineTable[UsedInList].FileName) then
            lineTable[UsedInList].FileName:= lineTable[UsedInList-1].FileName;
          inc(UsedInList);
        end else
          if (UsedInList<>0) and (lineTable[UsedInList-1].adr=-1) then
          begin                               // else find the address of the data generated by this line
                                              // the lines are generaly of the format: .a file line, offset of the datas produced by this line in the bin file, datas produced, original text
            if pos('ERROR:', s)<>0 then
            Begin
              SetLength(Errors, Length(Errors)+1);
              Errors[high(Errors)]:= lineTable[UsedInList-1];
            end;
            p:= SkipWhite(s, 1);
            while (p<=length(s)) and (s[p] in ['0'..'9']) do inc(p); // skip original line no (do not care, it's a wrong indicator)
            p:= SkipWhite(s, p);
            val('$'+copy(s,p,5), j, k);            // get the value of the output offset
            if (k = 0) and (p < 9 )then            // if valid then, is it the good line?
            Begin
              // wgg this is not perfect but its pretty good!
              p:= SkipWhite(s, p+5);                      // wgg get to generated code bytes
              val('$'+copy(s,p,5), m, k);                 // wgg get the value of the output offset
              RPL:= false;
              if (k=0) and (m>=0) then                    // get a valid 5 digit number or it is code
              begin
                p:= SkipWhite(s, p+10);                   // wgg point to opcode field
                if p+9<=length(s) then
                  if (copy(s,p,9)='CON(5)  =') Or (copy(s,p,9)='CON(6)  =') then RPL:= true
              end;
              lineTable[UsedInList-1].isRPL:= RPL;

              lineTable[UsedInList-1].adr:= j;
              if FirstAdr and (j<>0) then
                AdrFix:= True;
              FirstAdr:= False;
              // wgg now work backwards and fix any other previous lines (like a DEFINE xxx)
              k:= UsedInList-2;
              while (k >= 0) And (lineTable[k].adr = -1) do  // wgg
                begin
                  linetable[k].adr:= j;
                  linetable[k].isRPL:= RPL;
                  dec(k);
                end;
            end;
          end;
      end;
      Loaded:= True;
//    if (Length(Errors)<>0) and (assigned(FOnError)) then
//      FOnError(Self);
    finally
      free;
      if High(lineTable)>=0 then                                            // wgg in case .L file missing
      begin
        LineTable[UsedInList].fileName:= fileName;
        LineTable[UsedInList].adr:= stop-start;
        LineTable[UsedInList].line:= 0;
        inc(UsedInList);
        SetLength(lineTable, UsedInList);
        for i:=Low(LineTable) to High(LineTable) do
          LineTable[i].fil:= self;
      end;
    end;
end;

function TLFile.RamBased: boolean;
begin
  result:= vue=-1;
end;

function TLFile.ReWork(f: TFileName; lrStart, vue, adr: integer): PPos;
var
  i: integer;
  ff: TLFile;
begin
  LFiles.remove(self);
  try
    ReaddotLR2(f, lrstart, vue);
    i:=0; result:= nil;
    While (i<LFiles.count) and (result=nil) do
    Begin
      ff:= (LFiles[i] as TLFile);
      result:= ff.LineFromAdr(adr);
      inc(i);
    end;
  finally
    self.Free;
  end;
end;

function TSymbolList.GetFromAdr(i: integer): string;
begin
  result:= GetFromAdr2(debugger.FullAdr(i));
end;

function TEntry.RamBased: boolean;
begin
  result:= vue=-1;
end;

initialization
  Table:= TSymbolList.Create;
  NoRefTable:= TSymbolList.Create;
  LFiles:= TMyList.Create;

finalization
  while LFiles.Count<>0 do
    LFiles.delete(LFiles.count-1).free;
  LFiles.Free;
  Table.free;
  NoRefTable.Free;

end.
